//------------------------------------------------------------------------------
// PySyntaxBindings1.cpp
// Generated Python bindings for syntax types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "pyslang.h"

#include "slang/syntax/AllSyntax.h"

void registerSyntaxNodes1(py::module_& m) {
    py::class_<NetDeclarationSyntax, MemberSyntax>(m, "NetDeclarationSyntax")
        .def_readwrite("netType", &NetDeclarationSyntax::netType)
        .def_readwrite("strength", &NetDeclarationSyntax::strength)
        .def_readwrite("expansionHint", &NetDeclarationSyntax::expansionHint)
        .def_readwrite("type", &NetDeclarationSyntax::type)
        .def_readwrite("delay", &NetDeclarationSyntax::delay)
        .def_readwrite("declarators", &NetDeclarationSyntax::declarators)
        .def_readwrite("semi", &NetDeclarationSyntax::semi);

    py::class_<UserDefinedNetDeclarationSyntax, MemberSyntax>(m, "UserDefinedNetDeclarationSyntax")
        .def_readwrite("netType", &UserDefinedNetDeclarationSyntax::netType)
        .def_readwrite("delay", &UserDefinedNetDeclarationSyntax::delay)
        .def_readwrite("declarators", &UserDefinedNetDeclarationSyntax::declarators)
        .def_readwrite("semi", &UserDefinedNetDeclarationSyntax::semi);

    py::class_<WithFunctionClauseSyntax, SyntaxNode>(m, "WithFunctionClauseSyntax")
        .def_readwrite("with", &WithFunctionClauseSyntax::with)
        .def_readwrite("name", &WithFunctionClauseSyntax::name);

    py::class_<NetTypeDeclarationSyntax, MemberSyntax>(m, "NetTypeDeclarationSyntax")
        .def_readwrite("keyword", &NetTypeDeclarationSyntax::keyword)
        .def_readwrite("type", &NetTypeDeclarationSyntax::type)
        .def_readwrite("name", &NetTypeDeclarationSyntax::name)
        .def_readwrite("withFunction", &NetTypeDeclarationSyntax::withFunction)
        .def_readwrite("semi", &NetTypeDeclarationSyntax::semi);

    py::class_<PackageImportItemSyntax, SyntaxNode>(m, "PackageImportItemSyntax")
        .def_readwrite("package", &PackageImportItemSyntax::package)
        .def_readwrite("doubleColon", &PackageImportItemSyntax::doubleColon)
        .def_readwrite("item", &PackageImportItemSyntax::item);

    py::class_<PackageImportDeclarationSyntax, MemberSyntax>(m, "PackageImportDeclarationSyntax")
        .def_readwrite("keyword", &PackageImportDeclarationSyntax::keyword)
        .def_readwrite("items", &PackageImportDeclarationSyntax::items)
        .def_readwrite("semi", &PackageImportDeclarationSyntax::semi);

    py::class_<PackageExportDeclarationSyntax, MemberSyntax>(m, "PackageExportDeclarationSyntax")
        .def_readwrite("keyword", &PackageExportDeclarationSyntax::keyword)
        .def_readwrite("items", &PackageExportDeclarationSyntax::items)
        .def_readwrite("semi", &PackageExportDeclarationSyntax::semi);

    py::class_<PackageExportAllDeclarationSyntax, MemberSyntax>(m, "PackageExportAllDeclarationSyntax")
        .def_readwrite("keyword", &PackageExportAllDeclarationSyntax::keyword)
        .def_readwrite("star1", &PackageExportAllDeclarationSyntax::star1)
        .def_readwrite("doubleColon", &PackageExportAllDeclarationSyntax::doubleColon)
        .def_readwrite("star2", &PackageExportAllDeclarationSyntax::star2)
        .def_readwrite("semi", &PackageExportAllDeclarationSyntax::semi);

    py::class_<ParameterDeclarationBaseSyntax, SyntaxNode>(m, "ParameterDeclarationBaseSyntax")
        .def_readwrite("keyword", &ParameterDeclarationBaseSyntax::keyword);

    py::class_<ParameterDeclarationSyntax, ParameterDeclarationBaseSyntax>(m, "ParameterDeclarationSyntax")
        .def_readwrite("type", &ParameterDeclarationSyntax::type)
        .def_readwrite("declarators", &ParameterDeclarationSyntax::declarators);

    py::class_<EqualsTypeClauseSyntax, SyntaxNode>(m, "EqualsTypeClauseSyntax")
        .def_readwrite("equals", &EqualsTypeClauseSyntax::equals)
        .def_readwrite("type", &EqualsTypeClauseSyntax::type);

    py::class_<TypeAssignmentSyntax, SyntaxNode>(m, "TypeAssignmentSyntax")
        .def_readwrite("name", &TypeAssignmentSyntax::name)
        .def_readwrite("assignment", &TypeAssignmentSyntax::assignment);

    py::class_<TypeParameterDeclarationSyntax, ParameterDeclarationBaseSyntax>(m, "TypeParameterDeclarationSyntax")
        .def_readwrite("typeKeyword", &TypeParameterDeclarationSyntax::typeKeyword)
        .def_readwrite("typeRestriction", &TypeParameterDeclarationSyntax::typeRestriction)
        .def_readwrite("declarators", &TypeParameterDeclarationSyntax::declarators);

    py::class_<ParameterDeclarationStatementSyntax, MemberSyntax>(m, "ParameterDeclarationStatementSyntax")
        .def_readwrite("parameter", &ParameterDeclarationStatementSyntax::parameter)
        .def_readwrite("semi", &ParameterDeclarationStatementSyntax::semi);

    py::class_<PortHeaderSyntax, SyntaxNode>(m, "PortHeaderSyntax");

    py::class_<PortDeclarationSyntax, MemberSyntax>(m, "PortDeclarationSyntax")
        .def_readwrite("header", &PortDeclarationSyntax::header)
        .def_readwrite("declarators", &PortDeclarationSyntax::declarators)
        .def_readwrite("semi", &PortDeclarationSyntax::semi);

    py::class_<GenvarDeclarationSyntax, MemberSyntax>(m, "GenvarDeclarationSyntax")
        .def_readwrite("keyword", &GenvarDeclarationSyntax::keyword)
        .def_readwrite("identifiers", &GenvarDeclarationSyntax::identifiers)
        .def_readwrite("semi", &GenvarDeclarationSyntax::semi);

    py::class_<FunctionPortBaseSyntax, SyntaxNode>(m, "FunctionPortBaseSyntax");

    py::class_<DefaultFunctionPortSyntax, FunctionPortBaseSyntax>(m, "DefaultFunctionPortSyntax")
        .def_readwrite("keyword", &DefaultFunctionPortSyntax::keyword);

    py::class_<FunctionPortSyntax, FunctionPortBaseSyntax>(m, "FunctionPortSyntax")
        .def_readwrite("attributes", &FunctionPortSyntax::attributes)
        .def_readwrite("constKeyword", &FunctionPortSyntax::constKeyword)
        .def_readwrite("direction", &FunctionPortSyntax::direction)
        .def_readwrite("staticKeyword", &FunctionPortSyntax::staticKeyword)
        .def_readwrite("varKeyword", &FunctionPortSyntax::varKeyword)
        .def_readwrite("dataType", &FunctionPortSyntax::dataType)
        .def_readwrite("declarator", &FunctionPortSyntax::declarator);

    py::class_<FunctionPortListSyntax, SyntaxNode>(m, "FunctionPortListSyntax")
        .def_readwrite("openParen", &FunctionPortListSyntax::openParen)
        .def_readwrite("ports", &FunctionPortListSyntax::ports)
        .def_readwrite("closeParen", &FunctionPortListSyntax::closeParen);

    py::class_<IntegerTypeSyntax, DataTypeSyntax>(m, "IntegerTypeSyntax")
        .def_readwrite("keyword", &IntegerTypeSyntax::keyword)
        .def_readwrite("signing", &IntegerTypeSyntax::signing)
        .def_readwrite("dimensions", &IntegerTypeSyntax::dimensions);

    py::class_<KeywordTypeSyntax, DataTypeSyntax>(m, "KeywordTypeSyntax")
        .def_readwrite("keyword", &KeywordTypeSyntax::keyword);

    py::class_<NamedTypeSyntax, DataTypeSyntax>(m, "NamedTypeSyntax")
        .def_readwrite("name", &NamedTypeSyntax::name);

    py::class_<StructUnionMemberSyntax, SyntaxNode>(m, "StructUnionMemberSyntax")
        .def_readwrite("attributes", &StructUnionMemberSyntax::attributes)
        .def_readwrite("randomQualifier", &StructUnionMemberSyntax::randomQualifier)
        .def_readwrite("type", &StructUnionMemberSyntax::type)
        .def_readwrite("declarators", &StructUnionMemberSyntax::declarators)
        .def_readwrite("semi", &StructUnionMemberSyntax::semi);

    py::class_<StructUnionTypeSyntax, DataTypeSyntax>(m, "StructUnionTypeSyntax")
        .def_readwrite("keyword", &StructUnionTypeSyntax::keyword)
        .def_readwrite("taggedOrSoft", &StructUnionTypeSyntax::taggedOrSoft)
        .def_readwrite("packed", &StructUnionTypeSyntax::packed)
        .def_readwrite("signing", &StructUnionTypeSyntax::signing)
        .def_readwrite("openBrace", &StructUnionTypeSyntax::openBrace)
        .def_readwrite("members", &StructUnionTypeSyntax::members)
        .def_readwrite("closeBrace", &StructUnionTypeSyntax::closeBrace)
        .def_readwrite("dimensions", &StructUnionTypeSyntax::dimensions);

    py::class_<EnumTypeSyntax, DataTypeSyntax>(m, "EnumTypeSyntax")
        .def_readwrite("keyword", &EnumTypeSyntax::keyword)
        .def_readwrite("baseType", &EnumTypeSyntax::baseType)
        .def_readwrite("openBrace", &EnumTypeSyntax::openBrace)
        .def_readwrite("members", &EnumTypeSyntax::members)
        .def_readwrite("closeBrace", &EnumTypeSyntax::closeBrace)
        .def_readwrite("dimensions", &EnumTypeSyntax::dimensions);

    py::class_<TypeReferenceSyntax, DataTypeSyntax>(m, "TypeReferenceSyntax")
        .def_readwrite("typeKeyword", &TypeReferenceSyntax::typeKeyword)
        .def_readwrite("openParen", &TypeReferenceSyntax::openParen)
        .def_readwrite("expr", &TypeReferenceSyntax::expr)
        .def_readwrite("closeParen", &TypeReferenceSyntax::closeParen);

    py::class_<DotMemberClauseSyntax, SyntaxNode>(m, "DotMemberClauseSyntax")
        .def_readwrite("dot", &DotMemberClauseSyntax::dot)
        .def_readwrite("member", &DotMemberClauseSyntax::member);

    py::class_<VirtualInterfaceTypeSyntax, DataTypeSyntax>(m, "VirtualInterfaceTypeSyntax")
        .def_readwrite("virtualKeyword", &VirtualInterfaceTypeSyntax::virtualKeyword)
        .def_readwrite("interfaceKeyword", &VirtualInterfaceTypeSyntax::interfaceKeyword)
        .def_readwrite("name", &VirtualInterfaceTypeSyntax::name)
        .def_readwrite("parameters", &VirtualInterfaceTypeSyntax::parameters)
        .def_readwrite("modport", &VirtualInterfaceTypeSyntax::modport);

    py::class_<ImplicitTypeSyntax, DataTypeSyntax>(m, "ImplicitTypeSyntax")
        .def_readwrite("signing", &ImplicitTypeSyntax::signing)
        .def_readwrite("dimensions", &ImplicitTypeSyntax::dimensions)
        .def_readwrite("placeholder", &ImplicitTypeSyntax::placeholder);

    py::class_<DeferredAssertionSyntax, SyntaxNode>(m, "DeferredAssertionSyntax")
        .def_readwrite("hash", &DeferredAssertionSyntax::hash)
        .def_readwrite("zero", &DeferredAssertionSyntax::zero)
        .def_readwrite("finalKeyword", &DeferredAssertionSyntax::finalKeyword);

    py::class_<ElseClauseSyntax, SyntaxNode>(m, "ElseClauseSyntax")
        .def_readwrite("elseKeyword", &ElseClauseSyntax::elseKeyword)
        .def_readwrite("clause", &ElseClauseSyntax::clause);

    py::class_<ActionBlockSyntax, SyntaxNode>(m, "ActionBlockSyntax")
        .def_readwrite("statement", &ActionBlockSyntax::statement)
        .def_readwrite("elseClause", &ActionBlockSyntax::elseClause);

    py::class_<ImmediateAssertionStatementSyntax, StatementSyntax>(m, "ImmediateAssertionStatementSyntax")
        .def_readwrite("keyword", &ImmediateAssertionStatementSyntax::keyword)
        .def_readwrite("delay", &ImmediateAssertionStatementSyntax::delay)
        .def_readwrite("expr", &ImmediateAssertionStatementSyntax::expr)
        .def_readwrite("action", &ImmediateAssertionStatementSyntax::action);

    py::class_<DisableIffSyntax, SyntaxNode>(m, "DisableIffSyntax")
        .def_readwrite("disable", &DisableIffSyntax::disable)
        .def_readwrite("iff", &DisableIffSyntax::iff)
        .def_readwrite("openParen", &DisableIffSyntax::openParen)
        .def_readwrite("expr", &DisableIffSyntax::expr)
        .def_readwrite("closeParen", &DisableIffSyntax::closeParen);

    py::class_<PropertySpecSyntax, SyntaxNode>(m, "PropertySpecSyntax")
        .def_readwrite("clocking", &PropertySpecSyntax::clocking)
        .def_readwrite("disable", &PropertySpecSyntax::disable)
        .def_readwrite("expr", &PropertySpecSyntax::expr);

    py::class_<ConcurrentAssertionStatementSyntax, StatementSyntax>(m, "ConcurrentAssertionStatementSyntax")
        .def_readwrite("keyword", &ConcurrentAssertionStatementSyntax::keyword)
        .def_readwrite("propertyOrSequence", &ConcurrentAssertionStatementSyntax::propertyOrSequence)
        .def_readwrite("openParen", &ConcurrentAssertionStatementSyntax::openParen)
        .def_readwrite("propertySpec", &ConcurrentAssertionStatementSyntax::propertySpec)
        .def_readwrite("closeParen", &ConcurrentAssertionStatementSyntax::closeParen)
        .def_readwrite("action", &ConcurrentAssertionStatementSyntax::action);

    py::class_<ConcurrentAssertionMemberSyntax, MemberSyntax>(m, "ConcurrentAssertionMemberSyntax")
        .def_readwrite("statement", &ConcurrentAssertionMemberSyntax::statement);

    py::class_<ImmediateAssertionMemberSyntax, MemberSyntax>(m, "ImmediateAssertionMemberSyntax")
        .def_readwrite("statement", &ImmediateAssertionMemberSyntax::statement);

    py::class_<EmptyStatementSyntax, StatementSyntax>(m, "EmptyStatementSyntax")
        .def_readwrite("semicolon", &EmptyStatementSyntax::semicolon);

    py::class_<ConditionalStatementSyntax, StatementSyntax>(m, "ConditionalStatementSyntax")
        .def_readwrite("uniqueOrPriority", &ConditionalStatementSyntax::uniqueOrPriority)
        .def_readwrite("ifKeyword", &ConditionalStatementSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalStatementSyntax::openParen)
        .def_readwrite("predicate", &ConditionalStatementSyntax::predicate)
        .def_readwrite("closeParen", &ConditionalStatementSyntax::closeParen)
        .def_readwrite("statement", &ConditionalStatementSyntax::statement)
        .def_readwrite("elseClause", &ConditionalStatementSyntax::elseClause);

    py::class_<CaseItemSyntax, SyntaxNode>(m, "CaseItemSyntax");

    py::class_<DefaultCaseItemSyntax, CaseItemSyntax>(m, "DefaultCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultCaseItemSyntax::colon)
        .def_readwrite("clause", &DefaultCaseItemSyntax::clause);

    py::class_<PatternCaseItemSyntax, CaseItemSyntax>(m, "PatternCaseItemSyntax")
        .def_readwrite("pattern", &PatternCaseItemSyntax::pattern)
        .def_readwrite("tripleAnd", &PatternCaseItemSyntax::tripleAnd)
        .def_readwrite("expr", &PatternCaseItemSyntax::expr)
        .def_readwrite("colon", &PatternCaseItemSyntax::colon)
        .def_readwrite("statement", &PatternCaseItemSyntax::statement);

    py::class_<StandardCaseItemSyntax, CaseItemSyntax>(m, "StandardCaseItemSyntax")
        .def_readwrite("expressions", &StandardCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardCaseItemSyntax::colon)
        .def_readwrite("clause", &StandardCaseItemSyntax::clause);

    py::class_<CaseStatementSyntax, StatementSyntax>(m, "CaseStatementSyntax")
        .def_readwrite("uniqueOrPriority", &CaseStatementSyntax::uniqueOrPriority)
        .def_readwrite("caseKeyword", &CaseStatementSyntax::caseKeyword)
        .def_readwrite("openParen", &CaseStatementSyntax::openParen)
        .def_readwrite("expr", &CaseStatementSyntax::expr)
        .def_readwrite("closeParen", &CaseStatementSyntax::closeParen)
        .def_readwrite("matchesOrInside", &CaseStatementSyntax::matchesOrInside)
        .def_readwrite("items", &CaseStatementSyntax::items)
        .def_readwrite("endcase", &CaseStatementSyntax::endcase);

    py::class_<ForeverStatementSyntax, StatementSyntax>(m, "ForeverStatementSyntax")
        .def_readwrite("foreverKeyword", &ForeverStatementSyntax::foreverKeyword)
        .def_readwrite("statement", &ForeverStatementSyntax::statement);

    py::class_<LoopStatementSyntax, StatementSyntax>(m, "LoopStatementSyntax")
        .def_readwrite("repeatOrWhile", &LoopStatementSyntax::repeatOrWhile)
        .def_readwrite("openParen", &LoopStatementSyntax::openParen)
        .def_readwrite("expr", &LoopStatementSyntax::expr)
        .def_readwrite("closeParen", &LoopStatementSyntax::closeParen)
        .def_readwrite("statement", &LoopStatementSyntax::statement);

    py::class_<DoWhileStatementSyntax, StatementSyntax>(m, "DoWhileStatementSyntax")
        .def_readwrite("doKeyword", &DoWhileStatementSyntax::doKeyword)
        .def_readwrite("statement", &DoWhileStatementSyntax::statement)
        .def_readwrite("whileKeyword", &DoWhileStatementSyntax::whileKeyword)
        .def_readwrite("openParen", &DoWhileStatementSyntax::openParen)
        .def_readwrite("expr", &DoWhileStatementSyntax::expr)
        .def_readwrite("closeParen", &DoWhileStatementSyntax::closeParen)
        .def_readwrite("semi", &DoWhileStatementSyntax::semi);

    py::class_<ForVariableDeclarationSyntax, SyntaxNode>(m, "ForVariableDeclarationSyntax")
        .def_readwrite("varKeyword", &ForVariableDeclarationSyntax::varKeyword)
        .def_readwrite("type", &ForVariableDeclarationSyntax::type)
        .def_readwrite("declarator", &ForVariableDeclarationSyntax::declarator);

    py::class_<ForLoopStatementSyntax, StatementSyntax>(m, "ForLoopStatementSyntax")
        .def_readwrite("forKeyword", &ForLoopStatementSyntax::forKeyword)
        .def_readwrite("openParen", &ForLoopStatementSyntax::openParen)
        .def_readwrite("initializers", &ForLoopStatementSyntax::initializers)
        .def_readwrite("semi1", &ForLoopStatementSyntax::semi1)
        .def_readwrite("stopExpr", &ForLoopStatementSyntax::stopExpr)
        .def_readwrite("semi2", &ForLoopStatementSyntax::semi2)
        .def_readwrite("steps", &ForLoopStatementSyntax::steps)
        .def_readwrite("closeParen", &ForLoopStatementSyntax::closeParen)
        .def_readwrite("statement", &ForLoopStatementSyntax::statement);

    py::class_<ForeachLoopListSyntax, SyntaxNode>(m, "ForeachLoopListSyntax")
        .def_readwrite("openParen", &ForeachLoopListSyntax::openParen)
        .def_readwrite("arrayName", &ForeachLoopListSyntax::arrayName)
        .def_readwrite("openBracket", &ForeachLoopListSyntax::openBracket)
        .def_readwrite("loopVariables", &ForeachLoopListSyntax::loopVariables)
        .def_readwrite("closeBracket", &ForeachLoopListSyntax::closeBracket)
        .def_readwrite("closeParen", &ForeachLoopListSyntax::closeParen);

    py::class_<ForeachLoopStatementSyntax, StatementSyntax>(m, "ForeachLoopStatementSyntax")
        .def_readwrite("keyword", &ForeachLoopStatementSyntax::keyword)
        .def_readwrite("loopList", &ForeachLoopStatementSyntax::loopList)
        .def_readwrite("statement", &ForeachLoopStatementSyntax::statement);

    py::class_<ReturnStatementSyntax, StatementSyntax>(m, "ReturnStatementSyntax")
        .def_readwrite("returnKeyword", &ReturnStatementSyntax::returnKeyword)
        .def_readwrite("returnValue", &ReturnStatementSyntax::returnValue)
        .def_readwrite("semi", &ReturnStatementSyntax::semi);

    py::class_<JumpStatementSyntax, StatementSyntax>(m, "JumpStatementSyntax")
        .def_readwrite("breakOrContinue", &JumpStatementSyntax::breakOrContinue)
        .def_readwrite("semi", &JumpStatementSyntax::semi);

    py::class_<TimingControlStatementSyntax, StatementSyntax>(m, "TimingControlStatementSyntax")
        .def_readwrite("timingControl", &TimingControlStatementSyntax::timingControl)
        .def_readwrite("statement", &TimingControlStatementSyntax::statement);

    py::class_<ExpressionStatementSyntax, StatementSyntax>(m, "ExpressionStatementSyntax")
        .def_readwrite("expr", &ExpressionStatementSyntax::expr)
        .def_readwrite("semi", &ExpressionStatementSyntax::semi);

    py::class_<VoidCastedCallStatementSyntax, StatementSyntax>(m, "VoidCastedCallStatementSyntax")
        .def_readwrite("voidKeyword", &VoidCastedCallStatementSyntax::voidKeyword)
        .def_readwrite("apostrophe", &VoidCastedCallStatementSyntax::apostrophe)
        .def_readwrite("openParen", &VoidCastedCallStatementSyntax::openParen)
        .def_readwrite("expr", &VoidCastedCallStatementSyntax::expr)
        .def_readwrite("closeParen", &VoidCastedCallStatementSyntax::closeParen)
        .def_readwrite("semi", &VoidCastedCallStatementSyntax::semi);

    py::class_<ProceduralAssignStatementSyntax, StatementSyntax>(m, "ProceduralAssignStatementSyntax")
        .def_readwrite("keyword", &ProceduralAssignStatementSyntax::keyword)
        .def_readwrite("expr", &ProceduralAssignStatementSyntax::expr)
        .def_readwrite("semi", &ProceduralAssignStatementSyntax::semi);

    py::class_<ProceduralDeassignStatementSyntax, StatementSyntax>(m, "ProceduralDeassignStatementSyntax")
        .def_readwrite("keyword", &ProceduralDeassignStatementSyntax::keyword)
        .def_readwrite("variable", &ProceduralDeassignStatementSyntax::variable)
        .def_readwrite("semi", &ProceduralDeassignStatementSyntax::semi);

    py::class_<DisableStatementSyntax, StatementSyntax>(m, "DisableStatementSyntax")
        .def_readwrite("disable", &DisableStatementSyntax::disable)
        .def_readwrite("name", &DisableStatementSyntax::name)
        .def_readwrite("semi", &DisableStatementSyntax::semi);

    py::class_<DisableForkStatementSyntax, StatementSyntax>(m, "DisableForkStatementSyntax")
        .def_readwrite("disable", &DisableForkStatementSyntax::disable)
        .def_readwrite("fork", &DisableForkStatementSyntax::fork)
        .def_readwrite("semi", &DisableForkStatementSyntax::semi);

    py::class_<NamedBlockClauseSyntax, SyntaxNode>(m, "NamedBlockClauseSyntax")
        .def_readwrite("colon", &NamedBlockClauseSyntax::colon)
        .def_readwrite("name", &NamedBlockClauseSyntax::name);

    py::class_<BlockStatementSyntax, StatementSyntax>(m, "BlockStatementSyntax")
        .def_readwrite("begin", &BlockStatementSyntax::begin)
        .def_readwrite("blockName", &BlockStatementSyntax::blockName)
        .def_readwrite("items", &BlockStatementSyntax::items)
        .def_readwrite("end", &BlockStatementSyntax::end)
        .def_readwrite("endBlockName", &BlockStatementSyntax::endBlockName);

    py::class_<WaitStatementSyntax, StatementSyntax>(m, "WaitStatementSyntax")
        .def_readwrite("wait", &WaitStatementSyntax::wait)
        .def_readwrite("openParen", &WaitStatementSyntax::openParen)
        .def_readwrite("expr", &WaitStatementSyntax::expr)
        .def_readwrite("closeParen", &WaitStatementSyntax::closeParen)
        .def_readwrite("statement", &WaitStatementSyntax::statement);

    py::class_<WaitForkStatementSyntax, StatementSyntax>(m, "WaitForkStatementSyntax")
        .def_readwrite("wait", &WaitForkStatementSyntax::wait)
        .def_readwrite("fork", &WaitForkStatementSyntax::fork)
        .def_readwrite("semi", &WaitForkStatementSyntax::semi);

    py::class_<WaitOrderStatementSyntax, StatementSyntax>(m, "WaitOrderStatementSyntax")
        .def_readwrite("wait_order", &WaitOrderStatementSyntax::wait_order)
        .def_readwrite("openParen", &WaitOrderStatementSyntax::openParen)
        .def_readwrite("names", &WaitOrderStatementSyntax::names)
        .def_readwrite("closeParen", &WaitOrderStatementSyntax::closeParen)
        .def_readwrite("action", &WaitOrderStatementSyntax::action);

    py::class_<RandCaseItemSyntax, SyntaxNode>(m, "RandCaseItemSyntax")
        .def_readwrite("expr", &RandCaseItemSyntax::expr)
        .def_readwrite("colon", &RandCaseItemSyntax::colon)
        .def_readwrite("statement", &RandCaseItemSyntax::statement);

    py::class_<RandCaseStatementSyntax, StatementSyntax>(m, "RandCaseStatementSyntax")
        .def_readwrite("randCase", &RandCaseStatementSyntax::randCase)
        .def_readwrite("items", &RandCaseStatementSyntax::items)
        .def_readwrite("endCase", &RandCaseStatementSyntax::endCase);

    py::class_<RsProdSyntax, SyntaxNode>(m, "RsProdSyntax");

    py::class_<RsProdItemSyntax, RsProdSyntax>(m, "RsProdItemSyntax")
        .def_readwrite("name", &RsProdItemSyntax::name)
        .def_readwrite("argList", &RsProdItemSyntax::argList);

    py::class_<RsCodeBlockSyntax, RsProdSyntax>(m, "RsCodeBlockSyntax")
        .def_readwrite("openBrace", &RsCodeBlockSyntax::openBrace)
        .def_readwrite("items", &RsCodeBlockSyntax::items)
        .def_readwrite("closeBrace", &RsCodeBlockSyntax::closeBrace);

    py::class_<RsElseClauseSyntax, SyntaxNode>(m, "RsElseClauseSyntax")
        .def_readwrite("keyword", &RsElseClauseSyntax::keyword)
        .def_readwrite("item", &RsElseClauseSyntax::item);

    py::class_<RsIfElseSyntax, RsProdSyntax>(m, "RsIfElseSyntax")
        .def_readwrite("keyword", &RsIfElseSyntax::keyword)
        .def_readwrite("openParen", &RsIfElseSyntax::openParen)
        .def_readwrite("condition", &RsIfElseSyntax::condition)
        .def_readwrite("closeParen", &RsIfElseSyntax::closeParen)
        .def_readwrite("ifItem", &RsIfElseSyntax::ifItem)
        .def_readwrite("elseClause", &RsIfElseSyntax::elseClause);

    py::class_<RsRepeatSyntax, RsProdSyntax>(m, "RsRepeatSyntax")
        .def_readwrite("keyword", &RsRepeatSyntax::keyword)
        .def_readwrite("openParen", &RsRepeatSyntax::openParen)
        .def_readwrite("expr", &RsRepeatSyntax::expr)
        .def_readwrite("closeParen", &RsRepeatSyntax::closeParen)
        .def_readwrite("item", &RsRepeatSyntax::item);

    py::class_<RsCaseItemSyntax, SyntaxNode>(m, "RsCaseItemSyntax");

    py::class_<DefaultRsCaseItemSyntax, RsCaseItemSyntax>(m, "DefaultRsCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultRsCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultRsCaseItemSyntax::colon)
        .def_readwrite("item", &DefaultRsCaseItemSyntax::item)
        .def_readwrite("semi", &DefaultRsCaseItemSyntax::semi);

    py::class_<StandardRsCaseItemSyntax, RsCaseItemSyntax>(m, "StandardRsCaseItemSyntax")
        .def_readwrite("expressions", &StandardRsCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardRsCaseItemSyntax::colon)
        .def_readwrite("item", &StandardRsCaseItemSyntax::item)
        .def_readwrite("semi", &StandardRsCaseItemSyntax::semi);

    py::class_<RsCaseSyntax, RsProdSyntax>(m, "RsCaseSyntax")
        .def_readwrite("keyword", &RsCaseSyntax::keyword)
        .def_readwrite("openParen", &RsCaseSyntax::openParen)
        .def_readwrite("expr", &RsCaseSyntax::expr)
        .def_readwrite("closeParen", &RsCaseSyntax::closeParen)
        .def_readwrite("items", &RsCaseSyntax::items)
        .def_readwrite("endcase", &RsCaseSyntax::endcase);

    py::class_<RandJoinClauseSyntax, SyntaxNode>(m, "RandJoinClauseSyntax")
        .def_readwrite("rand", &RandJoinClauseSyntax::rand)
        .def_readwrite("join", &RandJoinClauseSyntax::join)
        .def_readwrite("expr", &RandJoinClauseSyntax::expr);

    py::class_<RsWeightClauseSyntax, SyntaxNode>(m, "RsWeightClauseSyntax")
        .def_readwrite("colonEqual", &RsWeightClauseSyntax::colonEqual)
        .def_readwrite("weight", &RsWeightClauseSyntax::weight)
        .def_readwrite("codeBlock", &RsWeightClauseSyntax::codeBlock);

    py::class_<RsRuleSyntax, SyntaxNode>(m, "RsRuleSyntax")
        .def_readwrite("randJoin", &RsRuleSyntax::randJoin)
        .def_readwrite("prods", &RsRuleSyntax::prods)
        .def_readwrite("weightClause", &RsRuleSyntax::weightClause);

    py::class_<ProductionSyntax, SyntaxNode>(m, "ProductionSyntax")
        .def_readwrite("dataType", &ProductionSyntax::dataType)
        .def_readwrite("name", &ProductionSyntax::name)
        .def_readwrite("portList", &ProductionSyntax::portList)
        .def_readwrite("colon", &ProductionSyntax::colon)
        .def_readwrite("rules", &ProductionSyntax::rules)
        .def_readwrite("semi", &ProductionSyntax::semi);

    py::class_<RandSequenceStatementSyntax, StatementSyntax>(m, "RandSequenceStatementSyntax")
        .def_readwrite("randsequence", &RandSequenceStatementSyntax::randsequence)
        .def_readwrite("openParen", &RandSequenceStatementSyntax::openParen)
        .def_readwrite("firstProduction", &RandSequenceStatementSyntax::firstProduction)
        .def_readwrite("closeParen", &RandSequenceStatementSyntax::closeParen)
        .def_readwrite("productions", &RandSequenceStatementSyntax::productions)
        .def_readwrite("endsequence", &RandSequenceStatementSyntax::endsequence);

    py::class_<EventTriggerStatementSyntax, StatementSyntax>(m, "EventTriggerStatementSyntax")
        .def_readwrite("trigger", &EventTriggerStatementSyntax::trigger)
        .def_readwrite("timing", &EventTriggerStatementSyntax::timing)
        .def_readwrite("name", &EventTriggerStatementSyntax::name)
        .def_readwrite("semi", &EventTriggerStatementSyntax::semi);

    py::class_<PortListSyntax, SyntaxNode>(m, "PortListSyntax");

    py::class_<NonAnsiPortSyntax, SyntaxNode>(m, "NonAnsiPortSyntax");

    py::class_<PortExpressionSyntax, SyntaxNode>(m, "PortExpressionSyntax");

    py::class_<PortReferenceSyntax, PortExpressionSyntax>(m, "PortReferenceSyntax")
        .def_readwrite("name", &PortReferenceSyntax::name)
        .def_readwrite("select", &PortReferenceSyntax::select);

    py::class_<PortConcatenationSyntax, PortExpressionSyntax>(m, "PortConcatenationSyntax")
        .def_readwrite("openBrace", &PortConcatenationSyntax::openBrace)
        .def_readwrite("references", &PortConcatenationSyntax::references)
        .def_readwrite("closeBrace", &PortConcatenationSyntax::closeBrace);

    py::class_<EmptyNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "EmptyNonAnsiPortSyntax")
        .def_readwrite("placeholder", &EmptyNonAnsiPortSyntax::placeholder);

    py::class_<ImplicitNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "ImplicitNonAnsiPortSyntax")
        .def_readwrite("expr", &ImplicitNonAnsiPortSyntax::expr);

    py::class_<ExplicitNonAnsiPortSyntax, NonAnsiPortSyntax>(m, "ExplicitNonAnsiPortSyntax")
        .def_readwrite("dot", &ExplicitNonAnsiPortSyntax::dot)
        .def_readwrite("name", &ExplicitNonAnsiPortSyntax::name)
        .def_readwrite("openParen", &ExplicitNonAnsiPortSyntax::openParen)
        .def_readwrite("expr", &ExplicitNonAnsiPortSyntax::expr)
        .def_readwrite("closeParen", &ExplicitNonAnsiPortSyntax::closeParen);

    py::class_<NonAnsiPortListSyntax, PortListSyntax>(m, "NonAnsiPortListSyntax")
        .def_readwrite("openParen", &NonAnsiPortListSyntax::openParen)
        .def_readwrite("ports", &NonAnsiPortListSyntax::ports)
        .def_readwrite("closeParen", &NonAnsiPortListSyntax::closeParen);

    py::class_<InterfacePortHeaderSyntax, PortHeaderSyntax>(m, "InterfacePortHeaderSyntax")
        .def_readwrite("nameOrKeyword", &InterfacePortHeaderSyntax::nameOrKeyword)
        .def_readwrite("modport", &InterfacePortHeaderSyntax::modport);

    py::class_<VariablePortHeaderSyntax, PortHeaderSyntax>(m, "VariablePortHeaderSyntax")
        .def_readwrite("constKeyword", &VariablePortHeaderSyntax::constKeyword)
        .def_readwrite("direction", &VariablePortHeaderSyntax::direction)
        .def_readwrite("varKeyword", &VariablePortHeaderSyntax::varKeyword)
        .def_readwrite("dataType", &VariablePortHeaderSyntax::dataType);

    py::class_<NetPortHeaderSyntax, PortHeaderSyntax>(m, "NetPortHeaderSyntax")
        .def_readwrite("direction", &NetPortHeaderSyntax::direction)
        .def_readwrite("netType", &NetPortHeaderSyntax::netType)
        .def_readwrite("dataType", &NetPortHeaderSyntax::dataType);

    py::class_<ImplicitAnsiPortSyntax, MemberSyntax>(m, "ImplicitAnsiPortSyntax")
        .def_readwrite("header", &ImplicitAnsiPortSyntax::header)
        .def_readwrite("declarator", &ImplicitAnsiPortSyntax::declarator);

    py::class_<ExplicitAnsiPortSyntax, MemberSyntax>(m, "ExplicitAnsiPortSyntax")
        .def_readwrite("direction", &ExplicitAnsiPortSyntax::direction)
        .def_readwrite("dot", &ExplicitAnsiPortSyntax::dot)
        .def_readwrite("name", &ExplicitAnsiPortSyntax::name)
        .def_readwrite("openParen", &ExplicitAnsiPortSyntax::openParen)
        .def_readwrite("expr", &ExplicitAnsiPortSyntax::expr)
        .def_readwrite("closeParen", &ExplicitAnsiPortSyntax::closeParen);

    py::class_<AnsiPortListSyntax, PortListSyntax>(m, "AnsiPortListSyntax")
        .def_readwrite("openParen", &AnsiPortListSyntax::openParen)
        .def_readwrite("ports", &AnsiPortListSyntax::ports)
        .def_readwrite("closeParen", &AnsiPortListSyntax::closeParen);

    py::class_<WildcardPortListSyntax, PortListSyntax>(m, "WildcardPortListSyntax")
        .def_readwrite("openParen", &WildcardPortListSyntax::openParen)
        .def_readwrite("dot", &WildcardPortListSyntax::dot)
        .def_readwrite("star", &WildcardPortListSyntax::star)
        .def_readwrite("closeParen", &WildcardPortListSyntax::closeParen);

    py::class_<ParameterPortListSyntax, SyntaxNode>(m, "ParameterPortListSyntax")
        .def_readwrite("hash", &ParameterPortListSyntax::hash)
        .def_readwrite("openParen", &ParameterPortListSyntax::openParen)
        .def_readwrite("declarations", &ParameterPortListSyntax::declarations)
        .def_readwrite("closeParen", &ParameterPortListSyntax::closeParen);

    py::class_<ModuleHeaderSyntax, SyntaxNode>(m, "ModuleHeaderSyntax")
        .def_readwrite("moduleKeyword", &ModuleHeaderSyntax::moduleKeyword)
        .def_readwrite("lifetime", &ModuleHeaderSyntax::lifetime)
        .def_readwrite("name", &ModuleHeaderSyntax::name)
        .def_readwrite("imports", &ModuleHeaderSyntax::imports)
        .def_readwrite("parameters", &ModuleHeaderSyntax::parameters)
        .def_readwrite("ports", &ModuleHeaderSyntax::ports)
        .def_readwrite("semi", &ModuleHeaderSyntax::semi);

    py::class_<ModuleDeclarationSyntax, MemberSyntax>(m, "ModuleDeclarationSyntax")
        .def_readwrite("header", &ModuleDeclarationSyntax::header)
        .def_readwrite("members", &ModuleDeclarationSyntax::members)
        .def_readwrite("endmodule", &ModuleDeclarationSyntax::endmodule)
        .def_readwrite("blockName", &ModuleDeclarationSyntax::blockName);

    py::class_<AnonymousProgramSyntax, MemberSyntax>(m, "AnonymousProgramSyntax")
        .def_readwrite("keyword", &AnonymousProgramSyntax::keyword)
        .def_readwrite("semi", &AnonymousProgramSyntax::semi)
        .def_readwrite("members", &AnonymousProgramSyntax::members)
        .def_readwrite("endkeyword", &AnonymousProgramSyntax::endkeyword);

    py::class_<EmptyMemberSyntax, MemberSyntax>(m, "EmptyMemberSyntax")
        .def_readwrite("qualifiers", &EmptyMemberSyntax::qualifiers)
        .def_readwrite("semi", &EmptyMemberSyntax::semi);

    py::class_<ProceduralBlockSyntax, MemberSyntax>(m, "ProceduralBlockSyntax")
        .def_readwrite("keyword", &ProceduralBlockSyntax::keyword)
        .def_readwrite("statement", &ProceduralBlockSyntax::statement);

    py::class_<GenerateRegionSyntax, MemberSyntax>(m, "GenerateRegionSyntax")
        .def_readwrite("keyword", &GenerateRegionSyntax::keyword)
        .def_readwrite("members", &GenerateRegionSyntax::members)
        .def_readwrite("endgenerate", &GenerateRegionSyntax::endgenerate);

}
