//------------------------------------------------------------------------------
//! @file ParserDiags.h
//! @brief Generated diagnostic enums for the Parser subsystem
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#pragma once

#include "slang/diagnostics/Diagnostics.h"

namespace slang::diag {

inline constexpr DiagCode AssertionPortDirNoLocal(DiagSubsystem::Parser, 0);
inline constexpr DiagCode AssertionPortPropOutput(DiagSubsystem::Parser, 1);
inline constexpr DiagCode AssertionPortRef(DiagSubsystem::Parser, 2);
inline constexpr DiagCode BindDirectiveInvalidName(DiagSubsystem::Parser, 3);
inline constexpr DiagCode CaseGenerateEmpty(DiagSubsystem::Parser, 4);
inline constexpr DiagCode CaseStatementEmpty(DiagSubsystem::Parser, 5);
inline constexpr DiagCode ChargeWithTriReg(DiagSubsystem::Parser, 6);
inline constexpr DiagCode CheckerPortInout(DiagSubsystem::Parser, 7);
inline constexpr DiagCode ClassSpecifierConflict(DiagSubsystem::Parser, 8);
inline constexpr DiagCode ClockingNameEmpty(DiagSubsystem::Parser, 9);
inline constexpr DiagCode ConfigMissingName(DiagSubsystem::Parser, 10);
inline constexpr DiagCode ConfigParamLiteral(DiagSubsystem::Parser, 11);
inline constexpr DiagCode ConfigParamsOrdered(DiagSubsystem::Parser, 12);
inline constexpr DiagCode ConfigSpecificCellLiblist(DiagSubsystem::Parser, 13);
inline constexpr DiagCode ConstFunctionPortRequiresRef(DiagSubsystem::Parser, 14);
inline constexpr DiagCode ConstraintQualOutOfBlock(DiagSubsystem::Parser, 15);
inline constexpr DiagCode ConstructorOutsideClass(DiagSubsystem::Parser, 16);
inline constexpr DiagCode ConstructorReturnType(DiagSubsystem::Parser, 17);
inline constexpr DiagCode CoverCrossItems(DiagSubsystem::Parser, 18);
inline constexpr DiagCode CoverageBinDefSeqSize(DiagSubsystem::Parser, 19);
inline constexpr DiagCode CoverageBinDefaultIgnore(DiagSubsystem::Parser, 20);
inline constexpr DiagCode CoverageBinDefaultWildcard(DiagSubsystem::Parser, 21);
inline constexpr DiagCode CoverageBinTransSize(DiagSubsystem::Parser, 22);
inline constexpr DiagCode DeclModifierConflict(DiagSubsystem::Parser, 23);
inline constexpr DiagCode DeclModifierOrdering(DiagSubsystem::Parser, 24);
inline constexpr DiagCode DeclarationsAtStart(DiagSubsystem::Parser, 25);
inline constexpr DiagCode DefaultArgNotAllowed(DiagSubsystem::Parser, 26);
inline constexpr DiagCode DeferredDelayMustBeZero(DiagSubsystem::Parser, 27);
inline constexpr DiagCode Delay3NotAllowed(DiagSubsystem::Parser, 28);
inline constexpr DiagCode Delay3UdpNotAllowed(DiagSubsystem::Parser, 29);
inline constexpr DiagCode DelaysNotAllowed(DiagSubsystem::Parser, 30);
inline constexpr DiagCode DerivedCovergroupNoBase(DiagSubsystem::Parser, 31);
inline constexpr DiagCode DerivedCovergroupNotInClass(DiagSubsystem::Parser, 32);
inline constexpr DiagCode DirectionOnInterfacePort(DiagSubsystem::Parser, 33);
inline constexpr DiagCode DriveStrengthHighZ(DiagSubsystem::Parser, 34);
inline constexpr DiagCode DriveStrengthInvalid(DiagSubsystem::Parser, 35);
inline constexpr DiagCode DriveStrengthNotAllowed(DiagSubsystem::Parser, 36);
inline constexpr DiagCode DuplicateClassSpecifier(DiagSubsystem::Parser, 37);
inline constexpr DiagCode DuplicateDeclModifier(DiagSubsystem::Parser, 38);
inline constexpr DiagCode DuplicateQualifier(DiagSubsystem::Parser, 39);
inline constexpr DiagCode EdgeDescWrongKeyword(DiagSubsystem::Parser, 40);
inline constexpr DiagCode EndNameMismatch(DiagSubsystem::Parser, 41);
inline constexpr DiagCode EndNameNotEmpty(DiagSubsystem::Parser, 42);
inline constexpr DiagCode ExpectedAnsiPort(DiagSubsystem::Parser, 43);
inline constexpr DiagCode ExpectedArgument(DiagSubsystem::Parser, 44);
inline constexpr DiagCode ExpectedAssertionItemPort(DiagSubsystem::Parser, 45);
inline constexpr DiagCode ExpectedAssignmentKey(DiagSubsystem::Parser, 46);
inline constexpr DiagCode ExpectedAttribute(DiagSubsystem::Parser, 47);
inline constexpr DiagCode ExpectedCaseItem(DiagSubsystem::Parser, 48);
inline constexpr DiagCode ExpectedClassSpecifier(DiagSubsystem::Parser, 49);
inline constexpr DiagCode ExpectedClockingSkew(DiagSubsystem::Parser, 50);
inline constexpr DiagCode ExpectedConditionalPattern(DiagSubsystem::Parser, 51);
inline constexpr DiagCode ExpectedConstraintName(DiagSubsystem::Parser, 52);
inline constexpr DiagCode ExpectedContinuousAssignment(DiagSubsystem::Parser, 53);
inline constexpr DiagCode ExpectedDPISpecString(DiagSubsystem::Parser, 54);
inline constexpr DiagCode ExpectedDeclarator(DiagSubsystem::Parser, 55);
inline constexpr DiagCode ExpectedDistItem(DiagSubsystem::Parser, 56);
inline constexpr DiagCode ExpectedEdgeDescriptor(DiagSubsystem::Parser, 57);
inline constexpr DiagCode ExpectedEnumBase(DiagSubsystem::Parser, 58);
inline constexpr DiagCode ExpectedForInitializer(DiagSubsystem::Parser, 59);
inline constexpr DiagCode ExpectedFunctionPort(DiagSubsystem::Parser, 60);
inline constexpr DiagCode ExpectedFunctionPortList(DiagSubsystem::Parser, 61);
inline constexpr DiagCode ExpectedGenvarIterVar(DiagSubsystem::Parser, 62);
inline constexpr DiagCode ExpectedHierarchicalInstantiation(DiagSubsystem::Parser, 63);
inline constexpr DiagCode ExpectedIdentifier(DiagSubsystem::Parser, 64);
inline constexpr DiagCode ExpectedIfOrCase(DiagSubsystem::Parser, 65);
inline constexpr DiagCode ExpectedIntegerLiteral(DiagSubsystem::Parser, 66);
inline constexpr DiagCode ExpectedInterfaceClassName(DiagSubsystem::Parser, 67);
inline constexpr DiagCode ExpectedMember(DiagSubsystem::Parser, 68);
inline constexpr DiagCode ExpectedModportPort(DiagSubsystem::Parser, 69);
inline constexpr DiagCode ExpectedNetStrength(DiagSubsystem::Parser, 70);
inline constexpr DiagCode ExpectedNonAnsiPort(DiagSubsystem::Parser, 71);
inline constexpr DiagCode ExpectedPackageImport(DiagSubsystem::Parser, 72);
inline constexpr DiagCode ExpectedParameterPort(DiagSubsystem::Parser, 73);
inline constexpr DiagCode ExpectedPathOp(DiagSubsystem::Parser, 74);
inline constexpr DiagCode ExpectedPattern(DiagSubsystem::Parser, 75);
inline constexpr DiagCode ExpectedPortConnection(DiagSubsystem::Parser, 76);
inline constexpr DiagCode ExpectedPortList(DiagSubsystem::Parser, 77);
inline constexpr DiagCode ExpectedRsRule(DiagSubsystem::Parser, 78);
inline constexpr DiagCode ExpectedSampleKeyword(DiagSubsystem::Parser, 79);
inline constexpr DiagCode ExpectedStatement(DiagSubsystem::Parser, 80);
inline constexpr DiagCode ExpectedStreamExpression(DiagSubsystem::Parser, 81);
inline constexpr DiagCode ExpectedStringLiteral(DiagSubsystem::Parser, 82);
inline constexpr DiagCode ExpectedSubroutineName(DiagSubsystem::Parser, 83);
inline constexpr DiagCode ExpectedToken(DiagSubsystem::Parser, 84);
inline constexpr DiagCode ExpectedUdpPort(DiagSubsystem::Parser, 85);
inline constexpr DiagCode ExpectedUdpSymbol(DiagSubsystem::Parser, 86);
inline constexpr DiagCode ExpectedValueRangeElement(DiagSubsystem::Parser, 87);
inline constexpr DiagCode ExpectedVariableAssignment(DiagSubsystem::Parser, 88);
inline constexpr DiagCode ExternWildcardPortList(DiagSubsystem::Parser, 89);
inline constexpr DiagCode FinalSpecifierLast(DiagSubsystem::Parser, 90);
inline constexpr DiagCode FinalWithPure(DiagSubsystem::Parser, 91);
inline constexpr DiagCode GlobalClockingEmpty(DiagSubsystem::Parser, 92);
inline constexpr DiagCode IfNoneEdgeSensitive(DiagSubsystem::Parser, 93);
inline constexpr DiagCode IfaceMethodPure(DiagSubsystem::Parser, 94);
inline constexpr DiagCode ImplicitNotAllowed(DiagSubsystem::Parser, 95);
inline constexpr DiagCode InOutDefaultSkew(DiagSubsystem::Parser, 96);
inline constexpr DiagCode InitializerRequired(DiagSubsystem::Parser, 97);
inline constexpr DiagCode InterconnectDelaySyntax(DiagSubsystem::Parser, 98);
inline constexpr DiagCode InterconnectInitializer(DiagSubsystem::Parser, 99);
inline constexpr DiagCode InterconnectTypeSyntax(DiagSubsystem::Parser, 100);
inline constexpr DiagCode InvalidAccessDotColon(DiagSubsystem::Parser, 101);
inline constexpr DiagCode InvalidConstraintQualifier(DiagSubsystem::Parser, 102);
inline constexpr DiagCode InvalidCoverageOption(DiagSubsystem::Parser, 103);
inline constexpr DiagCode InvalidDelayValue(DiagSubsystem::Parser, 104);
inline constexpr DiagCode InvalidDistExpression(DiagSubsystem::Parser, 105);
inline constexpr DiagCode InvalidEdgeDescriptor(DiagSubsystem::Parser, 106);
inline constexpr DiagCode InvalidForInitializer(DiagSubsystem::Parser, 107);
inline constexpr DiagCode InvalidGenvarIterExpression(DiagSubsystem::Parser, 108);
inline constexpr DiagCode InvalidMethodQualifier(DiagSubsystem::Parser, 109);
inline constexpr DiagCode InvalidPackageDecl(DiagSubsystem::Parser, 110);
inline constexpr DiagCode InvalidPropertyIndex(DiagSubsystem::Parser, 111);
inline constexpr DiagCode InvalidPropertyQualifier(DiagSubsystem::Parser, 112);
inline constexpr DiagCode InvalidPropertyRange(DiagSubsystem::Parser, 113);
inline constexpr DiagCode InvalidPullStrength(DiagSubsystem::Parser, 114);
inline constexpr DiagCode InvalidQualifierForConstructor(DiagSubsystem::Parser, 115);
inline constexpr DiagCode InvalidQualifierForIfaceMember(DiagSubsystem::Parser, 116);
inline constexpr DiagCode InvalidQualifierForMember(DiagSubsystem::Parser, 117);
inline constexpr DiagCode InvalidRepeatRange(DiagSubsystem::Parser, 118);
inline constexpr DiagCode InvalidSelectExpression(DiagSubsystem::Parser, 119);
inline constexpr DiagCode InvalidSuperNew(DiagSubsystem::Parser, 120);
inline constexpr DiagCode LabelAndName(DiagSubsystem::Parser, 121);
inline constexpr DiagCode MethodStaticLifetime(DiagSubsystem::Parser, 122);
inline constexpr DiagCode MisplacedTrailingSeparator(DiagSubsystem::Parser, 123);
inline constexpr DiagCode MissingModportPortDirection(DiagSubsystem::Parser, 124);
inline constexpr DiagCode MultipleDefaultCases(DiagSubsystem::Parser, 125);
inline constexpr DiagCode MultipleDefaultRules(DiagSubsystem::Parser, 126);
inline constexpr DiagCode MultipleGenerateDefaultCases(DiagSubsystem::Parser, 127);
inline constexpr DiagCode MultipleParallelTerminals(DiagSubsystem::Parser, 128);
inline constexpr DiagCode NestedIface(DiagSubsystem::Parser, 129);
inline constexpr DiagCode NewKeywordQualified(DiagSubsystem::Parser, 130);
inline constexpr DiagCode NoCommaInList(DiagSubsystem::Parser, 131);
inline constexpr DiagCode NoLabelOnSemicolon(DiagSubsystem::Parser, 132);
inline constexpr DiagCode NotAllowedInAnonymousProgram(DiagSubsystem::Parser, 133);
inline constexpr DiagCode NotAllowedInCU(DiagSubsystem::Parser, 134);
inline constexpr DiagCode NotAllowedInChecker(DiagSubsystem::Parser, 135);
inline constexpr DiagCode NotAllowedInClass(DiagSubsystem::Parser, 136);
inline constexpr DiagCode NotAllowedInClocking(DiagSubsystem::Parser, 137);
inline constexpr DiagCode NotAllowedInGenerate(DiagSubsystem::Parser, 138);
inline constexpr DiagCode NotAllowedInIfaceClass(DiagSubsystem::Parser, 139);
inline constexpr DiagCode NotAllowedInInterface(DiagSubsystem::Parser, 140);
inline constexpr DiagCode NotAllowedInModule(DiagSubsystem::Parser, 141);
inline constexpr DiagCode NotAllowedInPackage(DiagSubsystem::Parser, 142);
inline constexpr DiagCode NotAllowedInProgram(DiagSubsystem::Parser, 143);
inline constexpr DiagCode OverridingExtends(DiagSubsystem::Parser, 144);
inline constexpr DiagCode PackedDimsOnUnpacked(DiagSubsystem::Parser, 145);
inline constexpr DiagCode ParseTreeTooDeep(DiagSubsystem::Parser, 146);
inline constexpr DiagCode PullStrengthHighZ(DiagSubsystem::Parser, 147);
inline constexpr DiagCode PulseControlPATHPULSE(DiagSubsystem::Parser, 148);
inline constexpr DiagCode PulseControlSpecifyParent(DiagSubsystem::Parser, 149);
inline constexpr DiagCode PureRequiresVirtual(DiagSubsystem::Parser, 150);
inline constexpr DiagCode QualifierConflict(DiagSubsystem::Parser, 151);
inline constexpr DiagCode QualifierNotFirst(DiagSubsystem::Parser, 152);
inline constexpr DiagCode QualifiersOnOutOfBlock(DiagSubsystem::Parser, 153);
inline constexpr DiagCode RandJoinNotEnough(DiagSubsystem::Parser, 154);
inline constexpr DiagCode RandJoinProdItem(DiagSubsystem::Parser, 155);
inline constexpr DiagCode RandOnPackedMember(DiagSubsystem::Parser, 156);
inline constexpr DiagCode RandOnUnionMember(DiagSubsystem::Parser, 157);
inline constexpr DiagCode RegAfterNettype(DiagSubsystem::Parser, 158);
inline constexpr DiagCode ScopedClassCopy(DiagSubsystem::Parser, 159);
inline constexpr DiagCode SolveBeforeDisallowed(DiagSubsystem::Parser, 160);
inline constexpr DiagCode SpecifiersNotAllowed(DiagSubsystem::Parser, 161);
inline constexpr DiagCode StaticFuncSpecifier(DiagSubsystem::Parser, 162);
inline constexpr DiagCode SubroutinePrototypeScoped(DiagSubsystem::Parser, 163);
inline constexpr DiagCode TaggedStruct(DiagSubsystem::Parser, 164);
inline constexpr DiagCode TaskConstructor(DiagSubsystem::Parser, 165);
inline constexpr DiagCode TaskReturnType(DiagSubsystem::Parser, 166);
inline constexpr DiagCode TooManyEdgeDescriptors(DiagSubsystem::Parser, 167);
inline constexpr DiagCode TypeRefDeclVar(DiagSubsystem::Parser, 168);
inline constexpr DiagCode UdpCombState(DiagSubsystem::Parser, 169);
inline constexpr DiagCode UdpDupTransition(DiagSubsystem::Parser, 170);
inline constexpr DiagCode UdpEdgeInComb(DiagSubsystem::Parser, 171);
inline constexpr DiagCode UdpInvalidEdgeSymbol(DiagSubsystem::Parser, 172);
inline constexpr DiagCode UdpInvalidInputOnly(DiagSubsystem::Parser, 173);
inline constexpr DiagCode UdpInvalidMinus(DiagSubsystem::Parser, 174);
inline constexpr DiagCode UdpInvalidOutput(DiagSubsystem::Parser, 175);
inline constexpr DiagCode UdpInvalidSymbol(DiagSubsystem::Parser, 176);
inline constexpr DiagCode UdpInvalidTransition(DiagSubsystem::Parser, 177);
inline constexpr DiagCode UdpSequentialState(DiagSubsystem::Parser, 178);
inline constexpr DiagCode UdpSingleChar(DiagSubsystem::Parser, 179);
inline constexpr DiagCode UdpTransSameChar(DiagSubsystem::Parser, 180);
inline constexpr DiagCode UdpTransitionLength(DiagSubsystem::Parser, 181);
inline constexpr DiagCode UnexpectedEndDelim(DiagSubsystem::Parser, 182);
inline constexpr DiagCode UnexpectedLetPortKeyword(DiagSubsystem::Parser, 183);
inline constexpr DiagCode UnexpectedQualifiers(DiagSubsystem::Parser, 184);
inline constexpr DiagCode UniquePriorityAfterElse(DiagSubsystem::Parser, 185);
inline constexpr DiagCode UnpackedSigned(DiagSubsystem::Parser, 186);
inline constexpr DiagCode VoidNotAllowed(DiagSubsystem::Parser, 187);
inline constexpr DiagCode WireDataType(DiagSubsystem::Parser, 188);
inline constexpr DiagCode WrongSpecifyDelayCount(DiagSubsystem::Parser, 189);
inline constexpr DiagCode NoteLastBlockEnded(DiagSubsystem::Parser, 190);
inline constexpr DiagCode NoteLastBlockStarted(DiagSubsystem::Parser, 191);
inline constexpr DiagCode NoteToMatchThis(DiagSubsystem::Parser, 192);
inline constexpr DiagCode DPIPureTask(DiagSubsystem::Parser, 193);
inline constexpr DiagCode EmptyAssignmentPattern(DiagSubsystem::Parser, 194);
inline constexpr DiagCode EmptyBody(DiagSubsystem::Parser, 195);
inline constexpr DiagCode LifetimeForPrototype(DiagSubsystem::Parser, 196);
inline constexpr DiagCode NonStandardGenBlock(DiagSubsystem::Parser, 197);
inline constexpr DiagCode NonstandardDist(DiagSubsystem::Parser, 198);
inline constexpr DiagCode NonstandardForeach(DiagSubsystem::Parser, 199);
inline constexpr DiagCode SplitDistWeightOp(DiagSubsystem::Parser, 200);

}
