//------------------------------------------------------------------------------
// AllSyntax.cpp
// All generated syntax node data structures
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "slang/syntax/AllSyntax.h"

#include <type_traits>

// This file contains all parse tree syntax node generated definitions.
// It is auto-generated by the syntax_gen.py script under the scripts/ directory.

namespace slang::syntax {

size_t SyntaxNode::getChildCount() const {
    switch (kind) {
        case SyntaxKind::Unknown: return 0;
        case SyntaxKind::SyntaxList:
        case SyntaxKind::TokenList:
        case SyntaxKind::SeparatedList:
            return ((const SyntaxListBase*)this)->getChildCount();
        case SyntaxKind::AcceptOnPropertyExpr: return 5;
        case SyntaxKind::ActionBlock: return 2;
        case SyntaxKind::AddAssignmentExpression: return 4;
        case SyntaxKind::AddExpression: return 4;
        case SyntaxKind::AlwaysBlock: return 3;
        case SyntaxKind::AlwaysCombBlock: return 3;
        case SyntaxKind::AlwaysFFBlock: return 3;
        case SyntaxKind::AlwaysLatchBlock: return 3;
        case SyntaxKind::AndAssignmentExpression: return 4;
        case SyntaxKind::AndPropertyExpr: return 3;
        case SyntaxKind::AndSequenceExpr: return 3;
        case SyntaxKind::AnonymousProgram: return 5;
        case SyntaxKind::AnsiPortList: return 3;
        case SyntaxKind::AnsiUdpPortList: return 4;
        case SyntaxKind::ArgumentList: return 3;
        case SyntaxKind::ArithmeticLeftShiftAssignmentExpression: return 4;
        case SyntaxKind::ArithmeticRightShiftAssignmentExpression: return 4;
        case SyntaxKind::ArithmeticShiftLeftExpression: return 4;
        case SyntaxKind::ArithmeticShiftRightExpression: return 4;
        case SyntaxKind::ArrayAndMethod: return 1;
        case SyntaxKind::ArrayOrMethod: return 1;
        case SyntaxKind::ArrayOrRandomizeMethodExpression: return 4;
        case SyntaxKind::ArrayUniqueMethod: return 1;
        case SyntaxKind::ArrayXorMethod: return 1;
        case SyntaxKind::AscendingRangeSelect: return 3;
        case SyntaxKind::AssertPropertyStatement: return 8;
        case SyntaxKind::AssertionItemPort: return 7;
        case SyntaxKind::AssertionItemPortList: return 3;
        case SyntaxKind::AssignmentExpression: return 4;
        case SyntaxKind::AssignmentPatternExpression: return 2;
        case SyntaxKind::AssignmentPatternItem: return 3;
        case SyntaxKind::AssumePropertyStatement: return 8;
        case SyntaxKind::AttributeInstance: return 5;
        case SyntaxKind::AttributeSpec: return 2;
        case SyntaxKind::BadExpression: return 1;
        case SyntaxKind::BeginKeywordsDirective: return 2;
        case SyntaxKind::BinSelectWithFilterExpr: return 6;
        case SyntaxKind::BinaryAndExpression: return 4;
        case SyntaxKind::BinaryBinsSelectExpr: return 3;
        case SyntaxKind::BinaryBlockEventExpression: return 3;
        case SyntaxKind::BinaryConditionalDirectiveExpression: return 3;
        case SyntaxKind::BinaryEventExpression: return 3;
        case SyntaxKind::BinaryOrExpression: return 4;
        case SyntaxKind::BinaryXnorExpression: return 4;
        case SyntaxKind::BinaryXorExpression: return 4;
        case SyntaxKind::BindDirective: return 5;
        case SyntaxKind::BindTargetList: return 2;
        case SyntaxKind::BinsSelectConditionExpr: return 5;
        case SyntaxKind::BinsSelection: return 7;
        case SyntaxKind::BitSelect: return 1;
        case SyntaxKind::BitType: return 3;
        case SyntaxKind::BlockCoverageEvent: return 4;
        case SyntaxKind::BlockingEventTriggerStatement: return 6;
        case SyntaxKind::ByteType: return 3;
        case SyntaxKind::CHandleType: return 1;
        case SyntaxKind::CaseEqualityExpression: return 4;
        case SyntaxKind::CaseGenerate: return 7;
        case SyntaxKind::CaseInequalityExpression: return 4;
        case SyntaxKind::CasePropertyExpr: return 6;
        case SyntaxKind::CaseStatement: return 10;
        case SyntaxKind::CastExpression: return 3;
        case SyntaxKind::CellConfigRule: return 4;
        case SyntaxKind::CellDefineDirective: return 1;
        case SyntaxKind::ChargeStrength: return 3;
        case SyntaxKind::CheckerDataDeclaration: return 3;
        case SyntaxKind::CheckerDeclaration: return 8;
        case SyntaxKind::CheckerInstanceStatement: return 3;
        case SyntaxKind::CheckerInstantiation: return 5;
        case SyntaxKind::ClassDeclaration: return 12;
        case SyntaxKind::ClassMethodDeclaration: return 3;
        case SyntaxKind::ClassMethodPrototype: return 4;
        case SyntaxKind::ClassName: return 2;
        case SyntaxKind::ClassPropertyDeclaration: return 3;
        case SyntaxKind::ClassSpecifier: return 2;
        case SyntaxKind::ClockingDeclaration: return 10;
        case SyntaxKind::ClockingDirection: return 4;
        case SyntaxKind::ClockingItem: return 4;
        case SyntaxKind::ClockingPropertyExpr: return 2;
        case SyntaxKind::ClockingSequenceExpr: return 2;
        case SyntaxKind::ClockingSkew: return 2;
        case SyntaxKind::ColonExpressionClause: return 2;
        case SyntaxKind::CompilationUnit: return 2;
        case SyntaxKind::ConcatenationExpression: return 3;
        case SyntaxKind::ConcurrentAssertionMember: return 2;
        case SyntaxKind::ConditionalConstraint: return 6;
        case SyntaxKind::ConditionalExpression: return 6;
        case SyntaxKind::ConditionalPathDeclaration: return 6;
        case SyntaxKind::ConditionalPattern: return 2;
        case SyntaxKind::ConditionalPredicate: return 1;
        case SyntaxKind::ConditionalPropertyExpr: return 6;
        case SyntaxKind::ConditionalStatement: return 9;
        case SyntaxKind::ConfigCellIdentifier: return 3;
        case SyntaxKind::ConfigDeclaration: return 11;
        case SyntaxKind::ConfigInstanceIdentifier: return 2;
        case SyntaxKind::ConfigLiblist: return 2;
        case SyntaxKind::ConfigUseClause: return 5;
        case SyntaxKind::ConstraintBlock: return 3;
        case SyntaxKind::ConstraintDeclaration: return 6;
        case SyntaxKind::ConstraintPrototype: return 6;
        case SyntaxKind::ConstructorName: return 1;
        case SyntaxKind::ContinuousAssign: return 6;
        case SyntaxKind::CopyClassExpression: return 2;
        case SyntaxKind::CoverCross: return 9;
        case SyntaxKind::CoverPropertyStatement: return 8;
        case SyntaxKind::CoverSequenceStatement: return 8;
        case SyntaxKind::CoverageBins: return 9;
        case SyntaxKind::CoverageBinsArraySize: return 3;
        case SyntaxKind::CoverageIffClause: return 4;
        case SyntaxKind::CoverageOption: return 3;
        case SyntaxKind::CovergroupDeclaration: return 10;
        case SyntaxKind::Coverpoint: return 10;
        case SyntaxKind::CycleDelay: return 2;
        case SyntaxKind::DPIExport: return 8;
        case SyntaxKind::DPIImport: return 8;
        case SyntaxKind::DataDeclaration: return 5;
        case SyntaxKind::Declarator: return 3;
        case SyntaxKind::DefParam: return 4;
        case SyntaxKind::DefParamAssignment: return 2;
        case SyntaxKind::DefaultCaseItem: return 3;
        case SyntaxKind::DefaultClockingReference: return 5;
        case SyntaxKind::DefaultConfigRule: return 3;
        case SyntaxKind::DefaultCoverageBinInitializer: return 2;
        case SyntaxKind::DefaultDecayTimeDirective: return 2;
        case SyntaxKind::DefaultDisableDeclaration: return 6;
        case SyntaxKind::DefaultDistItem: return 2;
        case SyntaxKind::DefaultExtendsClauseArg: return 3;
        case SyntaxKind::DefaultFunctionPort: return 1;
        case SyntaxKind::DefaultNetTypeDirective: return 2;
        case SyntaxKind::DefaultPatternKeyExpression: return 1;
        case SyntaxKind::DefaultPropertyCaseItem: return 4;
        case SyntaxKind::DefaultRsCaseItem: return 4;
        case SyntaxKind::DefaultSkewItem: return 4;
        case SyntaxKind::DefaultTriregStrengthDirective: return 2;
        case SyntaxKind::DeferredAssertion: return 3;
        case SyntaxKind::DefineDirective: return 4;
        case SyntaxKind::Delay3: return 8;
        case SyntaxKind::DelayControl: return 2;
        case SyntaxKind::DelayModeDistributedDirective: return 1;
        case SyntaxKind::DelayModePathDirective: return 1;
        case SyntaxKind::DelayModeUnitDirective: return 1;
        case SyntaxKind::DelayModeZeroDirective: return 1;
        case SyntaxKind::DelayedSequenceElement: return 7;
        case SyntaxKind::DelayedSequenceExpr: return 2;
        case SyntaxKind::DescendingRangeSelect: return 3;
        case SyntaxKind::DisableConstraint: return 4;
        case SyntaxKind::DisableForkStatement: return 5;
        case SyntaxKind::DisableIff: return 5;
        case SyntaxKind::DisableStatement: return 5;
        case SyntaxKind::DistConstraintList: return 4;
        case SyntaxKind::DistItem: return 2;
        case SyntaxKind::DistWeight: return 3;
        case SyntaxKind::DivideAssignmentExpression: return 4;
        case SyntaxKind::DivideExpression: return 4;
        case SyntaxKind::DividerClause: return 2;
        case SyntaxKind::DoWhileStatement: return 9;
        case SyntaxKind::DotMemberClause: return 2;
        case SyntaxKind::DriveStrength: return 5;
        case SyntaxKind::EdgeControlSpecifier: return 3;
        case SyntaxKind::EdgeDescriptor: return 2;
        case SyntaxKind::EdgeSensitivePathSuffix: return 6;
        case SyntaxKind::ElabSystemTask: return 4;
        case SyntaxKind::ElementSelect: return 3;
        case SyntaxKind::ElementSelectExpression: return 2;
        case SyntaxKind::ElsIfDirective: return 3;
        case SyntaxKind::ElseClause: return 2;
        case SyntaxKind::ElseConstraintClause: return 2;
        case SyntaxKind::ElseDirective: return 2;
        case SyntaxKind::ElsePropertyClause: return 2;
        case SyntaxKind::EmptyArgument: return 1;
        case SyntaxKind::EmptyIdentifierName: return 1;
        case SyntaxKind::EmptyMember: return 3;
        case SyntaxKind::EmptyNonAnsiPort: return 1;
        case SyntaxKind::EmptyPortConnection: return 2;
        case SyntaxKind::EmptyQueueExpression: return 2;
        case SyntaxKind::EmptyStatement: return 3;
        case SyntaxKind::EmptyTimingCheckArg: return 1;
        case SyntaxKind::EndCellDefineDirective: return 1;
        case SyntaxKind::EndIfDirective: return 2;
        case SyntaxKind::EndKeywordsDirective: return 1;
        case SyntaxKind::EndProtectDirective: return 1;
        case SyntaxKind::EndProtectedDirective: return 1;
        case SyntaxKind::EnumType: return 6;
        case SyntaxKind::EqualityExpression: return 4;
        case SyntaxKind::EqualsAssertionArgClause: return 2;
        case SyntaxKind::EqualsTypeClause: return 2;
        case SyntaxKind::EqualsValueClause: return 2;
        case SyntaxKind::EventControl: return 2;
        case SyntaxKind::EventControlWithExpression: return 2;
        case SyntaxKind::EventType: return 1;
        case SyntaxKind::ExpectPropertyStatement: return 8;
        case SyntaxKind::ExplicitAnsiPort: return 7;
        case SyntaxKind::ExplicitNonAnsiPort: return 5;
        case SyntaxKind::ExpressionConstraint: return 3;
        case SyntaxKind::ExpressionCoverageBinInitializer: return 1;
        case SyntaxKind::ExpressionOrDist: return 2;
        case SyntaxKind::ExpressionPattern: return 1;
        case SyntaxKind::ExpressionStatement: return 4;
        case SyntaxKind::ExpressionTimingCheckArg: return 1;
        case SyntaxKind::ExtendsClause: return 4;
        case SyntaxKind::ExternInterfaceMethod: return 5;
        case SyntaxKind::ExternModuleDecl: return 4;
        case SyntaxKind::ExternUdpDecl: return 6;
        case SyntaxKind::FilePathSpec: return 1;
        case SyntaxKind::FinalBlock: return 3;
        case SyntaxKind::FirstMatchSequenceExpr: return 5;
        case SyntaxKind::FollowedByPropertyExpr: return 3;
        case SyntaxKind::ForLoopStatement: return 11;
        case SyntaxKind::ForVariableDeclaration: return 3;
        case SyntaxKind::ForeachLoopList: return 6;
        case SyntaxKind::ForeachLoopStatement: return 5;
        case SyntaxKind::ForeverStatement: return 4;
        case SyntaxKind::ForwardTypeRestriction: return 2;
        case SyntaxKind::ForwardTypedefDeclaration: return 5;
        case SyntaxKind::FunctionDeclaration: return 6;
        case SyntaxKind::FunctionPort: return 7;
        case SyntaxKind::FunctionPortList: return 3;
        case SyntaxKind::FunctionPrototype: return 6;
        case SyntaxKind::GenerateBlock: return 7;
        case SyntaxKind::GenerateRegion: return 4;
        case SyntaxKind::GenvarDeclaration: return 4;
        case SyntaxKind::GreaterThanEqualExpression: return 4;
        case SyntaxKind::GreaterThanExpression: return 4;
        case SyntaxKind::HierarchicalInstance: return 4;
        case SyntaxKind::HierarchyInstantiation: return 5;
        case SyntaxKind::IdWithExprCoverageBinInitializer: return 2;
        case SyntaxKind::IdentifierName: return 1;
        case SyntaxKind::IdentifierSelectName: return 2;
        case SyntaxKind::IfDefDirective: return 3;
        case SyntaxKind::IfGenerate: return 7;
        case SyntaxKind::IfNDefDirective: return 3;
        case SyntaxKind::IfNonePathDeclaration: return 3;
        case SyntaxKind::IffEventClause: return 2;
        case SyntaxKind::IffPropertyExpr: return 3;
        case SyntaxKind::ImmediateAssertStatement: return 6;
        case SyntaxKind::ImmediateAssertionMember: return 2;
        case SyntaxKind::ImmediateAssumeStatement: return 6;
        case SyntaxKind::ImmediateCoverStatement: return 6;
        case SyntaxKind::ImplementsClause: return 2;
        case SyntaxKind::ImplicationConstraint: return 3;
        case SyntaxKind::ImplicationPropertyExpr: return 3;
        case SyntaxKind::ImplicitAnsiPort: return 3;
        case SyntaxKind::ImplicitEventControl: return 4;
        case SyntaxKind::ImplicitNonAnsiPort: return 1;
        case SyntaxKind::ImplicitType: return 3;
        case SyntaxKind::ImpliesPropertyExpr: return 3;
        case SyntaxKind::IncludeDirective: return 2;
        case SyntaxKind::InequalityExpression: return 4;
        case SyntaxKind::InitialBlock: return 3;
        case SyntaxKind::InsideExpression: return 3;
        case SyntaxKind::InstanceConfigRule: return 5;
        case SyntaxKind::InstanceName: return 2;
        case SyntaxKind::IntType: return 3;
        case SyntaxKind::IntegerLiteralExpression: return 1;
        case SyntaxKind::IntegerType: return 3;
        case SyntaxKind::IntegerVectorExpression: return 3;
        case SyntaxKind::InterfaceDeclaration: return 5;
        case SyntaxKind::InterfaceHeader: return 7;
        case SyntaxKind::InterfacePortHeader: return 2;
        case SyntaxKind::IntersectClause: return 2;
        case SyntaxKind::IntersectSequenceExpr: return 3;
        case SyntaxKind::InvocationExpression: return 3;
        case SyntaxKind::JumpStatement: return 4;
        case SyntaxKind::LessThanEqualExpression: return 4;
        case SyntaxKind::LessThanExpression: return 4;
        case SyntaxKind::LetDeclaration: return 7;
        case SyntaxKind::LibraryDeclaration: return 6;
        case SyntaxKind::LibraryIncDirClause: return 3;
        case SyntaxKind::LibraryIncludeStatement: return 4;
        case SyntaxKind::LibraryMap: return 2;
        case SyntaxKind::LineDirective: return 4;
        case SyntaxKind::LocalScope: return 1;
        case SyntaxKind::LocalVariableDeclaration: return 5;
        case SyntaxKind::LogicType: return 3;
        case SyntaxKind::LogicalAndExpression: return 4;
        case SyntaxKind::LogicalEquivalenceExpression: return 4;
        case SyntaxKind::LogicalImplicationExpression: return 4;
        case SyntaxKind::LogicalLeftShiftAssignmentExpression: return 4;
        case SyntaxKind::LogicalOrExpression: return 4;
        case SyntaxKind::LogicalRightShiftAssignmentExpression: return 4;
        case SyntaxKind::LogicalShiftLeftExpression: return 4;
        case SyntaxKind::LogicalShiftRightExpression: return 4;
        case SyntaxKind::LongIntType: return 3;
        case SyntaxKind::LoopConstraint: return 3;
        case SyntaxKind::LoopGenerate: return 13;
        case SyntaxKind::LoopStatement: return 7;
        case SyntaxKind::MacroActualArgument: return 1;
        case SyntaxKind::MacroActualArgumentList: return 3;
        case SyntaxKind::MacroArgumentDefault: return 2;
        case SyntaxKind::MacroFormalArgument: return 2;
        case SyntaxKind::MacroFormalArgumentList: return 3;
        case SyntaxKind::MacroUsage: return 2;
        case SyntaxKind::MatchesClause: return 2;
        case SyntaxKind::MemberAccessExpression: return 3;
        case SyntaxKind::MinTypMaxExpression: return 5;
        case SyntaxKind::ModAssignmentExpression: return 4;
        case SyntaxKind::ModExpression: return 4;
        case SyntaxKind::ModportClockingPort: return 3;
        case SyntaxKind::ModportDeclaration: return 4;
        case SyntaxKind::ModportExplicitPort: return 5;
        case SyntaxKind::ModportItem: return 2;
        case SyntaxKind::ModportNamedPort: return 1;
        case SyntaxKind::ModportSimplePortList: return 3;
        case SyntaxKind::ModportSubroutinePort: return 1;
        case SyntaxKind::ModportSubroutinePortList: return 3;
        case SyntaxKind::ModuleDeclaration: return 5;
        case SyntaxKind::ModuleHeader: return 7;
        case SyntaxKind::MultipleConcatenationExpression: return 4;
        case SyntaxKind::MultiplyAssignmentExpression: return 4;
        case SyntaxKind::MultiplyExpression: return 4;
        case SyntaxKind::NameValuePragmaExpression: return 3;
        case SyntaxKind::NamedArgument: return 5;
        case SyntaxKind::NamedBlockClause: return 2;
        case SyntaxKind::NamedConditionalDirectiveExpression: return 1;
        case SyntaxKind::NamedLabel: return 2;
        case SyntaxKind::NamedParamAssignment: return 5;
        case SyntaxKind::NamedPortConnection: return 6;
        case SyntaxKind::NamedStructurePatternMember: return 3;
        case SyntaxKind::NamedType: return 1;
        case SyntaxKind::NetAlias: return 4;
        case SyntaxKind::NetDeclaration: return 8;
        case SyntaxKind::NetPortHeader: return 3;
        case SyntaxKind::NetTypeDeclaration: return 6;
        case SyntaxKind::NewArrayExpression: return 5;
        case SyntaxKind::NewClassExpression: return 2;
        case SyntaxKind::NoUnconnectedDriveDirective: return 1;
        case SyntaxKind::NonAnsiPortList: return 3;
        case SyntaxKind::NonAnsiUdpPortList: return 4;
        case SyntaxKind::NonblockingAssignmentExpression: return 4;
        case SyntaxKind::NonblockingEventTriggerStatement: return 6;
        case SyntaxKind::NullLiteralExpression: return 1;
        case SyntaxKind::NumberPragmaExpression: return 3;
        case SyntaxKind::OneStepDelay: return 2;
        case SyntaxKind::OrAssignmentExpression: return 4;
        case SyntaxKind::OrPropertyExpr: return 3;
        case SyntaxKind::OrSequenceExpr: return 3;
        case SyntaxKind::OrderedArgument: return 1;
        case SyntaxKind::OrderedParamAssignment: return 1;
        case SyntaxKind::OrderedPortConnection: return 2;
        case SyntaxKind::OrderedStructurePatternMember: return 1;
        case SyntaxKind::PackageDeclaration: return 5;
        case SyntaxKind::PackageExportAllDeclaration: return 6;
        case SyntaxKind::PackageExportDeclaration: return 4;
        case SyntaxKind::PackageHeader: return 7;
        case SyntaxKind::PackageImportDeclaration: return 4;
        case SyntaxKind::PackageImportItem: return 3;
        case SyntaxKind::ParallelBlockStatement: return 7;
        case SyntaxKind::ParameterDeclaration: return 3;
        case SyntaxKind::ParameterDeclarationStatement: return 3;
        case SyntaxKind::ParameterPortList: return 4;
        case SyntaxKind::ParameterValueAssignment: return 4;
        case SyntaxKind::ParenExpressionList: return 3;
        case SyntaxKind::ParenPragmaExpression: return 3;
        case SyntaxKind::ParenthesizedBinsSelectExpr: return 3;
        case SyntaxKind::ParenthesizedConditionalDirectiveExpression: return 3;
        case SyntaxKind::ParenthesizedEventExpression: return 3;
        case SyntaxKind::ParenthesizedExpression: return 3;
        case SyntaxKind::ParenthesizedPattern: return 3;
        case SyntaxKind::ParenthesizedPropertyExpr: return 4;
        case SyntaxKind::ParenthesizedSequenceExpr: return 5;
        case SyntaxKind::PathDeclaration: return 7;
        case SyntaxKind::PathDescription: return 7;
        case SyntaxKind::PatternCaseItem: return 5;
        case SyntaxKind::PortConcatenation: return 3;
        case SyntaxKind::PortDeclaration: return 4;
        case SyntaxKind::PortReference: return 2;
        case SyntaxKind::PostdecrementExpression: return 3;
        case SyntaxKind::PostincrementExpression: return 3;
        case SyntaxKind::PowerExpression: return 4;
        case SyntaxKind::PragmaDirective: return 3;
        case SyntaxKind::PrimaryBlockEventExpression: return 2;
        case SyntaxKind::PrimitiveInstantiation: return 6;
        case SyntaxKind::ProceduralAssignStatement: return 5;
        case SyntaxKind::ProceduralDeassignStatement: return 5;
        case SyntaxKind::ProceduralForceStatement: return 5;
        case SyntaxKind::ProceduralReleaseStatement: return 5;
        case SyntaxKind::Production: return 6;
        case SyntaxKind::ProgramDeclaration: return 5;
        case SyntaxKind::ProgramHeader: return 7;
        case SyntaxKind::PropertyDeclaration: return 10;
        case SyntaxKind::PropertySpec: return 3;
        case SyntaxKind::PropertyType: return 1;
        case SyntaxKind::ProtectDirective: return 1;
        case SyntaxKind::ProtectedDirective: return 1;
        case SyntaxKind::PullStrength: return 3;
        case SyntaxKind::PulseStyleDeclaration: return 4;
        case SyntaxKind::QueueDimensionSpecifier: return 2;
        case SyntaxKind::RandCaseItem: return 3;
        case SyntaxKind::RandCaseStatement: return 5;
        case SyntaxKind::RandJoinClause: return 3;
        case SyntaxKind::RandSequenceStatement: return 8;
        case SyntaxKind::RangeCoverageBinInitializer: return 2;
        case SyntaxKind::RangeDimensionSpecifier: return 1;
        case SyntaxKind::RangeList: return 3;
        case SyntaxKind::RealLiteralExpression: return 1;
        case SyntaxKind::RealTimeType: return 1;
        case SyntaxKind::RealType: return 1;
        case SyntaxKind::RegType: return 3;
        case SyntaxKind::RepeatedEventControl: return 5;
        case SyntaxKind::ReplicatedAssignmentPattern: return 6;
        case SyntaxKind::ResetAllDirective: return 1;
        case SyntaxKind::RestrictPropertyStatement: return 8;
        case SyntaxKind::ReturnStatement: return 5;
        case SyntaxKind::RootScope: return 1;
        case SyntaxKind::RsCase: return 6;
        case SyntaxKind::RsCodeBlock: return 3;
        case SyntaxKind::RsElseClause: return 2;
        case SyntaxKind::RsIfElse: return 6;
        case SyntaxKind::RsProdItem: return 2;
        case SyntaxKind::RsRepeat: return 5;
        case SyntaxKind::RsRule: return 3;
        case SyntaxKind::RsWeightClause: return 3;
        case SyntaxKind::SUntilPropertyExpr: return 3;
        case SyntaxKind::SUntilWithPropertyExpr: return 3;
        case SyntaxKind::ScopedName: return 3;
        case SyntaxKind::SequenceDeclaration: return 10;
        case SyntaxKind::SequenceMatchList: return 2;
        case SyntaxKind::SequenceRepetition: return 4;
        case SyntaxKind::SequenceType: return 1;
        case SyntaxKind::SequentialBlockStatement: return 7;
        case SyntaxKind::ShortIntType: return 3;
        case SyntaxKind::ShortRealType: return 1;
        case SyntaxKind::SignalEventExpression: return 3;
        case SyntaxKind::SignedCastExpression: return 3;
        case SyntaxKind::SimpleAssignmentPattern: return 3;
        case SyntaxKind::SimpleBinsSelectExpr: return 2;
        case SyntaxKind::SimplePathSuffix: return 1;
        case SyntaxKind::SimplePragmaExpression: return 1;
        case SyntaxKind::SimplePropertyExpr: return 1;
        case SyntaxKind::SimpleRangeSelect: return 3;
        case SyntaxKind::SimpleSequenceExpr: return 2;
        case SyntaxKind::SolveBeforeConstraint: return 5;
        case SyntaxKind::SpecifyBlock: return 4;
        case SyntaxKind::SpecparamDeclaration: return 5;
        case SyntaxKind::SpecparamDeclarator: return 7;
        case SyntaxKind::StandardCaseItem: return 3;
        case SyntaxKind::StandardPropertyCaseItem: return 4;
        case SyntaxKind::StandardRsCaseItem: return 4;
        case SyntaxKind::StreamExpression: return 2;
        case SyntaxKind::StreamExpressionWithRange: return 2;
        case SyntaxKind::StreamingConcatenationExpression: return 7;
        case SyntaxKind::StringLiteralExpression: return 1;
        case SyntaxKind::StringType: return 1;
        case SyntaxKind::StrongWeakPropertyExpr: return 4;
        case SyntaxKind::StructType: return 8;
        case SyntaxKind::StructUnionMember: return 5;
        case SyntaxKind::StructurePattern: return 3;
        case SyntaxKind::StructuredAssignmentPattern: return 3;
        case SyntaxKind::SubtractAssignmentExpression: return 4;
        case SyntaxKind::SubtractExpression: return 4;
        case SyntaxKind::SuperHandle: return 1;
        case SyntaxKind::SuperNewDefaultedArgsExpression: return 4;
        case SyntaxKind::SystemName: return 1;
        case SyntaxKind::SystemTimingCheck: return 6;
        case SyntaxKind::TaggedPattern: return 3;
        case SyntaxKind::TaggedUnionExpression: return 3;
        case SyntaxKind::TaskDeclaration: return 6;
        case SyntaxKind::ThisHandle: return 1;
        case SyntaxKind::ThroughoutSequenceExpr: return 3;
        case SyntaxKind::TimeLiteralExpression: return 1;
        case SyntaxKind::TimeScaleDirective: return 4;
        case SyntaxKind::TimeType: return 3;
        case SyntaxKind::TimeUnitsDeclaration: return 5;
        case SyntaxKind::TimingCheckEventArg: return 4;
        case SyntaxKind::TimingCheckEventCondition: return 2;
        case SyntaxKind::TimingControlExpression: return 2;
        case SyntaxKind::TimingControlStatement: return 4;
        case SyntaxKind::TransListCoverageBinInitializer: return 1;
        case SyntaxKind::TransRange: return 2;
        case SyntaxKind::TransRepeatRange: return 4;
        case SyntaxKind::TransSet: return 3;
        case SyntaxKind::TypeAssignment: return 2;
        case SyntaxKind::TypeParameterDeclaration: return 4;
        case SyntaxKind::TypeReference: return 4;
        case SyntaxKind::TypedefDeclaration: return 6;
        case SyntaxKind::UdpBody: return 5;
        case SyntaxKind::UdpDeclaration: return 7;
        case SyntaxKind::UdpEdgeField: return 4;
        case SyntaxKind::UdpEntry: return 6;
        case SyntaxKind::UdpInitialStmt: return 5;
        case SyntaxKind::UdpInputPortDecl: return 3;
        case SyntaxKind::UdpOutputPortDecl: return 5;
        case SyntaxKind::UdpSimpleField: return 1;
        case SyntaxKind::UnaryBinsSelectExpr: return 2;
        case SyntaxKind::UnaryBitwiseAndExpression: return 3;
        case SyntaxKind::UnaryBitwiseNandExpression: return 3;
        case SyntaxKind::UnaryBitwiseNorExpression: return 3;
        case SyntaxKind::UnaryBitwiseNotExpression: return 3;
        case SyntaxKind::UnaryBitwiseOrExpression: return 3;
        case SyntaxKind::UnaryBitwiseXnorExpression: return 3;
        case SyntaxKind::UnaryBitwiseXorExpression: return 3;
        case SyntaxKind::UnaryConditionalDirectiveExpression: return 2;
        case SyntaxKind::UnaryLogicalNotExpression: return 3;
        case SyntaxKind::UnaryMinusExpression: return 3;
        case SyntaxKind::UnaryPlusExpression: return 3;
        case SyntaxKind::UnaryPredecrementExpression: return 3;
        case SyntaxKind::UnaryPreincrementExpression: return 3;
        case SyntaxKind::UnaryPropertyExpr: return 2;
        case SyntaxKind::UnarySelectPropertyExpr: return 5;
        case SyntaxKind::UnbasedUnsizedLiteralExpression: return 1;
        case SyntaxKind::UnconnectedDriveDirective: return 2;
        case SyntaxKind::UndefDirective: return 2;
        case SyntaxKind::UndefineAllDirective: return 1;
        case SyntaxKind::UnionType: return 8;
        case SyntaxKind::UniquenessConstraint: return 3;
        case SyntaxKind::UnitScope: return 1;
        case SyntaxKind::UntilPropertyExpr: return 3;
        case SyntaxKind::UntilWithPropertyExpr: return 3;
        case SyntaxKind::Untyped: return 1;
        case SyntaxKind::UserDefinedNetDeclaration: return 5;
        case SyntaxKind::ValueRangeExpression: return 5;
        case SyntaxKind::VariableDimension: return 3;
        case SyntaxKind::VariablePattern: return 2;
        case SyntaxKind::VariablePortHeader: return 4;
        case SyntaxKind::VirtualInterfaceType: return 5;
        case SyntaxKind::VoidCastedCallStatement: return 8;
        case SyntaxKind::VoidType: return 1;
        case SyntaxKind::WaitForkStatement: return 5;
        case SyntaxKind::WaitOrderStatement: return 7;
        case SyntaxKind::WaitStatement: return 7;
        case SyntaxKind::WildcardDimensionSpecifier: return 1;
        case SyntaxKind::WildcardEqualityExpression: return 4;
        case SyntaxKind::WildcardInequalityExpression: return 4;
        case SyntaxKind::WildcardLiteralExpression: return 1;
        case SyntaxKind::WildcardPattern: return 2;
        case SyntaxKind::WildcardPortConnection: return 3;
        case SyntaxKind::WildcardPortList: return 4;
        case SyntaxKind::WildcardUdpPortList: return 5;
        case SyntaxKind::WithClause: return 4;
        case SyntaxKind::WithFunctionClause: return 2;
        case SyntaxKind::WithFunctionSample: return 4;
        case SyntaxKind::WithinSequenceExpr: return 3;
        case SyntaxKind::XorAssignmentExpression: return 4;
    }
    SLANG_UNREACHABLE;
}

bool AcceptOnPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AcceptOnPropertyExpr;
}

bool AcceptOnPropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AcceptOnPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax AcceptOnPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax AcceptOnPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &openParen;
        case 2: return condition.get();
        case 3: return &closeParen;
        case 4: return expr.get();
        default: return nullptr;
    }
}

void AcceptOnPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ActionBlockSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ActionBlock;
}

bool ActionBlockSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ActionBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return statement;
        case 1: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ActionBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return statement;
        case 1: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ActionBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return statement;
        case 1: return elseClause;
        default: return nullptr;
    }
}

void ActionBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        case 1: elseClause = child.node() ? &child.node()->as<ElseClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool AnonymousProgramSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AnonymousProgram;
}

bool AnonymousProgramSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AnonymousProgramSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return semi;
        case 3: return &members;
        case 4: return endkeyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AnonymousProgramSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return semi;
        case 3: return &members;
        case 4: return endkeyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AnonymousProgramSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &semi;
        case 3: return &members;
        case 4: return &endkeyword;
        default: return nullptr;
    }
}

void AnonymousProgramSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: semi = child.token(); return;
        case 3: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 4: endkeyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool AnsiPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AnsiPortList;
}

bool AnsiPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AnsiPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AnsiPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AnsiPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void AnsiPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<MemberSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool AnsiUdpPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AnsiUdpPortList;
}

bool AnsiUdpPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AnsiUdpPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AnsiUdpPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AnsiUdpPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        case 3: return &semi;
        default: return nullptr;
    }
}

void AnsiUdpPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<UdpPortDeclSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ArgumentListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ArgumentList;
}

bool ArgumentListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ArgumentListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &parameters;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ArgumentListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &parameters;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ArgumentListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &parameters;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ArgumentListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: parameters = child.node()->as<SeparatedSyntaxList<ArgumentSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ArgumentSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::EmptyArgument:
        case SyntaxKind::NamedArgument:
        case SyntaxKind::OrderedArgument:
            return true;
        default:
            return false;
    }
}

bool ArrayOrRandomizeMethodExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ArrayOrRandomizeMethodExpression;
}

bool ArrayOrRandomizeMethodExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ArrayOrRandomizeMethodExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return method.get();
        case 1: return with;
        case 2: return args;
        case 3: return constraints;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ArrayOrRandomizeMethodExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return method.get();
        case 1: return with;
        case 2: return args;
        case 3: return constraints;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ArrayOrRandomizeMethodExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return method.get();
        case 1: return &with;
        case 2: return args;
        case 3: return constraints;
        default: return nullptr;
    }
}

void ArrayOrRandomizeMethodExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: method = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: with = child.token(); return;
        case 2: args = child.node() ? &child.node()->as<ParenExpressionListSyntax>() : nullptr; return;
        case 3: constraints = child.node() ? &child.node()->as<ConstraintBlockSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool AssertionItemPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AssertionItemPortList;
}

bool AssertionItemPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AssertionItemPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AssertionItemPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AssertionItemPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void AssertionItemPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<AssertionItemPortSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool AssertionItemPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AssertionItemPort;
}

bool AssertionItemPortSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax AssertionItemPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return local;
        case 2: return direction;
        case 3: return type.get();
        case 4: return name;
        case 5: return &dimensions;
        case 6: return defaultValue;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AssertionItemPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return local;
        case 2: return direction;
        case 3: return type.get();
        case 4: return name;
        case 5: return &dimensions;
        case 6: return defaultValue;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AssertionItemPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &local;
        case 2: return &direction;
        case 3: return type.get();
        case 4: return &name;
        case 5: return &dimensions;
        case 6: return defaultValue;
        default: return nullptr;
    }
}

void AssertionItemPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: local = child.token(); return;
        case 2: direction = child.token(); return;
        case 3: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 4: name = child.token(); return;
        case 5: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        case 6: defaultValue = child.node() ? &child.node()->as<EqualsAssertionArgClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool AssignmentPatternExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AssignmentPatternExpression;
}

bool AssignmentPatternExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax AssignmentPatternExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return type;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax AssignmentPatternExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return type;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax AssignmentPatternExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return type;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

void AssignmentPatternExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 1: pattern = child.node() ? &child.node()->as<AssignmentPatternSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool AssignmentPatternItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AssignmentPatternItem;
}

bool AssignmentPatternItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AssignmentPatternItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return key.get();
        case 1: return colon;
        case 2: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax AssignmentPatternItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return key.get();
        case 1: return colon;
        case 2: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax AssignmentPatternItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return key.get();
        case 1: return &colon;
        case 2: return expr.get();
        default: return nullptr;
    }
}

void AssignmentPatternItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: key = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: colon = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool AssignmentPatternSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ReplicatedAssignmentPattern:
        case SyntaxKind::SimpleAssignmentPattern:
        case SyntaxKind::StructuredAssignmentPattern:
            return true;
        default:
            return false;
    }
}

bool AttributeInstanceSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AttributeInstance;
}

bool AttributeInstanceSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax AttributeInstanceSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return openStar;
        case 2: return &specs;
        case 3: return closeStar;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AttributeInstanceSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return openStar;
        case 2: return &specs;
        case 3: return closeStar;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AttributeInstanceSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &openStar;
        case 2: return &specs;
        case 3: return &closeStar;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void AttributeInstanceSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: openStar = child.token(); return;
        case 2: specs = child.node()->as<SeparatedSyntaxList<AttributeSpecSyntax>>(); return;
        case 3: closeStar = child.token(); return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool AttributeSpecSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::AttributeSpec;
}

bool AttributeSpecSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax AttributeSpecSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return value;
        default: return nullptr;
    }
}

ConstTokenOrSyntax AttributeSpecSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return value;
        default: return nullptr;
    }
}

PtrTokenOrSyntax AttributeSpecSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return value;
        default: return nullptr;
    }
}

void AttributeSpecSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: value = child.node() ? &child.node()->as<EqualsValueClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BadExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BadExpression;
}

bool BadExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BadExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BadExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BadExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void BadExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BeginKeywordsDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BeginKeywordsDirective;
}

bool BeginKeywordsDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BeginKeywordsDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return versionSpecifier;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BeginKeywordsDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return versionSpecifier;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BeginKeywordsDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &versionSpecifier;
        default: return nullptr;
    }
}

void BeginKeywordsDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: versionSpecifier = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinSelectWithFilterExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinSelectWithFilterExpr;
}

bool BinSelectWithFilterExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax BinSelectWithFilterExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return with;
        case 2: return openParen;
        case 3: return filter.get();
        case 4: return closeParen;
        case 5: return matchesClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinSelectWithFilterExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return with;
        case 2: return openParen;
        case 3: return filter.get();
        case 4: return closeParen;
        case 5: return matchesClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinSelectWithFilterExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return &with;
        case 2: return &openParen;
        case 3: return filter.get();
        case 4: return &closeParen;
        case 5: return matchesClause;
        default: return nullptr;
    }
}

void BinSelectWithFilterExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<BinsSelectExpressionSyntax>() : nullptr; return;
        case 1: with = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: filter = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        case 5: matchesClause = child.node() ? &child.node()->as<MatchesClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryBinsSelectExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinaryBinsSelectExpr;
}

bool BinaryBinsSelectExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryBinsSelectExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryBinsSelectExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryBinsSelectExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &op;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinaryBinsSelectExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<BinsSelectExpressionSyntax>() : nullptr; return;
        case 1: op = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<BinsSelectExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryBlockEventExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinaryBlockEventExpression;
}

bool BinaryBlockEventExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryBlockEventExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return orKeyword;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryBlockEventExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return orKeyword;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryBlockEventExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &orKeyword;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinaryBlockEventExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<BlockEventExpressionSyntax>() : nullptr; return;
        case 1: orKeyword = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<BlockEventExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryConditionalDirectiveExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinaryConditionalDirectiveExpression;
}

bool BinaryConditionalDirectiveExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryConditionalDirectiveExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryConditionalDirectiveExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryConditionalDirectiveExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &op;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinaryConditionalDirectiveExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ConditionalDirectiveExpressionSyntax>() : nullptr; return;
        case 1: op = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<ConditionalDirectiveExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryEventExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinaryEventExpression;
}

bool BinaryEventExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryEventExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return operatorToken;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryEventExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return operatorToken;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryEventExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &operatorToken;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinaryEventExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<EventExpressionSyntax>() : nullptr; return;
        case 1: operatorToken = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<EventExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AddAssignmentExpression:
        case SyntaxKind::AddExpression:
        case SyntaxKind::AndAssignmentExpression:
        case SyntaxKind::ArithmeticLeftShiftAssignmentExpression:
        case SyntaxKind::ArithmeticRightShiftAssignmentExpression:
        case SyntaxKind::ArithmeticShiftLeftExpression:
        case SyntaxKind::ArithmeticShiftRightExpression:
        case SyntaxKind::AssignmentExpression:
        case SyntaxKind::BinaryAndExpression:
        case SyntaxKind::BinaryOrExpression:
        case SyntaxKind::BinaryXnorExpression:
        case SyntaxKind::BinaryXorExpression:
        case SyntaxKind::CaseEqualityExpression:
        case SyntaxKind::CaseInequalityExpression:
        case SyntaxKind::DivideAssignmentExpression:
        case SyntaxKind::DivideExpression:
        case SyntaxKind::EqualityExpression:
        case SyntaxKind::GreaterThanEqualExpression:
        case SyntaxKind::GreaterThanExpression:
        case SyntaxKind::InequalityExpression:
        case SyntaxKind::LessThanEqualExpression:
        case SyntaxKind::LessThanExpression:
        case SyntaxKind::LogicalAndExpression:
        case SyntaxKind::LogicalEquivalenceExpression:
        case SyntaxKind::LogicalImplicationExpression:
        case SyntaxKind::LogicalLeftShiftAssignmentExpression:
        case SyntaxKind::LogicalOrExpression:
        case SyntaxKind::LogicalRightShiftAssignmentExpression:
        case SyntaxKind::LogicalShiftLeftExpression:
        case SyntaxKind::LogicalShiftRightExpression:
        case SyntaxKind::ModAssignmentExpression:
        case SyntaxKind::ModExpression:
        case SyntaxKind::MultiplyAssignmentExpression:
        case SyntaxKind::MultiplyExpression:
        case SyntaxKind::NonblockingAssignmentExpression:
        case SyntaxKind::OrAssignmentExpression:
        case SyntaxKind::PowerExpression:
        case SyntaxKind::SubtractAssignmentExpression:
        case SyntaxKind::SubtractExpression:
        case SyntaxKind::WildcardEqualityExpression:
        case SyntaxKind::WildcardInequalityExpression:
        case SyntaxKind::XorAssignmentExpression:
            return true;
        default:
            return false;
    }
}

bool BinaryExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return operatorToken;
        case 2: return &attributes;
        case 3: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return operatorToken;
        case 2: return &attributes;
        case 3: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &operatorToken;
        case 2: return &attributes;
        case 3: return right.get();
        default: return nullptr;
    }
}

void BinaryExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: operatorToken = child.token(); return;
        case 2: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 3: right = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinaryPropertyExprSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AndPropertyExpr:
        case SyntaxKind::FollowedByPropertyExpr:
        case SyntaxKind::IffPropertyExpr:
        case SyntaxKind::ImplicationPropertyExpr:
        case SyntaxKind::ImpliesPropertyExpr:
        case SyntaxKind::OrPropertyExpr:
        case SyntaxKind::SUntilPropertyExpr:
        case SyntaxKind::SUntilWithPropertyExpr:
        case SyntaxKind::UntilPropertyExpr:
        case SyntaxKind::UntilWithPropertyExpr:
            return true;
        default:
            return false;
    }
}

bool BinaryPropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinaryPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinaryPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinaryPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &op;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinaryPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 1: op = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinarySequenceExprSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AndSequenceExpr:
        case SyntaxKind::IntersectSequenceExpr:
        case SyntaxKind::OrSequenceExpr:
        case SyntaxKind::ThroughoutSequenceExpr:
        case SyntaxKind::WithinSequenceExpr:
            return true;
        default:
            return false;
    }
}

bool BinarySequenceExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BinarySequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinarySequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return op;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinarySequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &op;
        case 2: return right.get();
        default: return nullptr;
    }
}

void BinarySequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 1: op = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BindDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BindDirective;
}

bool BindDirectiveSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax BindDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return bind;
        case 2: return target.get();
        case 3: return targetInstances;
        case 4: return instantiation.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BindDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return bind;
        case 2: return target.get();
        case 3: return targetInstances;
        case 4: return instantiation.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BindDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &bind;
        case 2: return target.get();
        case 3: return targetInstances;
        case 4: return instantiation.get();
        default: return nullptr;
    }
}

void BindDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: bind = child.token(); return;
        case 2: target = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 3: targetInstances = child.node() ? &child.node()->as<BindTargetListSyntax>() : nullptr; return;
        case 4: instantiation = child.node() ? &child.node()->as<MemberSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BindTargetListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BindTargetList;
}

bool BindTargetListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BindTargetListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return colon;
        case 1: return &targets;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BindTargetListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return colon;
        case 1: return &targets;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BindTargetListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &colon;
        case 1: return &targets;
        default: return nullptr;
    }
}

void BindTargetListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: colon = child.token(); return;
        case 1: targets = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinsSelectConditionExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinsSelectConditionExpr;
}

bool BinsSelectConditionExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax BinsSelectConditionExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return binsof;
        case 1: return openParen;
        case 2: return name.get();
        case 3: return closeParen;
        case 4: return intersects;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinsSelectConditionExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return binsof;
        case 1: return openParen;
        case 2: return name.get();
        case 3: return closeParen;
        case 4: return intersects;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinsSelectConditionExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &binsof;
        case 1: return &openParen;
        case 2: return name.get();
        case 3: return &closeParen;
        case 4: return intersects;
        default: return nullptr;
    }
}

void BinsSelectConditionExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: binsof = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: intersects = child.node() ? &child.node()->as<IntersectClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BinsSelectExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BinSelectWithFilterExpr:
        case SyntaxKind::BinaryBinsSelectExpr:
        case SyntaxKind::BinsSelectConditionExpr:
        case SyntaxKind::ParenthesizedBinsSelectExpr:
        case SyntaxKind::SimpleBinsSelectExpr:
        case SyntaxKind::UnaryBinsSelectExpr:
            return true;
        default:
            return false;
    }
}

bool BinsSelectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BinsSelection;
}

bool BinsSelectionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax BinsSelectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return equals;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BinsSelectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return equals;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BinsSelectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &name;
        case 3: return &equals;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return &semi;
        default: return nullptr;
    }
}

void BinsSelectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: name = child.token(); return;
        case 3: equals = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<BinsSelectExpressionSyntax>() : nullptr; return;
        case 5: iff = child.node() ? &child.node()->as<CoverageIffClauseSyntax>() : nullptr; return;
        case 6: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool BitSelectSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BitSelect;
}

bool BitSelectSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BitSelectSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax BitSelectSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax BitSelectSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void BitSelectSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool BlockCoverageEventSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::BlockCoverageEvent;
}

bool BlockCoverageEventSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax BlockCoverageEventSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return atat;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BlockCoverageEventSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return atat;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BlockCoverageEventSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &atat;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void BlockCoverageEventSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: atat = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<BlockEventExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool BlockEventExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BinaryBlockEventExpression:
        case SyntaxKind::PrimaryBlockEventExpression:
            return true;
        default:
            return false;
    }
}

bool BlockStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ParallelBlockStatement:
        case SyntaxKind::SequentialBlockStatement:
            return true;
        default:
            return false;
    }
}

bool BlockStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 3: return true;
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax BlockStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return begin;
        case 3: return blockName;
        case 4: return &items;
        case 5: return end;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax BlockStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return begin;
        case 3: return blockName;
        case 4: return &items;
        case 5: return end;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax BlockStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &begin;
        case 3: return blockName;
        case 4: return &items;
        case 5: return &end;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

void BlockStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: begin = child.token(); return;
        case 3: blockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        case 4: items = child.node()->as<SyntaxList<SyntaxNode>>(); return;
        case 5: end = child.token(); return;
        case 6: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CaseGenerateSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CaseGenerate;
}

bool CaseGenerateSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CaseGenerateSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return condition.get();
        case 4: return closeParen;
        case 5: return &items;
        case 6: return endCase;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CaseGenerateSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return condition.get();
        case 4: return closeParen;
        case 5: return &items;
        case 6: return endCase;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CaseGenerateSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &openParen;
        case 3: return condition.get();
        case 4: return &closeParen;
        case 5: return &items;
        case 6: return &endCase;
        default: return nullptr;
    }
}

void CaseGenerateSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        case 5: items = child.node()->as<SyntaxList<CaseItemSyntax>>(); return;
        case 6: endCase = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CaseItemSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultCaseItem:
        case SyntaxKind::PatternCaseItem:
        case SyntaxKind::StandardCaseItem:
            return true;
        default:
            return false;
    }
}

bool CasePropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CasePropertyExpr;
}

bool CasePropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CasePropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return caseKeyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return &items;
        case 5: return endcase;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CasePropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return caseKeyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return &items;
        case 5: return endcase;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CasePropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &caseKeyword;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        case 4: return &items;
        case 5: return &endcase;
        default: return nullptr;
    }
}

void CasePropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: caseKeyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: items = child.node()->as<SyntaxList<PropertyCaseItemSyntax>>(); return;
        case 5: endcase = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CaseStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CaseStatement;
}

bool CaseStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax CaseStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return uniqueOrPriority;
        case 3: return caseKeyword;
        case 4: return openParen;
        case 5: return expr.get();
        case 6: return closeParen;
        case 7: return matchesOrInside;
        case 8: return &items;
        case 9: return endcase;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CaseStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return uniqueOrPriority;
        case 3: return caseKeyword;
        case 4: return openParen;
        case 5: return expr.get();
        case 6: return closeParen;
        case 7: return matchesOrInside;
        case 8: return &items;
        case 9: return endcase;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CaseStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &uniqueOrPriority;
        case 3: return &caseKeyword;
        case 4: return &openParen;
        case 5: return expr.get();
        case 6: return &closeParen;
        case 7: return &matchesOrInside;
        case 8: return &items;
        case 9: return &endcase;
        default: return nullptr;
    }
}

void CaseStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: uniqueOrPriority = child.token(); return;
        case 3: caseKeyword = child.token(); return;
        case 4: openParen = child.token(); return;
        case 5: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        case 7: matchesOrInside = child.token(); return;
        case 8: items = child.node()->as<SyntaxList<CaseItemSyntax>>(); return;
        case 9: endcase = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CastExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CastExpression;
}

bool CastExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CastExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return apostrophe;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax CastExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return apostrophe;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax CastExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &apostrophe;
        case 2: return right.get();
        default: return nullptr;
    }
}

void CastExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: apostrophe = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<ParenthesizedExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CellConfigRuleSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CellConfigRule;
}

bool CellConfigRuleSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CellConfigRuleSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return cell;
        case 1: return name.get();
        case 2: return ruleClause.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CellConfigRuleSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return cell;
        case 1: return name.get();
        case 2: return ruleClause.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CellConfigRuleSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &cell;
        case 1: return name.get();
        case 2: return ruleClause.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void CellConfigRuleSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: cell = child.token(); return;
        case 1: name = child.node() ? &child.node()->as<ConfigCellIdentifierSyntax>() : nullptr; return;
        case 2: ruleClause = child.node() ? &child.node()->as<ConfigRuleClauseSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ChargeStrengthSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ChargeStrength;
}

bool ChargeStrengthSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ChargeStrengthSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return strength;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ChargeStrengthSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return strength;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ChargeStrengthSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &strength;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ChargeStrengthSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: strength = child.token(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CheckerDataDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CheckerDataDeclaration;
}

bool CheckerDataDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CheckerDataDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return rand;
        case 2: return data.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax CheckerDataDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return rand;
        case 2: return data.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax CheckerDataDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &rand;
        case 2: return data.get();
        default: return nullptr;
    }
}

void CheckerDataDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: rand = child.token(); return;
        case 2: data = child.node() ? &child.node()->as<DataDeclarationSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CheckerDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CheckerDeclaration;
}

bool CheckerDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        case 7: return true;
        default: return false;
    }
}

TokenOrSyntax CheckerDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &members;
        case 6: return end;
        case 7: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CheckerDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &members;
        case 6: return end;
        case 7: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CheckerDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &name;
        case 3: return portList;
        case 4: return &semi;
        case 5: return &members;
        case 6: return &end;
        case 7: return endBlockName;
        default: return nullptr;
    }
}

void CheckerDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: name = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<AssertionItemPortListSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        case 5: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 6: end = child.token(); return;
        case 7: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CheckerInstanceStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CheckerInstanceStatement;
}

bool CheckerInstanceStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax CheckerInstanceStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return instance.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax CheckerInstanceStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return instance.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax CheckerInstanceStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return instance.get();
        default: return nullptr;
    }
}

void CheckerInstanceStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: instance = child.node() ? &child.node()->as<CheckerInstantiationSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CheckerInstantiationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CheckerInstantiation;
}

bool CheckerInstantiationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax CheckerInstantiationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return parameters;
        case 3: return &instances;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CheckerInstantiationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return parameters;
        case 3: return &instances;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CheckerInstantiationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return parameters;
        case 3: return &instances;
        case 4: return &semi;
        default: return nullptr;
    }
}

void CheckerInstantiationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: type = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 2: parameters = child.node() ? &child.node()->as<ParameterValueAssignmentSyntax>() : nullptr; return;
        case 3: instances = child.node()->as<SeparatedSyntaxList<HierarchicalInstanceSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassDeclaration;
}

bool ClassDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        case 5: return true;
        case 6: return true;
        case 7: return true;
        case 11: return true;
        default: return false;
    }
}

TokenOrSyntax ClassDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return virtualOrInterface;
        case 2: return classKeyword;
        case 3: return finalSpecifier;
        case 4: return name;
        case 5: return parameters;
        case 6: return extendsClause;
        case 7: return implementsClause;
        case 8: return semi;
        case 9: return &items;
        case 10: return endClass;
        case 11: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return virtualOrInterface;
        case 2: return classKeyword;
        case 3: return finalSpecifier;
        case 4: return name;
        case 5: return parameters;
        case 6: return extendsClause;
        case 7: return implementsClause;
        case 8: return semi;
        case 9: return &items;
        case 10: return endClass;
        case 11: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &virtualOrInterface;
        case 2: return &classKeyword;
        case 3: return finalSpecifier;
        case 4: return &name;
        case 5: return parameters;
        case 6: return extendsClause;
        case 7: return implementsClause;
        case 8: return &semi;
        case 9: return &items;
        case 10: return &endClass;
        case 11: return endBlockName;
        default: return nullptr;
    }
}

void ClassDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: virtualOrInterface = child.token(); return;
        case 2: classKeyword = child.token(); return;
        case 3: finalSpecifier = child.node() ? &child.node()->as<ClassSpecifierSyntax>() : nullptr; return;
        case 4: name = child.token(); return;
        case 5: parameters = child.node() ? &child.node()->as<ParameterPortListSyntax>() : nullptr; return;
        case 6: extendsClause = child.node() ? &child.node()->as<ExtendsClauseSyntax>() : nullptr; return;
        case 7: implementsClause = child.node() ? &child.node()->as<ImplementsClauseSyntax>() : nullptr; return;
        case 8: semi = child.token(); return;
        case 9: items = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 10: endClass = child.token(); return;
        case 11: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassMethodDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassMethodDeclaration;
}

bool ClassMethodDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClassMethodDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassMethodDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassMethodDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

void ClassMethodDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: declaration = child.node() ? &child.node()->as<FunctionDeclarationSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassMethodPrototypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassMethodPrototype;
}

bool ClassMethodPrototypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClassMethodPrototypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return prototype.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassMethodPrototypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return prototype.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassMethodPrototypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return prototype.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void ClassMethodPrototypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: prototype = child.node() ? &child.node()->as<FunctionPrototypeSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassName;
}

bool ClassNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClassNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return identifier;
        case 1: return parameters.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return identifier;
        case 1: return parameters.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &identifier;
        case 1: return parameters.get();
        default: return nullptr;
    }
}

void ClassNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: identifier = child.token(); return;
        case 1: parameters = child.node() ? &child.node()->as<ParameterValueAssignmentSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassPropertyDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassPropertyDeclaration;
}

bool ClassPropertyDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClassPropertyDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassPropertyDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassPropertyDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return declaration.get();
        default: return nullptr;
    }
}

void ClassPropertyDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: declaration = child.node() ? &child.node()->as<MemberSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClassSpecifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClassSpecifier;
}

bool ClassSpecifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClassSpecifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return colon;
        case 1: return keyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClassSpecifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return colon;
        case 1: return keyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClassSpecifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &colon;
        case 1: return &keyword;
        default: return nullptr;
    }
}

void ClassSpecifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: colon = child.token(); return;
        case 1: keyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingDeclaration;
}

bool ClockingDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 9: return true;
        default: return false;
    }
}

TokenOrSyntax ClockingDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return globalOrDefault;
        case 2: return clocking;
        case 3: return blockName;
        case 4: return at;
        case 5: return event.get();
        case 6: return semi;
        case 7: return &items;
        case 8: return endClocking;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return globalOrDefault;
        case 2: return clocking;
        case 3: return blockName;
        case 4: return at;
        case 5: return event.get();
        case 6: return semi;
        case 7: return &items;
        case 8: return endClocking;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &globalOrDefault;
        case 2: return &clocking;
        case 3: return &blockName;
        case 4: return &at;
        case 5: return event.get();
        case 6: return &semi;
        case 7: return &items;
        case 8: return &endClocking;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

void ClockingDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: globalOrDefault = child.token(); return;
        case 2: clocking = child.token(); return;
        case 3: blockName = child.token(); return;
        case 4: at = child.token(); return;
        case 5: event = child.node() ? &child.node()->as<EventExpressionSyntax>() : nullptr; return;
        case 6: semi = child.token(); return;
        case 7: items = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 8: endClocking = child.token(); return;
        case 9: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingDirectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingDirection;
}

bool ClockingDirectionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ClockingDirectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return input;
        case 1: return inputSkew;
        case 2: return output;
        case 3: return outputSkew;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingDirectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return input;
        case 1: return inputSkew;
        case 2: return output;
        case 3: return outputSkew;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingDirectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &input;
        case 1: return inputSkew;
        case 2: return &output;
        case 3: return outputSkew;
        default: return nullptr;
    }
}

void ClockingDirectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: input = child.token(); return;
        case 1: inputSkew = child.node() ? &child.node()->as<ClockingSkewSyntax>() : nullptr; return;
        case 2: output = child.token(); return;
        case 3: outputSkew = child.node() ? &child.node()->as<ClockingSkewSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingItem;
}

bool ClockingItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClockingItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction.get();
        case 2: return &decls;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction.get();
        case 2: return &decls;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction.get();
        case 2: return &decls;
        case 3: return &semi;
        default: return nullptr;
    }
}

void ClockingItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: direction = child.node() ? &child.node()->as<ClockingDirectionSyntax>() : nullptr; return;
        case 2: decls = child.node()->as<SeparatedSyntaxList<AttributeSpecSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingPropertyExpr;
}

bool ClockingPropertyExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ClockingPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return event.get();
        case 1: return expr;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return event.get();
        case 1: return expr;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return event.get();
        case 1: return expr;
        default: return nullptr;
    }
}

void ClockingPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: event = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingSequenceExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingSequenceExpr;
}

bool ClockingSequenceExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ClockingSequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return event.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingSequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return event.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingSequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return event.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

void ClockingSequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: event = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 1: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ClockingSkewSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ClockingSkew;
}

bool ClockingSkewSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ClockingSkewSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return edge;
        case 1: return delay;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ClockingSkewSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return edge;
        case 1: return delay;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ClockingSkewSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &edge;
        case 1: return delay;
        default: return nullptr;
    }
}

void ClockingSkewSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: edge = child.token(); return;
        case 1: delay = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ColonExpressionClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ColonExpressionClause;
}

bool ColonExpressionClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ColonExpressionClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return colon;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ColonExpressionClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return colon;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ColonExpressionClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &colon;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void ColonExpressionClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: colon = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CompilationUnitSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CompilationUnit;
}

bool CompilationUnitSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CompilationUnitSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &members;
        case 1: return endOfFile;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CompilationUnitSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &members;
        case 1: return endOfFile;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CompilationUnitSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &members;
        case 1: return &endOfFile;
        default: return nullptr;
    }
}

void CompilationUnitSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 1: endOfFile = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConcatenationExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConcatenationExpression;
}

bool ConcatenationExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConcatenationExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &expressions;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConcatenationExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &expressions;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConcatenationExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &expressions;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void ConcatenationExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: expressions = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConcurrentAssertionMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConcurrentAssertionMember;
}

bool ConcurrentAssertionMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConcurrentAssertionMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConcurrentAssertionMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConcurrentAssertionMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

void ConcurrentAssertionMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: statement = child.node() ? &child.node()->as<ConcurrentAssertionStatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConcurrentAssertionStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AssertPropertyStatement:
        case SyntaxKind::AssumePropertyStatement:
        case SyntaxKind::CoverPropertyStatement:
        case SyntaxKind::CoverSequenceStatement:
        case SyntaxKind::ExpectPropertyStatement:
        case SyntaxKind::RestrictPropertyStatement:
            return true;
        default:
            return false;
    }
}

bool ConcurrentAssertionStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ConcurrentAssertionStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return propertyOrSequence;
        case 4: return openParen;
        case 5: return propertySpec.get();
        case 6: return closeParen;
        case 7: return action.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConcurrentAssertionStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return propertyOrSequence;
        case 4: return openParen;
        case 5: return propertySpec.get();
        case 6: return closeParen;
        case 7: return action.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConcurrentAssertionStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &keyword;
        case 3: return &propertyOrSequence;
        case 4: return &openParen;
        case 5: return propertySpec.get();
        case 6: return &closeParen;
        case 7: return action.get();
        default: return nullptr;
    }
}

void ConcurrentAssertionStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: keyword = child.token(); return;
        case 3: propertyOrSequence = child.token(); return;
        case 4: openParen = child.token(); return;
        case 5: propertySpec = child.node() ? &child.node()->as<PropertySpecSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        case 7: action = child.node() ? &child.node()->as<ActionBlockSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalBranchDirectiveSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ElsIfDirective:
        case SyntaxKind::IfDefDirective:
        case SyntaxKind::IfNDefDirective:
            return true;
        default:
            return false;
    }
}

bool ConditionalBranchDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConditionalBranchDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return expr.get();
        case 2: return &disabledTokens;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalBranchDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return expr.get();
        case 2: return &disabledTokens;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalBranchDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return expr.get();
        case 2: return &disabledTokens;
        default: return nullptr;
    }
}

void ConditionalBranchDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ConditionalDirectiveExpressionSyntax>() : nullptr; return;
        case 2: disabledTokens = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalConstraint;
}

bool ConditionalConstraintSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax ConditionalConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return ifKeyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return constraints.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return ifKeyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return constraints.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &ifKeyword;
        case 1: return &openParen;
        case 2: return condition.get();
        case 3: return &closeParen;
        case 4: return constraints.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

void ConditionalConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: ifKeyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: constraints = child.node() ? &child.node()->as<ConstraintItemSyntax>() : nullptr; return;
        case 5: elseClause = child.node() ? &child.node()->as<ElseConstraintClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalDirectiveExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BinaryConditionalDirectiveExpression:
        case SyntaxKind::NamedConditionalDirectiveExpression:
        case SyntaxKind::ParenthesizedConditionalDirectiveExpression:
        case SyntaxKind::UnaryConditionalDirectiveExpression:
            return true;
        default:
            return false;
    }
}

bool ConditionalExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalExpression;
}

bool ConditionalExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConditionalExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return predicate.get();
        case 1: return question;
        case 2: return &attributes;
        case 3: return left.get();
        case 4: return colon;
        case 5: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return predicate.get();
        case 1: return question;
        case 2: return &attributes;
        case 3: return left.get();
        case 4: return colon;
        case 5: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return predicate.get();
        case 1: return &question;
        case 2: return &attributes;
        case 3: return left.get();
        case 4: return &colon;
        case 5: return right.get();
        default: return nullptr;
    }
}

void ConditionalExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: predicate = child.node() ? &child.node()->as<ConditionalPredicateSyntax>() : nullptr; return;
        case 1: question = child.token(); return;
        case 2: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 3: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: colon = child.token(); return;
        case 5: right = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalPathDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalPathDeclaration;
}

bool ConditionalPathDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConditionalPathDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return predicate.get();
        case 4: return closeParen;
        case 5: return path.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalPathDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return predicate.get();
        case 4: return closeParen;
        case 5: return path.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalPathDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &openParen;
        case 3: return predicate.get();
        case 4: return &closeParen;
        case 5: return path.get();
        default: return nullptr;
    }
}

void ConditionalPathDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: predicate = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        case 5: path = child.node() ? &child.node()->as<PathDeclarationSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalPattern;
}

bool ConditionalPatternSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ConditionalPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

void ConditionalPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: matchesClause = child.node() ? &child.node()->as<MatchesClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalPredicateSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalPredicate;
}

bool ConditionalPredicateSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConditionalPredicateSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &conditions;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalPredicateSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &conditions;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalPredicateSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &conditions;
        default: return nullptr;
    }
}

void ConditionalPredicateSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: conditions = child.node()->as<SeparatedSyntaxList<ConditionalPatternSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalPropertyExpr;
}

bool ConditionalPropertyExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax ConditionalPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return ifKeyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return expr.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return ifKeyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return expr.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &ifKeyword;
        case 1: return &openParen;
        case 2: return condition.get();
        case 3: return &closeParen;
        case 4: return expr.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

void ConditionalPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: ifKeyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 5: elseClause = child.node() ? &child.node()->as<ElsePropertyClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConditionalStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConditionalStatement;
}

bool ConditionalStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 8: return true;
        default: return false;
    }
}

TokenOrSyntax ConditionalStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return uniqueOrPriority;
        case 3: return ifKeyword;
        case 4: return openParen;
        case 5: return predicate.get();
        case 6: return closeParen;
        case 7: return statement.get();
        case 8: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConditionalStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return uniqueOrPriority;
        case 3: return ifKeyword;
        case 4: return openParen;
        case 5: return predicate.get();
        case 6: return closeParen;
        case 7: return statement.get();
        case 8: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConditionalStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &uniqueOrPriority;
        case 3: return &ifKeyword;
        case 4: return &openParen;
        case 5: return predicate.get();
        case 6: return &closeParen;
        case 7: return statement.get();
        case 8: return elseClause;
        default: return nullptr;
    }
}

void ConditionalStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: uniqueOrPriority = child.token(); return;
        case 3: ifKeyword = child.token(); return;
        case 4: openParen = child.token(); return;
        case 5: predicate = child.node() ? &child.node()->as<ConditionalPredicateSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        case 7: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        case 8: elseClause = child.node() ? &child.node()->as<ElseClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConfigCellIdentifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConfigCellIdentifier;
}

bool ConfigCellIdentifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConfigCellIdentifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return library;
        case 1: return dot;
        case 2: return cell;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConfigCellIdentifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return library;
        case 1: return dot;
        case 2: return cell;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConfigCellIdentifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &library;
        case 1: return &dot;
        case 2: return &cell;
        default: return nullptr;
    }
}

void ConfigCellIdentifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: library = child.token(); return;
        case 1: dot = child.token(); return;
        case 2: cell = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConfigDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConfigDeclaration;
}

bool ConfigDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 10: return true;
        default: return false;
    }
}

TokenOrSyntax ConfigDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return config;
        case 2: return name;
        case 3: return semi1;
        case 4: return &localparams;
        case 5: return design;
        case 6: return &topCells;
        case 7: return semi2;
        case 8: return &rules;
        case 9: return endconfig;
        case 10: return blockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConfigDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return config;
        case 2: return name;
        case 3: return semi1;
        case 4: return &localparams;
        case 5: return design;
        case 6: return &topCells;
        case 7: return semi2;
        case 8: return &rules;
        case 9: return endconfig;
        case 10: return blockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConfigDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &config;
        case 2: return &name;
        case 3: return &semi1;
        case 4: return &localparams;
        case 5: return &design;
        case 6: return &topCells;
        case 7: return &semi2;
        case 8: return &rules;
        case 9: return &endconfig;
        case 10: return blockName;
        default: return nullptr;
    }
}

void ConfigDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: config = child.token(); return;
        case 2: name = child.token(); return;
        case 3: semi1 = child.token(); return;
        case 4: localparams = child.node()->as<SyntaxList<ParameterDeclarationStatementSyntax>>(); return;
        case 5: design = child.token(); return;
        case 6: topCells = child.node()->as<SyntaxList<ConfigCellIdentifierSyntax>>(); return;
        case 7: semi2 = child.token(); return;
        case 8: rules = child.node()->as<SyntaxList<ConfigRuleSyntax>>(); return;
        case 9: endconfig = child.token(); return;
        case 10: blockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConfigInstanceIdentifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConfigInstanceIdentifier;
}

bool ConfigInstanceIdentifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConfigInstanceIdentifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConfigInstanceIdentifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConfigInstanceIdentifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &name;
        default: return nullptr;
    }
}

void ConfigInstanceIdentifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConfigLiblistSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConfigLiblist;
}

bool ConfigLiblistSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConfigLiblistSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return liblist;
        case 1: return &libraries;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConfigLiblistSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return liblist;
        case 1: return &libraries;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConfigLiblistSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &liblist;
        case 1: return &libraries;
        default: return nullptr;
    }
}

void ConfigLiblistSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: liblist = child.token(); return;
        case 1: libraries = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConfigRuleClauseSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ConfigLiblist:
        case SyntaxKind::ConfigUseClause:
            return true;
        default:
            return false;
    }
}

bool ConfigRuleSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::CellConfigRule:
        case SyntaxKind::DefaultConfigRule:
        case SyntaxKind::InstanceConfigRule:
            return true;
        default:
            return false;
    }
}

bool ConfigUseClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConfigUseClause;
}

bool ConfigUseClauseSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax ConfigUseClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return use;
        case 1: return name;
        case 2: return paramAssignments;
        case 3: return colon;
        case 4: return config;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConfigUseClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return use;
        case 1: return name;
        case 2: return paramAssignments;
        case 3: return colon;
        case 4: return config;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConfigUseClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &use;
        case 1: return name;
        case 2: return paramAssignments;
        case 3: return &colon;
        case 4: return &config;
        default: return nullptr;
    }
}

void ConfigUseClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: use = child.token(); return;
        case 1: name = child.node() ? &child.node()->as<ConfigCellIdentifierSyntax>() : nullptr; return;
        case 2: paramAssignments = child.node() ? &child.node()->as<ParameterValueAssignmentSyntax>() : nullptr; return;
        case 3: colon = child.token(); return;
        case 4: config = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConstraintBlockSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConstraintBlock;
}

bool ConstraintBlockSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConstraintBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConstraintBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConstraintBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &items;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void ConstraintBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: items = child.node()->as<SyntaxList<ConstraintItemSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConstraintDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConstraintDeclaration;
}

bool ConstraintDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConstraintDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return block.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConstraintDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return block.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConstraintDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return &keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return block.get();
        default: return nullptr;
    }
}

void ConstraintDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: keyword = child.token(); return;
        case 3: specifiers = child.node()->as<SyntaxList<ClassSpecifierSyntax>>(); return;
        case 4: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 5: block = child.node() ? &child.node()->as<ConstraintBlockSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ConstraintItemSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ConditionalConstraint:
        case SyntaxKind::ConstraintBlock:
        case SyntaxKind::DisableConstraint:
        case SyntaxKind::ExpressionConstraint:
        case SyntaxKind::ImplicationConstraint:
        case SyntaxKind::LoopConstraint:
        case SyntaxKind::SolveBeforeConstraint:
        case SyntaxKind::UniquenessConstraint:
            return true;
        default:
            return false;
    }
}

bool ConstraintPrototypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ConstraintPrototype;
}

bool ConstraintPrototypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ConstraintPrototypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ConstraintPrototypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ConstraintPrototypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return &keyword;
        case 3: return &specifiers;
        case 4: return name.get();
        case 5: return &semi;
        default: return nullptr;
    }
}

void ConstraintPrototypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: keyword = child.token(); return;
        case 3: specifiers = child.node()->as<SyntaxList<ClassSpecifierSyntax>>(); return;
        case 4: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ContinuousAssignSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ContinuousAssign;
}

bool ContinuousAssignSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ContinuousAssignSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return assign;
        case 2: return strength;
        case 3: return delay;
        case 4: return &assignments;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ContinuousAssignSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return assign;
        case 2: return strength;
        case 3: return delay;
        case 4: return &assignments;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ContinuousAssignSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &assign;
        case 2: return strength;
        case 3: return delay;
        case 4: return &assignments;
        case 5: return &semi;
        default: return nullptr;
    }
}

void ContinuousAssignSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: assign = child.token(); return;
        case 2: strength = child.node() ? &child.node()->as<DriveStrengthSyntax>() : nullptr; return;
        case 3: delay = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 4: assignments = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CopyClassExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CopyClassExpression;
}

bool CopyClassExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CopyClassExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax CopyClassExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax CopyClassExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

void CopyClassExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: scopedNew = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverCrossSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CoverCross;
}

bool CoverCrossSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax CoverCrossSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return cross;
        case 3: return &items;
        case 4: return iff;
        case 5: return openBrace;
        case 6: return &members;
        case 7: return closeBrace;
        case 8: return emptySemi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverCrossSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return cross;
        case 3: return &items;
        case 4: return iff;
        case 5: return openBrace;
        case 6: return &members;
        case 7: return closeBrace;
        case 8: return emptySemi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverCrossSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return &cross;
        case 3: return &items;
        case 4: return iff;
        case 5: return &openBrace;
        case 6: return &members;
        case 7: return &closeBrace;
        case 8: return &emptySemi;
        default: return nullptr;
    }
}

void CoverCrossSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 2: cross = child.token(); return;
        case 3: items = child.node()->as<SeparatedSyntaxList<IdentifierNameSyntax>>(); return;
        case 4: iff = child.node() ? &child.node()->as<CoverageIffClauseSyntax>() : nullptr; return;
        case 5: openBrace = child.token(); return;
        case 6: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 7: closeBrace = child.token(); return;
        case 8: emptySemi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultCoverageBinInitializer:
        case SyntaxKind::ExpressionCoverageBinInitializer:
        case SyntaxKind::IdWithExprCoverageBinInitializer:
        case SyntaxKind::RangeCoverageBinInitializer:
        case SyntaxKind::TransListCoverageBinInitializer:
            return true;
        default:
            return false;
    }
}

bool CoverageBinsArraySizeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CoverageBinsArraySize;
}

bool CoverageBinsArraySizeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax CoverageBinsArraySizeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return expr;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverageBinsArraySizeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return expr;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverageBinsArraySizeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return expr;
        case 2: return &closeBracket;
        default: return nullptr;
    }
}

void CoverageBinsArraySizeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverageBinsSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CoverageBins;
}

bool CoverageBinsSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        case 7: return true;
        default: return false;
    }
}

TokenOrSyntax CoverageBinsSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return wildcard;
        case 2: return keyword;
        case 3: return name;
        case 4: return size;
        case 5: return equals;
        case 6: return initializer.get();
        case 7: return iff;
        case 8: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverageBinsSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return wildcard;
        case 2: return keyword;
        case 3: return name;
        case 4: return size;
        case 5: return equals;
        case 6: return initializer.get();
        case 7: return iff;
        case 8: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverageBinsSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &wildcard;
        case 2: return &keyword;
        case 3: return &name;
        case 4: return size;
        case 5: return &equals;
        case 6: return initializer.get();
        case 7: return iff;
        case 8: return &semi;
        default: return nullptr;
    }
}

void CoverageBinsSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: wildcard = child.token(); return;
        case 2: keyword = child.token(); return;
        case 3: name = child.token(); return;
        case 4: size = child.node() ? &child.node()->as<CoverageBinsArraySizeSyntax>() : nullptr; return;
        case 5: equals = child.token(); return;
        case 6: initializer = child.node() ? &child.node()->as<CoverageBinInitializerSyntax>() : nullptr; return;
        case 7: iff = child.node() ? &child.node()->as<CoverageIffClauseSyntax>() : nullptr; return;
        case 8: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverageIffClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CoverageIffClause;
}

bool CoverageIffClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CoverageIffClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return iff;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverageIffClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return iff;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverageIffClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &iff;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void CoverageIffClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: iff = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverageOptionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CoverageOption;
}

bool CoverageOptionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax CoverageOptionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverageOptionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverageOptionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        case 2: return &semi;
        default: return nullptr;
    }
}

void CoverageOptionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool CovergroupDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::CovergroupDeclaration;
}

bool CovergroupDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        case 5: return true;
        case 9: return true;
        default: return false;
    }
}

TokenOrSyntax CovergroupDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return covergroup;
        case 2: return extends;
        case 3: return name;
        case 4: return portList;
        case 5: return event;
        case 6: return semi;
        case 7: return &members;
        case 8: return endgroup;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CovergroupDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return covergroup;
        case 2: return extends;
        case 3: return name;
        case 4: return portList;
        case 5: return event;
        case 6: return semi;
        case 7: return &members;
        case 8: return endgroup;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CovergroupDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &covergroup;
        case 2: return &extends;
        case 3: return &name;
        case 4: return portList;
        case 5: return event;
        case 6: return &semi;
        case 7: return &members;
        case 8: return &endgroup;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

void CovergroupDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: covergroup = child.token(); return;
        case 2: extends = child.token(); return;
        case 3: name = child.token(); return;
        case 4: portList = child.node() ? &child.node()->as<FunctionPortListSyntax>() : nullptr; return;
        case 5: event = child.node() ? &child.node()->as<SyntaxNode>() : nullptr; return;
        case 6: semi = child.token(); return;
        case 7: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 8: endgroup = child.token(); return;
        case 9: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool CoverpointSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::Coverpoint;
}

bool CoverpointSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax CoverpointSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return label;
        case 3: return coverpoint;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return openBrace;
        case 7: return &members;
        case 8: return closeBrace;
        case 9: return emptySemi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax CoverpointSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return label;
        case 3: return coverpoint;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return openBrace;
        case 7: return &members;
        case 8: return closeBrace;
        case 9: return emptySemi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax CoverpointSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type.get();
        case 2: return label;
        case 3: return &coverpoint;
        case 4: return expr.get();
        case 5: return iff;
        case 6: return &openBrace;
        case 7: return &members;
        case 8: return &closeBrace;
        case 9: return &emptySemi;
        default: return nullptr;
    }
}

void CoverpointSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 2: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 3: coverpoint = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: iff = child.node() ? &child.node()->as<CoverageIffClauseSyntax>() : nullptr; return;
        case 6: openBrace = child.token(); return;
        case 7: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 8: closeBrace = child.token(); return;
        case 9: emptySemi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DPIExportSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DPIExport;
}

bool DPIExportSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DPIExportSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return specString;
        case 3: return c_identifier;
        case 4: return equals;
        case 5: return functionOrTask;
        case 6: return name;
        case 7: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DPIExportSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return specString;
        case 3: return c_identifier;
        case 4: return equals;
        case 5: return functionOrTask;
        case 6: return name;
        case 7: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DPIExportSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &specString;
        case 3: return &c_identifier;
        case 4: return &equals;
        case 5: return &functionOrTask;
        case 6: return &name;
        case 7: return &semi;
        default: return nullptr;
    }
}

void DPIExportSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: specString = child.token(); return;
        case 3: c_identifier = child.token(); return;
        case 4: equals = child.token(); return;
        case 5: functionOrTask = child.token(); return;
        case 6: name = child.token(); return;
        case 7: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DPIImportSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DPIImport;
}

bool DPIImportSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DPIImportSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return specString;
        case 3: return property;
        case 4: return c_identifier;
        case 5: return equals;
        case 6: return method.get();
        case 7: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DPIImportSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return specString;
        case 3: return property;
        case 4: return c_identifier;
        case 5: return equals;
        case 6: return method.get();
        case 7: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DPIImportSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &specString;
        case 3: return &property;
        case 4: return &c_identifier;
        case 5: return &equals;
        case 6: return method.get();
        case 7: return &semi;
        default: return nullptr;
    }
}

void DPIImportSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: specString = child.token(); return;
        case 3: property = child.token(); return;
        case 4: c_identifier = child.token(); return;
        case 5: equals = child.token(); return;
        case 6: method = child.node() ? &child.node()->as<FunctionPrototypeSyntax>() : nullptr; return;
        case 7: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DataDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DataDeclaration;
}

bool DataDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DataDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &modifiers;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DataDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &modifiers;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DataDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &modifiers;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return &semi;
        default: return nullptr;
    }
}

void DataDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: modifiers = child.node()->as<TokenList>(); return;
        case 2: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DataTypeSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BitType:
        case SyntaxKind::ByteType:
        case SyntaxKind::CHandleType:
        case SyntaxKind::EnumType:
        case SyntaxKind::EventType:
        case SyntaxKind::ImplicitType:
        case SyntaxKind::IntType:
        case SyntaxKind::IntegerType:
        case SyntaxKind::LogicType:
        case SyntaxKind::LongIntType:
        case SyntaxKind::NamedType:
        case SyntaxKind::PropertyType:
        case SyntaxKind::RealTimeType:
        case SyntaxKind::RealType:
        case SyntaxKind::RegType:
        case SyntaxKind::SequenceType:
        case SyntaxKind::ShortIntType:
        case SyntaxKind::ShortRealType:
        case SyntaxKind::StringType:
        case SyntaxKind::StructType:
        case SyntaxKind::TimeType:
        case SyntaxKind::TypeReference:
        case SyntaxKind::UnionType:
        case SyntaxKind::Untyped:
        case SyntaxKind::VirtualInterfaceType:
        case SyntaxKind::VoidType:
            return true;
        default:
            return false;
    }
}

bool DeclaratorSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::Declarator;
}

bool DeclaratorSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax DeclaratorSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return &dimensions;
        case 2: return initializer;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DeclaratorSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return &dimensions;
        case 2: return initializer;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DeclaratorSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &dimensions;
        case 2: return initializer;
        default: return nullptr;
    }
}

void DeclaratorSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        case 2: initializer = child.node() ? &child.node()->as<EqualsValueClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefParamAssignmentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefParamAssignment;
}

bool DefParamAssignmentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefParamAssignmentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name.get();
        case 1: return setter.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefParamAssignmentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name.get();
        case 1: return setter.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefParamAssignmentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return name.get();
        case 1: return setter.get();
        default: return nullptr;
    }
}

void DefParamAssignmentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: setter = child.node() ? &child.node()->as<EqualsValueClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefParamSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefParam;
}

bool DefParamSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefParamSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return defparam;
        case 2: return &assignments;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefParamSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return defparam;
        case 2: return &assignments;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefParamSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &defparam;
        case 2: return &assignments;
        case 3: return &semi;
        default: return nullptr;
    }
}

void DefParamSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: defparam = child.token(); return;
        case 2: assignments = child.node()->as<SeparatedSyntaxList<DefParamAssignmentSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultCaseItem;
}

bool DefaultCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return &colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

void DefaultCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: colon = child.token(); return;
        case 2: clause = child.node() ? &child.node()->as<SyntaxNode>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultClockingReferenceSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultClockingReference;
}

bool DefaultClockingReferenceSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultClockingReferenceSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return defaultKeyword;
        case 2: return clocking;
        case 3: return name;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultClockingReferenceSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return defaultKeyword;
        case 2: return clocking;
        case 3: return name;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultClockingReferenceSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &defaultKeyword;
        case 2: return &clocking;
        case 3: return &name;
        case 4: return &semi;
        default: return nullptr;
    }
}

void DefaultClockingReferenceSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: defaultKeyword = child.token(); return;
        case 2: clocking = child.token(); return;
        case 3: name = child.token(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultConfigRuleSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultConfigRule;
}

bool DefaultConfigRuleSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultConfigRuleSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return liblist.get();
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultConfigRuleSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return liblist.get();
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultConfigRuleSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return liblist.get();
        case 2: return &semi;
        default: return nullptr;
    }
}

void DefaultConfigRuleSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: liblist = child.node() ? &child.node()->as<ConfigLiblistSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultCoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultCoverageBinInitializer;
}

bool DefaultCoverageBinInitializerSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultCoverageBinInitializerSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return sequenceKeyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultCoverageBinInitializerSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return sequenceKeyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultCoverageBinInitializerSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return &sequenceKeyword;
        default: return nullptr;
    }
}

void DefaultCoverageBinInitializerSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: sequenceKeyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultDecayTimeDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultDecayTimeDirective;
}

bool DefaultDecayTimeDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultDecayTimeDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return time;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultDecayTimeDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return time;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultDecayTimeDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &time;
        default: return nullptr;
    }
}

void DefaultDecayTimeDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: time = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultDisableDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultDisableDeclaration;
}

bool DefaultDisableDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultDisableDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return defaultKeyword;
        case 2: return disableKeyword;
        case 3: return iffKeyword;
        case 4: return expr.get();
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultDisableDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return defaultKeyword;
        case 2: return disableKeyword;
        case 3: return iffKeyword;
        case 4: return expr.get();
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultDisableDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &defaultKeyword;
        case 2: return &disableKeyword;
        case 3: return &iffKeyword;
        case 4: return expr.get();
        case 5: return &semi;
        default: return nullptr;
    }
}

void DefaultDisableDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: defaultKeyword = child.token(); return;
        case 2: disableKeyword = child.token(); return;
        case 3: iffKeyword = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultDistItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultDistItem;
}

bool DefaultDistItemSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax DefaultDistItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return weight;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultDistItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return weight;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultDistItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return weight;
        default: return nullptr;
    }
}

void DefaultDistItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: weight = child.node() ? &child.node()->as<DistWeightSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultExtendsClauseArgSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultExtendsClauseArg;
}

bool DefaultExtendsClauseArgSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultExtendsClauseArgSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return defaultKeyword;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultExtendsClauseArgSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return defaultKeyword;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultExtendsClauseArgSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &defaultKeyword;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void DefaultExtendsClauseArgSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: defaultKeyword = child.token(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultFunctionPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultFunctionPort;
}

bool DefaultFunctionPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultFunctionPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultFunctionPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultFunctionPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        default: return nullptr;
    }
}

void DefaultFunctionPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultNetTypeDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultNetTypeDirective;
}

bool DefaultNetTypeDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultNetTypeDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return netType;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultNetTypeDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return netType;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultNetTypeDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &netType;
        default: return nullptr;
    }
}

void DefaultNetTypeDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: netType = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultPropertyCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultPropertyCaseItem;
}

bool DefaultPropertyCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultPropertyCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultPropertyCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultPropertyCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return &colon;
        case 2: return expr.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void DefaultPropertyCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: colon = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultRsCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultRsCaseItem;
}

bool DefaultRsCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultRsCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return item.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultRsCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return defaultKeyword;
        case 1: return colon;
        case 2: return item.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultRsCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &defaultKeyword;
        case 1: return &colon;
        case 2: return item.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void DefaultRsCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: defaultKeyword = child.token(); return;
        case 1: colon = child.token(); return;
        case 2: item = child.node() ? &child.node()->as<RsProdItemSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultSkewItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultSkewItem;
}

bool DefaultSkewItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultSkewItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return direction.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultSkewItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return direction.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultSkewItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return direction.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void DefaultSkewItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: direction = child.node() ? &child.node()->as<ClockingDirectionSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefaultTriregStrengthDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefaultTriregStrengthDirective;
}

bool DefaultTriregStrengthDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DefaultTriregStrengthDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return strength;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefaultTriregStrengthDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return strength;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefaultTriregStrengthDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &strength;
        default: return nullptr;
    }
}

void DefaultTriregStrengthDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: strength = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DeferredAssertionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DeferredAssertion;
}

bool DeferredAssertionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DeferredAssertionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return zero;
        case 2: return finalKeyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DeferredAssertionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return zero;
        case 2: return finalKeyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DeferredAssertionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return &zero;
        case 2: return &finalKeyword;
        default: return nullptr;
    }
}

void DeferredAssertionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: zero = child.token(); return;
        case 2: finalKeyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DefineDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DefineDirective;
}

bool DefineDirectiveSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax DefineDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        case 2: return formalArguments;
        case 3: return &body;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DefineDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        case 2: return formalArguments;
        case 3: return &body;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DefineDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &name;
        case 2: return formalArguments;
        case 3: return &body;
        default: return nullptr;
    }
}

void DefineDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: name = child.token(); return;
        case 2: formalArguments = child.node() ? &child.node()->as<MacroFormalArgumentListSyntax>() : nullptr; return;
        case 3: body = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool Delay3Syntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::Delay3;
}

bool Delay3Syntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax Delay3Syntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return delay1.get();
        case 3: return comma1;
        case 4: return delay2;
        case 5: return comma2;
        case 6: return delay3;
        case 7: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax Delay3Syntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return delay1.get();
        case 3: return comma1;
        case 4: return delay2;
        case 5: return comma2;
        case 6: return delay3;
        case 7: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax Delay3Syntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return &openParen;
        case 2: return delay1.get();
        case 3: return &comma1;
        case 4: return delay2;
        case 5: return &comma2;
        case 6: return delay3;
        case 7: return &closeParen;
        default: return nullptr;
    }
}

void Delay3Syntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: delay1 = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: comma1 = child.token(); return;
        case 4: delay2 = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: comma2 = child.token(); return;
        case 6: delay3 = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 7: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DelaySyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::CycleDelay:
        case SyntaxKind::DelayControl:
            return true;
        default:
            return false;
    }
}

bool DelaySyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DelaySyntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return delayValue.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax DelaySyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return delayValue.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax DelaySyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return delayValue.get();
        default: return nullptr;
    }
}

void DelaySyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: delayValue = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DelayedSequenceElementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DelayedSequenceElement;
}

bool DelayedSequenceElementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax DelayedSequenceElementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return doubleHash;
        case 1: return delayVal;
        case 2: return openBracket;
        case 3: return op;
        case 4: return range;
        case 5: return closeBracket;
        case 6: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax DelayedSequenceElementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return doubleHash;
        case 1: return delayVal;
        case 2: return openBracket;
        case 3: return op;
        case 4: return range;
        case 5: return closeBracket;
        case 6: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax DelayedSequenceElementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &doubleHash;
        case 1: return delayVal;
        case 2: return &openBracket;
        case 3: return &op;
        case 4: return range;
        case 5: return &closeBracket;
        case 6: return expr.get();
        default: return nullptr;
    }
}

void DelayedSequenceElementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: doubleHash = child.token(); return;
        case 1: delayVal = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: openBracket = child.token(); return;
        case 3: op = child.token(); return;
        case 4: range = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        case 5: closeBracket = child.token(); return;
        case 6: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DelayedSequenceExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DelayedSequenceExpr;
}

bool DelayedSequenceExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax DelayedSequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return first;
        case 1: return &elements;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DelayedSequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return first;
        case 1: return &elements;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DelayedSequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return first;
        case 1: return &elements;
        default: return nullptr;
    }
}

void DelayedSequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: first = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 1: elements = child.node()->as<SyntaxList<DelayedSequenceElementSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DimensionSpecifierSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::QueueDimensionSpecifier:
        case SyntaxKind::RangeDimensionSpecifier:
        case SyntaxKind::WildcardDimensionSpecifier:
            return true;
        default:
            return false;
    }
}

bool DirectiveSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BeginKeywordsDirective:
        case SyntaxKind::CellDefineDirective:
        case SyntaxKind::DefaultDecayTimeDirective:
        case SyntaxKind::DefaultNetTypeDirective:
        case SyntaxKind::DefaultTriregStrengthDirective:
        case SyntaxKind::DefineDirective:
        case SyntaxKind::DelayModeDistributedDirective:
        case SyntaxKind::DelayModePathDirective:
        case SyntaxKind::DelayModeUnitDirective:
        case SyntaxKind::DelayModeZeroDirective:
        case SyntaxKind::ElsIfDirective:
        case SyntaxKind::ElseDirective:
        case SyntaxKind::EndCellDefineDirective:
        case SyntaxKind::EndIfDirective:
        case SyntaxKind::EndKeywordsDirective:
        case SyntaxKind::EndProtectDirective:
        case SyntaxKind::EndProtectedDirective:
        case SyntaxKind::IfDefDirective:
        case SyntaxKind::IfNDefDirective:
        case SyntaxKind::IncludeDirective:
        case SyntaxKind::LineDirective:
        case SyntaxKind::MacroUsage:
        case SyntaxKind::NoUnconnectedDriveDirective:
        case SyntaxKind::PragmaDirective:
        case SyntaxKind::ProtectDirective:
        case SyntaxKind::ProtectedDirective:
        case SyntaxKind::ResetAllDirective:
        case SyntaxKind::TimeScaleDirective:
        case SyntaxKind::UnconnectedDriveDirective:
        case SyntaxKind::UndefDirective:
        case SyntaxKind::UndefineAllDirective:
            return true;
        default:
            return false;
    }
}

bool DirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        default: return nullptr;
    }
}

void DirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DisableConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DisableConstraint;
}

bool DisableConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DisableConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return disable;
        case 1: return soft;
        case 2: return name.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DisableConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return disable;
        case 1: return soft;
        case 2: return name.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DisableConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &disable;
        case 1: return &soft;
        case 2: return name.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void DisableConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: disable = child.token(); return;
        case 1: soft = child.token(); return;
        case 2: name = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DisableForkStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DisableForkStatement;
}

bool DisableForkStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax DisableForkStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return disable;
        case 3: return fork;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DisableForkStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return disable;
        case 3: return fork;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DisableForkStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &disable;
        case 3: return &fork;
        case 4: return &semi;
        default: return nullptr;
    }
}

void DisableForkStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: disable = child.token(); return;
        case 3: fork = child.token(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DisableIffSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DisableIff;
}

bool DisableIffSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DisableIffSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return disable;
        case 1: return iff;
        case 2: return openParen;
        case 3: return expr.get();
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DisableIffSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return disable;
        case 1: return iff;
        case 2: return openParen;
        case 3: return expr.get();
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DisableIffSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &disable;
        case 1: return &iff;
        case 2: return &openParen;
        case 3: return expr.get();
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void DisableIffSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: disable = child.token(); return;
        case 1: iff = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DisableStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DisableStatement;
}

bool DisableStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax DisableStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return disable;
        case 3: return name.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DisableStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return disable;
        case 3: return name.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DisableStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &disable;
        case 3: return name.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void DisableStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: disable = child.token(); return;
        case 3: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DistConstraintListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DistConstraintList;
}

bool DistConstraintListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DistConstraintListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dist;
        case 1: return openBrace;
        case 2: return &items;
        case 3: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DistConstraintListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dist;
        case 1: return openBrace;
        case 2: return &items;
        case 3: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DistConstraintListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dist;
        case 1: return &openBrace;
        case 2: return &items;
        case 3: return &closeBrace;
        default: return nullptr;
    }
}

void DistConstraintListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dist = child.token(); return;
        case 1: openBrace = child.token(); return;
        case 2: items = child.node()->as<SeparatedSyntaxList<DistItemBaseSyntax>>(); return;
        case 3: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DistItemBaseSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultDistItem:
        case SyntaxKind::DistItem:
            return true;
        default:
            return false;
    }
}

bool DistItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DistItem;
}

bool DistItemSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax DistItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return range.get();
        case 1: return weight;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DistItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return range.get();
        case 1: return weight;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DistItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return range.get();
        case 1: return weight;
        default: return nullptr;
    }
}

void DistItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: range = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: weight = child.node() ? &child.node()->as<DistWeightSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DistWeightSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DistWeight;
}

bool DistWeightSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DistWeightSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return op;
        case 1: return extraOp;
        case 2: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax DistWeightSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return op;
        case 1: return extraOp;
        case 2: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax DistWeightSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &op;
        case 1: return &extraOp;
        case 2: return expr.get();
        default: return nullptr;
    }
}

void DistWeightSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: op = child.token(); return;
        case 1: extraOp = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool DividerClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DividerClause;
}

bool DividerClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DividerClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return divide;
        case 1: return value;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DividerClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return divide;
        case 1: return value;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DividerClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &divide;
        case 1: return &value;
        default: return nullptr;
    }
}

void DividerClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: divide = child.token(); return;
        case 1: value = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DoWhileStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DoWhileStatement;
}

bool DoWhileStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax DoWhileStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return doKeyword;
        case 3: return statement.get();
        case 4: return whileKeyword;
        case 5: return openParen;
        case 6: return expr.get();
        case 7: return closeParen;
        case 8: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DoWhileStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return doKeyword;
        case 3: return statement.get();
        case 4: return whileKeyword;
        case 5: return openParen;
        case 6: return expr.get();
        case 7: return closeParen;
        case 8: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DoWhileStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &doKeyword;
        case 3: return statement.get();
        case 4: return &whileKeyword;
        case 5: return &openParen;
        case 6: return expr.get();
        case 7: return &closeParen;
        case 8: return &semi;
        default: return nullptr;
    }
}

void DoWhileStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: doKeyword = child.token(); return;
        case 3: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        case 4: whileKeyword = child.token(); return;
        case 5: openParen = child.token(); return;
        case 6: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 7: closeParen = child.token(); return;
        case 8: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DotMemberClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DotMemberClause;
}

bool DotMemberClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DotMemberClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return member;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DotMemberClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return member;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DotMemberClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &member;
        default: return nullptr;
    }
}

void DotMemberClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: member = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool DriveStrengthSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::DriveStrength;
}

bool DriveStrengthSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax DriveStrengthSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return strength0;
        case 2: return comma;
        case 3: return strength1;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax DriveStrengthSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return strength0;
        case 2: return comma;
        case 3: return strength1;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax DriveStrengthSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &strength0;
        case 2: return &comma;
        case 3: return &strength1;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void DriveStrengthSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: strength0 = child.token(); return;
        case 2: comma = child.token(); return;
        case 3: strength1 = child.token(); return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EdgeControlSpecifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EdgeControlSpecifier;
}

bool EdgeControlSpecifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EdgeControlSpecifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return &descriptors;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EdgeControlSpecifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return &descriptors;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EdgeControlSpecifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return &descriptors;
        case 2: return &closeBracket;
        default: return nullptr;
    }
}

void EdgeControlSpecifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: descriptors = child.node()->as<SeparatedSyntaxList<EdgeDescriptorSyntax>>(); return;
        case 2: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EdgeDescriptorSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EdgeDescriptor;
}

bool EdgeDescriptorSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EdgeDescriptorSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return t1;
        case 1: return t2;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EdgeDescriptorSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return t1;
        case 1: return t2;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EdgeDescriptorSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &t1;
        case 1: return &t2;
        default: return nullptr;
    }
}

void EdgeDescriptorSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: t1 = child.token(); return;
        case 1: t2 = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EdgeSensitivePathSuffixSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EdgeSensitivePathSuffix;
}

bool EdgeSensitivePathSuffixSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EdgeSensitivePathSuffixSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &outputs;
        case 2: return polarityOperator;
        case 3: return colon;
        case 4: return expr.get();
        case 5: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EdgeSensitivePathSuffixSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &outputs;
        case 2: return polarityOperator;
        case 3: return colon;
        case 4: return expr.get();
        case 5: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EdgeSensitivePathSuffixSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &outputs;
        case 2: return &polarityOperator;
        case 3: return &colon;
        case 4: return expr.get();
        case 5: return &closeParen;
        default: return nullptr;
    }
}

void EdgeSensitivePathSuffixSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: outputs = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        case 2: polarityOperator = child.token(); return;
        case 3: colon = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElabSystemTaskSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElabSystemTask;
}

bool ElabSystemTaskSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax ElabSystemTaskSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return name;
        case 2: return arguments;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElabSystemTaskSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return name;
        case 2: return arguments;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElabSystemTaskSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &name;
        case 2: return arguments;
        case 3: return &semi;
        default: return nullptr;
    }
}

void ElabSystemTaskSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: name = child.token(); return;
        case 2: arguments = child.node() ? &child.node()->as<ArgumentListSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElementSelectExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElementSelectExpression;
}

bool ElementSelectExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ElementSelectExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return select.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElementSelectExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return select.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElementSelectExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return select.get();
        default: return nullptr;
    }
}

void ElementSelectExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: select = child.node() ? &child.node()->as<ElementSelectSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElementSelectSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElementSelect;
}

bool ElementSelectSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ElementSelectSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return selector;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElementSelectSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return selector;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElementSelectSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return selector;
        case 2: return &closeBracket;
        default: return nullptr;
    }
}

void ElementSelectSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: selector = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        case 2: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElseClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElseClause;
}

bool ElseClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ElseClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return clause.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElseClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return clause.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElseClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &elseKeyword;
        case 1: return clause.get();
        default: return nullptr;
    }
}

void ElseClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: elseKeyword = child.token(); return;
        case 1: clause = child.node() ? &child.node()->as<SyntaxNode>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElseConstraintClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElseConstraintClause;
}

bool ElseConstraintClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ElseConstraintClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return constraints.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElseConstraintClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return constraints.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElseConstraintClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &elseKeyword;
        case 1: return constraints.get();
        default: return nullptr;
    }
}

void ElseConstraintClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: elseKeyword = child.token(); return;
        case 1: constraints = child.node() ? &child.node()->as<ConstraintItemSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ElsePropertyClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ElsePropertyClause;
}

bool ElsePropertyClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ElsePropertyClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ElsePropertyClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return elseKeyword;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ElsePropertyClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &elseKeyword;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void ElsePropertyClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: elseKeyword = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyArgumentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyArgument;
}

bool EmptyArgumentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyArgumentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyArgumentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyArgumentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &placeholder;
        default: return nullptr;
    }
}

void EmptyArgumentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyIdentifierNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyIdentifierName;
}

bool EmptyIdentifierNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyIdentifierNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyIdentifierNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyIdentifierNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &placeholder;
        default: return nullptr;
    }
}

void EmptyIdentifierNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyMember;
}

bool EmptyMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &qualifiers;
        case 2: return &semi;
        default: return nullptr;
    }
}

void EmptyMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: qualifiers = child.node()->as<TokenList>(); return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyNonAnsiPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyNonAnsiPort;
}

bool EmptyNonAnsiPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyNonAnsiPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyNonAnsiPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyNonAnsiPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &placeholder;
        default: return nullptr;
    }
}

void EmptyNonAnsiPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyPortConnectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyPortConnection;
}

bool EmptyPortConnectionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyPortConnectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyPortConnectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyPortConnectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &placeholder;
        default: return nullptr;
    }
}

void EmptyPortConnectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyQueueExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyQueueExpression;
}

bool EmptyQueueExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyQueueExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyQueueExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyQueueExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &closeBrace;
        default: return nullptr;
    }
}

void EmptyQueueExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyStatement;
}

bool EmptyStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax EmptyStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return semicolon;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return semicolon;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &semicolon;
        default: return nullptr;
    }
}

void EmptyStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: semicolon = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EmptyTimingCheckArgSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EmptyTimingCheckArg;
}

bool EmptyTimingCheckArgSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EmptyTimingCheckArgSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EmptyTimingCheckArgSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EmptyTimingCheckArgSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &placeholder;
        default: return nullptr;
    }
}

void EmptyTimingCheckArgSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EnumTypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EnumType;
}

bool EnumTypeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax EnumTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return baseType;
        case 2: return openBrace;
        case 3: return &members;
        case 4: return closeBrace;
        case 5: return &dimensions;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EnumTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return baseType;
        case 2: return openBrace;
        case 3: return &members;
        case 4: return closeBrace;
        case 5: return &dimensions;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EnumTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return baseType;
        case 2: return &openBrace;
        case 3: return &members;
        case 4: return &closeBrace;
        case 5: return &dimensions;
        default: return nullptr;
    }
}

void EnumTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: baseType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 2: openBrace = child.token(); return;
        case 3: members = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 4: closeBrace = child.token(); return;
        case 5: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool EqualsAssertionArgClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EqualsAssertionArgClause;
}

bool EqualsAssertionArgClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EqualsAssertionArgClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax EqualsAssertionArgClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax EqualsAssertionArgClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void EqualsAssertionArgClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: equals = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EqualsTypeClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EqualsTypeClause;
}

bool EqualsTypeClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EqualsTypeClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return equals;
        case 1: return type.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax EqualsTypeClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return equals;
        case 1: return type.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax EqualsTypeClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &equals;
        case 1: return type.get();
        default: return nullptr;
    }
}

void EqualsTypeClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: equals = child.token(); return;
        case 1: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EqualsValueClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EqualsValueClause;
}

bool EqualsValueClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EqualsValueClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax EqualsValueClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax EqualsValueClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &equals;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void EqualsValueClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: equals = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EventControlSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EventControl;
}

bool EventControlSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EventControlSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return at;
        case 1: return eventName.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax EventControlSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return at;
        case 1: return eventName.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax EventControlSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &at;
        case 1: return eventName.get();
        default: return nullptr;
    }
}

void EventControlSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: at = child.token(); return;
        case 1: eventName = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EventControlWithExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::EventControlWithExpression;
}

bool EventControlWithExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax EventControlWithExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return at;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax EventControlWithExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return at;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax EventControlWithExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &at;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void EventControlWithExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: at = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<EventExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool EventExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BinaryEventExpression:
        case SyntaxKind::ParenthesizedEventExpression:
        case SyntaxKind::SignalEventExpression:
            return true;
        default:
            return false;
    }
}

bool EventTriggerStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BlockingEventTriggerStatement:
        case SyntaxKind::NonblockingEventTriggerStatement:
            return true;
        default:
            return false;
    }
}

bool EventTriggerStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax EventTriggerStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return trigger;
        case 3: return timing;
        case 4: return name.get();
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax EventTriggerStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return trigger;
        case 3: return timing;
        case 4: return name.get();
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax EventTriggerStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &trigger;
        case 3: return timing;
        case 4: return name.get();
        case 5: return &semi;
        default: return nullptr;
    }
}

void EventTriggerStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: trigger = child.token(); return;
        case 3: timing = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 4: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExplicitAnsiPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExplicitAnsiPort;
}

bool ExplicitAnsiPortSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax ExplicitAnsiPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction;
        case 2: return dot;
        case 3: return name;
        case 4: return openParen;
        case 5: return expr;
        case 6: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExplicitAnsiPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction;
        case 2: return dot;
        case 3: return name;
        case 4: return openParen;
        case 5: return expr;
        case 6: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExplicitAnsiPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &direction;
        case 2: return &dot;
        case 3: return &name;
        case 4: return &openParen;
        case 5: return expr;
        case 6: return &closeParen;
        default: return nullptr;
    }
}

void ExplicitAnsiPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: direction = child.token(); return;
        case 2: dot = child.token(); return;
        case 3: name = child.token(); return;
        case 4: openParen = child.token(); return;
        case 5: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExplicitNonAnsiPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExplicitNonAnsiPort;
}

bool ExplicitNonAnsiPortSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ExplicitNonAnsiPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExplicitNonAnsiPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExplicitNonAnsiPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &name;
        case 2: return &openParen;
        case 3: return expr;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void ExplicitNonAnsiPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: name = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<PortExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionConstraint;
}

bool ExpressionConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExpressionConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return soft;
        case 1: return expr.get();
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return soft;
        case 1: return expr.get();
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &soft;
        case 1: return expr.get();
        case 2: return &semi;
        default: return nullptr;
    }
}

void ExpressionConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: soft = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionCoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionCoverageBinInitializer;
}

bool ExpressionCoverageBinInitializerSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExpressionCoverageBinInitializerSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionCoverageBinInitializerSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionCoverageBinInitializerSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void ExpressionCoverageBinInitializerSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionOrDistSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionOrDist;
}

bool ExpressionOrDistSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExpressionOrDistSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return distribution.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionOrDistSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return distribution.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionOrDistSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return distribution.get();
        default: return nullptr;
    }
}

void ExpressionOrDistSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: distribution = child.node() ? &child.node()->as<DistConstraintListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionPattern;
}

bool ExpressionPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExpressionPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void ExpressionPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionStatement;
}

bool ExpressionStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ExpressionStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return expr.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void ExpressionStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AddAssignmentExpression:
        case SyntaxKind::AddExpression:
        case SyntaxKind::AndAssignmentExpression:
        case SyntaxKind::ArithmeticLeftShiftAssignmentExpression:
        case SyntaxKind::ArithmeticRightShiftAssignmentExpression:
        case SyntaxKind::ArithmeticShiftLeftExpression:
        case SyntaxKind::ArithmeticShiftRightExpression:
        case SyntaxKind::ArrayAndMethod:
        case SyntaxKind::ArrayOrMethod:
        case SyntaxKind::ArrayOrRandomizeMethodExpression:
        case SyntaxKind::ArrayUniqueMethod:
        case SyntaxKind::ArrayXorMethod:
        case SyntaxKind::AssignmentExpression:
        case SyntaxKind::AssignmentPatternExpression:
        case SyntaxKind::BadExpression:
        case SyntaxKind::BinaryAndExpression:
        case SyntaxKind::BinaryOrExpression:
        case SyntaxKind::BinaryXnorExpression:
        case SyntaxKind::BinaryXorExpression:
        case SyntaxKind::BitType:
        case SyntaxKind::ByteType:
        case SyntaxKind::CHandleType:
        case SyntaxKind::CaseEqualityExpression:
        case SyntaxKind::CaseInequalityExpression:
        case SyntaxKind::CastExpression:
        case SyntaxKind::ClassName:
        case SyntaxKind::ConcatenationExpression:
        case SyntaxKind::ConditionalExpression:
        case SyntaxKind::ConstructorName:
        case SyntaxKind::CopyClassExpression:
        case SyntaxKind::DefaultPatternKeyExpression:
        case SyntaxKind::DivideAssignmentExpression:
        case SyntaxKind::DivideExpression:
        case SyntaxKind::ElementSelectExpression:
        case SyntaxKind::EmptyIdentifierName:
        case SyntaxKind::EmptyQueueExpression:
        case SyntaxKind::EnumType:
        case SyntaxKind::EqualityExpression:
        case SyntaxKind::EventType:
        case SyntaxKind::ExpressionOrDist:
        case SyntaxKind::GreaterThanEqualExpression:
        case SyntaxKind::GreaterThanExpression:
        case SyntaxKind::IdentifierName:
        case SyntaxKind::IdentifierSelectName:
        case SyntaxKind::ImplicitType:
        case SyntaxKind::InequalityExpression:
        case SyntaxKind::InsideExpression:
        case SyntaxKind::IntType:
        case SyntaxKind::IntegerLiteralExpression:
        case SyntaxKind::IntegerType:
        case SyntaxKind::IntegerVectorExpression:
        case SyntaxKind::InvocationExpression:
        case SyntaxKind::LessThanEqualExpression:
        case SyntaxKind::LessThanExpression:
        case SyntaxKind::LocalScope:
        case SyntaxKind::LogicType:
        case SyntaxKind::LogicalAndExpression:
        case SyntaxKind::LogicalEquivalenceExpression:
        case SyntaxKind::LogicalImplicationExpression:
        case SyntaxKind::LogicalLeftShiftAssignmentExpression:
        case SyntaxKind::LogicalOrExpression:
        case SyntaxKind::LogicalRightShiftAssignmentExpression:
        case SyntaxKind::LogicalShiftLeftExpression:
        case SyntaxKind::LogicalShiftRightExpression:
        case SyntaxKind::LongIntType:
        case SyntaxKind::MemberAccessExpression:
        case SyntaxKind::MinTypMaxExpression:
        case SyntaxKind::ModAssignmentExpression:
        case SyntaxKind::ModExpression:
        case SyntaxKind::MultipleConcatenationExpression:
        case SyntaxKind::MultiplyAssignmentExpression:
        case SyntaxKind::MultiplyExpression:
        case SyntaxKind::NamedType:
        case SyntaxKind::NewArrayExpression:
        case SyntaxKind::NewClassExpression:
        case SyntaxKind::NonblockingAssignmentExpression:
        case SyntaxKind::NullLiteralExpression:
        case SyntaxKind::OrAssignmentExpression:
        case SyntaxKind::ParenthesizedExpression:
        case SyntaxKind::PostdecrementExpression:
        case SyntaxKind::PostincrementExpression:
        case SyntaxKind::PowerExpression:
        case SyntaxKind::PropertyType:
        case SyntaxKind::RealLiteralExpression:
        case SyntaxKind::RealTimeType:
        case SyntaxKind::RealType:
        case SyntaxKind::RegType:
        case SyntaxKind::RootScope:
        case SyntaxKind::ScopedName:
        case SyntaxKind::SequenceType:
        case SyntaxKind::ShortIntType:
        case SyntaxKind::ShortRealType:
        case SyntaxKind::SignedCastExpression:
        case SyntaxKind::StreamingConcatenationExpression:
        case SyntaxKind::StringLiteralExpression:
        case SyntaxKind::StringType:
        case SyntaxKind::StructType:
        case SyntaxKind::SubtractAssignmentExpression:
        case SyntaxKind::SubtractExpression:
        case SyntaxKind::SuperHandle:
        case SyntaxKind::SuperNewDefaultedArgsExpression:
        case SyntaxKind::SystemName:
        case SyntaxKind::TaggedUnionExpression:
        case SyntaxKind::ThisHandle:
        case SyntaxKind::TimeLiteralExpression:
        case SyntaxKind::TimeType:
        case SyntaxKind::TimingControlExpression:
        case SyntaxKind::TypeReference:
        case SyntaxKind::UnaryBitwiseAndExpression:
        case SyntaxKind::UnaryBitwiseNandExpression:
        case SyntaxKind::UnaryBitwiseNorExpression:
        case SyntaxKind::UnaryBitwiseNotExpression:
        case SyntaxKind::UnaryBitwiseOrExpression:
        case SyntaxKind::UnaryBitwiseXnorExpression:
        case SyntaxKind::UnaryBitwiseXorExpression:
        case SyntaxKind::UnaryLogicalNotExpression:
        case SyntaxKind::UnaryMinusExpression:
        case SyntaxKind::UnaryPlusExpression:
        case SyntaxKind::UnaryPredecrementExpression:
        case SyntaxKind::UnaryPreincrementExpression:
        case SyntaxKind::UnbasedUnsizedLiteralExpression:
        case SyntaxKind::UnionType:
        case SyntaxKind::UnitScope:
        case SyntaxKind::Untyped:
        case SyntaxKind::ValueRangeExpression:
        case SyntaxKind::VirtualInterfaceType:
        case SyntaxKind::VoidType:
        case SyntaxKind::WildcardEqualityExpression:
        case SyntaxKind::WildcardInequalityExpression:
        case SyntaxKind::WildcardLiteralExpression:
        case SyntaxKind::XorAssignmentExpression:
            return true;
        default:
            return false;
    }
}

bool ExpressionTimingCheckArgSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExpressionTimingCheckArg;
}

bool ExpressionTimingCheckArgSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExpressionTimingCheckArgSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExpressionTimingCheckArgSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExpressionTimingCheckArgSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void ExpressionTimingCheckArgSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExtendsClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExtendsClause;
}

bool ExtendsClauseSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ExtendsClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return baseName.get();
        case 2: return arguments;
        case 3: return defaultedArg;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExtendsClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return baseName.get();
        case 2: return arguments;
        case 3: return defaultedArg;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExtendsClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return baseName.get();
        case 2: return arguments;
        case 3: return defaultedArg;
        default: return nullptr;
    }
}

void ExtendsClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: baseName = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 2: arguments = child.node() ? &child.node()->as<ArgumentListSyntax>() : nullptr; return;
        case 3: defaultedArg = child.node() ? &child.node()->as<DefaultExtendsClauseArgSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExternInterfaceMethodSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExternInterfaceMethod;
}

bool ExternInterfaceMethodSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExternInterfaceMethodSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return forkJoin;
        case 3: return prototype.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExternInterfaceMethodSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return forkJoin;
        case 3: return prototype.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExternInterfaceMethodSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &externKeyword;
        case 2: return &forkJoin;
        case 3: return prototype.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void ExternInterfaceMethodSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: externKeyword = child.token(); return;
        case 2: forkJoin = child.token(); return;
        case 3: prototype = child.node() ? &child.node()->as<FunctionPrototypeSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExternModuleDeclSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExternModuleDecl;
}

bool ExternModuleDeclSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExternModuleDeclSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return &actualAttributes;
        case 3: return header.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExternModuleDeclSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return &actualAttributes;
        case 3: return header.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExternModuleDeclSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &externKeyword;
        case 2: return &actualAttributes;
        case 3: return header.get();
        default: return nullptr;
    }
}

void ExternModuleDeclSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: externKeyword = child.token(); return;
        case 2: actualAttributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 3: header = child.node() ? &child.node()->as<ModuleHeaderSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ExternUdpDeclSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ExternUdpDecl;
}

bool ExternUdpDeclSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ExternUdpDeclSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return &actualAttributes;
        case 3: return primitive;
        case 4: return name;
        case 5: return portList.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ExternUdpDeclSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return externKeyword;
        case 2: return &actualAttributes;
        case 3: return primitive;
        case 4: return name;
        case 5: return portList.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ExternUdpDeclSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &externKeyword;
        case 2: return &actualAttributes;
        case 3: return &primitive;
        case 4: return &name;
        case 5: return portList.get();
        default: return nullptr;
    }
}

void ExternUdpDeclSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: externKeyword = child.token(); return;
        case 2: actualAttributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 3: primitive = child.token(); return;
        case 4: name = child.token(); return;
        case 5: portList = child.node() ? &child.node()->as<UdpPortListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool FilePathSpecSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::FilePathSpec;
}

bool FilePathSpecSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax FilePathSpecSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return path;
        default: return nullptr;
    }
}

ConstTokenOrSyntax FilePathSpecSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return path;
        default: return nullptr;
    }
}

PtrTokenOrSyntax FilePathSpecSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &path;
        default: return nullptr;
    }
}

void FilePathSpecSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: path = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool FirstMatchSequenceExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::FirstMatchSequenceExpr;
}

bool FirstMatchSequenceExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax FirstMatchSequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return first_match;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return matchList;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax FirstMatchSequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return first_match;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return matchList;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax FirstMatchSequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &first_match;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return matchList;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void FirstMatchSequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: first_match = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 3: matchList = child.node() ? &child.node()->as<SequenceMatchListSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForLoopStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForLoopStatement;
}

bool ForLoopStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax ForLoopStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return forKeyword;
        case 3: return openParen;
        case 4: return &initializers;
        case 5: return semi1;
        case 6: return stopExpr;
        case 7: return semi2;
        case 8: return &steps;
        case 9: return closeParen;
        case 10: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForLoopStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return forKeyword;
        case 3: return openParen;
        case 4: return &initializers;
        case 5: return semi1;
        case 6: return stopExpr;
        case 7: return semi2;
        case 8: return &steps;
        case 9: return closeParen;
        case 10: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForLoopStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &forKeyword;
        case 3: return &openParen;
        case 4: return &initializers;
        case 5: return &semi1;
        case 6: return stopExpr;
        case 7: return &semi2;
        case 8: return &steps;
        case 9: return &closeParen;
        case 10: return statement.get();
        default: return nullptr;
    }
}

void ForLoopStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: forKeyword = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: initializers = child.node()->as<SeparatedSyntaxList<SyntaxNode>>(); return;
        case 5: semi1 = child.token(); return;
        case 6: stopExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 7: semi2 = child.token(); return;
        case 8: steps = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 9: closeParen = child.token(); return;
        case 10: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForVariableDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForVariableDeclaration;
}

bool ForVariableDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax ForVariableDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return varKeyword;
        case 1: return type;
        case 2: return declarator.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForVariableDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return varKeyword;
        case 1: return type;
        case 2: return declarator.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForVariableDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &varKeyword;
        case 1: return type;
        case 2: return declarator.get();
        default: return nullptr;
    }
}

void ForVariableDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: varKeyword = child.token(); return;
        case 1: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 2: declarator = child.node() ? &child.node()->as<DeclaratorSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForeachLoopListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForeachLoopList;
}

bool ForeachLoopListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ForeachLoopListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return arrayName.get();
        case 2: return openBracket;
        case 3: return &loopVariables;
        case 4: return closeBracket;
        case 5: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForeachLoopListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return arrayName.get();
        case 2: return openBracket;
        case 3: return &loopVariables;
        case 4: return closeBracket;
        case 5: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForeachLoopListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return arrayName.get();
        case 2: return &openBracket;
        case 3: return &loopVariables;
        case 4: return &closeBracket;
        case 5: return &closeParen;
        default: return nullptr;
    }
}

void ForeachLoopListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: arrayName = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 2: openBracket = child.token(); return;
        case 3: loopVariables = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        case 4: closeBracket = child.token(); return;
        case 5: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForeachLoopStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForeachLoopStatement;
}

bool ForeachLoopStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ForeachLoopStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return loopList.get();
        case 4: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForeachLoopStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return loopList.get();
        case 4: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForeachLoopStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &keyword;
        case 3: return loopList.get();
        case 4: return statement.get();
        default: return nullptr;
    }
}

void ForeachLoopStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: keyword = child.token(); return;
        case 3: loopList = child.node() ? &child.node()->as<ForeachLoopListSyntax>() : nullptr; return;
        case 4: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForeverStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForeverStatement;
}

bool ForeverStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ForeverStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return foreverKeyword;
        case 3: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForeverStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return foreverKeyword;
        case 3: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForeverStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &foreverKeyword;
        case 3: return statement.get();
        default: return nullptr;
    }
}

void ForeverStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: foreverKeyword = child.token(); return;
        case 3: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForwardTypeRestrictionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForwardTypeRestriction;
}

bool ForwardTypeRestrictionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ForwardTypeRestrictionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword1;
        case 1: return keyword2;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForwardTypeRestrictionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword1;
        case 1: return keyword2;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForwardTypeRestrictionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword1;
        case 1: return &keyword2;
        default: return nullptr;
    }
}

void ForwardTypeRestrictionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword1 = child.token(); return;
        case 1: keyword2 = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ForwardTypedefDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ForwardTypedefDeclaration;
}

bool ForwardTypedefDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax ForwardTypedefDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return typedefKeyword;
        case 2: return typeRestriction;
        case 3: return name;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ForwardTypedefDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return typedefKeyword;
        case 2: return typeRestriction;
        case 3: return name;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ForwardTypedefDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &typedefKeyword;
        case 2: return typeRestriction;
        case 3: return &name;
        case 4: return &semi;
        default: return nullptr;
    }
}

void ForwardTypedefDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: typedefKeyword = child.token(); return;
        case 2: typeRestriction = child.node() ? &child.node()->as<ForwardTypeRestrictionSyntax>() : nullptr; return;
        case 3: name = child.token(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool FunctionDeclarationSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::FunctionDeclaration:
        case SyntaxKind::TaskDeclaration:
            return true;
        default:
            return false;
    }
}

bool FunctionDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax FunctionDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return prototype.get();
        case 2: return semi;
        case 3: return &items;
        case 4: return end;
        case 5: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax FunctionDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return prototype.get();
        case 2: return semi;
        case 3: return &items;
        case 4: return end;
        case 5: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax FunctionDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return prototype.get();
        case 2: return &semi;
        case 3: return &items;
        case 4: return &end;
        case 5: return endBlockName;
        default: return nullptr;
    }
}

void FunctionDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: prototype = child.node() ? &child.node()->as<FunctionPrototypeSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        case 3: items = child.node()->as<SyntaxList<SyntaxNode>>(); return;
        case 4: end = child.token(); return;
        case 5: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool FunctionPortBaseSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultFunctionPort:
        case SyntaxKind::FunctionPort:
            return true;
        default:
            return false;
    }
}

bool FunctionPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::FunctionPortList;
}

bool FunctionPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax FunctionPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax FunctionPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax FunctionPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void FunctionPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<FunctionPortBaseSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool FunctionPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::FunctionPort;
}

bool FunctionPortSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax FunctionPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return constKeyword;
        case 2: return direction;
        case 3: return staticKeyword;
        case 4: return varKeyword;
        case 5: return dataType;
        case 6: return declarator.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax FunctionPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return constKeyword;
        case 2: return direction;
        case 3: return staticKeyword;
        case 4: return varKeyword;
        case 5: return dataType;
        case 6: return declarator.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax FunctionPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &constKeyword;
        case 2: return &direction;
        case 3: return &staticKeyword;
        case 4: return &varKeyword;
        case 5: return dataType;
        case 6: return declarator.get();
        default: return nullptr;
    }
}

void FunctionPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: constKeyword = child.token(); return;
        case 2: direction = child.token(); return;
        case 3: staticKeyword = child.token(); return;
        case 4: varKeyword = child.token(); return;
        case 5: dataType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 6: declarator = child.node() ? &child.node()->as<DeclaratorSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool FunctionPrototypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::FunctionPrototype;
}

bool FunctionPrototypeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax FunctionPrototypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return &specifiers;
        case 2: return lifetime;
        case 3: return returnType.get();
        case 4: return name.get();
        case 5: return portList;
        default: return nullptr;
    }
}

ConstTokenOrSyntax FunctionPrototypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return &specifiers;
        case 2: return lifetime;
        case 3: return returnType.get();
        case 4: return name.get();
        case 5: return portList;
        default: return nullptr;
    }
}

PtrTokenOrSyntax FunctionPrototypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &specifiers;
        case 2: return &lifetime;
        case 3: return returnType.get();
        case 4: return name.get();
        case 5: return portList;
        default: return nullptr;
    }
}

void FunctionPrototypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: specifiers = child.node()->as<SyntaxList<ClassSpecifierSyntax>>(); return;
        case 2: lifetime = child.token(); return;
        case 3: returnType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 4: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 5: portList = child.node() ? &child.node()->as<FunctionPortListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool GenerateBlockSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::GenerateBlock;
}

bool GenerateBlockSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 3: return true;
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax GenerateBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return begin;
        case 3: return beginName;
        case 4: return &members;
        case 5: return end;
        case 6: return endName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax GenerateBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return begin;
        case 3: return beginName;
        case 4: return &members;
        case 5: return end;
        case 6: return endName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax GenerateBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return label;
        case 2: return &begin;
        case 3: return beginName;
        case 4: return &members;
        case 5: return &end;
        case 6: return endName;
        default: return nullptr;
    }
}

void GenerateBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 2: begin = child.token(); return;
        case 3: beginName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        case 4: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 5: end = child.token(); return;
        case 6: endName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool GenerateRegionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::GenerateRegion;
}

bool GenerateRegionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax GenerateRegionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &members;
        case 3: return endgenerate;
        default: return nullptr;
    }
}

ConstTokenOrSyntax GenerateRegionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &members;
        case 3: return endgenerate;
        default: return nullptr;
    }
}

PtrTokenOrSyntax GenerateRegionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &members;
        case 3: return &endgenerate;
        default: return nullptr;
    }
}

void GenerateRegionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 3: endgenerate = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool GenvarDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::GenvarDeclaration;
}

bool GenvarDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax GenvarDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &identifiers;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax GenvarDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &identifiers;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax GenvarDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &identifiers;
        case 3: return &semi;
        default: return nullptr;
    }
}

void GenvarDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: identifiers = child.node()->as<SeparatedSyntaxList<IdentifierNameSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool HierarchicalInstanceSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::HierarchicalInstance;
}

bool HierarchicalInstanceSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax HierarchicalInstanceSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return decl;
        case 1: return openParen;
        case 2: return &connections;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax HierarchicalInstanceSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return decl;
        case 1: return openParen;
        case 2: return &connections;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax HierarchicalInstanceSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return decl;
        case 1: return &openParen;
        case 2: return &connections;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void HierarchicalInstanceSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: decl = child.node() ? &child.node()->as<InstanceNameSyntax>() : nullptr; return;
        case 1: openParen = child.token(); return;
        case 2: connections = child.node()->as<SeparatedSyntaxList<PortConnectionSyntax>>(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool HierarchyInstantiationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::HierarchyInstantiation;
}

bool HierarchyInstantiationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax HierarchyInstantiationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type;
        case 2: return parameters;
        case 3: return &instances;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax HierarchyInstantiationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return type;
        case 2: return parameters;
        case 3: return &instances;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax HierarchyInstantiationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &type;
        case 2: return parameters;
        case 3: return &instances;
        case 4: return &semi;
        default: return nullptr;
    }
}

void HierarchyInstantiationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: type = child.token(); return;
        case 2: parameters = child.node() ? &child.node()->as<ParameterValueAssignmentSyntax>() : nullptr; return;
        case 3: instances = child.node()->as<SeparatedSyntaxList<HierarchicalInstanceSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IdWithExprCoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IdWithExprCoverageBinInitializer;
}

bool IdWithExprCoverageBinInitializerSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IdWithExprCoverageBinInitializerSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return id;
        case 1: return withClause.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax IdWithExprCoverageBinInitializerSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return id;
        case 1: return withClause.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax IdWithExprCoverageBinInitializerSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &id;
        case 1: return withClause.get();
        default: return nullptr;
    }
}

void IdWithExprCoverageBinInitializerSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: id = child.token(); return;
        case 1: withClause = child.node() ? &child.node()->as<WithClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool IdentifierNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IdentifierName;
}

bool IdentifierNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IdentifierNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return identifier;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IdentifierNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return identifier;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IdentifierNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &identifier;
        default: return nullptr;
    }
}

void IdentifierNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: identifier = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IdentifierSelectNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IdentifierSelectName;
}

bool IdentifierSelectNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IdentifierSelectNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return identifier;
        case 1: return &selectors;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IdentifierSelectNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return identifier;
        case 1: return &selectors;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IdentifierSelectNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &identifier;
        case 1: return &selectors;
        default: return nullptr;
    }
}

void IdentifierSelectNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: identifier = child.token(); return;
        case 1: selectors = child.node()->as<SyntaxList<ElementSelectSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IfGenerateSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IfGenerate;
}

bool IfGenerateSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax IfGenerateSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return condition.get();
        case 4: return closeParen;
        case 5: return block.get();
        case 6: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IfGenerateSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return condition.get();
        case 4: return closeParen;
        case 5: return block.get();
        case 6: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IfGenerateSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &openParen;
        case 3: return condition.get();
        case 4: return &closeParen;
        case 5: return block.get();
        case 6: return elseClause;
        default: return nullptr;
    }
}

void IfGenerateSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        case 5: block = child.node() ? &child.node()->as<MemberSyntax>() : nullptr; return;
        case 6: elseClause = child.node() ? &child.node()->as<ElseClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool IfNonePathDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IfNonePathDeclaration;
}

bool IfNonePathDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IfNonePathDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return path.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax IfNonePathDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return path.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax IfNonePathDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return path.get();
        default: return nullptr;
    }
}

void IfNonePathDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: path = child.node() ? &child.node()->as<PathDeclarationSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool IffEventClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IffEventClause;
}

bool IffEventClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IffEventClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return iff;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax IffEventClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return iff;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax IffEventClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &iff;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void IffEventClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: iff = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImmediateAssertionMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImmediateAssertionMember;
}

bool ImmediateAssertionMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImmediateAssertionMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImmediateAssertionMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImmediateAssertionMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return statement.get();
        default: return nullptr;
    }
}

void ImmediateAssertionMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: statement = child.node() ? &child.node()->as<ImmediateAssertionStatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImmediateAssertionStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ImmediateAssertStatement:
        case SyntaxKind::ImmediateAssumeStatement:
        case SyntaxKind::ImmediateCoverStatement:
            return true;
        default:
            return false;
    }
}

bool ImmediateAssertionStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ImmediateAssertionStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return delay;
        case 4: return expr.get();
        case 5: return action.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImmediateAssertionStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return delay;
        case 4: return expr.get();
        case 5: return action.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImmediateAssertionStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &keyword;
        case 3: return delay;
        case 4: return expr.get();
        case 5: return action.get();
        default: return nullptr;
    }
}

void ImmediateAssertionStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: keyword = child.token(); return;
        case 3: delay = child.node() ? &child.node()->as<DeferredAssertionSyntax>() : nullptr; return;
        case 4: expr = child.node() ? &child.node()->as<ParenthesizedExpressionSyntax>() : nullptr; return;
        case 5: action = child.node() ? &child.node()->as<ActionBlockSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplementsClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplementsClause;
}

bool ImplementsClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplementsClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return &interfaces;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplementsClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return &interfaces;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplementsClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &interfaces;
        default: return nullptr;
    }
}

void ImplementsClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: interfaces = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplicationConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplicationConstraint;
}

bool ImplicationConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplicationConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return arrow;
        case 2: return constraints.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplicationConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return arrow;
        case 2: return constraints.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplicationConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &arrow;
        case 2: return constraints.get();
        default: return nullptr;
    }
}

void ImplicationConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: arrow = child.token(); return;
        case 2: constraints = child.node() ? &child.node()->as<ConstraintItemSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplicitAnsiPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplicitAnsiPort;
}

bool ImplicitAnsiPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplicitAnsiPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return declarator.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplicitAnsiPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return declarator.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplicitAnsiPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return declarator.get();
        default: return nullptr;
    }
}

void ImplicitAnsiPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: header = child.node() ? &child.node()->as<PortHeaderSyntax>() : nullptr; return;
        case 2: declarator = child.node() ? &child.node()->as<DeclaratorSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplicitEventControlSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplicitEventControl;
}

bool ImplicitEventControlSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplicitEventControlSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return at;
        case 1: return openParen;
        case 2: return star;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplicitEventControlSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return at;
        case 1: return openParen;
        case 2: return star;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplicitEventControlSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &at;
        case 1: return &openParen;
        case 2: return &star;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void ImplicitEventControlSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: at = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: star = child.token(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplicitNonAnsiPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplicitNonAnsiPort;
}

bool ImplicitNonAnsiPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplicitNonAnsiPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplicitNonAnsiPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplicitNonAnsiPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void ImplicitNonAnsiPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<PortExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ImplicitTypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ImplicitType;
}

bool ImplicitTypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ImplicitTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return signing;
        case 1: return &dimensions;
        case 2: return placeholder;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ImplicitTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return signing;
        case 1: return &dimensions;
        case 2: return placeholder;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ImplicitTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &signing;
        case 1: return &dimensions;
        case 2: return &placeholder;
        default: return nullptr;
    }
}

void ImplicitTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: signing = child.token(); return;
        case 1: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        case 2: placeholder = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IncludeDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IncludeDirective;
}

bool IncludeDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IncludeDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return fileName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IncludeDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return fileName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IncludeDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &fileName;
        default: return nullptr;
    }
}

void IncludeDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: fileName = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool InsideExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::InsideExpression;
}

bool InsideExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax InsideExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return inside;
        case 2: return ranges.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax InsideExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return inside;
        case 2: return ranges.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax InsideExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return &inside;
        case 2: return ranges.get();
        default: return nullptr;
    }
}

void InsideExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: inside = child.token(); return;
        case 2: ranges = child.node() ? &child.node()->as<RangeListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool InstanceConfigRuleSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::InstanceConfigRule;
}

bool InstanceConfigRuleSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax InstanceConfigRuleSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return instance;
        case 1: return topModule;
        case 2: return &instanceNames;
        case 3: return ruleClause.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax InstanceConfigRuleSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return instance;
        case 1: return topModule;
        case 2: return &instanceNames;
        case 3: return ruleClause.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax InstanceConfigRuleSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &instance;
        case 1: return &topModule;
        case 2: return &instanceNames;
        case 3: return ruleClause.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void InstanceConfigRuleSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: instance = child.token(); return;
        case 1: topModule = child.token(); return;
        case 2: instanceNames = child.node()->as<SyntaxList<ConfigInstanceIdentifierSyntax>>(); return;
        case 3: ruleClause = child.node() ? &child.node()->as<ConfigRuleClauseSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool InstanceNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::InstanceName;
}

bool InstanceNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax InstanceNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return &dimensions;
        default: return nullptr;
    }
}

ConstTokenOrSyntax InstanceNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return &dimensions;
        default: return nullptr;
    }
}

PtrTokenOrSyntax InstanceNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &dimensions;
        default: return nullptr;
    }
}

void InstanceNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IntegerTypeSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::BitType:
        case SyntaxKind::ByteType:
        case SyntaxKind::IntType:
        case SyntaxKind::IntegerType:
        case SyntaxKind::LogicType:
        case SyntaxKind::LongIntType:
        case SyntaxKind::RegType:
        case SyntaxKind::ShortIntType:
        case SyntaxKind::TimeType:
            return true;
        default:
            return false;
    }
}

bool IntegerTypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IntegerTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return signing;
        case 2: return &dimensions;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IntegerTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return signing;
        case 2: return &dimensions;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IntegerTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &signing;
        case 2: return &dimensions;
        default: return nullptr;
    }
}

void IntegerTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: signing = child.token(); return;
        case 2: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool IntegerVectorExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IntegerVectorExpression;
}

bool IntegerVectorExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IntegerVectorExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return size;
        case 1: return base;
        case 2: return value;
        default: return nullptr;
    }
}

ConstTokenOrSyntax IntegerVectorExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return size;
        case 1: return base;
        case 2: return value;
        default: return nullptr;
    }
}

PtrTokenOrSyntax IntegerVectorExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &size;
        case 1: return &base;
        case 2: return &value;
        default: return nullptr;
    }
}

void IntegerVectorExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: size = child.token(); return;
        case 1: base = child.token(); return;
        case 2: value = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool InterfacePortHeaderSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::InterfacePortHeader;
}

bool InterfacePortHeaderSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax InterfacePortHeaderSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return nameOrKeyword;
        case 1: return modport;
        default: return nullptr;
    }
}

ConstTokenOrSyntax InterfacePortHeaderSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return nameOrKeyword;
        case 1: return modport;
        default: return nullptr;
    }
}

PtrTokenOrSyntax InterfacePortHeaderSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &nameOrKeyword;
        case 1: return modport;
        default: return nullptr;
    }
}

void InterfacePortHeaderSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: nameOrKeyword = child.token(); return;
        case 1: modport = child.node() ? &child.node()->as<DotMemberClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool IntersectClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::IntersectClause;
}

bool IntersectClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax IntersectClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return intersect;
        case 1: return ranges.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax IntersectClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return intersect;
        case 1: return ranges.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax IntersectClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &intersect;
        case 1: return ranges.get();
        default: return nullptr;
    }
}

void IntersectClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: intersect = child.token(); return;
        case 1: ranges = child.node() ? &child.node()->as<RangeListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool InvocationExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::InvocationExpression;
}

bool InvocationExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax InvocationExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &attributes;
        case 2: return arguments;
        default: return nullptr;
    }
}

ConstTokenOrSyntax InvocationExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return &attributes;
        case 2: return arguments;
        default: return nullptr;
    }
}

PtrTokenOrSyntax InvocationExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &attributes;
        case 2: return arguments;
        default: return nullptr;
    }
}

void InvocationExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: arguments = child.node() ? &child.node()->as<ArgumentListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool JumpStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::JumpStatement;
}

bool JumpStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax JumpStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return breakOrContinue;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax JumpStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return breakOrContinue;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax JumpStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &breakOrContinue;
        case 3: return &semi;
        default: return nullptr;
    }
}

void JumpStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: breakOrContinue = child.token(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool KeywordNameSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ArrayAndMethod:
        case SyntaxKind::ArrayOrMethod:
        case SyntaxKind::ArrayUniqueMethod:
        case SyntaxKind::ArrayXorMethod:
        case SyntaxKind::ConstructorName:
        case SyntaxKind::LocalScope:
        case SyntaxKind::RootScope:
        case SyntaxKind::SuperHandle:
        case SyntaxKind::ThisHandle:
        case SyntaxKind::UnitScope:
            return true;
        default:
            return false;
    }
}

bool KeywordNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax KeywordNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax KeywordNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax KeywordNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        default: return nullptr;
    }
}

void KeywordNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool KeywordTypeSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::CHandleType:
        case SyntaxKind::EventType:
        case SyntaxKind::PropertyType:
        case SyntaxKind::RealTimeType:
        case SyntaxKind::RealType:
        case SyntaxKind::SequenceType:
        case SyntaxKind::ShortRealType:
        case SyntaxKind::StringType:
        case SyntaxKind::Untyped:
        case SyntaxKind::VoidType:
            return true;
        default:
            return false;
    }
}

bool KeywordTypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax KeywordTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax KeywordTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax KeywordTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        default: return nullptr;
    }
}

void KeywordTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LetDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LetDeclaration;
}

bool LetDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax LetDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return let;
        case 2: return identifier;
        case 3: return portList;
        case 4: return equals;
        case 5: return expr.get();
        case 6: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LetDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return let;
        case 2: return identifier;
        case 3: return portList;
        case 4: return equals;
        case 5: return expr.get();
        case 6: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LetDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &let;
        case 2: return &identifier;
        case 3: return portList;
        case 4: return &equals;
        case 5: return expr.get();
        case 6: return &semi;
        default: return nullptr;
    }
}

void LetDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: let = child.token(); return;
        case 2: identifier = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<AssertionItemPortListSyntax>() : nullptr; return;
        case 4: equals = child.token(); return;
        case 5: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 6: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LibraryDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LibraryDeclaration;
}

bool LibraryDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax LibraryDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return library;
        case 2: return name;
        case 3: return &filePaths;
        case 4: return incDirClause;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LibraryDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return library;
        case 2: return name;
        case 3: return &filePaths;
        case 4: return incDirClause;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LibraryDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &library;
        case 2: return &name;
        case 3: return &filePaths;
        case 4: return incDirClause;
        case 5: return &semi;
        default: return nullptr;
    }
}

void LibraryDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: library = child.token(); return;
        case 2: name = child.token(); return;
        case 3: filePaths = child.node()->as<SeparatedSyntaxList<FilePathSpecSyntax>>(); return;
        case 4: incDirClause = child.node() ? &child.node()->as<LibraryIncDirClauseSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LibraryIncDirClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LibraryIncDirClause;
}

bool LibraryIncDirClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LibraryIncDirClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return minus;
        case 1: return incdir;
        case 2: return &filePaths;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LibraryIncDirClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return minus;
        case 1: return incdir;
        case 2: return &filePaths;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LibraryIncDirClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &minus;
        case 1: return &incdir;
        case 2: return &filePaths;
        default: return nullptr;
    }
}

void LibraryIncDirClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: minus = child.token(); return;
        case 1: incdir = child.token(); return;
        case 2: filePaths = child.node()->as<SeparatedSyntaxList<FilePathSpecSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LibraryIncludeStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LibraryIncludeStatement;
}

bool LibraryIncludeStatementSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LibraryIncludeStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return include;
        case 2: return filePath.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LibraryIncludeStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return include;
        case 2: return filePath.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LibraryIncludeStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &include;
        case 2: return filePath.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void LibraryIncludeStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: include = child.token(); return;
        case 2: filePath = child.node() ? &child.node()->as<FilePathSpecSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LibraryMapSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LibraryMap;
}

bool LibraryMapSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LibraryMapSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &members;
        case 1: return endOfFile;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LibraryMapSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &members;
        case 1: return endOfFile;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LibraryMapSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &members;
        case 1: return &endOfFile;
        default: return nullptr;
    }
}

void LibraryMapSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 1: endOfFile = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LineDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LineDirective;
}

bool LineDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LineDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return lineNumber;
        case 2: return fileName;
        case 3: return level;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LineDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return lineNumber;
        case 2: return fileName;
        case 3: return level;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LineDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &lineNumber;
        case 2: return &fileName;
        case 3: return &level;
        default: return nullptr;
    }
}

void LineDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: lineNumber = child.token(); return;
        case 2: fileName = child.token(); return;
        case 3: level = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LiteralExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultPatternKeyExpression:
        case SyntaxKind::IntegerLiteralExpression:
        case SyntaxKind::NullLiteralExpression:
        case SyntaxKind::RealLiteralExpression:
        case SyntaxKind::StringLiteralExpression:
        case SyntaxKind::TimeLiteralExpression:
        case SyntaxKind::UnbasedUnsizedLiteralExpression:
        case SyntaxKind::WildcardLiteralExpression:
            return true;
        default:
            return false;
    }
}

bool LiteralExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LiteralExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return literal;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LiteralExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return literal;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LiteralExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &literal;
        default: return nullptr;
    }
}

void LiteralExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: literal = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LocalVariableDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LocalVariableDeclaration;
}

bool LocalVariableDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LocalVariableDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return var;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax LocalVariableDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return var;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax LocalVariableDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &var;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return &semi;
        default: return nullptr;
    }
}

void LocalVariableDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: var = child.token(); return;
        case 2: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool LoopConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LoopConstraint;
}

bool LoopConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LoopConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return foreachKeyword;
        case 1: return loopList.get();
        case 2: return constraints.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax LoopConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return foreachKeyword;
        case 1: return loopList.get();
        case 2: return constraints.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax LoopConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &foreachKeyword;
        case 1: return loopList.get();
        case 2: return constraints.get();
        default: return nullptr;
    }
}

void LoopConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: foreachKeyword = child.token(); return;
        case 1: loopList = child.node() ? &child.node()->as<ForeachLoopListSyntax>() : nullptr; return;
        case 2: constraints = child.node() ? &child.node()->as<ConstraintItemSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool LoopGenerateSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LoopGenerate;
}

bool LoopGenerateSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax LoopGenerateSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return genvar;
        case 4: return identifier;
        case 5: return equals;
        case 6: return initialExpr.get();
        case 7: return semi1;
        case 8: return stopExpr.get();
        case 9: return semi2;
        case 10: return iterationExpr.get();
        case 11: return closeParen;
        case 12: return block.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax LoopGenerateSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return openParen;
        case 3: return genvar;
        case 4: return identifier;
        case 5: return equals;
        case 6: return initialExpr.get();
        case 7: return semi1;
        case 8: return stopExpr.get();
        case 9: return semi2;
        case 10: return iterationExpr.get();
        case 11: return closeParen;
        case 12: return block.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax LoopGenerateSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &openParen;
        case 3: return &genvar;
        case 4: return &identifier;
        case 5: return &equals;
        case 6: return initialExpr.get();
        case 7: return &semi1;
        case 8: return stopExpr.get();
        case 9: return &semi2;
        case 10: return iterationExpr.get();
        case 11: return &closeParen;
        case 12: return block.get();
        default: return nullptr;
    }
}

void LoopGenerateSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: genvar = child.token(); return;
        case 4: identifier = child.token(); return;
        case 5: equals = child.token(); return;
        case 6: initialExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 7: semi1 = child.token(); return;
        case 8: stopExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 9: semi2 = child.token(); return;
        case 10: iterationExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 11: closeParen = child.token(); return;
        case 12: block = child.node() ? &child.node()->as<MemberSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool LoopStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::LoopStatement;
}

bool LoopStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax LoopStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return repeatOrWhile;
        case 3: return openParen;
        case 4: return expr.get();
        case 5: return closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax LoopStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return repeatOrWhile;
        case 3: return openParen;
        case 4: return expr.get();
        case 5: return closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax LoopStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &repeatOrWhile;
        case 3: return &openParen;
        case 4: return expr.get();
        case 5: return &closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

void LoopStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: repeatOrWhile = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: closeParen = child.token(); return;
        case 6: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroActualArgumentListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroActualArgumentList;
}

bool MacroActualArgumentListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MacroActualArgumentListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &args;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroActualArgumentListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &args;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroActualArgumentListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &args;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void MacroActualArgumentListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: args = child.node()->as<SeparatedSyntaxList<MacroActualArgumentSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroActualArgumentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroActualArgument;
}

bool MacroActualArgumentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MacroActualArgumentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &tokens;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroActualArgumentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &tokens;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroActualArgumentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &tokens;
        default: return nullptr;
    }
}

void MacroActualArgumentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: tokens = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroArgumentDefaultSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroArgumentDefault;
}

bool MacroArgumentDefaultSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MacroArgumentDefaultSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return equals;
        case 1: return &tokens;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroArgumentDefaultSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return equals;
        case 1: return &tokens;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroArgumentDefaultSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &equals;
        case 1: return &tokens;
        default: return nullptr;
    }
}

void MacroArgumentDefaultSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: equals = child.token(); return;
        case 1: tokens = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroFormalArgumentListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroFormalArgumentList;
}

bool MacroFormalArgumentListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MacroFormalArgumentListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &args;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroFormalArgumentListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &args;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroFormalArgumentListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &args;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void MacroFormalArgumentListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: args = child.node()->as<SeparatedSyntaxList<MacroFormalArgumentSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroFormalArgumentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroFormalArgument;
}

bool MacroFormalArgumentSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax MacroFormalArgumentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return defaultValue;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroFormalArgumentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return defaultValue;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroFormalArgumentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return defaultValue;
        default: return nullptr;
    }
}

void MacroFormalArgumentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: defaultValue = child.node() ? &child.node()->as<MacroArgumentDefaultSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool MacroUsageSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MacroUsage;
}

bool MacroUsageSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax MacroUsageSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return args;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MacroUsageSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return args;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MacroUsageSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return args;
        default: return nullptr;
    }
}

void MacroUsageSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: args = child.node() ? &child.node()->as<MacroActualArgumentListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool MatchesClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MatchesClause;
}

bool MatchesClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MatchesClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return matchesKeyword;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax MatchesClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return matchesKeyword;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax MatchesClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &matchesKeyword;
        case 1: return pattern.get();
        default: return nullptr;
    }
}

void MatchesClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: matchesKeyword = child.token(); return;
        case 1: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool MemberAccessExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MemberAccessExpression;
}

bool MemberAccessExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MemberAccessExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return dot;
        case 2: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MemberAccessExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return dot;
        case 2: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MemberAccessExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &dot;
        case 2: return &name;
        default: return nullptr;
    }
}

void MemberAccessExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: dot = child.token(); return;
        case 2: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MemberSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AlwaysBlock:
        case SyntaxKind::AlwaysCombBlock:
        case SyntaxKind::AlwaysFFBlock:
        case SyntaxKind::AlwaysLatchBlock:
        case SyntaxKind::AnonymousProgram:
        case SyntaxKind::BindDirective:
        case SyntaxKind::BinsSelection:
        case SyntaxKind::CaseGenerate:
        case SyntaxKind::CheckerDataDeclaration:
        case SyntaxKind::CheckerDeclaration:
        case SyntaxKind::CheckerInstantiation:
        case SyntaxKind::ClassDeclaration:
        case SyntaxKind::ClassMethodDeclaration:
        case SyntaxKind::ClassMethodPrototype:
        case SyntaxKind::ClassPropertyDeclaration:
        case SyntaxKind::ClockingDeclaration:
        case SyntaxKind::ClockingItem:
        case SyntaxKind::ConcurrentAssertionMember:
        case SyntaxKind::ConditionalPathDeclaration:
        case SyntaxKind::ConfigDeclaration:
        case SyntaxKind::ConstraintDeclaration:
        case SyntaxKind::ConstraintPrototype:
        case SyntaxKind::ContinuousAssign:
        case SyntaxKind::CoverCross:
        case SyntaxKind::CoverageBins:
        case SyntaxKind::CoverageOption:
        case SyntaxKind::CovergroupDeclaration:
        case SyntaxKind::Coverpoint:
        case SyntaxKind::DPIExport:
        case SyntaxKind::DPIImport:
        case SyntaxKind::DataDeclaration:
        case SyntaxKind::DefParam:
        case SyntaxKind::DefaultClockingReference:
        case SyntaxKind::DefaultDisableDeclaration:
        case SyntaxKind::DefaultSkewItem:
        case SyntaxKind::ElabSystemTask:
        case SyntaxKind::EmptyMember:
        case SyntaxKind::ExplicitAnsiPort:
        case SyntaxKind::ExternInterfaceMethod:
        case SyntaxKind::ExternModuleDecl:
        case SyntaxKind::ExternUdpDecl:
        case SyntaxKind::FinalBlock:
        case SyntaxKind::ForwardTypedefDeclaration:
        case SyntaxKind::FunctionDeclaration:
        case SyntaxKind::GenerateBlock:
        case SyntaxKind::GenerateRegion:
        case SyntaxKind::GenvarDeclaration:
        case SyntaxKind::HierarchyInstantiation:
        case SyntaxKind::IfGenerate:
        case SyntaxKind::IfNonePathDeclaration:
        case SyntaxKind::ImmediateAssertionMember:
        case SyntaxKind::ImplicitAnsiPort:
        case SyntaxKind::InitialBlock:
        case SyntaxKind::InterfaceDeclaration:
        case SyntaxKind::LetDeclaration:
        case SyntaxKind::LibraryDeclaration:
        case SyntaxKind::LibraryIncludeStatement:
        case SyntaxKind::LocalVariableDeclaration:
        case SyntaxKind::LoopGenerate:
        case SyntaxKind::ModportClockingPort:
        case SyntaxKind::ModportDeclaration:
        case SyntaxKind::ModportSimplePortList:
        case SyntaxKind::ModportSubroutinePortList:
        case SyntaxKind::ModuleDeclaration:
        case SyntaxKind::NetAlias:
        case SyntaxKind::NetDeclaration:
        case SyntaxKind::NetTypeDeclaration:
        case SyntaxKind::PackageDeclaration:
        case SyntaxKind::PackageExportAllDeclaration:
        case SyntaxKind::PackageExportDeclaration:
        case SyntaxKind::PackageImportDeclaration:
        case SyntaxKind::ParameterDeclarationStatement:
        case SyntaxKind::PathDeclaration:
        case SyntaxKind::PortDeclaration:
        case SyntaxKind::PrimitiveInstantiation:
        case SyntaxKind::ProgramDeclaration:
        case SyntaxKind::PropertyDeclaration:
        case SyntaxKind::PulseStyleDeclaration:
        case SyntaxKind::SequenceDeclaration:
        case SyntaxKind::SpecifyBlock:
        case SyntaxKind::SpecparamDeclaration:
        case SyntaxKind::SystemTimingCheck:
        case SyntaxKind::TaskDeclaration:
        case SyntaxKind::TimeUnitsDeclaration:
        case SyntaxKind::TypedefDeclaration:
        case SyntaxKind::UdpDeclaration:
        case SyntaxKind::UserDefinedNetDeclaration:
            return true;
        default:
            return false;
    }
}

bool MemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

void MemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MinTypMaxExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MinTypMaxExpression;
}

bool MinTypMaxExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MinTypMaxExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return min.get();
        case 1: return colon1;
        case 2: return typ.get();
        case 3: return colon2;
        case 4: return max.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax MinTypMaxExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return min.get();
        case 1: return colon1;
        case 2: return typ.get();
        case 3: return colon2;
        case 4: return max.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax MinTypMaxExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return min.get();
        case 1: return &colon1;
        case 2: return typ.get();
        case 3: return &colon2;
        case 4: return max.get();
        default: return nullptr;
    }
}

void MinTypMaxExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: min = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: colon1 = child.token(); return;
        case 2: typ = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: colon2 = child.token(); return;
        case 4: max = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportClockingPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportClockingPort;
}

bool ModportClockingPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportClockingPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return clocking;
        case 2: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportClockingPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return clocking;
        case 2: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportClockingPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &clocking;
        case 2: return &name;
        default: return nullptr;
    }
}

void ModportClockingPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: clocking = child.token(); return;
        case 2: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportDeclaration;
}

bool ModportDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &items;
        case 3: return &semi;
        default: return nullptr;
    }
}

void ModportDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: items = child.node()->as<SeparatedSyntaxList<ModportItemSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportExplicitPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportExplicitPort;
}

bool ModportExplicitPortSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ModportExplicitPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportExplicitPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportExplicitPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &name;
        case 2: return &openParen;
        case 3: return expr;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void ModportExplicitPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: name = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportItem;
}

bool ModportItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return ports.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return ports.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return ports.get();
        default: return nullptr;
    }
}

void ModportItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: ports = child.node() ? &child.node()->as<AnsiPortListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportNamedPortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportNamedPort;
}

bool ModportNamedPortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportNamedPortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportNamedPortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportNamedPortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        default: return nullptr;
    }
}

void ModportNamedPortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportPortSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ModportExplicitPort:
        case SyntaxKind::ModportNamedPort:
        case SyntaxKind::ModportSubroutinePort:
            return true;
        default:
            return false;
    }
}

bool ModportSimplePortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportSimplePortList;
}

bool ModportSimplePortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportSimplePortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction;
        case 2: return &ports;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportSimplePortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return direction;
        case 2: return &ports;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportSimplePortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &direction;
        case 2: return &ports;
        default: return nullptr;
    }
}

void ModportSimplePortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: direction = child.token(); return;
        case 2: ports = child.node()->as<SeparatedSyntaxList<ModportPortSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportSubroutinePortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportSubroutinePortList;
}

bool ModportSubroutinePortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportSubroutinePortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return importExport;
        case 2: return &ports;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportSubroutinePortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return importExport;
        case 2: return &ports;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportSubroutinePortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &importExport;
        case 2: return &ports;
        default: return nullptr;
    }
}

void ModportSubroutinePortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: importExport = child.token(); return;
        case 2: ports = child.node()->as<SeparatedSyntaxList<ModportPortSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModportSubroutinePortSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ModportSubroutinePort;
}

bool ModportSubroutinePortSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ModportSubroutinePortSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return prototype.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModportSubroutinePortSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return prototype.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModportSubroutinePortSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return prototype.get();
        default: return nullptr;
    }
}

void ModportSubroutinePortSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: prototype = child.node() ? &child.node()->as<FunctionPrototypeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModuleDeclarationSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::InterfaceDeclaration:
        case SyntaxKind::ModuleDeclaration:
        case SyntaxKind::PackageDeclaration:
        case SyntaxKind::ProgramDeclaration:
            return true;
        default:
            return false;
    }
}

bool ModuleDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax ModuleDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &members;
        case 3: return endmodule;
        case 4: return blockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModuleDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &members;
        case 3: return endmodule;
        case 4: return blockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModuleDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &members;
        case 3: return &endmodule;
        case 4: return blockName;
        default: return nullptr;
    }
}

void ModuleDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: header = child.node() ? &child.node()->as<ModuleHeaderSyntax>() : nullptr; return;
        case 2: members = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 3: endmodule = child.token(); return;
        case 4: blockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ModuleHeaderSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::InterfaceHeader:
        case SyntaxKind::ModuleHeader:
        case SyntaxKind::PackageHeader:
        case SyntaxKind::ProgramHeader:
            return true;
        default:
            return false;
    }
}

bool ModuleHeaderSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax ModuleHeaderSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return moduleKeyword;
        case 1: return lifetime;
        case 2: return name;
        case 3: return &imports;
        case 4: return parameters;
        case 5: return ports;
        case 6: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ModuleHeaderSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return moduleKeyword;
        case 1: return lifetime;
        case 2: return name;
        case 3: return &imports;
        case 4: return parameters;
        case 5: return ports;
        case 6: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ModuleHeaderSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &moduleKeyword;
        case 1: return &lifetime;
        case 2: return &name;
        case 3: return &imports;
        case 4: return parameters;
        case 5: return ports;
        case 6: return &semi;
        default: return nullptr;
    }
}

void ModuleHeaderSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: moduleKeyword = child.token(); return;
        case 1: lifetime = child.token(); return;
        case 2: name = child.token(); return;
        case 3: imports = child.node()->as<SyntaxList<PackageImportDeclarationSyntax>>(); return;
        case 4: parameters = child.node() ? &child.node()->as<ParameterPortListSyntax>() : nullptr; return;
        case 5: ports = child.node() ? &child.node()->as<PortListSyntax>() : nullptr; return;
        case 6: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool MultipleConcatenationExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::MultipleConcatenationExpression;
}

bool MultipleConcatenationExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax MultipleConcatenationExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return expression.get();
        case 2: return concatenation.get();
        case 3: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax MultipleConcatenationExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return expression.get();
        case 2: return concatenation.get();
        case 3: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax MultipleConcatenationExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return expression.get();
        case 2: return concatenation.get();
        case 3: return &closeBrace;
        default: return nullptr;
    }
}

void MultipleConcatenationExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: expression = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: concatenation = child.node() ? &child.node()->as<ConcatenationExpressionSyntax>() : nullptr; return;
        case 3: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NameSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ArrayAndMethod:
        case SyntaxKind::ArrayOrMethod:
        case SyntaxKind::ArrayUniqueMethod:
        case SyntaxKind::ArrayXorMethod:
        case SyntaxKind::ClassName:
        case SyntaxKind::ConstructorName:
        case SyntaxKind::EmptyIdentifierName:
        case SyntaxKind::IdentifierName:
        case SyntaxKind::IdentifierSelectName:
        case SyntaxKind::LocalScope:
        case SyntaxKind::RootScope:
        case SyntaxKind::ScopedName:
        case SyntaxKind::SuperHandle:
        case SyntaxKind::SystemName:
        case SyntaxKind::ThisHandle:
        case SyntaxKind::UnitScope:
            return true;
        default:
            return false;
    }
}

bool NameValuePragmaExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NameValuePragmaExpression;
}

bool NameValuePragmaExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NameValuePragmaExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return equals;
        case 2: return value.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax NameValuePragmaExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return equals;
        case 2: return value.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax NameValuePragmaExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &equals;
        case 2: return value.get();
        default: return nullptr;
    }
}

void NameValuePragmaExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: equals = child.token(); return;
        case 2: value = child.node() ? &child.node()->as<PragmaExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedArgumentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedArgument;
}

bool NamedArgumentSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax NamedArgumentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedArgumentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedArgumentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &name;
        case 2: return &openParen;
        case 3: return expr;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void NamedArgumentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: name = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedBlockClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedBlockClause;
}

bool NamedBlockClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NamedBlockClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return colon;
        case 1: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedBlockClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return colon;
        case 1: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedBlockClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &colon;
        case 1: return &name;
        default: return nullptr;
    }
}

void NamedBlockClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: colon = child.token(); return;
        case 1: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedConditionalDirectiveExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedConditionalDirectiveExpression;
}

bool NamedConditionalDirectiveExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NamedConditionalDirectiveExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedConditionalDirectiveExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedConditionalDirectiveExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        default: return nullptr;
    }
}

void NamedConditionalDirectiveExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedLabelSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedLabel;
}

bool NamedLabelSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NamedLabelSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return colon;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedLabelSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return colon;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedLabelSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &colon;
        default: return nullptr;
    }
}

void NamedLabelSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: colon = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedParamAssignmentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedParamAssignment;
}

bool NamedParamAssignmentSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax NamedParamAssignmentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedParamAssignmentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return name;
        case 2: return openParen;
        case 3: return expr;
        case 4: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedParamAssignmentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &name;
        case 2: return &openParen;
        case 3: return expr;
        case 4: return &closeParen;
        default: return nullptr;
    }
}

void NamedParamAssignmentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: name = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedPortConnectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedPortConnection;
}

bool NamedPortConnectionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax NamedPortConnectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return dot;
        case 2: return name;
        case 3: return openParen;
        case 4: return expr;
        case 5: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedPortConnectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return dot;
        case 2: return name;
        case 3: return openParen;
        case 4: return expr;
        case 5: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedPortConnectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &dot;
        case 2: return &name;
        case 3: return &openParen;
        case 4: return expr;
        case 5: return &closeParen;
        default: return nullptr;
    }
}

void NamedPortConnectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: dot = child.token(); return;
        case 2: name = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 5: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedStructurePatternMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedStructurePatternMember;
}

bool NamedStructurePatternMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NamedStructurePatternMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return colon;
        case 2: return pattern.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedStructurePatternMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return colon;
        case 2: return pattern.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedStructurePatternMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &colon;
        case 2: return pattern.get();
        default: return nullptr;
    }
}

void NamedStructurePatternMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: colon = child.token(); return;
        case 2: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NamedTypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NamedType;
}

bool NamedTypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NamedTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax NamedTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax NamedTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return name.get();
        default: return nullptr;
    }
}

void NamedTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NetAliasSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NetAlias;
}

bool NetAliasSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NetAliasSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &nets;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NetAliasSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &nets;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NetAliasSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &nets;
        case 3: return &semi;
        default: return nullptr;
    }
}

void NetAliasSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: nets = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NetDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NetDeclaration;
}

bool NetDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax NetDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return netType;
        case 2: return strength;
        case 3: return expansionHint;
        case 4: return type.get();
        case 5: return delay;
        case 6: return &declarators;
        case 7: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NetDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return netType;
        case 2: return strength;
        case 3: return expansionHint;
        case 4: return type.get();
        case 5: return delay;
        case 6: return &declarators;
        case 7: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NetDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &netType;
        case 2: return strength;
        case 3: return &expansionHint;
        case 4: return type.get();
        case 5: return delay;
        case 6: return &declarators;
        case 7: return &semi;
        default: return nullptr;
    }
}

void NetDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: netType = child.token(); return;
        case 2: strength = child.node() ? &child.node()->as<NetStrengthSyntax>() : nullptr; return;
        case 3: expansionHint = child.token(); return;
        case 4: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 5: delay = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 6: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 7: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NetPortHeaderSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NetPortHeader;
}

bool NetPortHeaderSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NetPortHeaderSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return direction;
        case 1: return netType;
        case 2: return dataType.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax NetPortHeaderSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return direction;
        case 1: return netType;
        case 2: return dataType.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax NetPortHeaderSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &direction;
        case 1: return &netType;
        case 2: return dataType.get();
        default: return nullptr;
    }
}

void NetPortHeaderSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: direction = child.token(); return;
        case 1: netType = child.token(); return;
        case 2: dataType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NetStrengthSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ChargeStrength:
        case SyntaxKind::DriveStrength:
        case SyntaxKind::PullStrength:
            return true;
        default:
            return false;
    }
}

bool NetTypeDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NetTypeDeclaration;
}

bool NetTypeDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax NetTypeDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return type.get();
        case 3: return name;
        case 4: return withFunction;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NetTypeDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return type.get();
        case 3: return name;
        case 4: return withFunction;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NetTypeDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return type.get();
        case 3: return &name;
        case 4: return withFunction;
        case 5: return &semi;
        default: return nullptr;
    }
}

void NetTypeDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 3: name = child.token(); return;
        case 4: withFunction = child.node() ? &child.node()->as<WithFunctionClauseSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NewArrayExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NewArrayExpression;
}

bool NewArrayExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax NewArrayExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return newKeyword.get();
        case 1: return openBracket;
        case 2: return sizeExpr.get();
        case 3: return closeBracket;
        case 4: return initializer;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NewArrayExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return newKeyword.get();
        case 1: return openBracket;
        case 2: return sizeExpr.get();
        case 3: return closeBracket;
        case 4: return initializer;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NewArrayExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return newKeyword.get();
        case 1: return &openBracket;
        case 2: return sizeExpr.get();
        case 3: return &closeBracket;
        case 4: return initializer;
        default: return nullptr;
    }
}

void NewArrayExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: newKeyword = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: openBracket = child.token(); return;
        case 2: sizeExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeBracket = child.token(); return;
        case 4: initializer = child.node() ? &child.node()->as<ParenthesizedExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NewClassExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NewClassExpression;
}

bool NewClassExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax NewClassExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return argList;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NewClassExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return argList;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NewClassExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return argList;
        default: return nullptr;
    }
}

void NewClassExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: scopedNew = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: argList = child.node() ? &child.node()->as<ArgumentListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool NonAnsiPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NonAnsiPortList;
}

bool NonAnsiPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NonAnsiPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NonAnsiPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NonAnsiPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void NonAnsiPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<NonAnsiPortSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NonAnsiPortSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::EmptyNonAnsiPort:
        case SyntaxKind::ExplicitNonAnsiPort:
        case SyntaxKind::ImplicitNonAnsiPort:
            return true;
        default:
            return false;
    }
}

bool NonAnsiUdpPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NonAnsiUdpPortList;
}

bool NonAnsiUdpPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NonAnsiUdpPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NonAnsiUdpPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ports;
        case 2: return closeParen;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NonAnsiUdpPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ports;
        case 2: return &closeParen;
        case 3: return &semi;
        default: return nullptr;
    }
}

void NonAnsiUdpPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ports = child.node()->as<SeparatedSyntaxList<IdentifierNameSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool NumberPragmaExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::NumberPragmaExpression;
}

bool NumberPragmaExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax NumberPragmaExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return size;
        case 1: return base;
        case 2: return value;
        default: return nullptr;
    }
}

ConstTokenOrSyntax NumberPragmaExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return size;
        case 1: return base;
        case 2: return value;
        default: return nullptr;
    }
}

PtrTokenOrSyntax NumberPragmaExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &size;
        case 1: return &base;
        case 2: return &value;
        default: return nullptr;
    }
}

void NumberPragmaExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: size = child.token(); return;
        case 1: base = child.token(); return;
        case 2: value = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool OneStepDelaySyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::OneStepDelay;
}

bool OneStepDelaySyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax OneStepDelaySyntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return oneStep;
        default: return nullptr;
    }
}

ConstTokenOrSyntax OneStepDelaySyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return oneStep;
        default: return nullptr;
    }
}

PtrTokenOrSyntax OneStepDelaySyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return &oneStep;
        default: return nullptr;
    }
}

void OneStepDelaySyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: oneStep = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool OrderedArgumentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::OrderedArgument;
}

bool OrderedArgumentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax OrderedArgumentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax OrderedArgumentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax OrderedArgumentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void OrderedArgumentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool OrderedParamAssignmentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::OrderedParamAssignment;
}

bool OrderedParamAssignmentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax OrderedParamAssignmentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax OrderedParamAssignmentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax OrderedParamAssignmentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void OrderedParamAssignmentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool OrderedPortConnectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::OrderedPortConnection;
}

bool OrderedPortConnectionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax OrderedPortConnectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax OrderedPortConnectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax OrderedPortConnectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void OrderedPortConnectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool OrderedStructurePatternMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::OrderedStructurePatternMember;
}

bool OrderedStructurePatternMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax OrderedStructurePatternMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return pattern.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax OrderedStructurePatternMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return pattern.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax OrderedStructurePatternMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return pattern.get();
        default: return nullptr;
    }
}

void OrderedStructurePatternMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PackageExportAllDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PackageExportAllDeclaration;
}

bool PackageExportAllDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PackageExportAllDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return star1;
        case 3: return doubleColon;
        case 4: return star2;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PackageExportAllDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return star1;
        case 3: return doubleColon;
        case 4: return star2;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PackageExportAllDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &star1;
        case 3: return &doubleColon;
        case 4: return &star2;
        case 5: return &semi;
        default: return nullptr;
    }
}

void PackageExportAllDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: star1 = child.token(); return;
        case 3: doubleColon = child.token(); return;
        case 4: star2 = child.token(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PackageExportDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PackageExportDeclaration;
}

bool PackageExportDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PackageExportDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PackageExportDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PackageExportDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &items;
        case 3: return &semi;
        default: return nullptr;
    }
}

void PackageExportDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: items = child.node()->as<SeparatedSyntaxList<PackageImportItemSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PackageImportDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PackageImportDeclaration;
}

bool PackageImportDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PackageImportDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PackageImportDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &items;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PackageImportDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &items;
        case 3: return &semi;
        default: return nullptr;
    }
}

void PackageImportDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: items = child.node()->as<SeparatedSyntaxList<PackageImportItemSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PackageImportItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PackageImportItem;
}

bool PackageImportItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PackageImportItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return package;
        case 1: return doubleColon;
        case 2: return item;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PackageImportItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return package;
        case 1: return doubleColon;
        case 2: return item;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PackageImportItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &package;
        case 1: return &doubleColon;
        case 2: return &item;
        default: return nullptr;
    }
}

void PackageImportItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: package = child.token(); return;
        case 1: doubleColon = child.token(); return;
        case 2: item = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParamAssignmentSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::NamedParamAssignment:
        case SyntaxKind::OrderedParamAssignment:
            return true;
        default:
            return false;
    }
}

bool ParameterDeclarationBaseSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ParameterDeclaration:
        case SyntaxKind::TypeParameterDeclaration:
            return true;
        default:
            return false;
    }
}

bool ParameterDeclarationBaseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParameterDeclarationBaseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParameterDeclarationBaseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParameterDeclarationBaseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        default: return nullptr;
    }
}

void ParameterDeclarationBaseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParameterDeclarationStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParameterDeclarationStatement;
}

bool ParameterDeclarationStatementSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParameterDeclarationStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return parameter.get();
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParameterDeclarationStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return parameter.get();
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParameterDeclarationStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return parameter.get();
        case 2: return &semi;
        default: return nullptr;
    }
}

void ParameterDeclarationStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: parameter = child.node() ? &child.node()->as<ParameterDeclarationBaseSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParameterDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParameterDeclaration;
}

bool ParameterDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParameterDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return type.get();
        case 2: return &declarators;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParameterDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return type.get();
        case 2: return &declarators;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParameterDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return type.get();
        case 2: return &declarators;
        default: return nullptr;
    }
}

void ParameterDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 2: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParameterPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParameterPortList;
}

bool ParameterPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParameterPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return &declarations;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParameterPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return &declarations;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParameterPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return &openParen;
        case 2: return &declarations;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void ParameterPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: declarations = child.node()->as<SeparatedSyntaxList<ParameterDeclarationBaseSyntax>>(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParameterValueAssignmentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParameterValueAssignment;
}

bool ParameterValueAssignmentSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParameterValueAssignmentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return &parameters;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParameterValueAssignmentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return hash;
        case 1: return openParen;
        case 2: return &parameters;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParameterValueAssignmentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &hash;
        case 1: return &openParen;
        case 2: return &parameters;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void ParameterValueAssignmentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: hash = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: parameters = child.node()->as<SeparatedSyntaxList<ParamAssignmentSyntax>>(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenExpressionListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenExpressionList;
}

bool ParenExpressionListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenExpressionListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &expressions;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenExpressionListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &expressions;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenExpressionListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &expressions;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenExpressionListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expressions = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenPragmaExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenPragmaExpression;
}

bool ParenPragmaExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenPragmaExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &values;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenPragmaExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &values;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenPragmaExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &values;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenPragmaExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: values = child.node()->as<SeparatedSyntaxList<PragmaExpressionSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedBinsSelectExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedBinsSelectExpr;
}

bool ParenthesizedBinsSelectExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenthesizedBinsSelectExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedBinsSelectExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedBinsSelectExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return expr.get();
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedBinsSelectExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<BinsSelectExpressionSyntax>() : nullptr; return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedConditionalDirectiveExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedConditionalDirectiveExpression;
}

bool ParenthesizedConditionalDirectiveExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenthesizedConditionalDirectiveExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return operand.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedConditionalDirectiveExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return operand.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedConditionalDirectiveExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return operand.get();
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedConditionalDirectiveExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: operand = child.node() ? &child.node()->as<ConditionalDirectiveExpressionSyntax>() : nullptr; return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedEventExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedEventExpression;
}

bool ParenthesizedEventExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenthesizedEventExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedEventExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedEventExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return expr.get();
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedEventExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<EventExpressionSyntax>() : nullptr; return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedExpression;
}

bool ParenthesizedExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenthesizedExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return expression.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return expression.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return expression.get();
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expression = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedPattern;
}

bool ParenthesizedPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ParenthesizedPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return pattern.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return pattern.get();
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return pattern.get();
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedPropertyExpr;
}

bool ParenthesizedPropertyExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax ParenthesizedPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void ParenthesizedPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 2: matchList = child.node() ? &child.node()->as<SequenceMatchListSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ParenthesizedSequenceExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ParenthesizedSequenceExpr;
}

bool ParenthesizedSequenceExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax ParenthesizedSequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return closeParen;
        case 4: return repetition;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ParenthesizedSequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return closeParen;
        case 4: return repetition;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ParenthesizedSequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return expr.get();
        case 2: return matchList;
        case 3: return &closeParen;
        case 4: return repetition;
        default: return nullptr;
    }
}

void ParenthesizedSequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 2: matchList = child.node() ? &child.node()->as<SequenceMatchListSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: repetition = child.node() ? &child.node()->as<SequenceRepetitionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PathDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PathDeclaration;
}

bool PathDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PathDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return desc.get();
        case 2: return equals;
        case 3: return openParen;
        case 4: return &delays;
        case 5: return closeParen;
        case 6: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PathDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return desc.get();
        case 2: return equals;
        case 3: return openParen;
        case 4: return &delays;
        case 5: return closeParen;
        case 6: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PathDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return desc.get();
        case 2: return &equals;
        case 3: return &openParen;
        case 4: return &delays;
        case 5: return &closeParen;
        case 6: return &semi;
        default: return nullptr;
    }
}

void PathDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: desc = child.node() ? &child.node()->as<PathDescriptionSyntax>() : nullptr; return;
        case 2: equals = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: delays = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 5: closeParen = child.token(); return;
        case 6: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PathDescriptionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PathDescription;
}

bool PathDescriptionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PathDescriptionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return edgeIdentifier;
        case 2: return &inputs;
        case 3: return polarityOperator;
        case 4: return pathOperator;
        case 5: return suffix.get();
        case 6: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PathDescriptionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return edgeIdentifier;
        case 2: return &inputs;
        case 3: return polarityOperator;
        case 4: return pathOperator;
        case 5: return suffix.get();
        case 6: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PathDescriptionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &edgeIdentifier;
        case 2: return &inputs;
        case 3: return &polarityOperator;
        case 4: return &pathOperator;
        case 5: return suffix.get();
        case 6: return &closeParen;
        default: return nullptr;
    }
}

void PathDescriptionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: edgeIdentifier = child.token(); return;
        case 2: inputs = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        case 3: polarityOperator = child.token(); return;
        case 4: pathOperator = child.token(); return;
        case 5: suffix = child.node() ? &child.node()->as<PathSuffixSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PathSuffixSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::EdgeSensitivePathSuffix:
        case SyntaxKind::SimplePathSuffix:
            return true;
        default:
            return false;
    }
}

bool PatternCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PatternCaseItem;
}

bool PatternCaseItemSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax PatternCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return pattern.get();
        case 1: return tripleAnd;
        case 2: return expr;
        case 3: return colon;
        case 4: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax PatternCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return pattern.get();
        case 1: return tripleAnd;
        case 2: return expr;
        case 3: return colon;
        case 4: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax PatternCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return pattern.get();
        case 1: return &tripleAnd;
        case 2: return expr;
        case 3: return &colon;
        case 4: return statement.get();
        default: return nullptr;
    }
}

void PatternCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        case 1: tripleAnd = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: colon = child.token(); return;
        case 4: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PatternSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ExpressionPattern:
        case SyntaxKind::ParenthesizedPattern:
        case SyntaxKind::StructurePattern:
        case SyntaxKind::TaggedPattern:
        case SyntaxKind::VariablePattern:
        case SyntaxKind::WildcardPattern:
            return true;
        default:
            return false;
    }
}

bool PortConcatenationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PortConcatenation;
}

bool PortConcatenationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PortConcatenationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &references;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PortConcatenationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &references;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PortConcatenationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &references;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void PortConcatenationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: references = child.node()->as<SeparatedSyntaxList<PortReferenceSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PortConnectionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::EmptyPortConnection:
        case SyntaxKind::NamedPortConnection:
        case SyntaxKind::OrderedPortConnection:
        case SyntaxKind::WildcardPortConnection:
            return true;
        default:
            return false;
    }
}

bool PortConnectionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PortConnectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PortConnectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PortConnectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

void PortConnectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PortDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PortDeclaration;
}

bool PortDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PortDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &declarators;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PortDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &declarators;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PortDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return header.get();
        case 2: return &declarators;
        case 3: return &semi;
        default: return nullptr;
    }
}

void PortDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: header = child.node() ? &child.node()->as<PortHeaderSyntax>() : nullptr; return;
        case 2: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PortExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::PortConcatenation:
        case SyntaxKind::PortReference:
            return true;
        default:
            return false;
    }
}

bool PortHeaderSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::InterfacePortHeader:
        case SyntaxKind::NetPortHeader:
        case SyntaxKind::VariablePortHeader:
            return true;
        default:
            return false;
    }
}

bool PortListSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AnsiPortList:
        case SyntaxKind::NonAnsiPortList:
        case SyntaxKind::WildcardPortList:
            return true;
        default:
            return false;
    }
}

bool PortReferenceSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PortReference;
}

bool PortReferenceSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax PortReferenceSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return select;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PortReferenceSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return select;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PortReferenceSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return select;
        default: return nullptr;
    }
}

void PortReferenceSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: select = child.node() ? &child.node()->as<ElementSelectSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PostfixUnaryExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::PostdecrementExpression:
        case SyntaxKind::PostincrementExpression:
            return true;
        default:
            return false;
    }
}

bool PostfixUnaryExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PostfixUnaryExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return operand.get();
        case 1: return &attributes;
        case 2: return operatorToken;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PostfixUnaryExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return operand.get();
        case 1: return &attributes;
        case 2: return operatorToken;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PostfixUnaryExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return operand.get();
        case 1: return &attributes;
        case 2: return &operatorToken;
        default: return nullptr;
    }
}

void PostfixUnaryExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: operand = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: operatorToken = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PragmaDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PragmaDirective;
}

bool PragmaDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PragmaDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        case 2: return &args;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PragmaDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        case 2: return &args;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PragmaDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &name;
        case 2: return &args;
        default: return nullptr;
    }
}

void PragmaDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: name = child.token(); return;
        case 2: args = child.node()->as<SeparatedSyntaxList<PragmaExpressionSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PragmaExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::NameValuePragmaExpression:
        case SyntaxKind::NumberPragmaExpression:
        case SyntaxKind::ParenPragmaExpression:
        case SyntaxKind::SimplePragmaExpression:
            return true;
        default:
            return false;
    }
}

bool PrefixUnaryExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::UnaryBitwiseAndExpression:
        case SyntaxKind::UnaryBitwiseNandExpression:
        case SyntaxKind::UnaryBitwiseNorExpression:
        case SyntaxKind::UnaryBitwiseNotExpression:
        case SyntaxKind::UnaryBitwiseOrExpression:
        case SyntaxKind::UnaryBitwiseXnorExpression:
        case SyntaxKind::UnaryBitwiseXorExpression:
        case SyntaxKind::UnaryLogicalNotExpression:
        case SyntaxKind::UnaryMinusExpression:
        case SyntaxKind::UnaryPlusExpression:
        case SyntaxKind::UnaryPredecrementExpression:
        case SyntaxKind::UnaryPreincrementExpression:
            return true;
        default:
            return false;
    }
}

bool PrefixUnaryExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PrefixUnaryExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return operatorToken;
        case 1: return &attributes;
        case 2: return operand.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax PrefixUnaryExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return operatorToken;
        case 1: return &attributes;
        case 2: return operand.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax PrefixUnaryExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &operatorToken;
        case 1: return &attributes;
        case 2: return operand.get();
        default: return nullptr;
    }
}

void PrefixUnaryExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: operatorToken = child.token(); return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: operand = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PrimaryBlockEventExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PrimaryBlockEventExpression;
}

bool PrimaryBlockEventExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PrimaryBlockEventExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return name.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax PrimaryBlockEventExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return name.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax PrimaryBlockEventExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return name.get();
        default: return nullptr;
    }
}

void PrimaryBlockEventExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PrimaryExpressionSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AssignmentPatternExpression:
        case SyntaxKind::ConcatenationExpression:
        case SyntaxKind::DefaultPatternKeyExpression:
        case SyntaxKind::EmptyQueueExpression:
        case SyntaxKind::IntegerLiteralExpression:
        case SyntaxKind::IntegerVectorExpression:
        case SyntaxKind::MultipleConcatenationExpression:
        case SyntaxKind::NullLiteralExpression:
        case SyntaxKind::ParenthesizedExpression:
        case SyntaxKind::RealLiteralExpression:
        case SyntaxKind::StreamingConcatenationExpression:
        case SyntaxKind::StringLiteralExpression:
        case SyntaxKind::TimeLiteralExpression:
        case SyntaxKind::UnbasedUnsizedLiteralExpression:
        case SyntaxKind::WildcardLiteralExpression:
            return true;
        default:
            return false;
    }
}

bool PrimitiveInstantiationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PrimitiveInstantiation;
}

bool PrimitiveInstantiationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax PrimitiveInstantiationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return type;
        case 2: return strength;
        case 3: return delay;
        case 4: return &instances;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PrimitiveInstantiationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return type;
        case 2: return strength;
        case 3: return delay;
        case 4: return &instances;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PrimitiveInstantiationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &type;
        case 2: return strength;
        case 3: return delay;
        case 4: return &instances;
        case 5: return &semi;
        default: return nullptr;
    }
}

void PrimitiveInstantiationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: type = child.token(); return;
        case 2: strength = child.node() ? &child.node()->as<NetStrengthSyntax>() : nullptr; return;
        case 3: delay = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 4: instances = child.node()->as<SeparatedSyntaxList<HierarchicalInstanceSyntax>>(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ProceduralAssignStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ProceduralAssignStatement:
        case SyntaxKind::ProceduralForceStatement:
            return true;
        default:
            return false;
    }
}

bool ProceduralAssignStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ProceduralAssignStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return expr.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ProceduralAssignStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return expr.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ProceduralAssignStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &keyword;
        case 3: return expr.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void ProceduralAssignStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: keyword = child.token(); return;
        case 3: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ProceduralBlockSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AlwaysBlock:
        case SyntaxKind::AlwaysCombBlock:
        case SyntaxKind::AlwaysFFBlock:
        case SyntaxKind::AlwaysLatchBlock:
        case SyntaxKind::FinalBlock:
        case SyntaxKind::InitialBlock:
            return true;
        default:
            return false;
    }
}

bool ProceduralBlockSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ProceduralBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ProceduralBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ProceduralBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return statement.get();
        default: return nullptr;
    }
}

void ProceduralBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ProceduralDeassignStatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ProceduralDeassignStatement:
        case SyntaxKind::ProceduralReleaseStatement:
            return true;
        default:
            return false;
    }
}

bool ProceduralDeassignStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax ProceduralDeassignStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return variable.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ProceduralDeassignStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return keyword;
        case 3: return variable.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ProceduralDeassignStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &keyword;
        case 3: return variable.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void ProceduralDeassignStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: keyword = child.token(); return;
        case 3: variable = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ProductionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::Production;
}

bool ProductionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax ProductionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dataType;
        case 1: return name;
        case 2: return portList;
        case 3: return colon;
        case 4: return &rules;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ProductionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dataType;
        case 1: return name;
        case 2: return portList;
        case 3: return colon;
        case 4: return &rules;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ProductionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return dataType;
        case 1: return &name;
        case 2: return portList;
        case 3: return &colon;
        case 4: return &rules;
        case 5: return &semi;
        default: return nullptr;
    }
}

void ProductionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dataType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 1: name = child.token(); return;
        case 2: portList = child.node() ? &child.node()->as<FunctionPortListSyntax>() : nullptr; return;
        case 3: colon = child.token(); return;
        case 4: rules = child.node()->as<SeparatedSyntaxList<RsRuleSyntax>>(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PropertyCaseItemSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultPropertyCaseItem:
        case SyntaxKind::StandardPropertyCaseItem:
            return true;
        default:
            return false;
    }
}

bool PropertyDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PropertyDeclaration;
}

bool PropertyDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        case 9: return true;
        default: return false;
    }
}

TokenOrSyntax PropertyDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &variables;
        case 6: return propertySpec.get();
        case 7: return optionalSemi;
        case 8: return end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PropertyDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &variables;
        case 6: return propertySpec.get();
        case 7: return optionalSemi;
        case 8: return end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PropertyDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &name;
        case 3: return portList;
        case 4: return &semi;
        case 5: return &variables;
        case 6: return propertySpec.get();
        case 7: return &optionalSemi;
        case 8: return &end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

void PropertyDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: name = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<AssertionItemPortListSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        case 5: variables = child.node()->as<SyntaxList<LocalVariableDeclarationSyntax>>(); return;
        case 6: propertySpec = child.node() ? &child.node()->as<PropertySpecSyntax>() : nullptr; return;
        case 7: optionalSemi = child.token(); return;
        case 8: end = child.token(); return;
        case 9: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PropertyExprSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AcceptOnPropertyExpr:
        case SyntaxKind::AndPropertyExpr:
        case SyntaxKind::CasePropertyExpr:
        case SyntaxKind::ClockingPropertyExpr:
        case SyntaxKind::ConditionalPropertyExpr:
        case SyntaxKind::FollowedByPropertyExpr:
        case SyntaxKind::IffPropertyExpr:
        case SyntaxKind::ImplicationPropertyExpr:
        case SyntaxKind::ImpliesPropertyExpr:
        case SyntaxKind::OrPropertyExpr:
        case SyntaxKind::ParenthesizedPropertyExpr:
        case SyntaxKind::SUntilPropertyExpr:
        case SyntaxKind::SUntilWithPropertyExpr:
        case SyntaxKind::SimplePropertyExpr:
        case SyntaxKind::StrongWeakPropertyExpr:
        case SyntaxKind::UnaryPropertyExpr:
        case SyntaxKind::UnarySelectPropertyExpr:
        case SyntaxKind::UntilPropertyExpr:
        case SyntaxKind::UntilWithPropertyExpr:
            return true;
        default:
            return false;
    }
}

bool PropertySpecSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PropertySpec;
}

bool PropertySpecSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax PropertySpecSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return clocking;
        case 1: return disable;
        case 2: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax PropertySpecSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return clocking;
        case 1: return disable;
        case 2: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax PropertySpecSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return clocking;
        case 1: return disable;
        case 2: return expr.get();
        default: return nullptr;
    }
}

void PropertySpecSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: clocking = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 1: disable = child.node() ? &child.node()->as<DisableIffSyntax>() : nullptr; return;
        case 2: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool PullStrengthSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PullStrength;
}

bool PullStrengthSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PullStrengthSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return strength;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PullStrengthSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return strength;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PullStrengthSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &strength;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void PullStrengthSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: strength = child.token(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool PulseStyleDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::PulseStyleDeclaration;
}

bool PulseStyleDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax PulseStyleDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &inputs;
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax PulseStyleDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &inputs;
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax PulseStyleDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &inputs;
        case 3: return &semi;
        default: return nullptr;
    }
}

void PulseStyleDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: inputs = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool QueueDimensionSpecifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::QueueDimensionSpecifier;
}

bool QueueDimensionSpecifierSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax QueueDimensionSpecifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dollar;
        case 1: return maxSizeClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax QueueDimensionSpecifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dollar;
        case 1: return maxSizeClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax QueueDimensionSpecifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dollar;
        case 1: return maxSizeClause;
        default: return nullptr;
    }
}

void QueueDimensionSpecifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dollar = child.token(); return;
        case 1: maxSizeClause = child.node() ? &child.node()->as<ColonExpressionClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RandCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RandCaseItem;
}

bool RandCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RandCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return colon;
        case 2: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax RandCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return colon;
        case 2: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax RandCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return &colon;
        case 2: return statement.get();
        default: return nullptr;
    }
}

void RandCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: colon = child.token(); return;
        case 2: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RandCaseStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RandCaseStatement;
}

bool RandCaseStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax RandCaseStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return randCase;
        case 3: return &items;
        case 4: return endCase;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RandCaseStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return randCase;
        case 3: return &items;
        case 4: return endCase;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RandCaseStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &randCase;
        case 3: return &items;
        case 4: return &endCase;
        default: return nullptr;
    }
}

void RandCaseStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: randCase = child.token(); return;
        case 3: items = child.node()->as<SyntaxList<RandCaseItemSyntax>>(); return;
        case 4: endCase = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RandJoinClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RandJoinClause;
}

bool RandJoinClauseSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax RandJoinClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return rand;
        case 1: return join;
        case 2: return expr;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RandJoinClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return rand;
        case 1: return join;
        case 2: return expr;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RandJoinClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &rand;
        case 1: return &join;
        case 2: return expr;
        default: return nullptr;
    }
}

void RandJoinClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: rand = child.token(); return;
        case 1: join = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ParenthesizedExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RandSequenceStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RandSequenceStatement;
}

bool RandSequenceStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax RandSequenceStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return randsequence;
        case 3: return openParen;
        case 4: return firstProduction;
        case 5: return closeParen;
        case 6: return &productions;
        case 7: return endsequence;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RandSequenceStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return randsequence;
        case 3: return openParen;
        case 4: return firstProduction;
        case 5: return closeParen;
        case 6: return &productions;
        case 7: return endsequence;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RandSequenceStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &randsequence;
        case 3: return &openParen;
        case 4: return &firstProduction;
        case 5: return &closeParen;
        case 6: return &productions;
        case 7: return &endsequence;
        default: return nullptr;
    }
}

void RandSequenceStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: randsequence = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: firstProduction = child.token(); return;
        case 5: closeParen = child.token(); return;
        case 6: productions = child.node()->as<SyntaxList<ProductionSyntax>>(); return;
        case 7: endsequence = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RangeCoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RangeCoverageBinInitializer;
}

bool RangeCoverageBinInitializerSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax RangeCoverageBinInitializerSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return ranges.get();
        case 1: return withClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RangeCoverageBinInitializerSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return ranges.get();
        case 1: return withClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RangeCoverageBinInitializerSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return ranges.get();
        case 1: return withClause;
        default: return nullptr;
    }
}

void RangeCoverageBinInitializerSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: ranges = child.node() ? &child.node()->as<RangeListSyntax>() : nullptr; return;
        case 1: withClause = child.node() ? &child.node()->as<WithClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RangeDimensionSpecifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RangeDimensionSpecifier;
}

bool RangeDimensionSpecifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RangeDimensionSpecifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return selector.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax RangeDimensionSpecifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return selector.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax RangeDimensionSpecifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return selector.get();
        default: return nullptr;
    }
}

void RangeDimensionSpecifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: selector = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RangeListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RangeList;
}

bool RangeListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RangeListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &valueRanges;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RangeListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &valueRanges;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RangeListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &valueRanges;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void RangeListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: valueRanges = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RangeSelectSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AscendingRangeSelect:
        case SyntaxKind::DescendingRangeSelect:
        case SyntaxKind::SimpleRangeSelect:
            return true;
        default:
            return false;
    }
}

bool RangeSelectSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RangeSelectSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return range;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax RangeSelectSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return range;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax RangeSelectSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &range;
        case 2: return right.get();
        default: return nullptr;
    }
}

void RangeSelectSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: range = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RepeatedEventControlSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RepeatedEventControl;
}

bool RepeatedEventControlSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax RepeatedEventControlSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return repeat;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return eventControl;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RepeatedEventControlSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return repeat;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return eventControl;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RepeatedEventControlSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &repeat;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        case 4: return eventControl;
        default: return nullptr;
    }
}

void RepeatedEventControlSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: repeat = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: eventControl = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ReplicatedAssignmentPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ReplicatedAssignmentPattern;
}

bool ReplicatedAssignmentPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ReplicatedAssignmentPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return countExpr.get();
        case 2: return innerOpenBrace;
        case 3: return &items;
        case 4: return innerCloseBrace;
        case 5: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ReplicatedAssignmentPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return countExpr.get();
        case 2: return innerOpenBrace;
        case 3: return &items;
        case 4: return innerCloseBrace;
        case 5: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ReplicatedAssignmentPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return countExpr.get();
        case 2: return &innerOpenBrace;
        case 3: return &items;
        case 4: return &innerCloseBrace;
        case 5: return &closeBrace;
        default: return nullptr;
    }
}

void ReplicatedAssignmentPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: countExpr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: innerOpenBrace = child.token(); return;
        case 3: items = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 4: innerCloseBrace = child.token(); return;
        case 5: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ReturnStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ReturnStatement;
}

bool ReturnStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax ReturnStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return returnKeyword;
        case 3: return returnValue;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ReturnStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return returnKeyword;
        case 3: return returnValue;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ReturnStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &returnKeyword;
        case 3: return returnValue;
        case 4: return &semi;
        default: return nullptr;
    }
}

void ReturnStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: returnKeyword = child.token(); return;
        case 3: returnValue = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsCaseItemSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::DefaultRsCaseItem:
        case SyntaxKind::StandardRsCaseItem:
            return true;
        default:
            return false;
    }
}

bool RsCaseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsCase;
}

bool RsCaseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RsCaseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return &items;
        case 5: return endcase;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsCaseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return &items;
        case 5: return endcase;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsCaseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        case 4: return &items;
        case 5: return &endcase;
        default: return nullptr;
    }
}

void RsCaseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: items = child.node()->as<SyntaxList<RsCaseItemSyntax>>(); return;
        case 5: endcase = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsCodeBlockSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsCodeBlock;
}

bool RsCodeBlockSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RsCodeBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsCodeBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsCodeBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &items;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void RsCodeBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: items = child.node()->as<SyntaxList<SyntaxNode>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsElseClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsElseClause;
}

bool RsElseClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RsElseClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return item.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsElseClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return item.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsElseClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return item.get();
        default: return nullptr;
    }
}

void RsElseClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: item = child.node() ? &child.node()->as<RsProdItemSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsIfElseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsIfElse;
}

bool RsIfElseSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax RsIfElseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return ifItem.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsIfElseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return condition.get();
        case 3: return closeParen;
        case 4: return ifItem.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsIfElseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &openParen;
        case 2: return condition.get();
        case 3: return &closeParen;
        case 4: return ifItem.get();
        case 5: return elseClause;
        default: return nullptr;
    }
}

void RsIfElseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: condition = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: ifItem = child.node() ? &child.node()->as<RsProdItemSyntax>() : nullptr; return;
        case 5: elseClause = child.node() ? &child.node()->as<RsElseClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsProdItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsProdItem;
}

bool RsProdItemSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax RsProdItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return argList;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsProdItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return argList;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsProdItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return argList;
        default: return nullptr;
    }
}

void RsProdItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: argList = child.node() ? &child.node()->as<ArgumentListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsProdSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::RsCase:
        case SyntaxKind::RsCodeBlock:
        case SyntaxKind::RsIfElse:
        case SyntaxKind::RsProdItem:
        case SyntaxKind::RsRepeat:
            return true;
        default:
            return false;
    }
}

bool RsRepeatSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsRepeat;
}

bool RsRepeatSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax RsRepeatSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return item.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsRepeatSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        case 4: return item.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsRepeatSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        case 4: return item.get();
        default: return nullptr;
    }
}

void RsRepeatSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        case 4: item = child.node() ? &child.node()->as<RsProdItemSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsRuleSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsRule;
}

bool RsRuleSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax RsRuleSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return randJoin;
        case 1: return &prods;
        case 2: return weightClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsRuleSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return randJoin;
        case 1: return &prods;
        case 2: return weightClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsRuleSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return randJoin;
        case 1: return &prods;
        case 2: return weightClause;
        default: return nullptr;
    }
}

void RsRuleSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: randJoin = child.node() ? &child.node()->as<RandJoinClauseSyntax>() : nullptr; return;
        case 1: prods = child.node()->as<SyntaxList<RsProdSyntax>>(); return;
        case 2: weightClause = child.node() ? &child.node()->as<RsWeightClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool RsWeightClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::RsWeightClause;
}

bool RsWeightClauseSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax RsWeightClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return colonEqual;
        case 1: return weight.get();
        case 2: return codeBlock;
        default: return nullptr;
    }
}

ConstTokenOrSyntax RsWeightClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return colonEqual;
        case 1: return weight.get();
        case 2: return codeBlock;
        default: return nullptr;
    }
}

PtrTokenOrSyntax RsWeightClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &colonEqual;
        case 1: return weight.get();
        case 2: return codeBlock;
        default: return nullptr;
    }
}

void RsWeightClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: colonEqual = child.token(); return;
        case 1: weight = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: codeBlock = child.node() ? &child.node()->as<RsProdSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool ScopedNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ScopedName;
}

bool ScopedNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ScopedNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return separator;
        case 2: return right.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax ScopedNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return left.get();
        case 1: return separator;
        case 2: return right.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax ScopedNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return left.get();
        case 1: return &separator;
        case 2: return right.get();
        default: return nullptr;
    }
}

void ScopedNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: left = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: separator = child.token(); return;
        case 2: right = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SelectorSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AscendingRangeSelect:
        case SyntaxKind::BitSelect:
        case SyntaxKind::DescendingRangeSelect:
        case SyntaxKind::SimpleRangeSelect:
            return true;
        default:
            return false;
    }
}

bool SequenceDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SequenceDeclaration;
}

bool SequenceDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        case 9: return true;
        default: return false;
    }
}

TokenOrSyntax SequenceDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &variables;
        case 6: return seqExpr.get();
        case 7: return optionalSemi;
        case 8: return end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SequenceDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return name;
        case 3: return portList;
        case 4: return semi;
        case 5: return &variables;
        case 6: return seqExpr.get();
        case 7: return optionalSemi;
        case 8: return end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SequenceDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &name;
        case 3: return portList;
        case 4: return &semi;
        case 5: return &variables;
        case 6: return seqExpr.get();
        case 7: return &optionalSemi;
        case 8: return &end;
        case 9: return endBlockName;
        default: return nullptr;
    }
}

void SequenceDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: name = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<AssertionItemPortListSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        case 5: variables = child.node()->as<SyntaxList<LocalVariableDeclarationSyntax>>(); return;
        case 6: seqExpr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 7: optionalSemi = child.token(); return;
        case 8: end = child.token(); return;
        case 9: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SequenceExprSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AndSequenceExpr:
        case SyntaxKind::BinaryEventExpression:
        case SyntaxKind::ClockingSequenceExpr:
        case SyntaxKind::DelayedSequenceExpr:
        case SyntaxKind::FirstMatchSequenceExpr:
        case SyntaxKind::IntersectSequenceExpr:
        case SyntaxKind::OrSequenceExpr:
        case SyntaxKind::ParenthesizedEventExpression:
        case SyntaxKind::ParenthesizedSequenceExpr:
        case SyntaxKind::SignalEventExpression:
        case SyntaxKind::SimpleSequenceExpr:
        case SyntaxKind::ThroughoutSequenceExpr:
        case SyntaxKind::WithinSequenceExpr:
            return true;
        default:
            return false;
    }
}

bool SequenceMatchListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SequenceMatchList;
}

bool SequenceMatchListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SequenceMatchListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return comma;
        case 1: return &items;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SequenceMatchListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return comma;
        case 1: return &items;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SequenceMatchListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &comma;
        case 1: return &items;
        default: return nullptr;
    }
}

void SequenceMatchListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: comma = child.token(); return;
        case 1: items = child.node()->as<SeparatedSyntaxList<PropertyExprSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SequenceRepetitionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SequenceRepetition;
}

bool SequenceRepetitionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax SequenceRepetitionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return op;
        case 2: return selector;
        case 3: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SequenceRepetitionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return op;
        case 2: return selector;
        case 3: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SequenceRepetitionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return &op;
        case 2: return selector;
        case 3: return &closeBracket;
        default: return nullptr;
    }
}

void SequenceRepetitionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: op = child.token(); return;
        case 2: selector = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        case 3: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SignalEventExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SignalEventExpression;
}

bool SignalEventExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax SignalEventExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return edge;
        case 1: return expr.get();
        case 2: return iffClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SignalEventExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return edge;
        case 1: return expr.get();
        case 2: return iffClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SignalEventExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &edge;
        case 1: return expr.get();
        case 2: return iffClause;
        default: return nullptr;
    }
}

void SignalEventExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: edge = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: iffClause = child.node() ? &child.node()->as<IffEventClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SignedCastExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SignedCastExpression;
}

bool SignedCastExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SignedCastExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return signing;
        case 1: return apostrophe;
        case 2: return inner.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax SignedCastExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return signing;
        case 1: return apostrophe;
        case 2: return inner.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax SignedCastExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &signing;
        case 1: return &apostrophe;
        case 2: return inner.get();
        default: return nullptr;
    }
}

void SignedCastExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: signing = child.token(); return;
        case 1: apostrophe = child.token(); return;
        case 2: inner = child.node() ? &child.node()->as<ParenthesizedExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimpleAssignmentPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimpleAssignmentPattern;
}

bool SimpleAssignmentPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SimpleAssignmentPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimpleAssignmentPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimpleAssignmentPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &items;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void SimpleAssignmentPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: items = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimpleBinsSelectExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimpleBinsSelectExpr;
}

bool SimpleBinsSelectExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax SimpleBinsSelectExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimpleBinsSelectExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimpleBinsSelectExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return matchesClause;
        default: return nullptr;
    }
}

void SimpleBinsSelectExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: matchesClause = child.node() ? &child.node()->as<MatchesClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimpleDirectiveSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::CellDefineDirective:
        case SyntaxKind::DelayModeDistributedDirective:
        case SyntaxKind::DelayModePathDirective:
        case SyntaxKind::DelayModeUnitDirective:
        case SyntaxKind::DelayModeZeroDirective:
        case SyntaxKind::EndCellDefineDirective:
        case SyntaxKind::EndKeywordsDirective:
        case SyntaxKind::EndProtectDirective:
        case SyntaxKind::EndProtectedDirective:
        case SyntaxKind::NoUnconnectedDriveDirective:
        case SyntaxKind::ProtectDirective:
        case SyntaxKind::ProtectedDirective:
        case SyntaxKind::ResetAllDirective:
        case SyntaxKind::UndefineAllDirective:
            return true;
        default:
            return false;
    }
}

bool SimpleDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SimpleDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimpleDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimpleDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        default: return nullptr;
    }
}

void SimpleDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimplePathSuffixSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimplePathSuffix;
}

bool SimplePathSuffixSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SimplePathSuffixSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &outputs;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimplePathSuffixSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &outputs;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimplePathSuffixSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &outputs;
        default: return nullptr;
    }
}

void SimplePathSuffixSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: outputs = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimplePragmaExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimplePragmaExpression;
}

bool SimplePragmaExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SimplePragmaExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return value;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimplePragmaExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return value;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimplePragmaExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &value;
        default: return nullptr;
    }
}

void SimplePragmaExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: value = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimplePropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimplePropertyExpr;
}

bool SimplePropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SimplePropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimplePropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimplePropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        default: return nullptr;
    }
}

void SimplePropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SimpleSequenceExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SimpleSequenceExpr;
}

bool SimpleSequenceExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax SimpleSequenceExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return repetition;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SimpleSequenceExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expr.get();
        case 1: return repetition;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SimpleSequenceExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expr.get();
        case 1: return repetition;
        default: return nullptr;
    }
}

void SimpleSequenceExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: repetition = child.node() ? &child.node()->as<SequenceRepetitionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool SolveBeforeConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SolveBeforeConstraint;
}

bool SolveBeforeConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SolveBeforeConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return solve;
        case 1: return &beforeExpr;
        case 2: return before;
        case 3: return &afterExpr;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SolveBeforeConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return solve;
        case 1: return &beforeExpr;
        case 2: return before;
        case 3: return &afterExpr;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SolveBeforeConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &solve;
        case 1: return &beforeExpr;
        case 2: return &before;
        case 3: return &afterExpr;
        case 4: return &semi;
        default: return nullptr;
    }
}

void SolveBeforeConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: solve = child.token(); return;
        case 1: beforeExpr = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 2: before = child.token(); return;
        case 3: afterExpr = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SpecifyBlockSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SpecifyBlock;
}

bool SpecifyBlockSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SpecifyBlockSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return specify;
        case 2: return &items;
        case 3: return endspecify;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SpecifyBlockSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return specify;
        case 2: return &items;
        case 3: return endspecify;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SpecifyBlockSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &specify;
        case 2: return &items;
        case 3: return &endspecify;
        default: return nullptr;
    }
}

void SpecifyBlockSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: specify = child.token(); return;
        case 2: items = child.node()->as<SyntaxList<MemberSyntax>>(); return;
        case 3: endspecify = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SpecparamDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SpecparamDeclaration;
}

bool SpecparamDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SpecparamDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SpecparamDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SpecparamDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return &semi;
        default: return nullptr;
    }
}

void SpecparamDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: type = child.node() ? &child.node()->as<ImplicitTypeSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<SpecparamDeclaratorSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SpecparamDeclaratorSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SpecparamDeclarator;
}

bool SpecparamDeclaratorSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 5: return true;
        default: return false;
    }
}

TokenOrSyntax SpecparamDeclaratorSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return equals;
        case 2: return openParen;
        case 3: return value1.get();
        case 4: return comma;
        case 5: return value2;
        case 6: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SpecparamDeclaratorSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return equals;
        case 2: return openParen;
        case 3: return value1.get();
        case 4: return comma;
        case 5: return value2;
        case 6: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SpecparamDeclaratorSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return &equals;
        case 2: return &openParen;
        case 3: return value1.get();
        case 4: return &comma;
        case 5: return value2;
        case 6: return &closeParen;
        default: return nullptr;
    }
}

void SpecparamDeclaratorSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: equals = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: value1 = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: comma = child.token(); return;
        case 5: value2 = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StandardCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StandardCaseItem;
}

bool StandardCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StandardCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax StandardCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax StandardCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return &colon;
        case 2: return clause.get();
        default: return nullptr;
    }
}

void StandardCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expressions = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 1: colon = child.token(); return;
        case 2: clause = child.node() ? &child.node()->as<SyntaxNode>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool StandardPropertyCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StandardPropertyCaseItem;
}

bool StandardPropertyCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StandardPropertyCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StandardPropertyCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return expr.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StandardPropertyCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return &colon;
        case 2: return expr.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void StandardPropertyCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expressions = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 1: colon = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StandardRsCaseItemSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StandardRsCaseItem;
}

bool StandardRsCaseItemSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StandardRsCaseItemSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return item.get();
        case 3: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StandardRsCaseItemSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &expressions;
        case 1: return colon;
        case 2: return item.get();
        case 3: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StandardRsCaseItemSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &expressions;
        case 1: return &colon;
        case 2: return item.get();
        case 3: return &semi;
        default: return nullptr;
    }
}

void StandardRsCaseItemSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expressions = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 1: colon = child.token(); return;
        case 2: item = child.node() ? &child.node()->as<RsProdItemSyntax>() : nullptr; return;
        case 3: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StatementSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AssertPropertyStatement:
        case SyntaxKind::AssumePropertyStatement:
        case SyntaxKind::BlockingEventTriggerStatement:
        case SyntaxKind::CaseStatement:
        case SyntaxKind::CheckerInstanceStatement:
        case SyntaxKind::ConditionalStatement:
        case SyntaxKind::CoverPropertyStatement:
        case SyntaxKind::CoverSequenceStatement:
        case SyntaxKind::DisableForkStatement:
        case SyntaxKind::DisableStatement:
        case SyntaxKind::DoWhileStatement:
        case SyntaxKind::EmptyStatement:
        case SyntaxKind::ExpectPropertyStatement:
        case SyntaxKind::ExpressionStatement:
        case SyntaxKind::ForLoopStatement:
        case SyntaxKind::ForeachLoopStatement:
        case SyntaxKind::ForeverStatement:
        case SyntaxKind::ImmediateAssertStatement:
        case SyntaxKind::ImmediateAssumeStatement:
        case SyntaxKind::ImmediateCoverStatement:
        case SyntaxKind::JumpStatement:
        case SyntaxKind::LoopStatement:
        case SyntaxKind::NonblockingEventTriggerStatement:
        case SyntaxKind::ParallelBlockStatement:
        case SyntaxKind::ProceduralAssignStatement:
        case SyntaxKind::ProceduralDeassignStatement:
        case SyntaxKind::ProceduralForceStatement:
        case SyntaxKind::ProceduralReleaseStatement:
        case SyntaxKind::RandCaseStatement:
        case SyntaxKind::RandSequenceStatement:
        case SyntaxKind::RestrictPropertyStatement:
        case SyntaxKind::ReturnStatement:
        case SyntaxKind::SequentialBlockStatement:
        case SyntaxKind::TimingControlStatement:
        case SyntaxKind::VoidCastedCallStatement:
        case SyntaxKind::WaitForkStatement:
        case SyntaxKind::WaitOrderStatement:
        case SyntaxKind::WaitStatement:
            return true;
        default:
            return false;
    }
}

bool StatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax StatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        default: return nullptr;
    }
}

void StatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StreamExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StreamExpression;
}

bool StreamExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax StreamExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return expression.get();
        case 1: return withRange;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StreamExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return expression.get();
        case 1: return withRange;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StreamExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return expression.get();
        case 1: return withRange;
        default: return nullptr;
    }
}

void StreamExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: expression = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 1: withRange = child.node() ? &child.node()->as<StreamExpressionWithRangeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool StreamExpressionWithRangeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StreamExpressionWithRange;
}

bool StreamExpressionWithRangeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StreamExpressionWithRangeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return withKeyword;
        case 1: return range.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax StreamExpressionWithRangeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return withKeyword;
        case 1: return range.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax StreamExpressionWithRangeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &withKeyword;
        case 1: return range.get();
        default: return nullptr;
    }
}

void StreamExpressionWithRangeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: withKeyword = child.token(); return;
        case 1: range = child.node() ? &child.node()->as<ElementSelectSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool StreamingConcatenationExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StreamingConcatenationExpression;
}

bool StreamingConcatenationExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax StreamingConcatenationExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return operatorToken;
        case 2: return sliceSize;
        case 3: return innerOpenBrace;
        case 4: return &expressions;
        case 5: return innerCloseBrace;
        case 6: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StreamingConcatenationExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return operatorToken;
        case 2: return sliceSize;
        case 3: return innerOpenBrace;
        case 4: return &expressions;
        case 5: return innerCloseBrace;
        case 6: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StreamingConcatenationExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &operatorToken;
        case 2: return sliceSize;
        case 3: return &innerOpenBrace;
        case 4: return &expressions;
        case 5: return &innerCloseBrace;
        case 6: return &closeBrace;
        default: return nullptr;
    }
}

void StreamingConcatenationExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: operatorToken = child.token(); return;
        case 2: sliceSize = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: innerOpenBrace = child.token(); return;
        case 4: expressions = child.node()->as<SeparatedSyntaxList<StreamExpressionSyntax>>(); return;
        case 5: innerCloseBrace = child.token(); return;
        case 6: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StrongWeakPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StrongWeakPropertyExpr;
}

bool StrongWeakPropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StrongWeakPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StrongWeakPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StrongWeakPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void StrongWeakPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<SequenceExprSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StructUnionMemberSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StructUnionMember;
}

bool StructUnionMemberSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StructUnionMemberSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return randomQualifier;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StructUnionMemberSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return randomQualifier;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StructUnionMemberSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &randomQualifier;
        case 2: return type.get();
        case 3: return &declarators;
        case 4: return &semi;
        default: return nullptr;
    }
}

void StructUnionMemberSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: randomQualifier = child.token(); return;
        case 2: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StructUnionTypeSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::StructType:
        case SyntaxKind::UnionType:
            return true;
        default:
            return false;
    }
}

bool StructUnionTypeSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StructUnionTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return taggedOrSoft;
        case 2: return packed;
        case 3: return signing;
        case 4: return openBrace;
        case 5: return &members;
        case 6: return closeBrace;
        case 7: return &dimensions;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StructUnionTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return taggedOrSoft;
        case 2: return packed;
        case 3: return signing;
        case 4: return openBrace;
        case 5: return &members;
        case 6: return closeBrace;
        case 7: return &dimensions;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StructUnionTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &taggedOrSoft;
        case 2: return &packed;
        case 3: return &signing;
        case 4: return &openBrace;
        case 5: return &members;
        case 6: return &closeBrace;
        case 7: return &dimensions;
        default: return nullptr;
    }
}

void StructUnionTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: taggedOrSoft = child.token(); return;
        case 2: packed = child.token(); return;
        case 3: signing = child.token(); return;
        case 4: openBrace = child.token(); return;
        case 5: members = child.node()->as<SyntaxList<StructUnionMemberSyntax>>(); return;
        case 6: closeBrace = child.token(); return;
        case 7: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StructurePatternMemberSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::NamedStructurePatternMember:
        case SyntaxKind::OrderedStructurePatternMember:
            return true;
        default:
            return false;
    }
}

bool StructurePatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StructurePattern;
}

bool StructurePatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StructurePatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &members;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StructurePatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &members;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StructurePatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &members;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void StructurePatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: members = child.node()->as<SeparatedSyntaxList<StructurePatternMemberSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool StructuredAssignmentPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::StructuredAssignmentPattern;
}

bool StructuredAssignmentPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax StructuredAssignmentPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

ConstTokenOrSyntax StructuredAssignmentPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBrace;
        case 1: return &items;
        case 2: return closeBrace;
        default: return nullptr;
    }
}

PtrTokenOrSyntax StructuredAssignmentPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBrace;
        case 1: return &items;
        case 2: return &closeBrace;
        default: return nullptr;
    }
}

void StructuredAssignmentPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBrace = child.token(); return;
        case 1: items = child.node()->as<SeparatedSyntaxList<AssignmentPatternItemSyntax>>(); return;
        case 2: closeBrace = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SuperNewDefaultedArgsExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SuperNewDefaultedArgsExpression;
}

bool SuperNewDefaultedArgsExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SuperNewDefaultedArgsExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return openParen;
        case 2: return defaultKeyword;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SuperNewDefaultedArgsExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return openParen;
        case 2: return defaultKeyword;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SuperNewDefaultedArgsExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return scopedNew.get();
        case 1: return &openParen;
        case 2: return &defaultKeyword;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void SuperNewDefaultedArgsExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: scopedNew = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        case 1: openParen = child.token(); return;
        case 2: defaultKeyword = child.token(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SystemNameSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SystemName;
}

bool SystemNameSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SystemNameSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return systemIdentifier;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SystemNameSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return systemIdentifier;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SystemNameSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &systemIdentifier;
        default: return nullptr;
    }
}

void SystemNameSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: systemIdentifier = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool SystemTimingCheckSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::SystemTimingCheck;
}

bool SystemTimingCheckSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax SystemTimingCheckSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return name;
        case 2: return openParen;
        case 3: return &args;
        case 4: return closeParen;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax SystemTimingCheckSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return name;
        case 2: return openParen;
        case 3: return &args;
        case 4: return closeParen;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax SystemTimingCheckSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &name;
        case 2: return &openParen;
        case 3: return &args;
        case 4: return &closeParen;
        case 5: return &semi;
        default: return nullptr;
    }
}

void SystemTimingCheckSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: name = child.token(); return;
        case 2: openParen = child.token(); return;
        case 3: args = child.node()->as<SeparatedSyntaxList<TimingCheckArgSyntax>>(); return;
        case 4: closeParen = child.token(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TaggedPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TaggedPattern;
}

bool TaggedPatternSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax TaggedPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return tagged;
        case 1: return memberName;
        case 2: return pattern;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TaggedPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return tagged;
        case 1: return memberName;
        case 2: return pattern;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TaggedPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &tagged;
        case 1: return &memberName;
        case 2: return pattern;
        default: return nullptr;
    }
}

void TaggedPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: tagged = child.token(); return;
        case 1: memberName = child.token(); return;
        case 2: pattern = child.node() ? &child.node()->as<PatternSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TaggedUnionExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TaggedUnionExpression;
}

bool TaggedUnionExpressionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax TaggedUnionExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return tagged;
        case 1: return member;
        case 2: return expr;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TaggedUnionExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return tagged;
        case 1: return member;
        case 2: return expr;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TaggedUnionExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &tagged;
        case 1: return &member;
        case 2: return expr;
        default: return nullptr;
    }
}

void TaggedUnionExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: tagged = child.token(); return;
        case 1: member = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimeScaleDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimeScaleDirective;
}

bool TimeScaleDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TimeScaleDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return timeUnit;
        case 2: return slash;
        case 3: return timePrecision;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimeScaleDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return timeUnit;
        case 2: return slash;
        case 3: return timePrecision;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimeScaleDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &timeUnit;
        case 2: return &slash;
        case 3: return &timePrecision;
        default: return nullptr;
    }
}

void TimeScaleDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: timeUnit = child.token(); return;
        case 2: slash = child.token(); return;
        case 3: timePrecision = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimeUnitsDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimeUnitsDeclaration;
}

bool TimeUnitsDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax TimeUnitsDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return time;
        case 3: return divider;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimeUnitsDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return time;
        case 3: return divider;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimeUnitsDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &time;
        case 3: return divider;
        case 4: return &semi;
        default: return nullptr;
    }
}

void TimeUnitsDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: time = child.token(); return;
        case 3: divider = child.node() ? &child.node()->as<DividerClauseSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimingCheckArgSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::EmptyTimingCheckArg:
        case SyntaxKind::ExpressionTimingCheckArg:
        case SyntaxKind::TimingCheckEventArg:
            return true;
        default:
            return false;
    }
}

bool TimingCheckEventArgSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimingCheckEventArg;
}

bool TimingCheckEventArgSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax TimingCheckEventArgSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return edge;
        case 1: return controlSpecifier;
        case 2: return terminal.get();
        case 3: return condition;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimingCheckEventArgSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return edge;
        case 1: return controlSpecifier;
        case 2: return terminal.get();
        case 3: return condition;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimingCheckEventArgSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &edge;
        case 1: return controlSpecifier;
        case 2: return terminal.get();
        case 3: return condition;
        default: return nullptr;
    }
}

void TimingCheckEventArgSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: edge = child.token(); return;
        case 1: controlSpecifier = child.node() ? &child.node()->as<EdgeControlSpecifierSyntax>() : nullptr; return;
        case 2: terminal = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: condition = child.node() ? &child.node()->as<TimingCheckEventConditionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimingCheckEventConditionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimingCheckEventCondition;
}

bool TimingCheckEventConditionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TimingCheckEventConditionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return tripleAnd;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimingCheckEventConditionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return tripleAnd;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimingCheckEventConditionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &tripleAnd;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void TimingCheckEventConditionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: tripleAnd = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimingControlExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimingControlExpression;
}

bool TimingControlExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TimingControlExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return timing.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimingControlExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return timing.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimingControlExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return timing.get();
        case 1: return expr.get();
        default: return nullptr;
    }
}

void TimingControlExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: timing = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 1: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimingControlStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TimingControlStatement;
}

bool TimingControlStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax TimingControlStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return timingControl.get();
        case 3: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax TimingControlStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return timingControl.get();
        case 3: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax TimingControlStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return timingControl.get();
        case 3: return statement.get();
        default: return nullptr;
    }
}

void TimingControlStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: timingControl = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 3: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TimingControlSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::CycleDelay:
        case SyntaxKind::Delay3:
        case SyntaxKind::DelayControl:
        case SyntaxKind::EventControl:
        case SyntaxKind::EventControlWithExpression:
        case SyntaxKind::ImplicitEventControl:
        case SyntaxKind::OneStepDelay:
        case SyntaxKind::RepeatedEventControl:
            return true;
        default:
            return false;
    }
}

bool TransListCoverageBinInitializerSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TransListCoverageBinInitializer;
}

bool TransListCoverageBinInitializerSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TransListCoverageBinInitializerSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &sets;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TransListCoverageBinInitializerSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &sets;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TransListCoverageBinInitializerSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &sets;
        default: return nullptr;
    }
}

void TransListCoverageBinInitializerSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: sets = child.node()->as<SeparatedSyntaxList<TransSetSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TransRangeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TransRange;
}

bool TransRangeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax TransRangeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &items;
        case 1: return repeat;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TransRangeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &items;
        case 1: return repeat;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TransRangeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &items;
        case 1: return repeat;
        default: return nullptr;
    }
}

void TransRangeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: items = child.node()->as<SeparatedSyntaxList<ExpressionSyntax>>(); return;
        case 1: repeat = child.node() ? &child.node()->as<TransRepeatRangeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TransRepeatRangeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TransRepeatRange;
}

bool TransRepeatRangeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax TransRepeatRangeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return specifier;
        case 2: return selector;
        case 3: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TransRepeatRangeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return specifier;
        case 2: return selector;
        case 3: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TransRepeatRangeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return &specifier;
        case 2: return selector;
        case 3: return &closeBracket;
        default: return nullptr;
    }
}

void TransRepeatRangeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: specifier = child.token(); return;
        case 2: selector = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        case 3: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TransSetSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TransSet;
}

bool TransSetSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TransSetSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return &ranges;
        case 2: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TransSetSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return &ranges;
        case 2: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TransSetSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &ranges;
        case 2: return &closeParen;
        default: return nullptr;
    }
}

void TransSetSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: ranges = child.node()->as<SeparatedSyntaxList<TransRangeSyntax>>(); return;
        case 2: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TypeAssignmentSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TypeAssignment;
}

bool TypeAssignmentSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax TypeAssignmentSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return name;
        case 1: return assignment;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TypeAssignmentSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return name;
        case 1: return assignment;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TypeAssignmentSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &name;
        case 1: return assignment;
        default: return nullptr;
    }
}

void TypeAssignmentSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: name = child.token(); return;
        case 1: assignment = child.node() ? &child.node()->as<EqualsTypeClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool TypeParameterDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TypeParameterDeclaration;
}

bool TypeParameterDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax TypeParameterDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return keyword;
        case 1: return typeKeyword;
        case 2: return typeRestriction;
        case 3: return &declarators;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TypeParameterDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return keyword;
        case 1: return typeKeyword;
        case 2: return typeRestriction;
        case 3: return &declarators;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TypeParameterDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &keyword;
        case 1: return &typeKeyword;
        case 2: return typeRestriction;
        case 3: return &declarators;
        default: return nullptr;
    }
}

void TypeParameterDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: keyword = child.token(); return;
        case 1: typeKeyword = child.token(); return;
        case 2: typeRestriction = child.node() ? &child.node()->as<ForwardTypeRestrictionSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<TypeAssignmentSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TypeReferenceSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TypeReference;
}

bool TypeReferenceSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TypeReferenceSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return typeKeyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TypeReferenceSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return typeKeyword;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TypeReferenceSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &typeKeyword;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void TypeReferenceSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: typeKeyword = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool TypedefDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::TypedefDeclaration;
}

bool TypedefDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax TypedefDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return typedefKeyword;
        case 2: return type.get();
        case 3: return name;
        case 4: return &dimensions;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax TypedefDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return typedefKeyword;
        case 2: return type.get();
        case 3: return name;
        case 4: return &dimensions;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax TypedefDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &typedefKeyword;
        case 2: return type.get();
        case 3: return &name;
        case 4: return &dimensions;
        case 5: return &semi;
        default: return nullptr;
    }
}

void TypedefDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: typedefKeyword = child.token(); return;
        case 2: type = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        case 3: name = child.token(); return;
        case 4: dimensions = child.node()->as<SyntaxList<VariableDimensionSyntax>>(); return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpBodySyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpBody;
}

bool UdpBodySyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax UdpBodySyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &portDecls;
        case 1: return initialStmt;
        case 2: return table;
        case 3: return &entries;
        case 4: return endtable;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpBodySyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &portDecls;
        case 1: return initialStmt;
        case 2: return table;
        case 3: return &entries;
        case 4: return endtable;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpBodySyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &portDecls;
        case 1: return initialStmt;
        case 2: return &table;
        case 3: return &entries;
        case 4: return &endtable;
        default: return nullptr;
    }
}

void UdpBodySyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: portDecls = child.node()->as<SeparatedSyntaxList<UdpPortDeclSyntax>>(); return;
        case 1: initialStmt = child.node() ? &child.node()->as<UdpInitialStmtSyntax>() : nullptr; return;
        case 2: table = child.token(); return;
        case 3: entries = child.node()->as<SyntaxList<UdpEntrySyntax>>(); return;
        case 4: endtable = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpDeclaration;
}

bool UdpDeclarationSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 6: return true;
        default: return false;
    }
}

TokenOrSyntax UdpDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return primitive;
        case 2: return name;
        case 3: return portList.get();
        case 4: return body.get();
        case 5: return endprimitive;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return primitive;
        case 2: return name;
        case 3: return portList.get();
        case 4: return body.get();
        case 5: return endprimitive;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &primitive;
        case 2: return &name;
        case 3: return portList.get();
        case 4: return body.get();
        case 5: return &endprimitive;
        case 6: return endBlockName;
        default: return nullptr;
    }
}

void UdpDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: primitive = child.token(); return;
        case 2: name = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<UdpPortListSyntax>() : nullptr; return;
        case 4: body = child.node() ? &child.node()->as<UdpBodySyntax>() : nullptr; return;
        case 5: endprimitive = child.token(); return;
        case 6: endBlockName = child.node() ? &child.node()->as<NamedBlockClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpEdgeFieldSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpEdgeField;
}

bool UdpEdgeFieldSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UdpEdgeFieldSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return first;
        case 2: return second;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpEdgeFieldSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return first;
        case 2: return second;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpEdgeFieldSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &first;
        case 2: return &second;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void UdpEdgeFieldSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: first = child.token(); return;
        case 2: second = child.token(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpEntrySyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpEntry;
}

bool UdpEntrySyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax UdpEntrySyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &inputs;
        case 1: return colon1;
        case 2: return current;
        case 3: return colon2;
        case 4: return next;
        case 5: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpEntrySyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &inputs;
        case 1: return colon1;
        case 2: return current;
        case 3: return colon2;
        case 4: return next;
        case 5: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpEntrySyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &inputs;
        case 1: return &colon1;
        case 2: return current;
        case 3: return &colon2;
        case 4: return next;
        case 5: return &semi;
        default: return nullptr;
    }
}

void UdpEntrySyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: inputs = child.node()->as<SyntaxList<UdpFieldBaseSyntax>>(); return;
        case 1: colon1 = child.token(); return;
        case 2: current = child.node() ? &child.node()->as<UdpFieldBaseSyntax>() : nullptr; return;
        case 3: colon2 = child.token(); return;
        case 4: next = child.node() ? &child.node()->as<UdpFieldBaseSyntax>() : nullptr; return;
        case 5: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpFieldBaseSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::UdpEdgeField:
        case SyntaxKind::UdpSimpleField:
            return true;
        default:
            return false;
    }
}

bool UdpInitialStmtSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpInitialStmt;
}

bool UdpInitialStmtSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UdpInitialStmtSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return initial;
        case 1: return name;
        case 2: return equals;
        case 3: return value.get();
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpInitialStmtSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return initial;
        case 1: return name;
        case 2: return equals;
        case 3: return value.get();
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpInitialStmtSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &initial;
        case 1: return &name;
        case 2: return &equals;
        case 3: return value.get();
        case 4: return &semi;
        default: return nullptr;
    }
}

void UdpInitialStmtSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: initial = child.token(); return;
        case 1: name = child.token(); return;
        case 2: equals = child.token(); return;
        case 3: value = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpInputPortDeclSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpInputPortDecl;
}

bool UdpInputPortDeclSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UdpInputPortDeclSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &names;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpInputPortDeclSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return &names;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpInputPortDeclSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &names;
        default: return nullptr;
    }
}

void UdpInputPortDeclSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: names = child.node()->as<SeparatedSyntaxList<IdentifierNameSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpOutputPortDeclSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpOutputPortDecl;
}

bool UdpOutputPortDeclSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax UdpOutputPortDeclSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return reg;
        case 3: return name;
        case 4: return initializer;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpOutputPortDeclSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return keyword;
        case 2: return reg;
        case 3: return name;
        case 4: return initializer;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpOutputPortDeclSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &keyword;
        case 2: return &reg;
        case 3: return &name;
        case 4: return initializer;
        default: return nullptr;
    }
}

void UdpOutputPortDeclSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: keyword = child.token(); return;
        case 2: reg = child.token(); return;
        case 3: name = child.token(); return;
        case 4: initializer = child.node() ? &child.node()->as<EqualsValueClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpPortDeclSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::UdpInputPortDecl:
        case SyntaxKind::UdpOutputPortDecl:
            return true;
        default:
            return false;
    }
}

bool UdpPortDeclSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UdpPortDeclSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpPortDeclSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpPortDeclSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        default: return nullptr;
    }
}

void UdpPortDeclSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UdpPortListSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::AnsiUdpPortList:
        case SyntaxKind::NonAnsiUdpPortList:
        case SyntaxKind::WildcardUdpPortList:
            return true;
        default:
            return false;
    }
}

bool UdpSimpleFieldSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UdpSimpleField;
}

bool UdpSimpleFieldSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UdpSimpleFieldSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return field;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UdpSimpleFieldSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return field;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UdpSimpleFieldSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &field;
        default: return nullptr;
    }
}

void UdpSimpleFieldSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: field = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnaryBinsSelectExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UnaryBinsSelectExpr;
}

bool UnaryBinsSelectExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UnaryBinsSelectExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnaryBinsSelectExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnaryBinsSelectExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void UnaryBinsSelectExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: op = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<BinsSelectConditionExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnaryConditionalDirectiveExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UnaryConditionalDirectiveExpression;
}

bool UnaryConditionalDirectiveExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UnaryConditionalDirectiveExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return op;
        case 1: return operand.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnaryConditionalDirectiveExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return op;
        case 1: return operand.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnaryConditionalDirectiveExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &op;
        case 1: return operand.get();
        default: return nullptr;
    }
}

void UnaryConditionalDirectiveExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: op = child.token(); return;
        case 1: operand = child.node() ? &child.node()->as<ConditionalDirectiveExpressionSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnaryPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UnaryPropertyExpr;
}

bool UnaryPropertyExprSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UnaryPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnaryPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnaryPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &op;
        case 1: return expr.get();
        default: return nullptr;
    }
}

void UnaryPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: op = child.token(); return;
        case 1: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnarySelectPropertyExprSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UnarySelectPropertyExpr;
}

bool UnarySelectPropertyExprSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 2: return true;
        default: return false;
    }
}

TokenOrSyntax UnarySelectPropertyExprSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return op;
        case 1: return openBracket;
        case 2: return selector;
        case 3: return closeBracket;
        case 4: return expr.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnarySelectPropertyExprSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return op;
        case 1: return openBracket;
        case 2: return selector;
        case 3: return closeBracket;
        case 4: return expr.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnarySelectPropertyExprSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &op;
        case 1: return &openBracket;
        case 2: return selector;
        case 3: return &closeBracket;
        case 4: return expr.get();
        default: return nullptr;
    }
}

void UnarySelectPropertyExprSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: op = child.token(); return;
        case 1: openBracket = child.token(); return;
        case 2: selector = child.node() ? &child.node()->as<SelectorSyntax>() : nullptr; return;
        case 3: closeBracket = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<PropertyExprSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnconditionalBranchDirectiveSyntax::isKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::ElseDirective:
        case SyntaxKind::EndIfDirective:
            return true;
        default:
            return false;
    }
}

bool UnconditionalBranchDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UnconditionalBranchDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return &disabledTokens;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnconditionalBranchDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return &disabledTokens;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnconditionalBranchDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &disabledTokens;
        default: return nullptr;
    }
}

void UnconditionalBranchDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: disabledTokens = child.node()->as<TokenList>(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UnconnectedDriveDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UnconnectedDriveDirective;
}

bool UnconnectedDriveDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UnconnectedDriveDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return strength;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UnconnectedDriveDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return strength;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UnconnectedDriveDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &strength;
        default: return nullptr;
    }
}

void UnconnectedDriveDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: strength = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UndefDirectiveSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UndefDirective;
}

bool UndefDirectiveSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UndefDirectiveSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UndefDirectiveSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return directive;
        case 1: return name;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UndefDirectiveSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &directive;
        case 1: return &name;
        default: return nullptr;
    }
}

void UndefDirectiveSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: directive = child.token(); return;
        case 1: name = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UniquenessConstraintSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UniquenessConstraint;
}

bool UniquenessConstraintSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UniquenessConstraintSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return unique;
        case 1: return ranges.get();
        case 2: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UniquenessConstraintSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return unique;
        case 1: return ranges.get();
        case 2: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UniquenessConstraintSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &unique;
        case 1: return ranges.get();
        case 2: return &semi;
        default: return nullptr;
    }
}

void UniquenessConstraintSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: unique = child.token(); return;
        case 1: ranges = child.node() ? &child.node()->as<RangeListSyntax>() : nullptr; return;
        case 2: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool UserDefinedNetDeclarationSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::UserDefinedNetDeclaration;
}

bool UserDefinedNetDeclarationSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax UserDefinedNetDeclarationSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return netType;
        case 2: return delay.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax UserDefinedNetDeclarationSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return netType;
        case 2: return delay.get();
        case 3: return &declarators;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax UserDefinedNetDeclarationSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &netType;
        case 2: return delay.get();
        case 3: return &declarators;
        case 4: return &semi;
        default: return nullptr;
    }
}

void UserDefinedNetDeclarationSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: netType = child.token(); return;
        case 2: delay = child.node() ? &child.node()->as<TimingControlSyntax>() : nullptr; return;
        case 3: declarators = child.node()->as<SeparatedSyntaxList<DeclaratorSyntax>>(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool ValueRangeExpressionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::ValueRangeExpression;
}

bool ValueRangeExpressionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax ValueRangeExpressionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return left.get();
        case 2: return op;
        case 3: return right.get();
        case 4: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax ValueRangeExpressionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return left.get();
        case 2: return op;
        case 3: return right.get();
        case 4: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax ValueRangeExpressionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return left.get();
        case 2: return &op;
        case 3: return right.get();
        case 4: return &closeBracket;
        default: return nullptr;
    }
}

void ValueRangeExpressionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: left = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 2: op = child.token(); return;
        case 3: right = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 4: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool VariableDimensionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::VariableDimension;
}

bool VariableDimensionSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 1: return true;
        default: return false;
    }
}

TokenOrSyntax VariableDimensionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openBracket;
        case 1: return specifier;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

ConstTokenOrSyntax VariableDimensionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openBracket;
        case 1: return specifier;
        case 2: return closeBracket;
        default: return nullptr;
    }
}

PtrTokenOrSyntax VariableDimensionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openBracket;
        case 1: return specifier;
        case 2: return &closeBracket;
        default: return nullptr;
    }
}

void VariableDimensionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openBracket = child.token(); return;
        case 1: specifier = child.node() ? &child.node()->as<DimensionSpecifierSyntax>() : nullptr; return;
        case 2: closeBracket = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool VariablePatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::VariablePattern;
}

bool VariablePatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax VariablePatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return variableName;
        default: return nullptr;
    }
}

ConstTokenOrSyntax VariablePatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return variableName;
        default: return nullptr;
    }
}

PtrTokenOrSyntax VariablePatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &variableName;
        default: return nullptr;
    }
}

void VariablePatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: variableName = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool VariablePortHeaderSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::VariablePortHeader;
}

bool VariablePortHeaderSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax VariablePortHeaderSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return constKeyword;
        case 1: return direction;
        case 2: return varKeyword;
        case 3: return dataType.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax VariablePortHeaderSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return constKeyword;
        case 1: return direction;
        case 2: return varKeyword;
        case 3: return dataType.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax VariablePortHeaderSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &constKeyword;
        case 1: return &direction;
        case 2: return &varKeyword;
        case 3: return dataType.get();
        default: return nullptr;
    }
}

void VariablePortHeaderSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: constKeyword = child.token(); return;
        case 1: direction = child.token(); return;
        case 2: varKeyword = child.token(); return;
        case 3: dataType = child.node() ? &child.node()->as<DataTypeSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool VirtualInterfaceTypeSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::VirtualInterfaceType;
}

bool VirtualInterfaceTypeSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        case 4: return true;
        default: return false;
    }
}

TokenOrSyntax VirtualInterfaceTypeSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return virtualKeyword;
        case 1: return interfaceKeyword;
        case 2: return name;
        case 3: return parameters;
        case 4: return modport;
        default: return nullptr;
    }
}

ConstTokenOrSyntax VirtualInterfaceTypeSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return virtualKeyword;
        case 1: return interfaceKeyword;
        case 2: return name;
        case 3: return parameters;
        case 4: return modport;
        default: return nullptr;
    }
}

PtrTokenOrSyntax VirtualInterfaceTypeSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &virtualKeyword;
        case 1: return &interfaceKeyword;
        case 2: return &name;
        case 3: return parameters;
        case 4: return modport;
        default: return nullptr;
    }
}

void VirtualInterfaceTypeSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: virtualKeyword = child.token(); return;
        case 1: interfaceKeyword = child.token(); return;
        case 2: name = child.token(); return;
        case 3: parameters = child.node() ? &child.node()->as<ParameterValueAssignmentSyntax>() : nullptr; return;
        case 4: modport = child.node() ? &child.node()->as<DotMemberClauseSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool VoidCastedCallStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::VoidCastedCallStatement;
}

bool VoidCastedCallStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax VoidCastedCallStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return voidKeyword;
        case 3: return apostrophe;
        case 4: return openParen;
        case 5: return expr.get();
        case 6: return closeParen;
        case 7: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax VoidCastedCallStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return voidKeyword;
        case 3: return apostrophe;
        case 4: return openParen;
        case 5: return expr.get();
        case 6: return closeParen;
        case 7: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax VoidCastedCallStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &voidKeyword;
        case 3: return &apostrophe;
        case 4: return &openParen;
        case 5: return expr.get();
        case 6: return &closeParen;
        case 7: return &semi;
        default: return nullptr;
    }
}

void VoidCastedCallStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: voidKeyword = child.token(); return;
        case 3: apostrophe = child.token(); return;
        case 4: openParen = child.token(); return;
        case 5: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 6: closeParen = child.token(); return;
        case 7: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WaitForkStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WaitForkStatement;
}

bool WaitForkStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax WaitForkStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait;
        case 3: return fork;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WaitForkStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait;
        case 3: return fork;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WaitForkStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &wait;
        case 3: return &fork;
        case 4: return &semi;
        default: return nullptr;
    }
}

void WaitForkStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: wait = child.token(); return;
        case 3: fork = child.token(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WaitOrderStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WaitOrderStatement;
}

bool WaitOrderStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax WaitOrderStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait_order;
        case 3: return openParen;
        case 4: return &names;
        case 5: return closeParen;
        case 6: return action.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax WaitOrderStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait_order;
        case 3: return openParen;
        case 4: return &names;
        case 5: return closeParen;
        case 6: return action.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax WaitOrderStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &wait_order;
        case 3: return &openParen;
        case 4: return &names;
        case 5: return &closeParen;
        case 6: return action.get();
        default: return nullptr;
    }
}

void WaitOrderStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: wait_order = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: names = child.node()->as<SeparatedSyntaxList<NameSyntax>>(); return;
        case 5: closeParen = child.token(); return;
        case 6: action = child.node() ? &child.node()->as<ActionBlockSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool WaitStatementSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WaitStatement;
}

bool WaitStatementSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 0: return true;
        default: return false;
    }
}

TokenOrSyntax WaitStatementSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait;
        case 3: return openParen;
        case 4: return expr.get();
        case 5: return closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax WaitStatementSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return wait;
        case 3: return openParen;
        case 4: return expr.get();
        case 5: return closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax WaitStatementSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return label;
        case 1: return &attributes;
        case 2: return &wait;
        case 3: return &openParen;
        case 4: return expr.get();
        case 5: return &closeParen;
        case 6: return statement.get();
        default: return nullptr;
    }
}

void WaitStatementSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: label = child.node() ? &child.node()->as<NamedLabelSyntax>() : nullptr; return;
        case 1: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 2: wait = child.token(); return;
        case 3: openParen = child.token(); return;
        case 4: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 5: closeParen = child.token(); return;
        case 6: statement = child.node() ? &child.node()->as<StatementSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool WildcardDimensionSpecifierSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WildcardDimensionSpecifier;
}

bool WildcardDimensionSpecifierSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WildcardDimensionSpecifierSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return star;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WildcardDimensionSpecifierSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return star;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WildcardDimensionSpecifierSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &star;
        default: return nullptr;
    }
}

void WildcardDimensionSpecifierSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: star = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WildcardPatternSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WildcardPattern;
}

bool WildcardPatternSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WildcardPatternSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return dot;
        case 1: return star;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WildcardPatternSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return dot;
        case 1: return star;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WildcardPatternSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &dot;
        case 1: return &star;
        default: return nullptr;
    }
}

void WildcardPatternSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: dot = child.token(); return;
        case 1: star = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WildcardPortConnectionSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WildcardPortConnection;
}

bool WildcardPortConnectionSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WildcardPortConnectionSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return dot;
        case 2: return star;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WildcardPortConnectionSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return &attributes;
        case 1: return dot;
        case 2: return star;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WildcardPortConnectionSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &attributes;
        case 1: return &dot;
        case 2: return &star;
        default: return nullptr;
    }
}

void WildcardPortConnectionSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: attributes = child.node()->as<SyntaxList<AttributeInstanceSyntax>>(); return;
        case 1: dot = child.token(); return;
        case 2: star = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WildcardPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WildcardPortList;
}

bool WildcardPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WildcardPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return dot;
        case 2: return star;
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WildcardPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return dot;
        case 2: return star;
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WildcardPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &dot;
        case 2: return &star;
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void WildcardPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: dot = child.token(); return;
        case 2: star = child.token(); return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WildcardUdpPortListSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WildcardUdpPortList;
}

bool WildcardUdpPortListSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WildcardUdpPortListSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return openParen;
        case 1: return dot;
        case 2: return star;
        case 3: return closeParen;
        case 4: return semi;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WildcardUdpPortListSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return openParen;
        case 1: return dot;
        case 2: return star;
        case 3: return closeParen;
        case 4: return semi;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WildcardUdpPortListSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &openParen;
        case 1: return &dot;
        case 2: return &star;
        case 3: return &closeParen;
        case 4: return &semi;
        default: return nullptr;
    }
}

void WildcardUdpPortListSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: openParen = child.token(); return;
        case 1: dot = child.token(); return;
        case 2: star = child.token(); return;
        case 3: closeParen = child.token(); return;
        case 4: semi = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WithClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WithClause;
}

bool WithClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WithClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return with;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WithClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return with;
        case 1: return openParen;
        case 2: return expr.get();
        case 3: return closeParen;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WithClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &with;
        case 1: return &openParen;
        case 2: return expr.get();
        case 3: return &closeParen;
        default: return nullptr;
    }
}

void WithClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: with = child.token(); return;
        case 1: openParen = child.token(); return;
        case 2: expr = child.node() ? &child.node()->as<ExpressionSyntax>() : nullptr; return;
        case 3: closeParen = child.token(); return;
        default: SLANG_UNREACHABLE;
    }
}

bool WithFunctionClauseSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WithFunctionClause;
}

bool WithFunctionClauseSyntax::isChildOptional(size_t index) {
    (void)index;
    return false;
}

TokenOrSyntax WithFunctionClauseSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return with;
        case 1: return name.get();
        default: return nullptr;
    }
}

ConstTokenOrSyntax WithFunctionClauseSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return with;
        case 1: return name.get();
        default: return nullptr;
    }
}

PtrTokenOrSyntax WithFunctionClauseSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &with;
        case 1: return name.get();
        default: return nullptr;
    }
}

void WithFunctionClauseSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: with = child.token(); return;
        case 1: name = child.node() ? &child.node()->as<NameSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

bool WithFunctionSampleSyntax::isKind(SyntaxKind kind) {
    return kind == SyntaxKind::WithFunctionSample;
}

bool WithFunctionSampleSyntax::isChildOptional(size_t index) {
    switch (index) {
        case 3: return true;
        default: return false;
    }
}

TokenOrSyntax WithFunctionSampleSyntax::getChild(size_t index) {
    switch (index) {
        case 0: return with;
        case 1: return function;
        case 2: return sample;
        case 3: return portList;
        default: return nullptr;
    }
}

ConstTokenOrSyntax WithFunctionSampleSyntax::getChild(size_t index) const {
    switch (index) {
        case 0: return with;
        case 1: return function;
        case 2: return sample;
        case 3: return portList;
        default: return nullptr;
    }
}

PtrTokenOrSyntax WithFunctionSampleSyntax::getChildPtr(size_t index) {
    switch (index) {
        case 0: return &with;
        case 1: return &function;
        case 2: return &sample;
        case 3: return portList;
        default: return nullptr;
    }
}

void WithFunctionSampleSyntax::setChild(size_t index, TokenOrSyntax child) {
    switch (index) {
        case 0: with = child.token(); return;
        case 1: function = child.token(); return;
        case 2: sample = child.token(); return;
        case 3: portList = child.node() ? &child.node()->as<FunctionPortListSyntax>() : nullptr; return;
        default: SLANG_UNREACHABLE;
    }
}

AcceptOnPropertyExprSyntax& SyntaxFactory::acceptOnPropertyExpr(Token keyword, Token openParen, ExpressionSyntax& condition, Token closeParen, PropertyExprSyntax& expr) {
    return *alloc.emplace<AcceptOnPropertyExprSyntax>(keyword, openParen, condition, closeParen, expr);
}

ActionBlockSyntax& SyntaxFactory::actionBlock(StatementSyntax* statement, ElseClauseSyntax* elseClause) {
    return *alloc.emplace<ActionBlockSyntax>(statement, elseClause);
}

AnonymousProgramSyntax& SyntaxFactory::anonymousProgram(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token semi, const SyntaxList<MemberSyntax>& members, Token endkeyword) {
    return *alloc.emplace<AnonymousProgramSyntax>(attributes, keyword, semi, members, endkeyword);
}

AnsiPortListSyntax& SyntaxFactory::ansiPortList(Token openParen, const SeparatedSyntaxList<MemberSyntax>& ports, Token closeParen) {
    return *alloc.emplace<AnsiPortListSyntax>(openParen, ports, closeParen);
}

AnsiUdpPortListSyntax& SyntaxFactory::ansiUdpPortList(Token openParen, const SeparatedSyntaxList<UdpPortDeclSyntax>& ports, Token closeParen, Token semi) {
    return *alloc.emplace<AnsiUdpPortListSyntax>(openParen, ports, closeParen, semi);
}

ArgumentListSyntax& SyntaxFactory::argumentList(Token openParen, const SeparatedSyntaxList<ArgumentSyntax>& parameters, Token closeParen) {
    return *alloc.emplace<ArgumentListSyntax>(openParen, parameters, closeParen);
}

ArrayOrRandomizeMethodExpressionSyntax& SyntaxFactory::arrayOrRandomizeMethodExpression(ExpressionSyntax& method, Token with, ParenExpressionListSyntax* args, ConstraintBlockSyntax* constraints) {
    return *alloc.emplace<ArrayOrRandomizeMethodExpressionSyntax>(method, with, args, constraints);
}

AssertionItemPortListSyntax& SyntaxFactory::assertionItemPortList(Token openParen, const SeparatedSyntaxList<AssertionItemPortSyntax>& ports, Token closeParen) {
    return *alloc.emplace<AssertionItemPortListSyntax>(openParen, ports, closeParen);
}

AssertionItemPortSyntax& SyntaxFactory::assertionItemPort(const SyntaxList<AttributeInstanceSyntax>& attributes, Token local, Token direction, DataTypeSyntax& type, Token name, const SyntaxList<VariableDimensionSyntax>& dimensions, EqualsAssertionArgClauseSyntax* defaultValue) {
    return *alloc.emplace<AssertionItemPortSyntax>(attributes, local, direction, type, name, dimensions, defaultValue);
}

AssignmentPatternExpressionSyntax& SyntaxFactory::assignmentPatternExpression(DataTypeSyntax* type, AssignmentPatternSyntax& pattern) {
    return *alloc.emplace<AssignmentPatternExpressionSyntax>(type, pattern);
}

AssignmentPatternItemSyntax& SyntaxFactory::assignmentPatternItem(ExpressionSyntax& key, Token colon, ExpressionSyntax& expr) {
    return *alloc.emplace<AssignmentPatternItemSyntax>(key, colon, expr);
}

AttributeInstanceSyntax& SyntaxFactory::attributeInstance(Token openParen, Token openStar, const SeparatedSyntaxList<AttributeSpecSyntax>& specs, Token closeStar, Token closeParen) {
    return *alloc.emplace<AttributeInstanceSyntax>(openParen, openStar, specs, closeStar, closeParen);
}

AttributeSpecSyntax& SyntaxFactory::attributeSpec(Token name, EqualsValueClauseSyntax* value) {
    return *alloc.emplace<AttributeSpecSyntax>(name, value);
}

BadExpressionSyntax& SyntaxFactory::badExpression(ExpressionSyntax& expr) {
    return *alloc.emplace<BadExpressionSyntax>(expr);
}

BeginKeywordsDirectiveSyntax& SyntaxFactory::beginKeywordsDirective(Token directive, Token versionSpecifier) {
    return *alloc.emplace<BeginKeywordsDirectiveSyntax>(directive, versionSpecifier);
}

BinSelectWithFilterExprSyntax& SyntaxFactory::binSelectWithFilterExpr(BinsSelectExpressionSyntax& expr, Token with, Token openParen, ExpressionSyntax& filter, Token closeParen, MatchesClauseSyntax* matchesClause) {
    return *alloc.emplace<BinSelectWithFilterExprSyntax>(expr, with, openParen, filter, closeParen, matchesClause);
}

BinaryBinsSelectExprSyntax& SyntaxFactory::binaryBinsSelectExpr(BinsSelectExpressionSyntax& left, Token op, BinsSelectExpressionSyntax& right) {
    return *alloc.emplace<BinaryBinsSelectExprSyntax>(left, op, right);
}

BinaryBlockEventExpressionSyntax& SyntaxFactory::binaryBlockEventExpression(BlockEventExpressionSyntax& left, Token orKeyword, BlockEventExpressionSyntax& right) {
    return *alloc.emplace<BinaryBlockEventExpressionSyntax>(left, orKeyword, right);
}

BinaryConditionalDirectiveExpressionSyntax& SyntaxFactory::binaryConditionalDirectiveExpression(ConditionalDirectiveExpressionSyntax& left, Token op, ConditionalDirectiveExpressionSyntax& right) {
    return *alloc.emplace<BinaryConditionalDirectiveExpressionSyntax>(left, op, right);
}

BinaryEventExpressionSyntax& SyntaxFactory::binaryEventExpression(EventExpressionSyntax& left, Token operatorToken, EventExpressionSyntax& right) {
    return *alloc.emplace<BinaryEventExpressionSyntax>(left, operatorToken, right);
}

BinaryExpressionSyntax& SyntaxFactory::binaryExpression(SyntaxKind kind, ExpressionSyntax& left, Token operatorToken, const SyntaxList<AttributeInstanceSyntax>& attributes, ExpressionSyntax& right) {
    return *alloc.emplace<BinaryExpressionSyntax>(kind, left, operatorToken, attributes, right);
}

BinaryPropertyExprSyntax& SyntaxFactory::binaryPropertyExpr(SyntaxKind kind, PropertyExprSyntax& left, Token op, PropertyExprSyntax& right) {
    return *alloc.emplace<BinaryPropertyExprSyntax>(kind, left, op, right);
}

BinarySequenceExprSyntax& SyntaxFactory::binarySequenceExpr(SyntaxKind kind, SequenceExprSyntax& left, Token op, SequenceExprSyntax& right) {
    return *alloc.emplace<BinarySequenceExprSyntax>(kind, left, op, right);
}

BindDirectiveSyntax& SyntaxFactory::bindDirective(const SyntaxList<AttributeInstanceSyntax>& attributes, Token bind, NameSyntax& target, BindTargetListSyntax* targetInstances, MemberSyntax& instantiation) {
    return *alloc.emplace<BindDirectiveSyntax>(attributes, bind, target, targetInstances, instantiation);
}

BindTargetListSyntax& SyntaxFactory::bindTargetList(Token colon, const SeparatedSyntaxList<NameSyntax>& targets) {
    return *alloc.emplace<BindTargetListSyntax>(colon, targets);
}

BinsSelectConditionExprSyntax& SyntaxFactory::binsSelectConditionExpr(Token binsof, Token openParen, NameSyntax& name, Token closeParen, IntersectClauseSyntax* intersects) {
    return *alloc.emplace<BinsSelectConditionExprSyntax>(binsof, openParen, name, closeParen, intersects);
}

BinsSelectionSyntax& SyntaxFactory::binsSelection(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token name, Token equals, BinsSelectExpressionSyntax& expr, CoverageIffClauseSyntax* iff, Token semi) {
    return *alloc.emplace<BinsSelectionSyntax>(attributes, keyword, name, equals, expr, iff, semi);
}

BitSelectSyntax& SyntaxFactory::bitSelect(ExpressionSyntax& expr) {
    return *alloc.emplace<BitSelectSyntax>(expr);
}

BlockCoverageEventSyntax& SyntaxFactory::blockCoverageEvent(Token atat, Token openParen, BlockEventExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<BlockCoverageEventSyntax>(atat, openParen, expr, closeParen);
}

BlockStatementSyntax& SyntaxFactory::blockStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token begin, NamedBlockClauseSyntax* blockName, const SyntaxList<SyntaxNode>& items, Token end, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<BlockStatementSyntax>(kind, label, attributes, begin, blockName, items, end, endBlockName);
}

CaseGenerateSyntax& SyntaxFactory::caseGenerate(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token openParen, ExpressionSyntax& condition, Token closeParen, const SyntaxList<CaseItemSyntax>& items, Token endCase) {
    return *alloc.emplace<CaseGenerateSyntax>(attributes, keyword, openParen, condition, closeParen, items, endCase);
}

CasePropertyExprSyntax& SyntaxFactory::casePropertyExpr(Token caseKeyword, Token openParen, ExpressionSyntax& expr, Token closeParen, const SyntaxList<PropertyCaseItemSyntax>& items, Token endcase) {
    return *alloc.emplace<CasePropertyExprSyntax>(caseKeyword, openParen, expr, closeParen, items, endcase);
}

CaseStatementSyntax& SyntaxFactory::caseStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token uniqueOrPriority, Token caseKeyword, Token openParen, ExpressionSyntax& expr, Token closeParen, Token matchesOrInside, const SyntaxList<CaseItemSyntax>& items, Token endcase) {
    return *alloc.emplace<CaseStatementSyntax>(label, attributes, uniqueOrPriority, caseKeyword, openParen, expr, closeParen, matchesOrInside, items, endcase);
}

CastExpressionSyntax& SyntaxFactory::castExpression(ExpressionSyntax& left, Token apostrophe, ParenthesizedExpressionSyntax& right) {
    return *alloc.emplace<CastExpressionSyntax>(left, apostrophe, right);
}

CellConfigRuleSyntax& SyntaxFactory::cellConfigRule(Token cell, ConfigCellIdentifierSyntax& name, ConfigRuleClauseSyntax& ruleClause, Token semi) {
    return *alloc.emplace<CellConfigRuleSyntax>(cell, name, ruleClause, semi);
}

ChargeStrengthSyntax& SyntaxFactory::chargeStrength(Token openParen, Token strength, Token closeParen) {
    return *alloc.emplace<ChargeStrengthSyntax>(openParen, strength, closeParen);
}

CheckerDataDeclarationSyntax& SyntaxFactory::checkerDataDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token rand, DataDeclarationSyntax& data) {
    return *alloc.emplace<CheckerDataDeclarationSyntax>(attributes, rand, data);
}

CheckerDeclarationSyntax& SyntaxFactory::checkerDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token name, AssertionItemPortListSyntax* portList, Token semi, const SyntaxList<MemberSyntax>& members, Token end, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<CheckerDeclarationSyntax>(attributes, keyword, name, portList, semi, members, end, endBlockName);
}

CheckerInstanceStatementSyntax& SyntaxFactory::checkerInstanceStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, CheckerInstantiationSyntax& instance) {
    return *alloc.emplace<CheckerInstanceStatementSyntax>(label, attributes, instance);
}

CheckerInstantiationSyntax& SyntaxFactory::checkerInstantiation(const SyntaxList<AttributeInstanceSyntax>& attributes, NameSyntax& type, ParameterValueAssignmentSyntax* parameters, const SeparatedSyntaxList<HierarchicalInstanceSyntax>& instances, Token semi) {
    return *alloc.emplace<CheckerInstantiationSyntax>(attributes, type, parameters, instances, semi);
}

ClassDeclarationSyntax& SyntaxFactory::classDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token virtualOrInterface, Token classKeyword, ClassSpecifierSyntax* finalSpecifier, Token name, ParameterPortListSyntax* parameters, ExtendsClauseSyntax* extendsClause, ImplementsClauseSyntax* implementsClause, Token semi, const SyntaxList<MemberSyntax>& items, Token endClass, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<ClassDeclarationSyntax>(attributes, virtualOrInterface, classKeyword, finalSpecifier, name, parameters, extendsClause, implementsClause, semi, items, endClass, endBlockName);
}

ClassMethodDeclarationSyntax& SyntaxFactory::classMethodDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, FunctionDeclarationSyntax& declaration) {
    return *alloc.emplace<ClassMethodDeclarationSyntax>(attributes, qualifiers, declaration);
}

ClassMethodPrototypeSyntax& SyntaxFactory::classMethodPrototype(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, FunctionPrototypeSyntax& prototype, Token semi) {
    return *alloc.emplace<ClassMethodPrototypeSyntax>(attributes, qualifiers, prototype, semi);
}

ClassNameSyntax& SyntaxFactory::className(Token identifier, ParameterValueAssignmentSyntax& parameters) {
    return *alloc.emplace<ClassNameSyntax>(identifier, parameters);
}

ClassPropertyDeclarationSyntax& SyntaxFactory::classPropertyDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, MemberSyntax& declaration) {
    return *alloc.emplace<ClassPropertyDeclarationSyntax>(attributes, qualifiers, declaration);
}

ClassSpecifierSyntax& SyntaxFactory::classSpecifier(Token colon, Token keyword) {
    return *alloc.emplace<ClassSpecifierSyntax>(colon, keyword);
}

ClockingDeclarationSyntax& SyntaxFactory::clockingDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token globalOrDefault, Token clocking, Token blockName, Token at, EventExpressionSyntax& event, Token semi, const SyntaxList<MemberSyntax>& items, Token endClocking, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<ClockingDeclarationSyntax>(attributes, globalOrDefault, clocking, blockName, at, event, semi, items, endClocking, endBlockName);
}

ClockingDirectionSyntax& SyntaxFactory::clockingDirection(Token input, ClockingSkewSyntax* inputSkew, Token output, ClockingSkewSyntax* outputSkew) {
    return *alloc.emplace<ClockingDirectionSyntax>(input, inputSkew, output, outputSkew);
}

ClockingItemSyntax& SyntaxFactory::clockingItem(const SyntaxList<AttributeInstanceSyntax>& attributes, ClockingDirectionSyntax& direction, const SeparatedSyntaxList<AttributeSpecSyntax>& decls, Token semi) {
    return *alloc.emplace<ClockingItemSyntax>(attributes, direction, decls, semi);
}

ClockingPropertyExprSyntax& SyntaxFactory::clockingPropertyExpr(TimingControlSyntax& event, PropertyExprSyntax* expr) {
    return *alloc.emplace<ClockingPropertyExprSyntax>(event, expr);
}

ClockingSequenceExprSyntax& SyntaxFactory::clockingSequenceExpr(TimingControlSyntax& event, SequenceExprSyntax& expr) {
    return *alloc.emplace<ClockingSequenceExprSyntax>(event, expr);
}

ClockingSkewSyntax& SyntaxFactory::clockingSkew(Token edge, TimingControlSyntax* delay) {
    return *alloc.emplace<ClockingSkewSyntax>(edge, delay);
}

ColonExpressionClauseSyntax& SyntaxFactory::colonExpressionClause(Token colon, ExpressionSyntax& expr) {
    return *alloc.emplace<ColonExpressionClauseSyntax>(colon, expr);
}

CompilationUnitSyntax& SyntaxFactory::compilationUnit(const SyntaxList<MemberSyntax>& members, Token endOfFile) {
    return *alloc.emplace<CompilationUnitSyntax>(members, endOfFile);
}

ConcatenationExpressionSyntax& SyntaxFactory::concatenationExpression(Token openBrace, const SeparatedSyntaxList<ExpressionSyntax>& expressions, Token closeBrace) {
    return *alloc.emplace<ConcatenationExpressionSyntax>(openBrace, expressions, closeBrace);
}

ConcurrentAssertionMemberSyntax& SyntaxFactory::concurrentAssertionMember(const SyntaxList<AttributeInstanceSyntax>& attributes, ConcurrentAssertionStatementSyntax& statement) {
    return *alloc.emplace<ConcurrentAssertionMemberSyntax>(attributes, statement);
}

ConcurrentAssertionStatementSyntax& SyntaxFactory::concurrentAssertionStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token propertyOrSequence, Token openParen, PropertySpecSyntax& propertySpec, Token closeParen, ActionBlockSyntax& action) {
    return *alloc.emplace<ConcurrentAssertionStatementSyntax>(kind, label, attributes, keyword, propertyOrSequence, openParen, propertySpec, closeParen, action);
}

ConditionalBranchDirectiveSyntax& SyntaxFactory::conditionalBranchDirective(SyntaxKind kind, Token directive, ConditionalDirectiveExpressionSyntax& expr, const TokenList& disabledTokens) {
    return *alloc.emplace<ConditionalBranchDirectiveSyntax>(kind, directive, expr, disabledTokens);
}

ConditionalConstraintSyntax& SyntaxFactory::conditionalConstraint(Token ifKeyword, Token openParen, ExpressionSyntax& condition, Token closeParen, ConstraintItemSyntax& constraints, ElseConstraintClauseSyntax* elseClause) {
    return *alloc.emplace<ConditionalConstraintSyntax>(ifKeyword, openParen, condition, closeParen, constraints, elseClause);
}

ConditionalExpressionSyntax& SyntaxFactory::conditionalExpression(ConditionalPredicateSyntax& predicate, Token question, const SyntaxList<AttributeInstanceSyntax>& attributes, ExpressionSyntax& left, Token colon, ExpressionSyntax& right) {
    return *alloc.emplace<ConditionalExpressionSyntax>(predicate, question, attributes, left, colon, right);
}

ConditionalPathDeclarationSyntax& SyntaxFactory::conditionalPathDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token openParen, ExpressionSyntax& predicate, Token closeParen, PathDeclarationSyntax& path) {
    return *alloc.emplace<ConditionalPathDeclarationSyntax>(attributes, keyword, openParen, predicate, closeParen, path);
}

ConditionalPatternSyntax& SyntaxFactory::conditionalPattern(ExpressionSyntax& expr, MatchesClauseSyntax* matchesClause) {
    return *alloc.emplace<ConditionalPatternSyntax>(expr, matchesClause);
}

ConditionalPredicateSyntax& SyntaxFactory::conditionalPredicate(const SeparatedSyntaxList<ConditionalPatternSyntax>& conditions) {
    return *alloc.emplace<ConditionalPredicateSyntax>(conditions);
}

ConditionalPropertyExprSyntax& SyntaxFactory::conditionalPropertyExpr(Token ifKeyword, Token openParen, ExpressionSyntax& condition, Token closeParen, PropertyExprSyntax& expr, ElsePropertyClauseSyntax* elseClause) {
    return *alloc.emplace<ConditionalPropertyExprSyntax>(ifKeyword, openParen, condition, closeParen, expr, elseClause);
}

ConditionalStatementSyntax& SyntaxFactory::conditionalStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token uniqueOrPriority, Token ifKeyword, Token openParen, ConditionalPredicateSyntax& predicate, Token closeParen, StatementSyntax& statement, ElseClauseSyntax* elseClause) {
    return *alloc.emplace<ConditionalStatementSyntax>(label, attributes, uniqueOrPriority, ifKeyword, openParen, predicate, closeParen, statement, elseClause);
}

ConfigCellIdentifierSyntax& SyntaxFactory::configCellIdentifier(Token library, Token dot, Token cell) {
    return *alloc.emplace<ConfigCellIdentifierSyntax>(library, dot, cell);
}

ConfigDeclarationSyntax& SyntaxFactory::configDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token config, Token name, Token semi1, const SyntaxList<ParameterDeclarationStatementSyntax>& localparams, Token design, const SyntaxList<ConfigCellIdentifierSyntax>& topCells, Token semi2, const SyntaxList<ConfigRuleSyntax>& rules, Token endconfig, NamedBlockClauseSyntax* blockName) {
    return *alloc.emplace<ConfigDeclarationSyntax>(attributes, config, name, semi1, localparams, design, topCells, semi2, rules, endconfig, blockName);
}

ConfigInstanceIdentifierSyntax& SyntaxFactory::configInstanceIdentifier(Token dot, Token name) {
    return *alloc.emplace<ConfigInstanceIdentifierSyntax>(dot, name);
}

ConfigLiblistSyntax& SyntaxFactory::configLiblist(Token liblist, const TokenList& libraries) {
    return *alloc.emplace<ConfigLiblistSyntax>(liblist, libraries);
}

ConfigUseClauseSyntax& SyntaxFactory::configUseClause(Token use, ConfigCellIdentifierSyntax* name, ParameterValueAssignmentSyntax* paramAssignments, Token colon, Token config) {
    return *alloc.emplace<ConfigUseClauseSyntax>(use, name, paramAssignments, colon, config);
}

ConstraintBlockSyntax& SyntaxFactory::constraintBlock(Token openBrace, const SyntaxList<ConstraintItemSyntax>& items, Token closeBrace) {
    return *alloc.emplace<ConstraintBlockSyntax>(openBrace, items, closeBrace);
}

ConstraintDeclarationSyntax& SyntaxFactory::constraintDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, Token keyword, const SyntaxList<ClassSpecifierSyntax>& specifiers, NameSyntax& name, ConstraintBlockSyntax& block) {
    return *alloc.emplace<ConstraintDeclarationSyntax>(attributes, qualifiers, keyword, specifiers, name, block);
}

ConstraintPrototypeSyntax& SyntaxFactory::constraintPrototype(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, Token keyword, const SyntaxList<ClassSpecifierSyntax>& specifiers, NameSyntax& name, Token semi) {
    return *alloc.emplace<ConstraintPrototypeSyntax>(attributes, qualifiers, keyword, specifiers, name, semi);
}

ContinuousAssignSyntax& SyntaxFactory::continuousAssign(const SyntaxList<AttributeInstanceSyntax>& attributes, Token assign, DriveStrengthSyntax* strength, TimingControlSyntax* delay, const SeparatedSyntaxList<ExpressionSyntax>& assignments, Token semi) {
    return *alloc.emplace<ContinuousAssignSyntax>(attributes, assign, strength, delay, assignments, semi);
}

CopyClassExpressionSyntax& SyntaxFactory::copyClassExpression(NameSyntax& scopedNew, ExpressionSyntax& expr) {
    return *alloc.emplace<CopyClassExpressionSyntax>(scopedNew, expr);
}

CoverCrossSyntax& SyntaxFactory::coverCross(const SyntaxList<AttributeInstanceSyntax>& attributes, NamedLabelSyntax* label, Token cross, const SeparatedSyntaxList<IdentifierNameSyntax>& items, CoverageIffClauseSyntax* iff, Token openBrace, const SyntaxList<MemberSyntax>& members, Token closeBrace, Token emptySemi) {
    return *alloc.emplace<CoverCrossSyntax>(attributes, label, cross, items, iff, openBrace, members, closeBrace, emptySemi);
}

CoverageBinsArraySizeSyntax& SyntaxFactory::coverageBinsArraySize(Token openBracket, ExpressionSyntax* expr, Token closeBracket) {
    return *alloc.emplace<CoverageBinsArraySizeSyntax>(openBracket, expr, closeBracket);
}

CoverageBinsSyntax& SyntaxFactory::coverageBins(const SyntaxList<AttributeInstanceSyntax>& attributes, Token wildcard, Token keyword, Token name, CoverageBinsArraySizeSyntax* size, Token equals, CoverageBinInitializerSyntax& initializer, CoverageIffClauseSyntax* iff, Token semi) {
    return *alloc.emplace<CoverageBinsSyntax>(attributes, wildcard, keyword, name, size, equals, initializer, iff, semi);
}

CoverageIffClauseSyntax& SyntaxFactory::coverageIffClause(Token iff, Token openParen, ExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<CoverageIffClauseSyntax>(iff, openParen, expr, closeParen);
}

CoverageOptionSyntax& SyntaxFactory::coverageOption(const SyntaxList<AttributeInstanceSyntax>& attributes, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<CoverageOptionSyntax>(attributes, expr, semi);
}

CovergroupDeclarationSyntax& SyntaxFactory::covergroupDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token covergroup, Token extends, Token name, FunctionPortListSyntax* portList, SyntaxNode* event, Token semi, const SyntaxList<MemberSyntax>& members, Token endgroup, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<CovergroupDeclarationSyntax>(attributes, covergroup, extends, name, portList, event, semi, members, endgroup, endBlockName);
}

CoverpointSyntax& SyntaxFactory::coverpoint(const SyntaxList<AttributeInstanceSyntax>& attributes, DataTypeSyntax& type, NamedLabelSyntax* label, Token coverpoint, ExpressionSyntax& expr, CoverageIffClauseSyntax* iff, Token openBrace, const SyntaxList<MemberSyntax>& members, Token closeBrace, Token emptySemi) {
    return *alloc.emplace<CoverpointSyntax>(attributes, type, label, coverpoint, expr, iff, openBrace, members, closeBrace, emptySemi);
}

DPIExportSyntax& SyntaxFactory::dPIExport(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token specString, Token c_identifier, Token equals, Token functionOrTask, Token name, Token semi) {
    return *alloc.emplace<DPIExportSyntax>(attributes, keyword, specString, c_identifier, equals, functionOrTask, name, semi);
}

DPIImportSyntax& SyntaxFactory::dPIImport(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token specString, Token property, Token c_identifier, Token equals, FunctionPrototypeSyntax& method, Token semi) {
    return *alloc.emplace<DPIImportSyntax>(attributes, keyword, specString, property, c_identifier, equals, method, semi);
}

DataDeclarationSyntax& SyntaxFactory::dataDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& modifiers, DataTypeSyntax& type, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<DataDeclarationSyntax>(attributes, modifiers, type, declarators, semi);
}

DeclaratorSyntax& SyntaxFactory::declarator(Token name, const SyntaxList<VariableDimensionSyntax>& dimensions, EqualsValueClauseSyntax* initializer) {
    return *alloc.emplace<DeclaratorSyntax>(name, dimensions, initializer);
}

DefParamAssignmentSyntax& SyntaxFactory::defParamAssignment(NameSyntax& name, EqualsValueClauseSyntax& setter) {
    return *alloc.emplace<DefParamAssignmentSyntax>(name, setter);
}

DefParamSyntax& SyntaxFactory::defParam(const SyntaxList<AttributeInstanceSyntax>& attributes, Token defparam, const SeparatedSyntaxList<DefParamAssignmentSyntax>& assignments, Token semi) {
    return *alloc.emplace<DefParamSyntax>(attributes, defparam, assignments, semi);
}

DefaultCaseItemSyntax& SyntaxFactory::defaultCaseItem(Token defaultKeyword, Token colon, SyntaxNode& clause) {
    return *alloc.emplace<DefaultCaseItemSyntax>(defaultKeyword, colon, clause);
}

DefaultClockingReferenceSyntax& SyntaxFactory::defaultClockingReference(const SyntaxList<AttributeInstanceSyntax>& attributes, Token defaultKeyword, Token clocking, Token name, Token semi) {
    return *alloc.emplace<DefaultClockingReferenceSyntax>(attributes, defaultKeyword, clocking, name, semi);
}

DefaultConfigRuleSyntax& SyntaxFactory::defaultConfigRule(Token defaultKeyword, ConfigLiblistSyntax& liblist, Token semi) {
    return *alloc.emplace<DefaultConfigRuleSyntax>(defaultKeyword, liblist, semi);
}

DefaultCoverageBinInitializerSyntax& SyntaxFactory::defaultCoverageBinInitializer(Token defaultKeyword, Token sequenceKeyword) {
    return *alloc.emplace<DefaultCoverageBinInitializerSyntax>(defaultKeyword, sequenceKeyword);
}

DefaultDecayTimeDirectiveSyntax& SyntaxFactory::defaultDecayTimeDirective(Token directive, Token time) {
    return *alloc.emplace<DefaultDecayTimeDirectiveSyntax>(directive, time);
}

DefaultDisableDeclarationSyntax& SyntaxFactory::defaultDisableDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token defaultKeyword, Token disableKeyword, Token iffKeyword, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<DefaultDisableDeclarationSyntax>(attributes, defaultKeyword, disableKeyword, iffKeyword, expr, semi);
}

DefaultDistItemSyntax& SyntaxFactory::defaultDistItem(Token defaultKeyword, DistWeightSyntax* weight) {
    return *alloc.emplace<DefaultDistItemSyntax>(defaultKeyword, weight);
}

DefaultExtendsClauseArgSyntax& SyntaxFactory::defaultExtendsClauseArg(Token openParen, Token defaultKeyword, Token closeParen) {
    return *alloc.emplace<DefaultExtendsClauseArgSyntax>(openParen, defaultKeyword, closeParen);
}

DefaultFunctionPortSyntax& SyntaxFactory::defaultFunctionPort(Token keyword) {
    return *alloc.emplace<DefaultFunctionPortSyntax>(keyword);
}

DefaultNetTypeDirectiveSyntax& SyntaxFactory::defaultNetTypeDirective(Token directive, Token netType) {
    return *alloc.emplace<DefaultNetTypeDirectiveSyntax>(directive, netType);
}

DefaultPropertyCaseItemSyntax& SyntaxFactory::defaultPropertyCaseItem(Token defaultKeyword, Token colon, PropertyExprSyntax& expr, Token semi) {
    return *alloc.emplace<DefaultPropertyCaseItemSyntax>(defaultKeyword, colon, expr, semi);
}

DefaultRsCaseItemSyntax& SyntaxFactory::defaultRsCaseItem(Token defaultKeyword, Token colon, RsProdItemSyntax& item, Token semi) {
    return *alloc.emplace<DefaultRsCaseItemSyntax>(defaultKeyword, colon, item, semi);
}

DefaultSkewItemSyntax& SyntaxFactory::defaultSkewItem(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, ClockingDirectionSyntax& direction, Token semi) {
    return *alloc.emplace<DefaultSkewItemSyntax>(attributes, keyword, direction, semi);
}

DefaultTriregStrengthDirectiveSyntax& SyntaxFactory::defaultTriregStrengthDirective(Token directive, Token strength) {
    return *alloc.emplace<DefaultTriregStrengthDirectiveSyntax>(directive, strength);
}

DeferredAssertionSyntax& SyntaxFactory::deferredAssertion(Token hash, Token zero, Token finalKeyword) {
    return *alloc.emplace<DeferredAssertionSyntax>(hash, zero, finalKeyword);
}

DefineDirectiveSyntax& SyntaxFactory::defineDirective(Token directive, Token name, MacroFormalArgumentListSyntax* formalArguments, const TokenList& body) {
    return *alloc.emplace<DefineDirectiveSyntax>(directive, name, formalArguments, body);
}

Delay3Syntax& SyntaxFactory::delay3(Token hash, Token openParen, ExpressionSyntax& delay1, Token comma1, ExpressionSyntax* delay2, Token comma2, ExpressionSyntax* delay3, Token closeParen) {
    return *alloc.emplace<Delay3Syntax>(hash, openParen, delay1, comma1, delay2, comma2, delay3, closeParen);
}

DelaySyntax& SyntaxFactory::delay(SyntaxKind kind, Token hash, ExpressionSyntax& delayValue) {
    return *alloc.emplace<DelaySyntax>(kind, hash, delayValue);
}

DelayedSequenceElementSyntax& SyntaxFactory::delayedSequenceElement(Token doubleHash, ExpressionSyntax* delayVal, Token openBracket, Token op, SelectorSyntax* range, Token closeBracket, SequenceExprSyntax& expr) {
    return *alloc.emplace<DelayedSequenceElementSyntax>(doubleHash, delayVal, openBracket, op, range, closeBracket, expr);
}

DelayedSequenceExprSyntax& SyntaxFactory::delayedSequenceExpr(SequenceExprSyntax* first, const SyntaxList<DelayedSequenceElementSyntax>& elements) {
    return *alloc.emplace<DelayedSequenceExprSyntax>(first, elements);
}

DisableConstraintSyntax& SyntaxFactory::disableConstraint(Token disable, Token soft, ExpressionSyntax& name, Token semi) {
    return *alloc.emplace<DisableConstraintSyntax>(disable, soft, name, semi);
}

DisableForkStatementSyntax& SyntaxFactory::disableForkStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token disable, Token fork, Token semi) {
    return *alloc.emplace<DisableForkStatementSyntax>(label, attributes, disable, fork, semi);
}

DisableIffSyntax& SyntaxFactory::disableIff(Token disable, Token iff, Token openParen, ExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<DisableIffSyntax>(disable, iff, openParen, expr, closeParen);
}

DisableStatementSyntax& SyntaxFactory::disableStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token disable, NameSyntax& name, Token semi) {
    return *alloc.emplace<DisableStatementSyntax>(label, attributes, disable, name, semi);
}

DistConstraintListSyntax& SyntaxFactory::distConstraintList(Token dist, Token openBrace, const SeparatedSyntaxList<DistItemBaseSyntax>& items, Token closeBrace) {
    return *alloc.emplace<DistConstraintListSyntax>(dist, openBrace, items, closeBrace);
}

DistItemSyntax& SyntaxFactory::distItem(ExpressionSyntax& range, DistWeightSyntax* weight) {
    return *alloc.emplace<DistItemSyntax>(range, weight);
}

DistWeightSyntax& SyntaxFactory::distWeight(Token op, Token extraOp, ExpressionSyntax& expr) {
    return *alloc.emplace<DistWeightSyntax>(op, extraOp, expr);
}

DividerClauseSyntax& SyntaxFactory::dividerClause(Token divide, Token value) {
    return *alloc.emplace<DividerClauseSyntax>(divide, value);
}

DoWhileStatementSyntax& SyntaxFactory::doWhileStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token doKeyword, StatementSyntax& statement, Token whileKeyword, Token openParen, ExpressionSyntax& expr, Token closeParen, Token semi) {
    return *alloc.emplace<DoWhileStatementSyntax>(label, attributes, doKeyword, statement, whileKeyword, openParen, expr, closeParen, semi);
}

DotMemberClauseSyntax& SyntaxFactory::dotMemberClause(Token dot, Token member) {
    return *alloc.emplace<DotMemberClauseSyntax>(dot, member);
}

DriveStrengthSyntax& SyntaxFactory::driveStrength(Token openParen, Token strength0, Token comma, Token strength1, Token closeParen) {
    return *alloc.emplace<DriveStrengthSyntax>(openParen, strength0, comma, strength1, closeParen);
}

EdgeControlSpecifierSyntax& SyntaxFactory::edgeControlSpecifier(Token openBracket, const SeparatedSyntaxList<EdgeDescriptorSyntax>& descriptors, Token closeBracket) {
    return *alloc.emplace<EdgeControlSpecifierSyntax>(openBracket, descriptors, closeBracket);
}

EdgeDescriptorSyntax& SyntaxFactory::edgeDescriptor(Token t1, Token t2) {
    return *alloc.emplace<EdgeDescriptorSyntax>(t1, t2);
}

EdgeSensitivePathSuffixSyntax& SyntaxFactory::edgeSensitivePathSuffix(Token openParen, const SeparatedSyntaxList<NameSyntax>& outputs, Token polarityOperator, Token colon, ExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<EdgeSensitivePathSuffixSyntax>(openParen, outputs, polarityOperator, colon, expr, closeParen);
}

ElabSystemTaskSyntax& SyntaxFactory::elabSystemTask(const SyntaxList<AttributeInstanceSyntax>& attributes, Token name, ArgumentListSyntax* arguments, Token semi) {
    return *alloc.emplace<ElabSystemTaskSyntax>(attributes, name, arguments, semi);
}

ElementSelectExpressionSyntax& SyntaxFactory::elementSelectExpression(ExpressionSyntax& left, ElementSelectSyntax& select) {
    return *alloc.emplace<ElementSelectExpressionSyntax>(left, select);
}

ElementSelectSyntax& SyntaxFactory::elementSelect(Token openBracket, SelectorSyntax* selector, Token closeBracket) {
    return *alloc.emplace<ElementSelectSyntax>(openBracket, selector, closeBracket);
}

ElseClauseSyntax& SyntaxFactory::elseClause(Token elseKeyword, SyntaxNode& clause) {
    return *alloc.emplace<ElseClauseSyntax>(elseKeyword, clause);
}

ElseConstraintClauseSyntax& SyntaxFactory::elseConstraintClause(Token elseKeyword, ConstraintItemSyntax& constraints) {
    return *alloc.emplace<ElseConstraintClauseSyntax>(elseKeyword, constraints);
}

ElsePropertyClauseSyntax& SyntaxFactory::elsePropertyClause(Token elseKeyword, PropertyExprSyntax& expr) {
    return *alloc.emplace<ElsePropertyClauseSyntax>(elseKeyword, expr);
}

EmptyArgumentSyntax& SyntaxFactory::emptyArgument(Token placeholder) {
    return *alloc.emplace<EmptyArgumentSyntax>(placeholder);
}

EmptyIdentifierNameSyntax& SyntaxFactory::emptyIdentifierName(Token placeholder) {
    return *alloc.emplace<EmptyIdentifierNameSyntax>(placeholder);
}

EmptyMemberSyntax& SyntaxFactory::emptyMember(const SyntaxList<AttributeInstanceSyntax>& attributes, const TokenList& qualifiers, Token semi) {
    return *alloc.emplace<EmptyMemberSyntax>(attributes, qualifiers, semi);
}

EmptyNonAnsiPortSyntax& SyntaxFactory::emptyNonAnsiPort(Token placeholder) {
    return *alloc.emplace<EmptyNonAnsiPortSyntax>(placeholder);
}

EmptyPortConnectionSyntax& SyntaxFactory::emptyPortConnection(const SyntaxList<AttributeInstanceSyntax>& attributes, Token placeholder) {
    return *alloc.emplace<EmptyPortConnectionSyntax>(attributes, placeholder);
}

EmptyQueueExpressionSyntax& SyntaxFactory::emptyQueueExpression(Token openBrace, Token closeBrace) {
    return *alloc.emplace<EmptyQueueExpressionSyntax>(openBrace, closeBrace);
}

EmptyStatementSyntax& SyntaxFactory::emptyStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token semicolon) {
    return *alloc.emplace<EmptyStatementSyntax>(label, attributes, semicolon);
}

EmptyTimingCheckArgSyntax& SyntaxFactory::emptyTimingCheckArg(Token placeholder) {
    return *alloc.emplace<EmptyTimingCheckArgSyntax>(placeholder);
}

EnumTypeSyntax& SyntaxFactory::enumType(Token keyword, DataTypeSyntax* baseType, Token openBrace, const SeparatedSyntaxList<DeclaratorSyntax>& members, Token closeBrace, const SyntaxList<VariableDimensionSyntax>& dimensions) {
    return *alloc.emplace<EnumTypeSyntax>(keyword, baseType, openBrace, members, closeBrace, dimensions);
}

EqualsAssertionArgClauseSyntax& SyntaxFactory::equalsAssertionArgClause(Token equals, PropertyExprSyntax& expr) {
    return *alloc.emplace<EqualsAssertionArgClauseSyntax>(equals, expr);
}

EqualsTypeClauseSyntax& SyntaxFactory::equalsTypeClause(Token equals, DataTypeSyntax& type) {
    return *alloc.emplace<EqualsTypeClauseSyntax>(equals, type);
}

EqualsValueClauseSyntax& SyntaxFactory::equalsValueClause(Token equals, ExpressionSyntax& expr) {
    return *alloc.emplace<EqualsValueClauseSyntax>(equals, expr);
}

EventControlSyntax& SyntaxFactory::eventControl(Token at, ExpressionSyntax& eventName) {
    return *alloc.emplace<EventControlSyntax>(at, eventName);
}

EventControlWithExpressionSyntax& SyntaxFactory::eventControlWithExpression(Token at, EventExpressionSyntax& expr) {
    return *alloc.emplace<EventControlWithExpressionSyntax>(at, expr);
}

EventTriggerStatementSyntax& SyntaxFactory::eventTriggerStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token trigger, TimingControlSyntax* timing, NameSyntax& name, Token semi) {
    return *alloc.emplace<EventTriggerStatementSyntax>(kind, label, attributes, trigger, timing, name, semi);
}

ExplicitAnsiPortSyntax& SyntaxFactory::explicitAnsiPort(const SyntaxList<AttributeInstanceSyntax>& attributes, Token direction, Token dot, Token name, Token openParen, ExpressionSyntax* expr, Token closeParen) {
    return *alloc.emplace<ExplicitAnsiPortSyntax>(attributes, direction, dot, name, openParen, expr, closeParen);
}

ExplicitNonAnsiPortSyntax& SyntaxFactory::explicitNonAnsiPort(Token dot, Token name, Token openParen, PortExpressionSyntax* expr, Token closeParen) {
    return *alloc.emplace<ExplicitNonAnsiPortSyntax>(dot, name, openParen, expr, closeParen);
}

ExpressionConstraintSyntax& SyntaxFactory::expressionConstraint(Token soft, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<ExpressionConstraintSyntax>(soft, expr, semi);
}

ExpressionCoverageBinInitializerSyntax& SyntaxFactory::expressionCoverageBinInitializer(ExpressionSyntax& expr) {
    return *alloc.emplace<ExpressionCoverageBinInitializerSyntax>(expr);
}

ExpressionOrDistSyntax& SyntaxFactory::expressionOrDist(ExpressionSyntax& expr, DistConstraintListSyntax& distribution) {
    return *alloc.emplace<ExpressionOrDistSyntax>(expr, distribution);
}

ExpressionPatternSyntax& SyntaxFactory::expressionPattern(ExpressionSyntax& expr) {
    return *alloc.emplace<ExpressionPatternSyntax>(expr);
}

ExpressionStatementSyntax& SyntaxFactory::expressionStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<ExpressionStatementSyntax>(label, attributes, expr, semi);
}

ExpressionTimingCheckArgSyntax& SyntaxFactory::expressionTimingCheckArg(ExpressionSyntax& expr) {
    return *alloc.emplace<ExpressionTimingCheckArgSyntax>(expr);
}

ExtendsClauseSyntax& SyntaxFactory::extendsClause(Token keyword, NameSyntax& baseName, ArgumentListSyntax* arguments, DefaultExtendsClauseArgSyntax* defaultedArg) {
    return *alloc.emplace<ExtendsClauseSyntax>(keyword, baseName, arguments, defaultedArg);
}

ExternInterfaceMethodSyntax& SyntaxFactory::externInterfaceMethod(const SyntaxList<AttributeInstanceSyntax>& attributes, Token externKeyword, Token forkJoin, FunctionPrototypeSyntax& prototype, Token semi) {
    return *alloc.emplace<ExternInterfaceMethodSyntax>(attributes, externKeyword, forkJoin, prototype, semi);
}

ExternModuleDeclSyntax& SyntaxFactory::externModuleDecl(const SyntaxList<AttributeInstanceSyntax>& attributes, Token externKeyword, const SyntaxList<AttributeInstanceSyntax>& actualAttributes, ModuleHeaderSyntax& header) {
    return *alloc.emplace<ExternModuleDeclSyntax>(attributes, externKeyword, actualAttributes, header);
}

ExternUdpDeclSyntax& SyntaxFactory::externUdpDecl(const SyntaxList<AttributeInstanceSyntax>& attributes, Token externKeyword, const SyntaxList<AttributeInstanceSyntax>& actualAttributes, Token primitive, Token name, UdpPortListSyntax& portList) {
    return *alloc.emplace<ExternUdpDeclSyntax>(attributes, externKeyword, actualAttributes, primitive, name, portList);
}

FilePathSpecSyntax& SyntaxFactory::filePathSpec(Token path) {
    return *alloc.emplace<FilePathSpecSyntax>(path);
}

FirstMatchSequenceExprSyntax& SyntaxFactory::firstMatchSequenceExpr(Token first_match, Token openParen, SequenceExprSyntax& expr, SequenceMatchListSyntax* matchList, Token closeParen) {
    return *alloc.emplace<FirstMatchSequenceExprSyntax>(first_match, openParen, expr, matchList, closeParen);
}

ForLoopStatementSyntax& SyntaxFactory::forLoopStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token forKeyword, Token openParen, const SeparatedSyntaxList<SyntaxNode>& initializers, Token semi1, ExpressionSyntax* stopExpr, Token semi2, const SeparatedSyntaxList<ExpressionSyntax>& steps, Token closeParen, StatementSyntax& statement) {
    return *alloc.emplace<ForLoopStatementSyntax>(label, attributes, forKeyword, openParen, initializers, semi1, stopExpr, semi2, steps, closeParen, statement);
}

ForVariableDeclarationSyntax& SyntaxFactory::forVariableDeclaration(Token varKeyword, DataTypeSyntax* type, DeclaratorSyntax& declarator) {
    return *alloc.emplace<ForVariableDeclarationSyntax>(varKeyword, type, declarator);
}

ForeachLoopListSyntax& SyntaxFactory::foreachLoopList(Token openParen, NameSyntax& arrayName, Token openBracket, const SeparatedSyntaxList<NameSyntax>& loopVariables, Token closeBracket, Token closeParen) {
    return *alloc.emplace<ForeachLoopListSyntax>(openParen, arrayName, openBracket, loopVariables, closeBracket, closeParen);
}

ForeachLoopStatementSyntax& SyntaxFactory::foreachLoopStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, ForeachLoopListSyntax& loopList, StatementSyntax& statement) {
    return *alloc.emplace<ForeachLoopStatementSyntax>(label, attributes, keyword, loopList, statement);
}

ForeverStatementSyntax& SyntaxFactory::foreverStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token foreverKeyword, StatementSyntax& statement) {
    return *alloc.emplace<ForeverStatementSyntax>(label, attributes, foreverKeyword, statement);
}

ForwardTypeRestrictionSyntax& SyntaxFactory::forwardTypeRestriction(Token keyword1, Token keyword2) {
    return *alloc.emplace<ForwardTypeRestrictionSyntax>(keyword1, keyword2);
}

ForwardTypedefDeclarationSyntax& SyntaxFactory::forwardTypedefDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token typedefKeyword, ForwardTypeRestrictionSyntax* typeRestriction, Token name, Token semi) {
    return *alloc.emplace<ForwardTypedefDeclarationSyntax>(attributes, typedefKeyword, typeRestriction, name, semi);
}

FunctionDeclarationSyntax& SyntaxFactory::functionDeclaration(SyntaxKind kind, const SyntaxList<AttributeInstanceSyntax>& attributes, FunctionPrototypeSyntax& prototype, Token semi, const SyntaxList<SyntaxNode>& items, Token end, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<FunctionDeclarationSyntax>(kind, attributes, prototype, semi, items, end, endBlockName);
}

FunctionPortListSyntax& SyntaxFactory::functionPortList(Token openParen, const SeparatedSyntaxList<FunctionPortBaseSyntax>& ports, Token closeParen) {
    return *alloc.emplace<FunctionPortListSyntax>(openParen, ports, closeParen);
}

FunctionPortSyntax& SyntaxFactory::functionPort(const SyntaxList<AttributeInstanceSyntax>& attributes, Token constKeyword, Token direction, Token staticKeyword, Token varKeyword, DataTypeSyntax* dataType, DeclaratorSyntax& declarator) {
    return *alloc.emplace<FunctionPortSyntax>(attributes, constKeyword, direction, staticKeyword, varKeyword, dataType, declarator);
}

FunctionPrototypeSyntax& SyntaxFactory::functionPrototype(Token keyword, const SyntaxList<ClassSpecifierSyntax>& specifiers, Token lifetime, DataTypeSyntax& returnType, NameSyntax& name, FunctionPortListSyntax* portList) {
    return *alloc.emplace<FunctionPrototypeSyntax>(keyword, specifiers, lifetime, returnType, name, portList);
}

GenerateBlockSyntax& SyntaxFactory::generateBlock(const SyntaxList<AttributeInstanceSyntax>& attributes, NamedLabelSyntax* label, Token begin, NamedBlockClauseSyntax* beginName, const SyntaxList<MemberSyntax>& members, Token end, NamedBlockClauseSyntax* endName) {
    return *alloc.emplace<GenerateBlockSyntax>(attributes, label, begin, beginName, members, end, endName);
}

GenerateRegionSyntax& SyntaxFactory::generateRegion(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SyntaxList<MemberSyntax>& members, Token endgenerate) {
    return *alloc.emplace<GenerateRegionSyntax>(attributes, keyword, members, endgenerate);
}

GenvarDeclarationSyntax& SyntaxFactory::genvarDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<IdentifierNameSyntax>& identifiers, Token semi) {
    return *alloc.emplace<GenvarDeclarationSyntax>(attributes, keyword, identifiers, semi);
}

HierarchicalInstanceSyntax& SyntaxFactory::hierarchicalInstance(InstanceNameSyntax* decl, Token openParen, const SeparatedSyntaxList<PortConnectionSyntax>& connections, Token closeParen) {
    return *alloc.emplace<HierarchicalInstanceSyntax>(decl, openParen, connections, closeParen);
}

HierarchyInstantiationSyntax& SyntaxFactory::hierarchyInstantiation(const SyntaxList<AttributeInstanceSyntax>& attributes, Token type, ParameterValueAssignmentSyntax* parameters, const SeparatedSyntaxList<HierarchicalInstanceSyntax>& instances, Token semi) {
    return *alloc.emplace<HierarchyInstantiationSyntax>(attributes, type, parameters, instances, semi);
}

IdWithExprCoverageBinInitializerSyntax& SyntaxFactory::idWithExprCoverageBinInitializer(Token id, WithClauseSyntax& withClause) {
    return *alloc.emplace<IdWithExprCoverageBinInitializerSyntax>(id, withClause);
}

IdentifierNameSyntax& SyntaxFactory::identifierName(Token identifier) {
    return *alloc.emplace<IdentifierNameSyntax>(identifier);
}

IdentifierSelectNameSyntax& SyntaxFactory::identifierSelectName(Token identifier, const SyntaxList<ElementSelectSyntax>& selectors) {
    return *alloc.emplace<IdentifierSelectNameSyntax>(identifier, selectors);
}

IfGenerateSyntax& SyntaxFactory::ifGenerate(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token openParen, ExpressionSyntax& condition, Token closeParen, MemberSyntax& block, ElseClauseSyntax* elseClause) {
    return *alloc.emplace<IfGenerateSyntax>(attributes, keyword, openParen, condition, closeParen, block, elseClause);
}

IfNonePathDeclarationSyntax& SyntaxFactory::ifNonePathDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, PathDeclarationSyntax& path) {
    return *alloc.emplace<IfNonePathDeclarationSyntax>(attributes, keyword, path);
}

IffEventClauseSyntax& SyntaxFactory::iffEventClause(Token iff, ExpressionSyntax& expr) {
    return *alloc.emplace<IffEventClauseSyntax>(iff, expr);
}

ImmediateAssertionMemberSyntax& SyntaxFactory::immediateAssertionMember(const SyntaxList<AttributeInstanceSyntax>& attributes, ImmediateAssertionStatementSyntax& statement) {
    return *alloc.emplace<ImmediateAssertionMemberSyntax>(attributes, statement);
}

ImmediateAssertionStatementSyntax& SyntaxFactory::immediateAssertionStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, DeferredAssertionSyntax* delay, ParenthesizedExpressionSyntax& expr, ActionBlockSyntax& action) {
    return *alloc.emplace<ImmediateAssertionStatementSyntax>(kind, label, attributes, keyword, delay, expr, action);
}

ImplementsClauseSyntax& SyntaxFactory::implementsClause(Token keyword, const SeparatedSyntaxList<NameSyntax>& interfaces) {
    return *alloc.emplace<ImplementsClauseSyntax>(keyword, interfaces);
}

ImplicationConstraintSyntax& SyntaxFactory::implicationConstraint(ExpressionSyntax& left, Token arrow, ConstraintItemSyntax& constraints) {
    return *alloc.emplace<ImplicationConstraintSyntax>(left, arrow, constraints);
}

ImplicitAnsiPortSyntax& SyntaxFactory::implicitAnsiPort(const SyntaxList<AttributeInstanceSyntax>& attributes, PortHeaderSyntax& header, DeclaratorSyntax& declarator) {
    return *alloc.emplace<ImplicitAnsiPortSyntax>(attributes, header, declarator);
}

ImplicitEventControlSyntax& SyntaxFactory::implicitEventControl(Token at, Token openParen, Token star, Token closeParen) {
    return *alloc.emplace<ImplicitEventControlSyntax>(at, openParen, star, closeParen);
}

ImplicitNonAnsiPortSyntax& SyntaxFactory::implicitNonAnsiPort(PortExpressionSyntax& expr) {
    return *alloc.emplace<ImplicitNonAnsiPortSyntax>(expr);
}

ImplicitTypeSyntax& SyntaxFactory::implicitType(Token signing, const SyntaxList<VariableDimensionSyntax>& dimensions, Token placeholder) {
    return *alloc.emplace<ImplicitTypeSyntax>(signing, dimensions, placeholder);
}

IncludeDirectiveSyntax& SyntaxFactory::includeDirective(Token directive, Token fileName) {
    return *alloc.emplace<IncludeDirectiveSyntax>(directive, fileName);
}

InsideExpressionSyntax& SyntaxFactory::insideExpression(ExpressionSyntax& expr, Token inside, RangeListSyntax& ranges) {
    return *alloc.emplace<InsideExpressionSyntax>(expr, inside, ranges);
}

InstanceConfigRuleSyntax& SyntaxFactory::instanceConfigRule(Token instance, Token topModule, const SyntaxList<ConfigInstanceIdentifierSyntax>& instanceNames, ConfigRuleClauseSyntax& ruleClause, Token semi) {
    return *alloc.emplace<InstanceConfigRuleSyntax>(instance, topModule, instanceNames, ruleClause, semi);
}

InstanceNameSyntax& SyntaxFactory::instanceName(Token name, const SyntaxList<VariableDimensionSyntax>& dimensions) {
    return *alloc.emplace<InstanceNameSyntax>(name, dimensions);
}

IntegerTypeSyntax& SyntaxFactory::integerType(SyntaxKind kind, Token keyword, Token signing, const SyntaxList<VariableDimensionSyntax>& dimensions) {
    return *alloc.emplace<IntegerTypeSyntax>(kind, keyword, signing, dimensions);
}

IntegerVectorExpressionSyntax& SyntaxFactory::integerVectorExpression(Token size, Token base, Token value) {
    return *alloc.emplace<IntegerVectorExpressionSyntax>(size, base, value);
}

InterfacePortHeaderSyntax& SyntaxFactory::interfacePortHeader(Token nameOrKeyword, DotMemberClauseSyntax* modport) {
    return *alloc.emplace<InterfacePortHeaderSyntax>(nameOrKeyword, modport);
}

IntersectClauseSyntax& SyntaxFactory::intersectClause(Token intersect, RangeListSyntax& ranges) {
    return *alloc.emplace<IntersectClauseSyntax>(intersect, ranges);
}

InvocationExpressionSyntax& SyntaxFactory::invocationExpression(ExpressionSyntax& left, const SyntaxList<AttributeInstanceSyntax>& attributes, ArgumentListSyntax* arguments) {
    return *alloc.emplace<InvocationExpressionSyntax>(left, attributes, arguments);
}

JumpStatementSyntax& SyntaxFactory::jumpStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token breakOrContinue, Token semi) {
    return *alloc.emplace<JumpStatementSyntax>(label, attributes, breakOrContinue, semi);
}

KeywordNameSyntax& SyntaxFactory::keywordName(SyntaxKind kind, Token keyword) {
    return *alloc.emplace<KeywordNameSyntax>(kind, keyword);
}

KeywordTypeSyntax& SyntaxFactory::keywordType(SyntaxKind kind, Token keyword) {
    return *alloc.emplace<KeywordTypeSyntax>(kind, keyword);
}

LetDeclarationSyntax& SyntaxFactory::letDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token let, Token identifier, AssertionItemPortListSyntax* portList, Token equals, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<LetDeclarationSyntax>(attributes, let, identifier, portList, equals, expr, semi);
}

LibraryDeclarationSyntax& SyntaxFactory::libraryDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token library, Token name, const SeparatedSyntaxList<FilePathSpecSyntax>& filePaths, LibraryIncDirClauseSyntax* incDirClause, Token semi) {
    return *alloc.emplace<LibraryDeclarationSyntax>(attributes, library, name, filePaths, incDirClause, semi);
}

LibraryIncDirClauseSyntax& SyntaxFactory::libraryIncDirClause(Token minus, Token incdir, const SeparatedSyntaxList<FilePathSpecSyntax>& filePaths) {
    return *alloc.emplace<LibraryIncDirClauseSyntax>(minus, incdir, filePaths);
}

LibraryIncludeStatementSyntax& SyntaxFactory::libraryIncludeStatement(const SyntaxList<AttributeInstanceSyntax>& attributes, Token include, FilePathSpecSyntax& filePath, Token semi) {
    return *alloc.emplace<LibraryIncludeStatementSyntax>(attributes, include, filePath, semi);
}

LibraryMapSyntax& SyntaxFactory::libraryMap(const SyntaxList<MemberSyntax>& members, Token endOfFile) {
    return *alloc.emplace<LibraryMapSyntax>(members, endOfFile);
}

LineDirectiveSyntax& SyntaxFactory::lineDirective(Token directive, Token lineNumber, Token fileName, Token level) {
    return *alloc.emplace<LineDirectiveSyntax>(directive, lineNumber, fileName, level);
}

LiteralExpressionSyntax& SyntaxFactory::literalExpression(SyntaxKind kind, Token literal) {
    return *alloc.emplace<LiteralExpressionSyntax>(kind, literal);
}

LocalVariableDeclarationSyntax& SyntaxFactory::localVariableDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token var, DataTypeSyntax& type, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<LocalVariableDeclarationSyntax>(attributes, var, type, declarators, semi);
}

LoopConstraintSyntax& SyntaxFactory::loopConstraint(Token foreachKeyword, ForeachLoopListSyntax& loopList, ConstraintItemSyntax& constraints) {
    return *alloc.emplace<LoopConstraintSyntax>(foreachKeyword, loopList, constraints);
}

LoopGenerateSyntax& SyntaxFactory::loopGenerate(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token openParen, Token genvar, Token identifier, Token equals, ExpressionSyntax& initialExpr, Token semi1, ExpressionSyntax& stopExpr, Token semi2, ExpressionSyntax& iterationExpr, Token closeParen, MemberSyntax& block) {
    return *alloc.emplace<LoopGenerateSyntax>(attributes, keyword, openParen, genvar, identifier, equals, initialExpr, semi1, stopExpr, semi2, iterationExpr, closeParen, block);
}

LoopStatementSyntax& SyntaxFactory::loopStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token repeatOrWhile, Token openParen, ExpressionSyntax& expr, Token closeParen, StatementSyntax& statement) {
    return *alloc.emplace<LoopStatementSyntax>(label, attributes, repeatOrWhile, openParen, expr, closeParen, statement);
}

MacroActualArgumentListSyntax& SyntaxFactory::macroActualArgumentList(Token openParen, const SeparatedSyntaxList<MacroActualArgumentSyntax>& args, Token closeParen) {
    return *alloc.emplace<MacroActualArgumentListSyntax>(openParen, args, closeParen);
}

MacroActualArgumentSyntax& SyntaxFactory::macroActualArgument(const TokenList& tokens) {
    return *alloc.emplace<MacroActualArgumentSyntax>(tokens);
}

MacroArgumentDefaultSyntax& SyntaxFactory::macroArgumentDefault(Token equals, const TokenList& tokens) {
    return *alloc.emplace<MacroArgumentDefaultSyntax>(equals, tokens);
}

MacroFormalArgumentListSyntax& SyntaxFactory::macroFormalArgumentList(Token openParen, const SeparatedSyntaxList<MacroFormalArgumentSyntax>& args, Token closeParen) {
    return *alloc.emplace<MacroFormalArgumentListSyntax>(openParen, args, closeParen);
}

MacroFormalArgumentSyntax& SyntaxFactory::macroFormalArgument(Token name, MacroArgumentDefaultSyntax* defaultValue) {
    return *alloc.emplace<MacroFormalArgumentSyntax>(name, defaultValue);
}

MacroUsageSyntax& SyntaxFactory::macroUsage(Token directive, MacroActualArgumentListSyntax* args) {
    return *alloc.emplace<MacroUsageSyntax>(directive, args);
}

MatchesClauseSyntax& SyntaxFactory::matchesClause(Token matchesKeyword, PatternSyntax& pattern) {
    return *alloc.emplace<MatchesClauseSyntax>(matchesKeyword, pattern);
}

MemberAccessExpressionSyntax& SyntaxFactory::memberAccessExpression(ExpressionSyntax& left, Token dot, Token name) {
    return *alloc.emplace<MemberAccessExpressionSyntax>(left, dot, name);
}

MinTypMaxExpressionSyntax& SyntaxFactory::minTypMaxExpression(ExpressionSyntax& min, Token colon1, ExpressionSyntax& typ, Token colon2, ExpressionSyntax& max) {
    return *alloc.emplace<MinTypMaxExpressionSyntax>(min, colon1, typ, colon2, max);
}

ModportClockingPortSyntax& SyntaxFactory::modportClockingPort(const SyntaxList<AttributeInstanceSyntax>& attributes, Token clocking, Token name) {
    return *alloc.emplace<ModportClockingPortSyntax>(attributes, clocking, name);
}

ModportDeclarationSyntax& SyntaxFactory::modportDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<ModportItemSyntax>& items, Token semi) {
    return *alloc.emplace<ModportDeclarationSyntax>(attributes, keyword, items, semi);
}

ModportExplicitPortSyntax& SyntaxFactory::modportExplicitPort(Token dot, Token name, Token openParen, ExpressionSyntax* expr, Token closeParen) {
    return *alloc.emplace<ModportExplicitPortSyntax>(dot, name, openParen, expr, closeParen);
}

ModportItemSyntax& SyntaxFactory::modportItem(Token name, AnsiPortListSyntax& ports) {
    return *alloc.emplace<ModportItemSyntax>(name, ports);
}

ModportNamedPortSyntax& SyntaxFactory::modportNamedPort(Token name) {
    return *alloc.emplace<ModportNamedPortSyntax>(name);
}

ModportSimplePortListSyntax& SyntaxFactory::modportSimplePortList(const SyntaxList<AttributeInstanceSyntax>& attributes, Token direction, const SeparatedSyntaxList<ModportPortSyntax>& ports) {
    return *alloc.emplace<ModportSimplePortListSyntax>(attributes, direction, ports);
}

ModportSubroutinePortListSyntax& SyntaxFactory::modportSubroutinePortList(const SyntaxList<AttributeInstanceSyntax>& attributes, Token importExport, const SeparatedSyntaxList<ModportPortSyntax>& ports) {
    return *alloc.emplace<ModportSubroutinePortListSyntax>(attributes, importExport, ports);
}

ModportSubroutinePortSyntax& SyntaxFactory::modportSubroutinePort(FunctionPrototypeSyntax& prototype) {
    return *alloc.emplace<ModportSubroutinePortSyntax>(prototype);
}

ModuleDeclarationSyntax& SyntaxFactory::moduleDeclaration(SyntaxKind kind, const SyntaxList<AttributeInstanceSyntax>& attributes, ModuleHeaderSyntax& header, const SyntaxList<MemberSyntax>& members, Token endmodule, NamedBlockClauseSyntax* blockName) {
    return *alloc.emplace<ModuleDeclarationSyntax>(kind, attributes, header, members, endmodule, blockName);
}

ModuleHeaderSyntax& SyntaxFactory::moduleHeader(SyntaxKind kind, Token moduleKeyword, Token lifetime, Token name, const SyntaxList<PackageImportDeclarationSyntax>& imports, ParameterPortListSyntax* parameters, PortListSyntax* ports, Token semi) {
    return *alloc.emplace<ModuleHeaderSyntax>(kind, moduleKeyword, lifetime, name, imports, parameters, ports, semi);
}

MultipleConcatenationExpressionSyntax& SyntaxFactory::multipleConcatenationExpression(Token openBrace, ExpressionSyntax& expression, ConcatenationExpressionSyntax& concatenation, Token closeBrace) {
    return *alloc.emplace<MultipleConcatenationExpressionSyntax>(openBrace, expression, concatenation, closeBrace);
}

NameValuePragmaExpressionSyntax& SyntaxFactory::nameValuePragmaExpression(Token name, Token equals, PragmaExpressionSyntax& value) {
    return *alloc.emplace<NameValuePragmaExpressionSyntax>(name, equals, value);
}

NamedArgumentSyntax& SyntaxFactory::namedArgument(Token dot, Token name, Token openParen, PropertyExprSyntax* expr, Token closeParen) {
    return *alloc.emplace<NamedArgumentSyntax>(dot, name, openParen, expr, closeParen);
}

NamedBlockClauseSyntax& SyntaxFactory::namedBlockClause(Token colon, Token name) {
    return *alloc.emplace<NamedBlockClauseSyntax>(colon, name);
}

NamedConditionalDirectiveExpressionSyntax& SyntaxFactory::namedConditionalDirectiveExpression(Token name) {
    return *alloc.emplace<NamedConditionalDirectiveExpressionSyntax>(name);
}

NamedLabelSyntax& SyntaxFactory::namedLabel(Token name, Token colon) {
    return *alloc.emplace<NamedLabelSyntax>(name, colon);
}

NamedParamAssignmentSyntax& SyntaxFactory::namedParamAssignment(Token dot, Token name, Token openParen, ExpressionSyntax* expr, Token closeParen) {
    return *alloc.emplace<NamedParamAssignmentSyntax>(dot, name, openParen, expr, closeParen);
}

NamedPortConnectionSyntax& SyntaxFactory::namedPortConnection(const SyntaxList<AttributeInstanceSyntax>& attributes, Token dot, Token name, Token openParen, PropertyExprSyntax* expr, Token closeParen) {
    return *alloc.emplace<NamedPortConnectionSyntax>(attributes, dot, name, openParen, expr, closeParen);
}

NamedStructurePatternMemberSyntax& SyntaxFactory::namedStructurePatternMember(Token name, Token colon, PatternSyntax& pattern) {
    return *alloc.emplace<NamedStructurePatternMemberSyntax>(name, colon, pattern);
}

NamedTypeSyntax& SyntaxFactory::namedType(NameSyntax& name) {
    return *alloc.emplace<NamedTypeSyntax>(name);
}

NetAliasSyntax& SyntaxFactory::netAlias(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<ExpressionSyntax>& nets, Token semi) {
    return *alloc.emplace<NetAliasSyntax>(attributes, keyword, nets, semi);
}

NetDeclarationSyntax& SyntaxFactory::netDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token netType, NetStrengthSyntax* strength, Token expansionHint, DataTypeSyntax& type, TimingControlSyntax* delay, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<NetDeclarationSyntax>(attributes, netType, strength, expansionHint, type, delay, declarators, semi);
}

NetPortHeaderSyntax& SyntaxFactory::netPortHeader(Token direction, Token netType, DataTypeSyntax& dataType) {
    return *alloc.emplace<NetPortHeaderSyntax>(direction, netType, dataType);
}

NetTypeDeclarationSyntax& SyntaxFactory::netTypeDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, DataTypeSyntax& type, Token name, WithFunctionClauseSyntax* withFunction, Token semi) {
    return *alloc.emplace<NetTypeDeclarationSyntax>(attributes, keyword, type, name, withFunction, semi);
}

NewArrayExpressionSyntax& SyntaxFactory::newArrayExpression(NameSyntax& newKeyword, Token openBracket, ExpressionSyntax& sizeExpr, Token closeBracket, ParenthesizedExpressionSyntax* initializer) {
    return *alloc.emplace<NewArrayExpressionSyntax>(newKeyword, openBracket, sizeExpr, closeBracket, initializer);
}

NewClassExpressionSyntax& SyntaxFactory::newClassExpression(NameSyntax& scopedNew, ArgumentListSyntax* argList) {
    return *alloc.emplace<NewClassExpressionSyntax>(scopedNew, argList);
}

NonAnsiPortListSyntax& SyntaxFactory::nonAnsiPortList(Token openParen, const SeparatedSyntaxList<NonAnsiPortSyntax>& ports, Token closeParen) {
    return *alloc.emplace<NonAnsiPortListSyntax>(openParen, ports, closeParen);
}

NonAnsiUdpPortListSyntax& SyntaxFactory::nonAnsiUdpPortList(Token openParen, const SeparatedSyntaxList<IdentifierNameSyntax>& ports, Token closeParen, Token semi) {
    return *alloc.emplace<NonAnsiUdpPortListSyntax>(openParen, ports, closeParen, semi);
}

NumberPragmaExpressionSyntax& SyntaxFactory::numberPragmaExpression(Token size, Token base, Token value) {
    return *alloc.emplace<NumberPragmaExpressionSyntax>(size, base, value);
}

OneStepDelaySyntax& SyntaxFactory::oneStepDelay(Token hash, Token oneStep) {
    return *alloc.emplace<OneStepDelaySyntax>(hash, oneStep);
}

OrderedArgumentSyntax& SyntaxFactory::orderedArgument(PropertyExprSyntax& expr) {
    return *alloc.emplace<OrderedArgumentSyntax>(expr);
}

OrderedParamAssignmentSyntax& SyntaxFactory::orderedParamAssignment(ExpressionSyntax& expr) {
    return *alloc.emplace<OrderedParamAssignmentSyntax>(expr);
}

OrderedPortConnectionSyntax& SyntaxFactory::orderedPortConnection(const SyntaxList<AttributeInstanceSyntax>& attributes, PropertyExprSyntax& expr) {
    return *alloc.emplace<OrderedPortConnectionSyntax>(attributes, expr);
}

OrderedStructurePatternMemberSyntax& SyntaxFactory::orderedStructurePatternMember(PatternSyntax& pattern) {
    return *alloc.emplace<OrderedStructurePatternMemberSyntax>(pattern);
}

PackageExportAllDeclarationSyntax& SyntaxFactory::packageExportAllDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token star1, Token doubleColon, Token star2, Token semi) {
    return *alloc.emplace<PackageExportAllDeclarationSyntax>(attributes, keyword, star1, doubleColon, star2, semi);
}

PackageExportDeclarationSyntax& SyntaxFactory::packageExportDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<PackageImportItemSyntax>& items, Token semi) {
    return *alloc.emplace<PackageExportDeclarationSyntax>(attributes, keyword, items, semi);
}

PackageImportDeclarationSyntax& SyntaxFactory::packageImportDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<PackageImportItemSyntax>& items, Token semi) {
    return *alloc.emplace<PackageImportDeclarationSyntax>(attributes, keyword, items, semi);
}

PackageImportItemSyntax& SyntaxFactory::packageImportItem(Token package, Token doubleColon, Token item) {
    return *alloc.emplace<PackageImportItemSyntax>(package, doubleColon, item);
}

ParameterDeclarationStatementSyntax& SyntaxFactory::parameterDeclarationStatement(const SyntaxList<AttributeInstanceSyntax>& attributes, ParameterDeclarationBaseSyntax& parameter, Token semi) {
    return *alloc.emplace<ParameterDeclarationStatementSyntax>(attributes, parameter, semi);
}

ParameterDeclarationSyntax& SyntaxFactory::parameterDeclaration(Token keyword, DataTypeSyntax& type, const SeparatedSyntaxList<DeclaratorSyntax>& declarators) {
    return *alloc.emplace<ParameterDeclarationSyntax>(keyword, type, declarators);
}

ParameterPortListSyntax& SyntaxFactory::parameterPortList(Token hash, Token openParen, const SeparatedSyntaxList<ParameterDeclarationBaseSyntax>& declarations, Token closeParen) {
    return *alloc.emplace<ParameterPortListSyntax>(hash, openParen, declarations, closeParen);
}

ParameterValueAssignmentSyntax& SyntaxFactory::parameterValueAssignment(Token hash, Token openParen, const SeparatedSyntaxList<ParamAssignmentSyntax>& parameters, Token closeParen) {
    return *alloc.emplace<ParameterValueAssignmentSyntax>(hash, openParen, parameters, closeParen);
}

ParenExpressionListSyntax& SyntaxFactory::parenExpressionList(Token openParen, const SeparatedSyntaxList<ExpressionSyntax>& expressions, Token closeParen) {
    return *alloc.emplace<ParenExpressionListSyntax>(openParen, expressions, closeParen);
}

ParenPragmaExpressionSyntax& SyntaxFactory::parenPragmaExpression(Token openParen, const SeparatedSyntaxList<PragmaExpressionSyntax>& values, Token closeParen) {
    return *alloc.emplace<ParenPragmaExpressionSyntax>(openParen, values, closeParen);
}

ParenthesizedBinsSelectExprSyntax& SyntaxFactory::parenthesizedBinsSelectExpr(Token openParen, BinsSelectExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<ParenthesizedBinsSelectExprSyntax>(openParen, expr, closeParen);
}

ParenthesizedConditionalDirectiveExpressionSyntax& SyntaxFactory::parenthesizedConditionalDirectiveExpression(Token openParen, ConditionalDirectiveExpressionSyntax& operand, Token closeParen) {
    return *alloc.emplace<ParenthesizedConditionalDirectiveExpressionSyntax>(openParen, operand, closeParen);
}

ParenthesizedEventExpressionSyntax& SyntaxFactory::parenthesizedEventExpression(Token openParen, EventExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<ParenthesizedEventExpressionSyntax>(openParen, expr, closeParen);
}

ParenthesizedExpressionSyntax& SyntaxFactory::parenthesizedExpression(Token openParen, ExpressionSyntax& expression, Token closeParen) {
    return *alloc.emplace<ParenthesizedExpressionSyntax>(openParen, expression, closeParen);
}

ParenthesizedPatternSyntax& SyntaxFactory::parenthesizedPattern(Token openParen, PatternSyntax& pattern, Token closeParen) {
    return *alloc.emplace<ParenthesizedPatternSyntax>(openParen, pattern, closeParen);
}

ParenthesizedPropertyExprSyntax& SyntaxFactory::parenthesizedPropertyExpr(Token openParen, PropertyExprSyntax& expr, SequenceMatchListSyntax* matchList, Token closeParen) {
    return *alloc.emplace<ParenthesizedPropertyExprSyntax>(openParen, expr, matchList, closeParen);
}

ParenthesizedSequenceExprSyntax& SyntaxFactory::parenthesizedSequenceExpr(Token openParen, SequenceExprSyntax& expr, SequenceMatchListSyntax* matchList, Token closeParen, SequenceRepetitionSyntax* repetition) {
    return *alloc.emplace<ParenthesizedSequenceExprSyntax>(openParen, expr, matchList, closeParen, repetition);
}

PathDeclarationSyntax& SyntaxFactory::pathDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, PathDescriptionSyntax& desc, Token equals, Token openParen, const SeparatedSyntaxList<ExpressionSyntax>& delays, Token closeParen, Token semi) {
    return *alloc.emplace<PathDeclarationSyntax>(attributes, desc, equals, openParen, delays, closeParen, semi);
}

PathDescriptionSyntax& SyntaxFactory::pathDescription(Token openParen, Token edgeIdentifier, const SeparatedSyntaxList<NameSyntax>& inputs, Token polarityOperator, Token pathOperator, PathSuffixSyntax& suffix, Token closeParen) {
    return *alloc.emplace<PathDescriptionSyntax>(openParen, edgeIdentifier, inputs, polarityOperator, pathOperator, suffix, closeParen);
}

PatternCaseItemSyntax& SyntaxFactory::patternCaseItem(PatternSyntax& pattern, Token tripleAnd, ExpressionSyntax* expr, Token colon, StatementSyntax& statement) {
    return *alloc.emplace<PatternCaseItemSyntax>(pattern, tripleAnd, expr, colon, statement);
}

PortConcatenationSyntax& SyntaxFactory::portConcatenation(Token openBrace, const SeparatedSyntaxList<PortReferenceSyntax>& references, Token closeBrace) {
    return *alloc.emplace<PortConcatenationSyntax>(openBrace, references, closeBrace);
}

PortDeclarationSyntax& SyntaxFactory::portDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, PortHeaderSyntax& header, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<PortDeclarationSyntax>(attributes, header, declarators, semi);
}

PortReferenceSyntax& SyntaxFactory::portReference(Token name, ElementSelectSyntax* select) {
    return *alloc.emplace<PortReferenceSyntax>(name, select);
}

PostfixUnaryExpressionSyntax& SyntaxFactory::postfixUnaryExpression(SyntaxKind kind, ExpressionSyntax& operand, const SyntaxList<AttributeInstanceSyntax>& attributes, Token operatorToken) {
    return *alloc.emplace<PostfixUnaryExpressionSyntax>(kind, operand, attributes, operatorToken);
}

PragmaDirectiveSyntax& SyntaxFactory::pragmaDirective(Token directive, Token name, const SeparatedSyntaxList<PragmaExpressionSyntax>& args) {
    return *alloc.emplace<PragmaDirectiveSyntax>(directive, name, args);
}

PrefixUnaryExpressionSyntax& SyntaxFactory::prefixUnaryExpression(SyntaxKind kind, Token operatorToken, const SyntaxList<AttributeInstanceSyntax>& attributes, ExpressionSyntax& operand) {
    return *alloc.emplace<PrefixUnaryExpressionSyntax>(kind, operatorToken, attributes, operand);
}

PrimaryBlockEventExpressionSyntax& SyntaxFactory::primaryBlockEventExpression(Token keyword, NameSyntax& name) {
    return *alloc.emplace<PrimaryBlockEventExpressionSyntax>(keyword, name);
}

PrimitiveInstantiationSyntax& SyntaxFactory::primitiveInstantiation(const SyntaxList<AttributeInstanceSyntax>& attributes, Token type, NetStrengthSyntax* strength, TimingControlSyntax* delay, const SeparatedSyntaxList<HierarchicalInstanceSyntax>& instances, Token semi) {
    return *alloc.emplace<PrimitiveInstantiationSyntax>(attributes, type, strength, delay, instances, semi);
}

ProceduralAssignStatementSyntax& SyntaxFactory::proceduralAssignStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, ExpressionSyntax& expr, Token semi) {
    return *alloc.emplace<ProceduralAssignStatementSyntax>(kind, label, attributes, keyword, expr, semi);
}

ProceduralBlockSyntax& SyntaxFactory::proceduralBlock(SyntaxKind kind, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, StatementSyntax& statement) {
    return *alloc.emplace<ProceduralBlockSyntax>(kind, attributes, keyword, statement);
}

ProceduralDeassignStatementSyntax& SyntaxFactory::proceduralDeassignStatement(SyntaxKind kind, NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, ExpressionSyntax& variable, Token semi) {
    return *alloc.emplace<ProceduralDeassignStatementSyntax>(kind, label, attributes, keyword, variable, semi);
}

ProductionSyntax& SyntaxFactory::production(DataTypeSyntax* dataType, Token name, FunctionPortListSyntax* portList, Token colon, const SeparatedSyntaxList<RsRuleSyntax>& rules, Token semi) {
    return *alloc.emplace<ProductionSyntax>(dataType, name, portList, colon, rules, semi);
}

PropertyDeclarationSyntax& SyntaxFactory::propertyDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token name, AssertionItemPortListSyntax* portList, Token semi, const SyntaxList<LocalVariableDeclarationSyntax>& variables, PropertySpecSyntax& propertySpec, Token optionalSemi, Token end, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<PropertyDeclarationSyntax>(attributes, keyword, name, portList, semi, variables, propertySpec, optionalSemi, end, endBlockName);
}

PropertySpecSyntax& SyntaxFactory::propertySpec(TimingControlSyntax* clocking, DisableIffSyntax* disable, PropertyExprSyntax& expr) {
    return *alloc.emplace<PropertySpecSyntax>(clocking, disable, expr);
}

PullStrengthSyntax& SyntaxFactory::pullStrength(Token openParen, Token strength, Token closeParen) {
    return *alloc.emplace<PullStrengthSyntax>(openParen, strength, closeParen);
}

PulseStyleDeclarationSyntax& SyntaxFactory::pulseStyleDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<NameSyntax>& inputs, Token semi) {
    return *alloc.emplace<PulseStyleDeclarationSyntax>(attributes, keyword, inputs, semi);
}

QueueDimensionSpecifierSyntax& SyntaxFactory::queueDimensionSpecifier(Token dollar, ColonExpressionClauseSyntax* maxSizeClause) {
    return *alloc.emplace<QueueDimensionSpecifierSyntax>(dollar, maxSizeClause);
}

RandCaseItemSyntax& SyntaxFactory::randCaseItem(ExpressionSyntax& expr, Token colon, StatementSyntax& statement) {
    return *alloc.emplace<RandCaseItemSyntax>(expr, colon, statement);
}

RandCaseStatementSyntax& SyntaxFactory::randCaseStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token randCase, const SyntaxList<RandCaseItemSyntax>& items, Token endCase) {
    return *alloc.emplace<RandCaseStatementSyntax>(label, attributes, randCase, items, endCase);
}

RandJoinClauseSyntax& SyntaxFactory::randJoinClause(Token rand, Token join, ParenthesizedExpressionSyntax* expr) {
    return *alloc.emplace<RandJoinClauseSyntax>(rand, join, expr);
}

RandSequenceStatementSyntax& SyntaxFactory::randSequenceStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token randsequence, Token openParen, Token firstProduction, Token closeParen, const SyntaxList<ProductionSyntax>& productions, Token endsequence) {
    return *alloc.emplace<RandSequenceStatementSyntax>(label, attributes, randsequence, openParen, firstProduction, closeParen, productions, endsequence);
}

RangeCoverageBinInitializerSyntax& SyntaxFactory::rangeCoverageBinInitializer(RangeListSyntax& ranges, WithClauseSyntax* withClause) {
    return *alloc.emplace<RangeCoverageBinInitializerSyntax>(ranges, withClause);
}

RangeDimensionSpecifierSyntax& SyntaxFactory::rangeDimensionSpecifier(SelectorSyntax& selector) {
    return *alloc.emplace<RangeDimensionSpecifierSyntax>(selector);
}

RangeListSyntax& SyntaxFactory::rangeList(Token openBrace, const SeparatedSyntaxList<ExpressionSyntax>& valueRanges, Token closeBrace) {
    return *alloc.emplace<RangeListSyntax>(openBrace, valueRanges, closeBrace);
}

RangeSelectSyntax& SyntaxFactory::rangeSelect(SyntaxKind kind, ExpressionSyntax& left, Token range, ExpressionSyntax& right) {
    return *alloc.emplace<RangeSelectSyntax>(kind, left, range, right);
}

RepeatedEventControlSyntax& SyntaxFactory::repeatedEventControl(Token repeat, Token openParen, ExpressionSyntax& expr, Token closeParen, TimingControlSyntax* eventControl) {
    return *alloc.emplace<RepeatedEventControlSyntax>(repeat, openParen, expr, closeParen, eventControl);
}

ReplicatedAssignmentPatternSyntax& SyntaxFactory::replicatedAssignmentPattern(Token openBrace, ExpressionSyntax& countExpr, Token innerOpenBrace, const SeparatedSyntaxList<ExpressionSyntax>& items, Token innerCloseBrace, Token closeBrace) {
    return *alloc.emplace<ReplicatedAssignmentPatternSyntax>(openBrace, countExpr, innerOpenBrace, items, innerCloseBrace, closeBrace);
}

ReturnStatementSyntax& SyntaxFactory::returnStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token returnKeyword, ExpressionSyntax* returnValue, Token semi) {
    return *alloc.emplace<ReturnStatementSyntax>(label, attributes, returnKeyword, returnValue, semi);
}

RsCaseSyntax& SyntaxFactory::rsCase(Token keyword, Token openParen, ExpressionSyntax& expr, Token closeParen, const SyntaxList<RsCaseItemSyntax>& items, Token endcase) {
    return *alloc.emplace<RsCaseSyntax>(keyword, openParen, expr, closeParen, items, endcase);
}

RsCodeBlockSyntax& SyntaxFactory::rsCodeBlock(Token openBrace, const SyntaxList<SyntaxNode>& items, Token closeBrace) {
    return *alloc.emplace<RsCodeBlockSyntax>(openBrace, items, closeBrace);
}

RsElseClauseSyntax& SyntaxFactory::rsElseClause(Token keyword, RsProdItemSyntax& item) {
    return *alloc.emplace<RsElseClauseSyntax>(keyword, item);
}

RsIfElseSyntax& SyntaxFactory::rsIfElse(Token keyword, Token openParen, ExpressionSyntax& condition, Token closeParen, RsProdItemSyntax& ifItem, RsElseClauseSyntax* elseClause) {
    return *alloc.emplace<RsIfElseSyntax>(keyword, openParen, condition, closeParen, ifItem, elseClause);
}

RsProdItemSyntax& SyntaxFactory::rsProdItem(Token name, ArgumentListSyntax* argList) {
    return *alloc.emplace<RsProdItemSyntax>(name, argList);
}

RsRepeatSyntax& SyntaxFactory::rsRepeat(Token keyword, Token openParen, ExpressionSyntax& expr, Token closeParen, RsProdItemSyntax& item) {
    return *alloc.emplace<RsRepeatSyntax>(keyword, openParen, expr, closeParen, item);
}

RsRuleSyntax& SyntaxFactory::rsRule(RandJoinClauseSyntax* randJoin, const SyntaxList<RsProdSyntax>& prods, RsWeightClauseSyntax* weightClause) {
    return *alloc.emplace<RsRuleSyntax>(randJoin, prods, weightClause);
}

RsWeightClauseSyntax& SyntaxFactory::rsWeightClause(Token colonEqual, ExpressionSyntax& weight, RsProdSyntax* codeBlock) {
    return *alloc.emplace<RsWeightClauseSyntax>(colonEqual, weight, codeBlock);
}

ScopedNameSyntax& SyntaxFactory::scopedName(NameSyntax& left, Token separator, NameSyntax& right) {
    return *alloc.emplace<ScopedNameSyntax>(left, separator, right);
}

SequenceDeclarationSyntax& SyntaxFactory::sequenceDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token name, AssertionItemPortListSyntax* portList, Token semi, const SyntaxList<LocalVariableDeclarationSyntax>& variables, SequenceExprSyntax& seqExpr, Token optionalSemi, Token end, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<SequenceDeclarationSyntax>(attributes, keyword, name, portList, semi, variables, seqExpr, optionalSemi, end, endBlockName);
}

SequenceMatchListSyntax& SyntaxFactory::sequenceMatchList(Token comma, const SeparatedSyntaxList<PropertyExprSyntax>& items) {
    return *alloc.emplace<SequenceMatchListSyntax>(comma, items);
}

SequenceRepetitionSyntax& SyntaxFactory::sequenceRepetition(Token openBracket, Token op, SelectorSyntax* selector, Token closeBracket) {
    return *alloc.emplace<SequenceRepetitionSyntax>(openBracket, op, selector, closeBracket);
}

SignalEventExpressionSyntax& SyntaxFactory::signalEventExpression(Token edge, ExpressionSyntax& expr, IffEventClauseSyntax* iffClause) {
    return *alloc.emplace<SignalEventExpressionSyntax>(edge, expr, iffClause);
}

SignedCastExpressionSyntax& SyntaxFactory::signedCastExpression(Token signing, Token apostrophe, ParenthesizedExpressionSyntax& inner) {
    return *alloc.emplace<SignedCastExpressionSyntax>(signing, apostrophe, inner);
}

SimpleAssignmentPatternSyntax& SyntaxFactory::simpleAssignmentPattern(Token openBrace, const SeparatedSyntaxList<ExpressionSyntax>& items, Token closeBrace) {
    return *alloc.emplace<SimpleAssignmentPatternSyntax>(openBrace, items, closeBrace);
}

SimpleBinsSelectExprSyntax& SyntaxFactory::simpleBinsSelectExpr(ExpressionSyntax& expr, MatchesClauseSyntax* matchesClause) {
    return *alloc.emplace<SimpleBinsSelectExprSyntax>(expr, matchesClause);
}

SimpleDirectiveSyntax& SyntaxFactory::simpleDirective(SyntaxKind kind, Token directive) {
    return *alloc.emplace<SimpleDirectiveSyntax>(kind, directive);
}

SimplePathSuffixSyntax& SyntaxFactory::simplePathSuffix(const SeparatedSyntaxList<NameSyntax>& outputs) {
    return *alloc.emplace<SimplePathSuffixSyntax>(outputs);
}

SimplePragmaExpressionSyntax& SyntaxFactory::simplePragmaExpression(Token value) {
    return *alloc.emplace<SimplePragmaExpressionSyntax>(value);
}

SimplePropertyExprSyntax& SyntaxFactory::simplePropertyExpr(SequenceExprSyntax& expr) {
    return *alloc.emplace<SimplePropertyExprSyntax>(expr);
}

SimpleSequenceExprSyntax& SyntaxFactory::simpleSequenceExpr(ExpressionSyntax& expr, SequenceRepetitionSyntax* repetition) {
    return *alloc.emplace<SimpleSequenceExprSyntax>(expr, repetition);
}

SolveBeforeConstraintSyntax& SyntaxFactory::solveBeforeConstraint(Token solve, const SeparatedSyntaxList<ExpressionSyntax>& beforeExpr, Token before, const SeparatedSyntaxList<ExpressionSyntax>& afterExpr, Token semi) {
    return *alloc.emplace<SolveBeforeConstraintSyntax>(solve, beforeExpr, before, afterExpr, semi);
}

SpecifyBlockSyntax& SyntaxFactory::specifyBlock(const SyntaxList<AttributeInstanceSyntax>& attributes, Token specify, const SyntaxList<MemberSyntax>& items, Token endspecify) {
    return *alloc.emplace<SpecifyBlockSyntax>(attributes, specify, items, endspecify);
}

SpecparamDeclarationSyntax& SyntaxFactory::specparamDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, ImplicitTypeSyntax& type, const SeparatedSyntaxList<SpecparamDeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<SpecparamDeclarationSyntax>(attributes, keyword, type, declarators, semi);
}

SpecparamDeclaratorSyntax& SyntaxFactory::specparamDeclarator(Token name, Token equals, Token openParen, ExpressionSyntax& value1, Token comma, ExpressionSyntax* value2, Token closeParen) {
    return *alloc.emplace<SpecparamDeclaratorSyntax>(name, equals, openParen, value1, comma, value2, closeParen);
}

StandardCaseItemSyntax& SyntaxFactory::standardCaseItem(const SeparatedSyntaxList<ExpressionSyntax>& expressions, Token colon, SyntaxNode& clause) {
    return *alloc.emplace<StandardCaseItemSyntax>(expressions, colon, clause);
}

StandardPropertyCaseItemSyntax& SyntaxFactory::standardPropertyCaseItem(const SeparatedSyntaxList<ExpressionSyntax>& expressions, Token colon, PropertyExprSyntax& expr, Token semi) {
    return *alloc.emplace<StandardPropertyCaseItemSyntax>(expressions, colon, expr, semi);
}

StandardRsCaseItemSyntax& SyntaxFactory::standardRsCaseItem(const SeparatedSyntaxList<ExpressionSyntax>& expressions, Token colon, RsProdItemSyntax& item, Token semi) {
    return *alloc.emplace<StandardRsCaseItemSyntax>(expressions, colon, item, semi);
}

StreamExpressionSyntax& SyntaxFactory::streamExpression(ExpressionSyntax& expression, StreamExpressionWithRangeSyntax* withRange) {
    return *alloc.emplace<StreamExpressionSyntax>(expression, withRange);
}

StreamExpressionWithRangeSyntax& SyntaxFactory::streamExpressionWithRange(Token withKeyword, ElementSelectSyntax& range) {
    return *alloc.emplace<StreamExpressionWithRangeSyntax>(withKeyword, range);
}

StreamingConcatenationExpressionSyntax& SyntaxFactory::streamingConcatenationExpression(Token openBrace, Token operatorToken, ExpressionSyntax* sliceSize, Token innerOpenBrace, const SeparatedSyntaxList<StreamExpressionSyntax>& expressions, Token innerCloseBrace, Token closeBrace) {
    return *alloc.emplace<StreamingConcatenationExpressionSyntax>(openBrace, operatorToken, sliceSize, innerOpenBrace, expressions, innerCloseBrace, closeBrace);
}

StrongWeakPropertyExprSyntax& SyntaxFactory::strongWeakPropertyExpr(Token keyword, Token openParen, SequenceExprSyntax& expr, Token closeParen) {
    return *alloc.emplace<StrongWeakPropertyExprSyntax>(keyword, openParen, expr, closeParen);
}

StructUnionMemberSyntax& SyntaxFactory::structUnionMember(const SyntaxList<AttributeInstanceSyntax>& attributes, Token randomQualifier, DataTypeSyntax& type, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<StructUnionMemberSyntax>(attributes, randomQualifier, type, declarators, semi);
}

StructUnionTypeSyntax& SyntaxFactory::structUnionType(SyntaxKind kind, Token keyword, Token taggedOrSoft, Token packed, Token signing, Token openBrace, const SyntaxList<StructUnionMemberSyntax>& members, Token closeBrace, const SyntaxList<VariableDimensionSyntax>& dimensions) {
    return *alloc.emplace<StructUnionTypeSyntax>(kind, keyword, taggedOrSoft, packed, signing, openBrace, members, closeBrace, dimensions);
}

StructurePatternSyntax& SyntaxFactory::structurePattern(Token openBrace, const SeparatedSyntaxList<StructurePatternMemberSyntax>& members, Token closeBrace) {
    return *alloc.emplace<StructurePatternSyntax>(openBrace, members, closeBrace);
}

StructuredAssignmentPatternSyntax& SyntaxFactory::structuredAssignmentPattern(Token openBrace, const SeparatedSyntaxList<AssignmentPatternItemSyntax>& items, Token closeBrace) {
    return *alloc.emplace<StructuredAssignmentPatternSyntax>(openBrace, items, closeBrace);
}

SuperNewDefaultedArgsExpressionSyntax& SyntaxFactory::superNewDefaultedArgsExpression(NameSyntax& scopedNew, Token openParen, Token defaultKeyword, Token closeParen) {
    return *alloc.emplace<SuperNewDefaultedArgsExpressionSyntax>(scopedNew, openParen, defaultKeyword, closeParen);
}

SystemNameSyntax& SyntaxFactory::systemName(Token systemIdentifier) {
    return *alloc.emplace<SystemNameSyntax>(systemIdentifier);
}

SystemTimingCheckSyntax& SyntaxFactory::systemTimingCheck(const SyntaxList<AttributeInstanceSyntax>& attributes, Token name, Token openParen, const SeparatedSyntaxList<TimingCheckArgSyntax>& args, Token closeParen, Token semi) {
    return *alloc.emplace<SystemTimingCheckSyntax>(attributes, name, openParen, args, closeParen, semi);
}

TaggedPatternSyntax& SyntaxFactory::taggedPattern(Token tagged, Token memberName, PatternSyntax* pattern) {
    return *alloc.emplace<TaggedPatternSyntax>(tagged, memberName, pattern);
}

TaggedUnionExpressionSyntax& SyntaxFactory::taggedUnionExpression(Token tagged, Token member, ExpressionSyntax* expr) {
    return *alloc.emplace<TaggedUnionExpressionSyntax>(tagged, member, expr);
}

TimeScaleDirectiveSyntax& SyntaxFactory::timeScaleDirective(Token directive, Token timeUnit, Token slash, Token timePrecision) {
    return *alloc.emplace<TimeScaleDirectiveSyntax>(directive, timeUnit, slash, timePrecision);
}

TimeUnitsDeclarationSyntax& SyntaxFactory::timeUnitsDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token time, DividerClauseSyntax* divider, Token semi) {
    return *alloc.emplace<TimeUnitsDeclarationSyntax>(attributes, keyword, time, divider, semi);
}

TimingCheckEventArgSyntax& SyntaxFactory::timingCheckEventArg(Token edge, EdgeControlSpecifierSyntax* controlSpecifier, ExpressionSyntax& terminal, TimingCheckEventConditionSyntax* condition) {
    return *alloc.emplace<TimingCheckEventArgSyntax>(edge, controlSpecifier, terminal, condition);
}

TimingCheckEventConditionSyntax& SyntaxFactory::timingCheckEventCondition(Token tripleAnd, ExpressionSyntax& expr) {
    return *alloc.emplace<TimingCheckEventConditionSyntax>(tripleAnd, expr);
}

TimingControlExpressionSyntax& SyntaxFactory::timingControlExpression(TimingControlSyntax& timing, ExpressionSyntax& expr) {
    return *alloc.emplace<TimingControlExpressionSyntax>(timing, expr);
}

TimingControlStatementSyntax& SyntaxFactory::timingControlStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, TimingControlSyntax& timingControl, StatementSyntax& statement) {
    return *alloc.emplace<TimingControlStatementSyntax>(label, attributes, timingControl, statement);
}

TransListCoverageBinInitializerSyntax& SyntaxFactory::transListCoverageBinInitializer(const SeparatedSyntaxList<TransSetSyntax>& sets) {
    return *alloc.emplace<TransListCoverageBinInitializerSyntax>(sets);
}

TransRangeSyntax& SyntaxFactory::transRange(const SeparatedSyntaxList<ExpressionSyntax>& items, TransRepeatRangeSyntax* repeat) {
    return *alloc.emplace<TransRangeSyntax>(items, repeat);
}

TransRepeatRangeSyntax& SyntaxFactory::transRepeatRange(Token openBracket, Token specifier, SelectorSyntax* selector, Token closeBracket) {
    return *alloc.emplace<TransRepeatRangeSyntax>(openBracket, specifier, selector, closeBracket);
}

TransSetSyntax& SyntaxFactory::transSet(Token openParen, const SeparatedSyntaxList<TransRangeSyntax>& ranges, Token closeParen) {
    return *alloc.emplace<TransSetSyntax>(openParen, ranges, closeParen);
}

TypeAssignmentSyntax& SyntaxFactory::typeAssignment(Token name, EqualsTypeClauseSyntax* assignment) {
    return *alloc.emplace<TypeAssignmentSyntax>(name, assignment);
}

TypeParameterDeclarationSyntax& SyntaxFactory::typeParameterDeclaration(Token keyword, Token typeKeyword, ForwardTypeRestrictionSyntax* typeRestriction, const SeparatedSyntaxList<TypeAssignmentSyntax>& declarators) {
    return *alloc.emplace<TypeParameterDeclarationSyntax>(keyword, typeKeyword, typeRestriction, declarators);
}

TypeReferenceSyntax& SyntaxFactory::typeReference(Token typeKeyword, Token openParen, ExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<TypeReferenceSyntax>(typeKeyword, openParen, expr, closeParen);
}

TypedefDeclarationSyntax& SyntaxFactory::typedefDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token typedefKeyword, DataTypeSyntax& type, Token name, const SyntaxList<VariableDimensionSyntax>& dimensions, Token semi) {
    return *alloc.emplace<TypedefDeclarationSyntax>(attributes, typedefKeyword, type, name, dimensions, semi);
}

UdpBodySyntax& SyntaxFactory::udpBody(const SeparatedSyntaxList<UdpPortDeclSyntax>& portDecls, UdpInitialStmtSyntax* initialStmt, Token table, const SyntaxList<UdpEntrySyntax>& entries, Token endtable) {
    return *alloc.emplace<UdpBodySyntax>(portDecls, initialStmt, table, entries, endtable);
}

UdpDeclarationSyntax& SyntaxFactory::udpDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token primitive, Token name, UdpPortListSyntax& portList, UdpBodySyntax& body, Token endprimitive, NamedBlockClauseSyntax* endBlockName) {
    return *alloc.emplace<UdpDeclarationSyntax>(attributes, primitive, name, portList, body, endprimitive, endBlockName);
}

UdpEdgeFieldSyntax& SyntaxFactory::udpEdgeField(Token openParen, Token first, Token second, Token closeParen) {
    return *alloc.emplace<UdpEdgeFieldSyntax>(openParen, first, second, closeParen);
}

UdpEntrySyntax& SyntaxFactory::udpEntry(const SyntaxList<UdpFieldBaseSyntax>& inputs, Token colon1, UdpFieldBaseSyntax* current, Token colon2, UdpFieldBaseSyntax* next, Token semi) {
    return *alloc.emplace<UdpEntrySyntax>(inputs, colon1, current, colon2, next, semi);
}

UdpInitialStmtSyntax& SyntaxFactory::udpInitialStmt(Token initial, Token name, Token equals, ExpressionSyntax& value, Token semi) {
    return *alloc.emplace<UdpInitialStmtSyntax>(initial, name, equals, value, semi);
}

UdpInputPortDeclSyntax& SyntaxFactory::udpInputPortDecl(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, const SeparatedSyntaxList<IdentifierNameSyntax>& names) {
    return *alloc.emplace<UdpInputPortDeclSyntax>(attributes, keyword, names);
}

UdpOutputPortDeclSyntax& SyntaxFactory::udpOutputPortDecl(const SyntaxList<AttributeInstanceSyntax>& attributes, Token keyword, Token reg, Token name, EqualsValueClauseSyntax* initializer) {
    return *alloc.emplace<UdpOutputPortDeclSyntax>(attributes, keyword, reg, name, initializer);
}

UdpSimpleFieldSyntax& SyntaxFactory::udpSimpleField(Token field) {
    return *alloc.emplace<UdpSimpleFieldSyntax>(field);
}

UnaryBinsSelectExprSyntax& SyntaxFactory::unaryBinsSelectExpr(Token op, BinsSelectConditionExprSyntax& expr) {
    return *alloc.emplace<UnaryBinsSelectExprSyntax>(op, expr);
}

UnaryConditionalDirectiveExpressionSyntax& SyntaxFactory::unaryConditionalDirectiveExpression(Token op, ConditionalDirectiveExpressionSyntax& operand) {
    return *alloc.emplace<UnaryConditionalDirectiveExpressionSyntax>(op, operand);
}

UnaryPropertyExprSyntax& SyntaxFactory::unaryPropertyExpr(Token op, PropertyExprSyntax& expr) {
    return *alloc.emplace<UnaryPropertyExprSyntax>(op, expr);
}

UnarySelectPropertyExprSyntax& SyntaxFactory::unarySelectPropertyExpr(Token op, Token openBracket, SelectorSyntax* selector, Token closeBracket, PropertyExprSyntax& expr) {
    return *alloc.emplace<UnarySelectPropertyExprSyntax>(op, openBracket, selector, closeBracket, expr);
}

UnconditionalBranchDirectiveSyntax& SyntaxFactory::unconditionalBranchDirective(SyntaxKind kind, Token directive, const TokenList& disabledTokens) {
    return *alloc.emplace<UnconditionalBranchDirectiveSyntax>(kind, directive, disabledTokens);
}

UnconnectedDriveDirectiveSyntax& SyntaxFactory::unconnectedDriveDirective(Token directive, Token strength) {
    return *alloc.emplace<UnconnectedDriveDirectiveSyntax>(directive, strength);
}

UndefDirectiveSyntax& SyntaxFactory::undefDirective(Token directive, Token name) {
    return *alloc.emplace<UndefDirectiveSyntax>(directive, name);
}

UniquenessConstraintSyntax& SyntaxFactory::uniquenessConstraint(Token unique, RangeListSyntax& ranges, Token semi) {
    return *alloc.emplace<UniquenessConstraintSyntax>(unique, ranges, semi);
}

UserDefinedNetDeclarationSyntax& SyntaxFactory::userDefinedNetDeclaration(const SyntaxList<AttributeInstanceSyntax>& attributes, Token netType, TimingControlSyntax& delay, const SeparatedSyntaxList<DeclaratorSyntax>& declarators, Token semi) {
    return *alloc.emplace<UserDefinedNetDeclarationSyntax>(attributes, netType, delay, declarators, semi);
}

ValueRangeExpressionSyntax& SyntaxFactory::valueRangeExpression(Token openBracket, ExpressionSyntax& left, Token op, ExpressionSyntax& right, Token closeBracket) {
    return *alloc.emplace<ValueRangeExpressionSyntax>(openBracket, left, op, right, closeBracket);
}

VariableDimensionSyntax& SyntaxFactory::variableDimension(Token openBracket, DimensionSpecifierSyntax* specifier, Token closeBracket) {
    return *alloc.emplace<VariableDimensionSyntax>(openBracket, specifier, closeBracket);
}

VariablePatternSyntax& SyntaxFactory::variablePattern(Token dot, Token variableName) {
    return *alloc.emplace<VariablePatternSyntax>(dot, variableName);
}

VariablePortHeaderSyntax& SyntaxFactory::variablePortHeader(Token constKeyword, Token direction, Token varKeyword, DataTypeSyntax& dataType) {
    return *alloc.emplace<VariablePortHeaderSyntax>(constKeyword, direction, varKeyword, dataType);
}

VirtualInterfaceTypeSyntax& SyntaxFactory::virtualInterfaceType(Token virtualKeyword, Token interfaceKeyword, Token name, ParameterValueAssignmentSyntax* parameters, DotMemberClauseSyntax* modport) {
    return *alloc.emplace<VirtualInterfaceTypeSyntax>(virtualKeyword, interfaceKeyword, name, parameters, modport);
}

VoidCastedCallStatementSyntax& SyntaxFactory::voidCastedCallStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token voidKeyword, Token apostrophe, Token openParen, ExpressionSyntax& expr, Token closeParen, Token semi) {
    return *alloc.emplace<VoidCastedCallStatementSyntax>(label, attributes, voidKeyword, apostrophe, openParen, expr, closeParen, semi);
}

WaitForkStatementSyntax& SyntaxFactory::waitForkStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token wait, Token fork, Token semi) {
    return *alloc.emplace<WaitForkStatementSyntax>(label, attributes, wait, fork, semi);
}

WaitOrderStatementSyntax& SyntaxFactory::waitOrderStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token wait_order, Token openParen, const SeparatedSyntaxList<NameSyntax>& names, Token closeParen, ActionBlockSyntax& action) {
    return *alloc.emplace<WaitOrderStatementSyntax>(label, attributes, wait_order, openParen, names, closeParen, action);
}

WaitStatementSyntax& SyntaxFactory::waitStatement(NamedLabelSyntax* label, const SyntaxList<AttributeInstanceSyntax>& attributes, Token wait, Token openParen, ExpressionSyntax& expr, Token closeParen, StatementSyntax& statement) {
    return *alloc.emplace<WaitStatementSyntax>(label, attributes, wait, openParen, expr, closeParen, statement);
}

WildcardDimensionSpecifierSyntax& SyntaxFactory::wildcardDimensionSpecifier(Token star) {
    return *alloc.emplace<WildcardDimensionSpecifierSyntax>(star);
}

WildcardPatternSyntax& SyntaxFactory::wildcardPattern(Token dot, Token star) {
    return *alloc.emplace<WildcardPatternSyntax>(dot, star);
}

WildcardPortConnectionSyntax& SyntaxFactory::wildcardPortConnection(const SyntaxList<AttributeInstanceSyntax>& attributes, Token dot, Token star) {
    return *alloc.emplace<WildcardPortConnectionSyntax>(attributes, dot, star);
}

WildcardPortListSyntax& SyntaxFactory::wildcardPortList(Token openParen, Token dot, Token star, Token closeParen) {
    return *alloc.emplace<WildcardPortListSyntax>(openParen, dot, star, closeParen);
}

WildcardUdpPortListSyntax& SyntaxFactory::wildcardUdpPortList(Token openParen, Token dot, Token star, Token closeParen, Token semi) {
    return *alloc.emplace<WildcardUdpPortListSyntax>(openParen, dot, star, closeParen, semi);
}

WithClauseSyntax& SyntaxFactory::withClause(Token with, Token openParen, ExpressionSyntax& expr, Token closeParen) {
    return *alloc.emplace<WithClauseSyntax>(with, openParen, expr, closeParen);
}

WithFunctionClauseSyntax& SyntaxFactory::withFunctionClause(Token with, NameSyntax& name) {
    return *alloc.emplace<WithFunctionClauseSyntax>(with, name);
}

WithFunctionSampleSyntax& SyntaxFactory::withFunctionSample(Token with, Token function, Token sample, FunctionPortListSyntax* portList) {
    return *alloc.emplace<WithFunctionSampleSyntax>(with, function, sample, portList);
}


std::ostream& operator<<(std::ostream& os, SyntaxKind kind) {
    os << toString(kind);
    return os;
}

std::string_view toString(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::Unknown: return "Unknown";
        case SyntaxKind::SyntaxList: return "SyntaxList";
        case SyntaxKind::TokenList: return "TokenList";
        case SyntaxKind::SeparatedList: return "SeparatedList";
        case SyntaxKind::AcceptOnPropertyExpr: return "AcceptOnPropertyExpr";
        case SyntaxKind::ActionBlock: return "ActionBlock";
        case SyntaxKind::AddAssignmentExpression: return "AddAssignmentExpression";
        case SyntaxKind::AddExpression: return "AddExpression";
        case SyntaxKind::AlwaysBlock: return "AlwaysBlock";
        case SyntaxKind::AlwaysCombBlock: return "AlwaysCombBlock";
        case SyntaxKind::AlwaysFFBlock: return "AlwaysFFBlock";
        case SyntaxKind::AlwaysLatchBlock: return "AlwaysLatchBlock";
        case SyntaxKind::AndAssignmentExpression: return "AndAssignmentExpression";
        case SyntaxKind::AndPropertyExpr: return "AndPropertyExpr";
        case SyntaxKind::AndSequenceExpr: return "AndSequenceExpr";
        case SyntaxKind::AnonymousProgram: return "AnonymousProgram";
        case SyntaxKind::AnsiPortList: return "AnsiPortList";
        case SyntaxKind::AnsiUdpPortList: return "AnsiUdpPortList";
        case SyntaxKind::ArgumentList: return "ArgumentList";
        case SyntaxKind::ArithmeticLeftShiftAssignmentExpression: return "ArithmeticLeftShiftAssignmentExpression";
        case SyntaxKind::ArithmeticRightShiftAssignmentExpression: return "ArithmeticRightShiftAssignmentExpression";
        case SyntaxKind::ArithmeticShiftLeftExpression: return "ArithmeticShiftLeftExpression";
        case SyntaxKind::ArithmeticShiftRightExpression: return "ArithmeticShiftRightExpression";
        case SyntaxKind::ArrayAndMethod: return "ArrayAndMethod";
        case SyntaxKind::ArrayOrMethod: return "ArrayOrMethod";
        case SyntaxKind::ArrayOrRandomizeMethodExpression: return "ArrayOrRandomizeMethodExpression";
        case SyntaxKind::ArrayUniqueMethod: return "ArrayUniqueMethod";
        case SyntaxKind::ArrayXorMethod: return "ArrayXorMethod";
        case SyntaxKind::AscendingRangeSelect: return "AscendingRangeSelect";
        case SyntaxKind::AssertPropertyStatement: return "AssertPropertyStatement";
        case SyntaxKind::AssertionItemPort: return "AssertionItemPort";
        case SyntaxKind::AssertionItemPortList: return "AssertionItemPortList";
        case SyntaxKind::AssignmentExpression: return "AssignmentExpression";
        case SyntaxKind::AssignmentPatternExpression: return "AssignmentPatternExpression";
        case SyntaxKind::AssignmentPatternItem: return "AssignmentPatternItem";
        case SyntaxKind::AssumePropertyStatement: return "AssumePropertyStatement";
        case SyntaxKind::AttributeInstance: return "AttributeInstance";
        case SyntaxKind::AttributeSpec: return "AttributeSpec";
        case SyntaxKind::BadExpression: return "BadExpression";
        case SyntaxKind::BeginKeywordsDirective: return "BeginKeywordsDirective";
        case SyntaxKind::BinSelectWithFilterExpr: return "BinSelectWithFilterExpr";
        case SyntaxKind::BinaryAndExpression: return "BinaryAndExpression";
        case SyntaxKind::BinaryBinsSelectExpr: return "BinaryBinsSelectExpr";
        case SyntaxKind::BinaryBlockEventExpression: return "BinaryBlockEventExpression";
        case SyntaxKind::BinaryConditionalDirectiveExpression: return "BinaryConditionalDirectiveExpression";
        case SyntaxKind::BinaryEventExpression: return "BinaryEventExpression";
        case SyntaxKind::BinaryOrExpression: return "BinaryOrExpression";
        case SyntaxKind::BinaryXnorExpression: return "BinaryXnorExpression";
        case SyntaxKind::BinaryXorExpression: return "BinaryXorExpression";
        case SyntaxKind::BindDirective: return "BindDirective";
        case SyntaxKind::BindTargetList: return "BindTargetList";
        case SyntaxKind::BinsSelectConditionExpr: return "BinsSelectConditionExpr";
        case SyntaxKind::BinsSelection: return "BinsSelection";
        case SyntaxKind::BitSelect: return "BitSelect";
        case SyntaxKind::BitType: return "BitType";
        case SyntaxKind::BlockCoverageEvent: return "BlockCoverageEvent";
        case SyntaxKind::BlockingEventTriggerStatement: return "BlockingEventTriggerStatement";
        case SyntaxKind::ByteType: return "ByteType";
        case SyntaxKind::CHandleType: return "CHandleType";
        case SyntaxKind::CaseEqualityExpression: return "CaseEqualityExpression";
        case SyntaxKind::CaseGenerate: return "CaseGenerate";
        case SyntaxKind::CaseInequalityExpression: return "CaseInequalityExpression";
        case SyntaxKind::CasePropertyExpr: return "CasePropertyExpr";
        case SyntaxKind::CaseStatement: return "CaseStatement";
        case SyntaxKind::CastExpression: return "CastExpression";
        case SyntaxKind::CellConfigRule: return "CellConfigRule";
        case SyntaxKind::CellDefineDirective: return "CellDefineDirective";
        case SyntaxKind::ChargeStrength: return "ChargeStrength";
        case SyntaxKind::CheckerDataDeclaration: return "CheckerDataDeclaration";
        case SyntaxKind::CheckerDeclaration: return "CheckerDeclaration";
        case SyntaxKind::CheckerInstanceStatement: return "CheckerInstanceStatement";
        case SyntaxKind::CheckerInstantiation: return "CheckerInstantiation";
        case SyntaxKind::ClassDeclaration: return "ClassDeclaration";
        case SyntaxKind::ClassMethodDeclaration: return "ClassMethodDeclaration";
        case SyntaxKind::ClassMethodPrototype: return "ClassMethodPrototype";
        case SyntaxKind::ClassName: return "ClassName";
        case SyntaxKind::ClassPropertyDeclaration: return "ClassPropertyDeclaration";
        case SyntaxKind::ClassSpecifier: return "ClassSpecifier";
        case SyntaxKind::ClockingDeclaration: return "ClockingDeclaration";
        case SyntaxKind::ClockingDirection: return "ClockingDirection";
        case SyntaxKind::ClockingItem: return "ClockingItem";
        case SyntaxKind::ClockingPropertyExpr: return "ClockingPropertyExpr";
        case SyntaxKind::ClockingSequenceExpr: return "ClockingSequenceExpr";
        case SyntaxKind::ClockingSkew: return "ClockingSkew";
        case SyntaxKind::ColonExpressionClause: return "ColonExpressionClause";
        case SyntaxKind::CompilationUnit: return "CompilationUnit";
        case SyntaxKind::ConcatenationExpression: return "ConcatenationExpression";
        case SyntaxKind::ConcurrentAssertionMember: return "ConcurrentAssertionMember";
        case SyntaxKind::ConditionalConstraint: return "ConditionalConstraint";
        case SyntaxKind::ConditionalExpression: return "ConditionalExpression";
        case SyntaxKind::ConditionalPathDeclaration: return "ConditionalPathDeclaration";
        case SyntaxKind::ConditionalPattern: return "ConditionalPattern";
        case SyntaxKind::ConditionalPredicate: return "ConditionalPredicate";
        case SyntaxKind::ConditionalPropertyExpr: return "ConditionalPropertyExpr";
        case SyntaxKind::ConditionalStatement: return "ConditionalStatement";
        case SyntaxKind::ConfigCellIdentifier: return "ConfigCellIdentifier";
        case SyntaxKind::ConfigDeclaration: return "ConfigDeclaration";
        case SyntaxKind::ConfigInstanceIdentifier: return "ConfigInstanceIdentifier";
        case SyntaxKind::ConfigLiblist: return "ConfigLiblist";
        case SyntaxKind::ConfigUseClause: return "ConfigUseClause";
        case SyntaxKind::ConstraintBlock: return "ConstraintBlock";
        case SyntaxKind::ConstraintDeclaration: return "ConstraintDeclaration";
        case SyntaxKind::ConstraintPrototype: return "ConstraintPrototype";
        case SyntaxKind::ConstructorName: return "ConstructorName";
        case SyntaxKind::ContinuousAssign: return "ContinuousAssign";
        case SyntaxKind::CopyClassExpression: return "CopyClassExpression";
        case SyntaxKind::CoverCross: return "CoverCross";
        case SyntaxKind::CoverPropertyStatement: return "CoverPropertyStatement";
        case SyntaxKind::CoverSequenceStatement: return "CoverSequenceStatement";
        case SyntaxKind::CoverageBins: return "CoverageBins";
        case SyntaxKind::CoverageBinsArraySize: return "CoverageBinsArraySize";
        case SyntaxKind::CoverageIffClause: return "CoverageIffClause";
        case SyntaxKind::CoverageOption: return "CoverageOption";
        case SyntaxKind::CovergroupDeclaration: return "CovergroupDeclaration";
        case SyntaxKind::Coverpoint: return "Coverpoint";
        case SyntaxKind::CycleDelay: return "CycleDelay";
        case SyntaxKind::DPIExport: return "DPIExport";
        case SyntaxKind::DPIImport: return "DPIImport";
        case SyntaxKind::DataDeclaration: return "DataDeclaration";
        case SyntaxKind::Declarator: return "Declarator";
        case SyntaxKind::DefParam: return "DefParam";
        case SyntaxKind::DefParamAssignment: return "DefParamAssignment";
        case SyntaxKind::DefaultCaseItem: return "DefaultCaseItem";
        case SyntaxKind::DefaultClockingReference: return "DefaultClockingReference";
        case SyntaxKind::DefaultConfigRule: return "DefaultConfigRule";
        case SyntaxKind::DefaultCoverageBinInitializer: return "DefaultCoverageBinInitializer";
        case SyntaxKind::DefaultDecayTimeDirective: return "DefaultDecayTimeDirective";
        case SyntaxKind::DefaultDisableDeclaration: return "DefaultDisableDeclaration";
        case SyntaxKind::DefaultDistItem: return "DefaultDistItem";
        case SyntaxKind::DefaultExtendsClauseArg: return "DefaultExtendsClauseArg";
        case SyntaxKind::DefaultFunctionPort: return "DefaultFunctionPort";
        case SyntaxKind::DefaultNetTypeDirective: return "DefaultNetTypeDirective";
        case SyntaxKind::DefaultPatternKeyExpression: return "DefaultPatternKeyExpression";
        case SyntaxKind::DefaultPropertyCaseItem: return "DefaultPropertyCaseItem";
        case SyntaxKind::DefaultRsCaseItem: return "DefaultRsCaseItem";
        case SyntaxKind::DefaultSkewItem: return "DefaultSkewItem";
        case SyntaxKind::DefaultTriregStrengthDirective: return "DefaultTriregStrengthDirective";
        case SyntaxKind::DeferredAssertion: return "DeferredAssertion";
        case SyntaxKind::DefineDirective: return "DefineDirective";
        case SyntaxKind::Delay3: return "Delay3";
        case SyntaxKind::DelayControl: return "DelayControl";
        case SyntaxKind::DelayModeDistributedDirective: return "DelayModeDistributedDirective";
        case SyntaxKind::DelayModePathDirective: return "DelayModePathDirective";
        case SyntaxKind::DelayModeUnitDirective: return "DelayModeUnitDirective";
        case SyntaxKind::DelayModeZeroDirective: return "DelayModeZeroDirective";
        case SyntaxKind::DelayedSequenceElement: return "DelayedSequenceElement";
        case SyntaxKind::DelayedSequenceExpr: return "DelayedSequenceExpr";
        case SyntaxKind::DescendingRangeSelect: return "DescendingRangeSelect";
        case SyntaxKind::DisableConstraint: return "DisableConstraint";
        case SyntaxKind::DisableForkStatement: return "DisableForkStatement";
        case SyntaxKind::DisableIff: return "DisableIff";
        case SyntaxKind::DisableStatement: return "DisableStatement";
        case SyntaxKind::DistConstraintList: return "DistConstraintList";
        case SyntaxKind::DistItem: return "DistItem";
        case SyntaxKind::DistWeight: return "DistWeight";
        case SyntaxKind::DivideAssignmentExpression: return "DivideAssignmentExpression";
        case SyntaxKind::DivideExpression: return "DivideExpression";
        case SyntaxKind::DividerClause: return "DividerClause";
        case SyntaxKind::DoWhileStatement: return "DoWhileStatement";
        case SyntaxKind::DotMemberClause: return "DotMemberClause";
        case SyntaxKind::DriveStrength: return "DriveStrength";
        case SyntaxKind::EdgeControlSpecifier: return "EdgeControlSpecifier";
        case SyntaxKind::EdgeDescriptor: return "EdgeDescriptor";
        case SyntaxKind::EdgeSensitivePathSuffix: return "EdgeSensitivePathSuffix";
        case SyntaxKind::ElabSystemTask: return "ElabSystemTask";
        case SyntaxKind::ElementSelect: return "ElementSelect";
        case SyntaxKind::ElementSelectExpression: return "ElementSelectExpression";
        case SyntaxKind::ElsIfDirective: return "ElsIfDirective";
        case SyntaxKind::ElseClause: return "ElseClause";
        case SyntaxKind::ElseConstraintClause: return "ElseConstraintClause";
        case SyntaxKind::ElseDirective: return "ElseDirective";
        case SyntaxKind::ElsePropertyClause: return "ElsePropertyClause";
        case SyntaxKind::EmptyArgument: return "EmptyArgument";
        case SyntaxKind::EmptyIdentifierName: return "EmptyIdentifierName";
        case SyntaxKind::EmptyMember: return "EmptyMember";
        case SyntaxKind::EmptyNonAnsiPort: return "EmptyNonAnsiPort";
        case SyntaxKind::EmptyPortConnection: return "EmptyPortConnection";
        case SyntaxKind::EmptyQueueExpression: return "EmptyQueueExpression";
        case SyntaxKind::EmptyStatement: return "EmptyStatement";
        case SyntaxKind::EmptyTimingCheckArg: return "EmptyTimingCheckArg";
        case SyntaxKind::EndCellDefineDirective: return "EndCellDefineDirective";
        case SyntaxKind::EndIfDirective: return "EndIfDirective";
        case SyntaxKind::EndKeywordsDirective: return "EndKeywordsDirective";
        case SyntaxKind::EndProtectDirective: return "EndProtectDirective";
        case SyntaxKind::EndProtectedDirective: return "EndProtectedDirective";
        case SyntaxKind::EnumType: return "EnumType";
        case SyntaxKind::EqualityExpression: return "EqualityExpression";
        case SyntaxKind::EqualsAssertionArgClause: return "EqualsAssertionArgClause";
        case SyntaxKind::EqualsTypeClause: return "EqualsTypeClause";
        case SyntaxKind::EqualsValueClause: return "EqualsValueClause";
        case SyntaxKind::EventControl: return "EventControl";
        case SyntaxKind::EventControlWithExpression: return "EventControlWithExpression";
        case SyntaxKind::EventType: return "EventType";
        case SyntaxKind::ExpectPropertyStatement: return "ExpectPropertyStatement";
        case SyntaxKind::ExplicitAnsiPort: return "ExplicitAnsiPort";
        case SyntaxKind::ExplicitNonAnsiPort: return "ExplicitNonAnsiPort";
        case SyntaxKind::ExpressionConstraint: return "ExpressionConstraint";
        case SyntaxKind::ExpressionCoverageBinInitializer: return "ExpressionCoverageBinInitializer";
        case SyntaxKind::ExpressionOrDist: return "ExpressionOrDist";
        case SyntaxKind::ExpressionPattern: return "ExpressionPattern";
        case SyntaxKind::ExpressionStatement: return "ExpressionStatement";
        case SyntaxKind::ExpressionTimingCheckArg: return "ExpressionTimingCheckArg";
        case SyntaxKind::ExtendsClause: return "ExtendsClause";
        case SyntaxKind::ExternInterfaceMethod: return "ExternInterfaceMethod";
        case SyntaxKind::ExternModuleDecl: return "ExternModuleDecl";
        case SyntaxKind::ExternUdpDecl: return "ExternUdpDecl";
        case SyntaxKind::FilePathSpec: return "FilePathSpec";
        case SyntaxKind::FinalBlock: return "FinalBlock";
        case SyntaxKind::FirstMatchSequenceExpr: return "FirstMatchSequenceExpr";
        case SyntaxKind::FollowedByPropertyExpr: return "FollowedByPropertyExpr";
        case SyntaxKind::ForLoopStatement: return "ForLoopStatement";
        case SyntaxKind::ForVariableDeclaration: return "ForVariableDeclaration";
        case SyntaxKind::ForeachLoopList: return "ForeachLoopList";
        case SyntaxKind::ForeachLoopStatement: return "ForeachLoopStatement";
        case SyntaxKind::ForeverStatement: return "ForeverStatement";
        case SyntaxKind::ForwardTypeRestriction: return "ForwardTypeRestriction";
        case SyntaxKind::ForwardTypedefDeclaration: return "ForwardTypedefDeclaration";
        case SyntaxKind::FunctionDeclaration: return "FunctionDeclaration";
        case SyntaxKind::FunctionPort: return "FunctionPort";
        case SyntaxKind::FunctionPortList: return "FunctionPortList";
        case SyntaxKind::FunctionPrototype: return "FunctionPrototype";
        case SyntaxKind::GenerateBlock: return "GenerateBlock";
        case SyntaxKind::GenerateRegion: return "GenerateRegion";
        case SyntaxKind::GenvarDeclaration: return "GenvarDeclaration";
        case SyntaxKind::GreaterThanEqualExpression: return "GreaterThanEqualExpression";
        case SyntaxKind::GreaterThanExpression: return "GreaterThanExpression";
        case SyntaxKind::HierarchicalInstance: return "HierarchicalInstance";
        case SyntaxKind::HierarchyInstantiation: return "HierarchyInstantiation";
        case SyntaxKind::IdWithExprCoverageBinInitializer: return "IdWithExprCoverageBinInitializer";
        case SyntaxKind::IdentifierName: return "IdentifierName";
        case SyntaxKind::IdentifierSelectName: return "IdentifierSelectName";
        case SyntaxKind::IfDefDirective: return "IfDefDirective";
        case SyntaxKind::IfGenerate: return "IfGenerate";
        case SyntaxKind::IfNDefDirective: return "IfNDefDirective";
        case SyntaxKind::IfNonePathDeclaration: return "IfNonePathDeclaration";
        case SyntaxKind::IffEventClause: return "IffEventClause";
        case SyntaxKind::IffPropertyExpr: return "IffPropertyExpr";
        case SyntaxKind::ImmediateAssertStatement: return "ImmediateAssertStatement";
        case SyntaxKind::ImmediateAssertionMember: return "ImmediateAssertionMember";
        case SyntaxKind::ImmediateAssumeStatement: return "ImmediateAssumeStatement";
        case SyntaxKind::ImmediateCoverStatement: return "ImmediateCoverStatement";
        case SyntaxKind::ImplementsClause: return "ImplementsClause";
        case SyntaxKind::ImplicationConstraint: return "ImplicationConstraint";
        case SyntaxKind::ImplicationPropertyExpr: return "ImplicationPropertyExpr";
        case SyntaxKind::ImplicitAnsiPort: return "ImplicitAnsiPort";
        case SyntaxKind::ImplicitEventControl: return "ImplicitEventControl";
        case SyntaxKind::ImplicitNonAnsiPort: return "ImplicitNonAnsiPort";
        case SyntaxKind::ImplicitType: return "ImplicitType";
        case SyntaxKind::ImpliesPropertyExpr: return "ImpliesPropertyExpr";
        case SyntaxKind::IncludeDirective: return "IncludeDirective";
        case SyntaxKind::InequalityExpression: return "InequalityExpression";
        case SyntaxKind::InitialBlock: return "InitialBlock";
        case SyntaxKind::InsideExpression: return "InsideExpression";
        case SyntaxKind::InstanceConfigRule: return "InstanceConfigRule";
        case SyntaxKind::InstanceName: return "InstanceName";
        case SyntaxKind::IntType: return "IntType";
        case SyntaxKind::IntegerLiteralExpression: return "IntegerLiteralExpression";
        case SyntaxKind::IntegerType: return "IntegerType";
        case SyntaxKind::IntegerVectorExpression: return "IntegerVectorExpression";
        case SyntaxKind::InterfaceDeclaration: return "InterfaceDeclaration";
        case SyntaxKind::InterfaceHeader: return "InterfaceHeader";
        case SyntaxKind::InterfacePortHeader: return "InterfacePortHeader";
        case SyntaxKind::IntersectClause: return "IntersectClause";
        case SyntaxKind::IntersectSequenceExpr: return "IntersectSequenceExpr";
        case SyntaxKind::InvocationExpression: return "InvocationExpression";
        case SyntaxKind::JumpStatement: return "JumpStatement";
        case SyntaxKind::LessThanEqualExpression: return "LessThanEqualExpression";
        case SyntaxKind::LessThanExpression: return "LessThanExpression";
        case SyntaxKind::LetDeclaration: return "LetDeclaration";
        case SyntaxKind::LibraryDeclaration: return "LibraryDeclaration";
        case SyntaxKind::LibraryIncDirClause: return "LibraryIncDirClause";
        case SyntaxKind::LibraryIncludeStatement: return "LibraryIncludeStatement";
        case SyntaxKind::LibraryMap: return "LibraryMap";
        case SyntaxKind::LineDirective: return "LineDirective";
        case SyntaxKind::LocalScope: return "LocalScope";
        case SyntaxKind::LocalVariableDeclaration: return "LocalVariableDeclaration";
        case SyntaxKind::LogicType: return "LogicType";
        case SyntaxKind::LogicalAndExpression: return "LogicalAndExpression";
        case SyntaxKind::LogicalEquivalenceExpression: return "LogicalEquivalenceExpression";
        case SyntaxKind::LogicalImplicationExpression: return "LogicalImplicationExpression";
        case SyntaxKind::LogicalLeftShiftAssignmentExpression: return "LogicalLeftShiftAssignmentExpression";
        case SyntaxKind::LogicalOrExpression: return "LogicalOrExpression";
        case SyntaxKind::LogicalRightShiftAssignmentExpression: return "LogicalRightShiftAssignmentExpression";
        case SyntaxKind::LogicalShiftLeftExpression: return "LogicalShiftLeftExpression";
        case SyntaxKind::LogicalShiftRightExpression: return "LogicalShiftRightExpression";
        case SyntaxKind::LongIntType: return "LongIntType";
        case SyntaxKind::LoopConstraint: return "LoopConstraint";
        case SyntaxKind::LoopGenerate: return "LoopGenerate";
        case SyntaxKind::LoopStatement: return "LoopStatement";
        case SyntaxKind::MacroActualArgument: return "MacroActualArgument";
        case SyntaxKind::MacroActualArgumentList: return "MacroActualArgumentList";
        case SyntaxKind::MacroArgumentDefault: return "MacroArgumentDefault";
        case SyntaxKind::MacroFormalArgument: return "MacroFormalArgument";
        case SyntaxKind::MacroFormalArgumentList: return "MacroFormalArgumentList";
        case SyntaxKind::MacroUsage: return "MacroUsage";
        case SyntaxKind::MatchesClause: return "MatchesClause";
        case SyntaxKind::MemberAccessExpression: return "MemberAccessExpression";
        case SyntaxKind::MinTypMaxExpression: return "MinTypMaxExpression";
        case SyntaxKind::ModAssignmentExpression: return "ModAssignmentExpression";
        case SyntaxKind::ModExpression: return "ModExpression";
        case SyntaxKind::ModportClockingPort: return "ModportClockingPort";
        case SyntaxKind::ModportDeclaration: return "ModportDeclaration";
        case SyntaxKind::ModportExplicitPort: return "ModportExplicitPort";
        case SyntaxKind::ModportItem: return "ModportItem";
        case SyntaxKind::ModportNamedPort: return "ModportNamedPort";
        case SyntaxKind::ModportSimplePortList: return "ModportSimplePortList";
        case SyntaxKind::ModportSubroutinePort: return "ModportSubroutinePort";
        case SyntaxKind::ModportSubroutinePortList: return "ModportSubroutinePortList";
        case SyntaxKind::ModuleDeclaration: return "ModuleDeclaration";
        case SyntaxKind::ModuleHeader: return "ModuleHeader";
        case SyntaxKind::MultipleConcatenationExpression: return "MultipleConcatenationExpression";
        case SyntaxKind::MultiplyAssignmentExpression: return "MultiplyAssignmentExpression";
        case SyntaxKind::MultiplyExpression: return "MultiplyExpression";
        case SyntaxKind::NameValuePragmaExpression: return "NameValuePragmaExpression";
        case SyntaxKind::NamedArgument: return "NamedArgument";
        case SyntaxKind::NamedBlockClause: return "NamedBlockClause";
        case SyntaxKind::NamedConditionalDirectiveExpression: return "NamedConditionalDirectiveExpression";
        case SyntaxKind::NamedLabel: return "NamedLabel";
        case SyntaxKind::NamedParamAssignment: return "NamedParamAssignment";
        case SyntaxKind::NamedPortConnection: return "NamedPortConnection";
        case SyntaxKind::NamedStructurePatternMember: return "NamedStructurePatternMember";
        case SyntaxKind::NamedType: return "NamedType";
        case SyntaxKind::NetAlias: return "NetAlias";
        case SyntaxKind::NetDeclaration: return "NetDeclaration";
        case SyntaxKind::NetPortHeader: return "NetPortHeader";
        case SyntaxKind::NetTypeDeclaration: return "NetTypeDeclaration";
        case SyntaxKind::NewArrayExpression: return "NewArrayExpression";
        case SyntaxKind::NewClassExpression: return "NewClassExpression";
        case SyntaxKind::NoUnconnectedDriveDirective: return "NoUnconnectedDriveDirective";
        case SyntaxKind::NonAnsiPortList: return "NonAnsiPortList";
        case SyntaxKind::NonAnsiUdpPortList: return "NonAnsiUdpPortList";
        case SyntaxKind::NonblockingAssignmentExpression: return "NonblockingAssignmentExpression";
        case SyntaxKind::NonblockingEventTriggerStatement: return "NonblockingEventTriggerStatement";
        case SyntaxKind::NullLiteralExpression: return "NullLiteralExpression";
        case SyntaxKind::NumberPragmaExpression: return "NumberPragmaExpression";
        case SyntaxKind::OneStepDelay: return "OneStepDelay";
        case SyntaxKind::OrAssignmentExpression: return "OrAssignmentExpression";
        case SyntaxKind::OrPropertyExpr: return "OrPropertyExpr";
        case SyntaxKind::OrSequenceExpr: return "OrSequenceExpr";
        case SyntaxKind::OrderedArgument: return "OrderedArgument";
        case SyntaxKind::OrderedParamAssignment: return "OrderedParamAssignment";
        case SyntaxKind::OrderedPortConnection: return "OrderedPortConnection";
        case SyntaxKind::OrderedStructurePatternMember: return "OrderedStructurePatternMember";
        case SyntaxKind::PackageDeclaration: return "PackageDeclaration";
        case SyntaxKind::PackageExportAllDeclaration: return "PackageExportAllDeclaration";
        case SyntaxKind::PackageExportDeclaration: return "PackageExportDeclaration";
        case SyntaxKind::PackageHeader: return "PackageHeader";
        case SyntaxKind::PackageImportDeclaration: return "PackageImportDeclaration";
        case SyntaxKind::PackageImportItem: return "PackageImportItem";
        case SyntaxKind::ParallelBlockStatement: return "ParallelBlockStatement";
        case SyntaxKind::ParameterDeclaration: return "ParameterDeclaration";
        case SyntaxKind::ParameterDeclarationStatement: return "ParameterDeclarationStatement";
        case SyntaxKind::ParameterPortList: return "ParameterPortList";
        case SyntaxKind::ParameterValueAssignment: return "ParameterValueAssignment";
        case SyntaxKind::ParenExpressionList: return "ParenExpressionList";
        case SyntaxKind::ParenPragmaExpression: return "ParenPragmaExpression";
        case SyntaxKind::ParenthesizedBinsSelectExpr: return "ParenthesizedBinsSelectExpr";
        case SyntaxKind::ParenthesizedConditionalDirectiveExpression: return "ParenthesizedConditionalDirectiveExpression";
        case SyntaxKind::ParenthesizedEventExpression: return "ParenthesizedEventExpression";
        case SyntaxKind::ParenthesizedExpression: return "ParenthesizedExpression";
        case SyntaxKind::ParenthesizedPattern: return "ParenthesizedPattern";
        case SyntaxKind::ParenthesizedPropertyExpr: return "ParenthesizedPropertyExpr";
        case SyntaxKind::ParenthesizedSequenceExpr: return "ParenthesizedSequenceExpr";
        case SyntaxKind::PathDeclaration: return "PathDeclaration";
        case SyntaxKind::PathDescription: return "PathDescription";
        case SyntaxKind::PatternCaseItem: return "PatternCaseItem";
        case SyntaxKind::PortConcatenation: return "PortConcatenation";
        case SyntaxKind::PortDeclaration: return "PortDeclaration";
        case SyntaxKind::PortReference: return "PortReference";
        case SyntaxKind::PostdecrementExpression: return "PostdecrementExpression";
        case SyntaxKind::PostincrementExpression: return "PostincrementExpression";
        case SyntaxKind::PowerExpression: return "PowerExpression";
        case SyntaxKind::PragmaDirective: return "PragmaDirective";
        case SyntaxKind::PrimaryBlockEventExpression: return "PrimaryBlockEventExpression";
        case SyntaxKind::PrimitiveInstantiation: return "PrimitiveInstantiation";
        case SyntaxKind::ProceduralAssignStatement: return "ProceduralAssignStatement";
        case SyntaxKind::ProceduralDeassignStatement: return "ProceduralDeassignStatement";
        case SyntaxKind::ProceduralForceStatement: return "ProceduralForceStatement";
        case SyntaxKind::ProceduralReleaseStatement: return "ProceduralReleaseStatement";
        case SyntaxKind::Production: return "Production";
        case SyntaxKind::ProgramDeclaration: return "ProgramDeclaration";
        case SyntaxKind::ProgramHeader: return "ProgramHeader";
        case SyntaxKind::PropertyDeclaration: return "PropertyDeclaration";
        case SyntaxKind::PropertySpec: return "PropertySpec";
        case SyntaxKind::PropertyType: return "PropertyType";
        case SyntaxKind::ProtectDirective: return "ProtectDirective";
        case SyntaxKind::ProtectedDirective: return "ProtectedDirective";
        case SyntaxKind::PullStrength: return "PullStrength";
        case SyntaxKind::PulseStyleDeclaration: return "PulseStyleDeclaration";
        case SyntaxKind::QueueDimensionSpecifier: return "QueueDimensionSpecifier";
        case SyntaxKind::RandCaseItem: return "RandCaseItem";
        case SyntaxKind::RandCaseStatement: return "RandCaseStatement";
        case SyntaxKind::RandJoinClause: return "RandJoinClause";
        case SyntaxKind::RandSequenceStatement: return "RandSequenceStatement";
        case SyntaxKind::RangeCoverageBinInitializer: return "RangeCoverageBinInitializer";
        case SyntaxKind::RangeDimensionSpecifier: return "RangeDimensionSpecifier";
        case SyntaxKind::RangeList: return "RangeList";
        case SyntaxKind::RealLiteralExpression: return "RealLiteralExpression";
        case SyntaxKind::RealTimeType: return "RealTimeType";
        case SyntaxKind::RealType: return "RealType";
        case SyntaxKind::RegType: return "RegType";
        case SyntaxKind::RepeatedEventControl: return "RepeatedEventControl";
        case SyntaxKind::ReplicatedAssignmentPattern: return "ReplicatedAssignmentPattern";
        case SyntaxKind::ResetAllDirective: return "ResetAllDirective";
        case SyntaxKind::RestrictPropertyStatement: return "RestrictPropertyStatement";
        case SyntaxKind::ReturnStatement: return "ReturnStatement";
        case SyntaxKind::RootScope: return "RootScope";
        case SyntaxKind::RsCase: return "RsCase";
        case SyntaxKind::RsCodeBlock: return "RsCodeBlock";
        case SyntaxKind::RsElseClause: return "RsElseClause";
        case SyntaxKind::RsIfElse: return "RsIfElse";
        case SyntaxKind::RsProdItem: return "RsProdItem";
        case SyntaxKind::RsRepeat: return "RsRepeat";
        case SyntaxKind::RsRule: return "RsRule";
        case SyntaxKind::RsWeightClause: return "RsWeightClause";
        case SyntaxKind::SUntilPropertyExpr: return "SUntilPropertyExpr";
        case SyntaxKind::SUntilWithPropertyExpr: return "SUntilWithPropertyExpr";
        case SyntaxKind::ScopedName: return "ScopedName";
        case SyntaxKind::SequenceDeclaration: return "SequenceDeclaration";
        case SyntaxKind::SequenceMatchList: return "SequenceMatchList";
        case SyntaxKind::SequenceRepetition: return "SequenceRepetition";
        case SyntaxKind::SequenceType: return "SequenceType";
        case SyntaxKind::SequentialBlockStatement: return "SequentialBlockStatement";
        case SyntaxKind::ShortIntType: return "ShortIntType";
        case SyntaxKind::ShortRealType: return "ShortRealType";
        case SyntaxKind::SignalEventExpression: return "SignalEventExpression";
        case SyntaxKind::SignedCastExpression: return "SignedCastExpression";
        case SyntaxKind::SimpleAssignmentPattern: return "SimpleAssignmentPattern";
        case SyntaxKind::SimpleBinsSelectExpr: return "SimpleBinsSelectExpr";
        case SyntaxKind::SimplePathSuffix: return "SimplePathSuffix";
        case SyntaxKind::SimplePragmaExpression: return "SimplePragmaExpression";
        case SyntaxKind::SimplePropertyExpr: return "SimplePropertyExpr";
        case SyntaxKind::SimpleRangeSelect: return "SimpleRangeSelect";
        case SyntaxKind::SimpleSequenceExpr: return "SimpleSequenceExpr";
        case SyntaxKind::SolveBeforeConstraint: return "SolveBeforeConstraint";
        case SyntaxKind::SpecifyBlock: return "SpecifyBlock";
        case SyntaxKind::SpecparamDeclaration: return "SpecparamDeclaration";
        case SyntaxKind::SpecparamDeclarator: return "SpecparamDeclarator";
        case SyntaxKind::StandardCaseItem: return "StandardCaseItem";
        case SyntaxKind::StandardPropertyCaseItem: return "StandardPropertyCaseItem";
        case SyntaxKind::StandardRsCaseItem: return "StandardRsCaseItem";
        case SyntaxKind::StreamExpression: return "StreamExpression";
        case SyntaxKind::StreamExpressionWithRange: return "StreamExpressionWithRange";
        case SyntaxKind::StreamingConcatenationExpression: return "StreamingConcatenationExpression";
        case SyntaxKind::StringLiteralExpression: return "StringLiteralExpression";
        case SyntaxKind::StringType: return "StringType";
        case SyntaxKind::StrongWeakPropertyExpr: return "StrongWeakPropertyExpr";
        case SyntaxKind::StructType: return "StructType";
        case SyntaxKind::StructUnionMember: return "StructUnionMember";
        case SyntaxKind::StructurePattern: return "StructurePattern";
        case SyntaxKind::StructuredAssignmentPattern: return "StructuredAssignmentPattern";
        case SyntaxKind::SubtractAssignmentExpression: return "SubtractAssignmentExpression";
        case SyntaxKind::SubtractExpression: return "SubtractExpression";
        case SyntaxKind::SuperHandle: return "SuperHandle";
        case SyntaxKind::SuperNewDefaultedArgsExpression: return "SuperNewDefaultedArgsExpression";
        case SyntaxKind::SystemName: return "SystemName";
        case SyntaxKind::SystemTimingCheck: return "SystemTimingCheck";
        case SyntaxKind::TaggedPattern: return "TaggedPattern";
        case SyntaxKind::TaggedUnionExpression: return "TaggedUnionExpression";
        case SyntaxKind::TaskDeclaration: return "TaskDeclaration";
        case SyntaxKind::ThisHandle: return "ThisHandle";
        case SyntaxKind::ThroughoutSequenceExpr: return "ThroughoutSequenceExpr";
        case SyntaxKind::TimeLiteralExpression: return "TimeLiteralExpression";
        case SyntaxKind::TimeScaleDirective: return "TimeScaleDirective";
        case SyntaxKind::TimeType: return "TimeType";
        case SyntaxKind::TimeUnitsDeclaration: return "TimeUnitsDeclaration";
        case SyntaxKind::TimingCheckEventArg: return "TimingCheckEventArg";
        case SyntaxKind::TimingCheckEventCondition: return "TimingCheckEventCondition";
        case SyntaxKind::TimingControlExpression: return "TimingControlExpression";
        case SyntaxKind::TimingControlStatement: return "TimingControlStatement";
        case SyntaxKind::TransListCoverageBinInitializer: return "TransListCoverageBinInitializer";
        case SyntaxKind::TransRange: return "TransRange";
        case SyntaxKind::TransRepeatRange: return "TransRepeatRange";
        case SyntaxKind::TransSet: return "TransSet";
        case SyntaxKind::TypeAssignment: return "TypeAssignment";
        case SyntaxKind::TypeParameterDeclaration: return "TypeParameterDeclaration";
        case SyntaxKind::TypeReference: return "TypeReference";
        case SyntaxKind::TypedefDeclaration: return "TypedefDeclaration";
        case SyntaxKind::UdpBody: return "UdpBody";
        case SyntaxKind::UdpDeclaration: return "UdpDeclaration";
        case SyntaxKind::UdpEdgeField: return "UdpEdgeField";
        case SyntaxKind::UdpEntry: return "UdpEntry";
        case SyntaxKind::UdpInitialStmt: return "UdpInitialStmt";
        case SyntaxKind::UdpInputPortDecl: return "UdpInputPortDecl";
        case SyntaxKind::UdpOutputPortDecl: return "UdpOutputPortDecl";
        case SyntaxKind::UdpSimpleField: return "UdpSimpleField";
        case SyntaxKind::UnaryBinsSelectExpr: return "UnaryBinsSelectExpr";
        case SyntaxKind::UnaryBitwiseAndExpression: return "UnaryBitwiseAndExpression";
        case SyntaxKind::UnaryBitwiseNandExpression: return "UnaryBitwiseNandExpression";
        case SyntaxKind::UnaryBitwiseNorExpression: return "UnaryBitwiseNorExpression";
        case SyntaxKind::UnaryBitwiseNotExpression: return "UnaryBitwiseNotExpression";
        case SyntaxKind::UnaryBitwiseOrExpression: return "UnaryBitwiseOrExpression";
        case SyntaxKind::UnaryBitwiseXnorExpression: return "UnaryBitwiseXnorExpression";
        case SyntaxKind::UnaryBitwiseXorExpression: return "UnaryBitwiseXorExpression";
        case SyntaxKind::UnaryConditionalDirectiveExpression: return "UnaryConditionalDirectiveExpression";
        case SyntaxKind::UnaryLogicalNotExpression: return "UnaryLogicalNotExpression";
        case SyntaxKind::UnaryMinusExpression: return "UnaryMinusExpression";
        case SyntaxKind::UnaryPlusExpression: return "UnaryPlusExpression";
        case SyntaxKind::UnaryPredecrementExpression: return "UnaryPredecrementExpression";
        case SyntaxKind::UnaryPreincrementExpression: return "UnaryPreincrementExpression";
        case SyntaxKind::UnaryPropertyExpr: return "UnaryPropertyExpr";
        case SyntaxKind::UnarySelectPropertyExpr: return "UnarySelectPropertyExpr";
        case SyntaxKind::UnbasedUnsizedLiteralExpression: return "UnbasedUnsizedLiteralExpression";
        case SyntaxKind::UnconnectedDriveDirective: return "UnconnectedDriveDirective";
        case SyntaxKind::UndefDirective: return "UndefDirective";
        case SyntaxKind::UndefineAllDirective: return "UndefineAllDirective";
        case SyntaxKind::UnionType: return "UnionType";
        case SyntaxKind::UniquenessConstraint: return "UniquenessConstraint";
        case SyntaxKind::UnitScope: return "UnitScope";
        case SyntaxKind::UntilPropertyExpr: return "UntilPropertyExpr";
        case SyntaxKind::UntilWithPropertyExpr: return "UntilWithPropertyExpr";
        case SyntaxKind::Untyped: return "Untyped";
        case SyntaxKind::UserDefinedNetDeclaration: return "UserDefinedNetDeclaration";
        case SyntaxKind::ValueRangeExpression: return "ValueRangeExpression";
        case SyntaxKind::VariableDimension: return "VariableDimension";
        case SyntaxKind::VariablePattern: return "VariablePattern";
        case SyntaxKind::VariablePortHeader: return "VariablePortHeader";
        case SyntaxKind::VirtualInterfaceType: return "VirtualInterfaceType";
        case SyntaxKind::VoidCastedCallStatement: return "VoidCastedCallStatement";
        case SyntaxKind::VoidType: return "VoidType";
        case SyntaxKind::WaitForkStatement: return "WaitForkStatement";
        case SyntaxKind::WaitOrderStatement: return "WaitOrderStatement";
        case SyntaxKind::WaitStatement: return "WaitStatement";
        case SyntaxKind::WildcardDimensionSpecifier: return "WildcardDimensionSpecifier";
        case SyntaxKind::WildcardEqualityExpression: return "WildcardEqualityExpression";
        case SyntaxKind::WildcardInequalityExpression: return "WildcardInequalityExpression";
        case SyntaxKind::WildcardLiteralExpression: return "WildcardLiteralExpression";
        case SyntaxKind::WildcardPattern: return "WildcardPattern";
        case SyntaxKind::WildcardPortConnection: return "WildcardPortConnection";
        case SyntaxKind::WildcardPortList: return "WildcardPortList";
        case SyntaxKind::WildcardUdpPortList: return "WildcardUdpPortList";
        case SyntaxKind::WithClause: return "WithClause";
        case SyntaxKind::WithFunctionClause: return "WithFunctionClause";
        case SyntaxKind::WithFunctionSample: return "WithFunctionSample";
        case SyntaxKind::WithinSequenceExpr: return "WithinSequenceExpr";
        case SyntaxKind::XorAssignmentExpression: return "XorAssignmentExpression";
        default: return "";
    }
}

decltype(SyntaxKind_traits::values) SyntaxKind_traits::values = {
    SyntaxKind::Unknown,
    SyntaxKind::SyntaxList,
    SyntaxKind::TokenList,
    SyntaxKind::SeparatedList,
    SyntaxKind::AcceptOnPropertyExpr,
    SyntaxKind::ActionBlock,
    SyntaxKind::AddAssignmentExpression,
    SyntaxKind::AddExpression,
    SyntaxKind::AlwaysBlock,
    SyntaxKind::AlwaysCombBlock,
    SyntaxKind::AlwaysFFBlock,
    SyntaxKind::AlwaysLatchBlock,
    SyntaxKind::AndAssignmentExpression,
    SyntaxKind::AndPropertyExpr,
    SyntaxKind::AndSequenceExpr,
    SyntaxKind::AnonymousProgram,
    SyntaxKind::AnsiPortList,
    SyntaxKind::AnsiUdpPortList,
    SyntaxKind::ArgumentList,
    SyntaxKind::ArithmeticLeftShiftAssignmentExpression,
    SyntaxKind::ArithmeticRightShiftAssignmentExpression,
    SyntaxKind::ArithmeticShiftLeftExpression,
    SyntaxKind::ArithmeticShiftRightExpression,
    SyntaxKind::ArrayAndMethod,
    SyntaxKind::ArrayOrMethod,
    SyntaxKind::ArrayOrRandomizeMethodExpression,
    SyntaxKind::ArrayUniqueMethod,
    SyntaxKind::ArrayXorMethod,
    SyntaxKind::AscendingRangeSelect,
    SyntaxKind::AssertPropertyStatement,
    SyntaxKind::AssertionItemPort,
    SyntaxKind::AssertionItemPortList,
    SyntaxKind::AssignmentExpression,
    SyntaxKind::AssignmentPatternExpression,
    SyntaxKind::AssignmentPatternItem,
    SyntaxKind::AssumePropertyStatement,
    SyntaxKind::AttributeInstance,
    SyntaxKind::AttributeSpec,
    SyntaxKind::BadExpression,
    SyntaxKind::BeginKeywordsDirective,
    SyntaxKind::BinSelectWithFilterExpr,
    SyntaxKind::BinaryAndExpression,
    SyntaxKind::BinaryBinsSelectExpr,
    SyntaxKind::BinaryBlockEventExpression,
    SyntaxKind::BinaryConditionalDirectiveExpression,
    SyntaxKind::BinaryEventExpression,
    SyntaxKind::BinaryOrExpression,
    SyntaxKind::BinaryXnorExpression,
    SyntaxKind::BinaryXorExpression,
    SyntaxKind::BindDirective,
    SyntaxKind::BindTargetList,
    SyntaxKind::BinsSelectConditionExpr,
    SyntaxKind::BinsSelection,
    SyntaxKind::BitSelect,
    SyntaxKind::BitType,
    SyntaxKind::BlockCoverageEvent,
    SyntaxKind::BlockingEventTriggerStatement,
    SyntaxKind::ByteType,
    SyntaxKind::CHandleType,
    SyntaxKind::CaseEqualityExpression,
    SyntaxKind::CaseGenerate,
    SyntaxKind::CaseInequalityExpression,
    SyntaxKind::CasePropertyExpr,
    SyntaxKind::CaseStatement,
    SyntaxKind::CastExpression,
    SyntaxKind::CellConfigRule,
    SyntaxKind::CellDefineDirective,
    SyntaxKind::ChargeStrength,
    SyntaxKind::CheckerDataDeclaration,
    SyntaxKind::CheckerDeclaration,
    SyntaxKind::CheckerInstanceStatement,
    SyntaxKind::CheckerInstantiation,
    SyntaxKind::ClassDeclaration,
    SyntaxKind::ClassMethodDeclaration,
    SyntaxKind::ClassMethodPrototype,
    SyntaxKind::ClassName,
    SyntaxKind::ClassPropertyDeclaration,
    SyntaxKind::ClassSpecifier,
    SyntaxKind::ClockingDeclaration,
    SyntaxKind::ClockingDirection,
    SyntaxKind::ClockingItem,
    SyntaxKind::ClockingPropertyExpr,
    SyntaxKind::ClockingSequenceExpr,
    SyntaxKind::ClockingSkew,
    SyntaxKind::ColonExpressionClause,
    SyntaxKind::CompilationUnit,
    SyntaxKind::ConcatenationExpression,
    SyntaxKind::ConcurrentAssertionMember,
    SyntaxKind::ConditionalConstraint,
    SyntaxKind::ConditionalExpression,
    SyntaxKind::ConditionalPathDeclaration,
    SyntaxKind::ConditionalPattern,
    SyntaxKind::ConditionalPredicate,
    SyntaxKind::ConditionalPropertyExpr,
    SyntaxKind::ConditionalStatement,
    SyntaxKind::ConfigCellIdentifier,
    SyntaxKind::ConfigDeclaration,
    SyntaxKind::ConfigInstanceIdentifier,
    SyntaxKind::ConfigLiblist,
    SyntaxKind::ConfigUseClause,
    SyntaxKind::ConstraintBlock,
    SyntaxKind::ConstraintDeclaration,
    SyntaxKind::ConstraintPrototype,
    SyntaxKind::ConstructorName,
    SyntaxKind::ContinuousAssign,
    SyntaxKind::CopyClassExpression,
    SyntaxKind::CoverCross,
    SyntaxKind::CoverPropertyStatement,
    SyntaxKind::CoverSequenceStatement,
    SyntaxKind::CoverageBins,
    SyntaxKind::CoverageBinsArraySize,
    SyntaxKind::CoverageIffClause,
    SyntaxKind::CoverageOption,
    SyntaxKind::CovergroupDeclaration,
    SyntaxKind::Coverpoint,
    SyntaxKind::CycleDelay,
    SyntaxKind::DPIExport,
    SyntaxKind::DPIImport,
    SyntaxKind::DataDeclaration,
    SyntaxKind::Declarator,
    SyntaxKind::DefParam,
    SyntaxKind::DefParamAssignment,
    SyntaxKind::DefaultCaseItem,
    SyntaxKind::DefaultClockingReference,
    SyntaxKind::DefaultConfigRule,
    SyntaxKind::DefaultCoverageBinInitializer,
    SyntaxKind::DefaultDecayTimeDirective,
    SyntaxKind::DefaultDisableDeclaration,
    SyntaxKind::DefaultDistItem,
    SyntaxKind::DefaultExtendsClauseArg,
    SyntaxKind::DefaultFunctionPort,
    SyntaxKind::DefaultNetTypeDirective,
    SyntaxKind::DefaultPatternKeyExpression,
    SyntaxKind::DefaultPropertyCaseItem,
    SyntaxKind::DefaultRsCaseItem,
    SyntaxKind::DefaultSkewItem,
    SyntaxKind::DefaultTriregStrengthDirective,
    SyntaxKind::DeferredAssertion,
    SyntaxKind::DefineDirective,
    SyntaxKind::Delay3,
    SyntaxKind::DelayControl,
    SyntaxKind::DelayModeDistributedDirective,
    SyntaxKind::DelayModePathDirective,
    SyntaxKind::DelayModeUnitDirective,
    SyntaxKind::DelayModeZeroDirective,
    SyntaxKind::DelayedSequenceElement,
    SyntaxKind::DelayedSequenceExpr,
    SyntaxKind::DescendingRangeSelect,
    SyntaxKind::DisableConstraint,
    SyntaxKind::DisableForkStatement,
    SyntaxKind::DisableIff,
    SyntaxKind::DisableStatement,
    SyntaxKind::DistConstraintList,
    SyntaxKind::DistItem,
    SyntaxKind::DistWeight,
    SyntaxKind::DivideAssignmentExpression,
    SyntaxKind::DivideExpression,
    SyntaxKind::DividerClause,
    SyntaxKind::DoWhileStatement,
    SyntaxKind::DotMemberClause,
    SyntaxKind::DriveStrength,
    SyntaxKind::EdgeControlSpecifier,
    SyntaxKind::EdgeDescriptor,
    SyntaxKind::EdgeSensitivePathSuffix,
    SyntaxKind::ElabSystemTask,
    SyntaxKind::ElementSelect,
    SyntaxKind::ElementSelectExpression,
    SyntaxKind::ElsIfDirective,
    SyntaxKind::ElseClause,
    SyntaxKind::ElseConstraintClause,
    SyntaxKind::ElseDirective,
    SyntaxKind::ElsePropertyClause,
    SyntaxKind::EmptyArgument,
    SyntaxKind::EmptyIdentifierName,
    SyntaxKind::EmptyMember,
    SyntaxKind::EmptyNonAnsiPort,
    SyntaxKind::EmptyPortConnection,
    SyntaxKind::EmptyQueueExpression,
    SyntaxKind::EmptyStatement,
    SyntaxKind::EmptyTimingCheckArg,
    SyntaxKind::EndCellDefineDirective,
    SyntaxKind::EndIfDirective,
    SyntaxKind::EndKeywordsDirective,
    SyntaxKind::EndProtectDirective,
    SyntaxKind::EndProtectedDirective,
    SyntaxKind::EnumType,
    SyntaxKind::EqualityExpression,
    SyntaxKind::EqualsAssertionArgClause,
    SyntaxKind::EqualsTypeClause,
    SyntaxKind::EqualsValueClause,
    SyntaxKind::EventControl,
    SyntaxKind::EventControlWithExpression,
    SyntaxKind::EventType,
    SyntaxKind::ExpectPropertyStatement,
    SyntaxKind::ExplicitAnsiPort,
    SyntaxKind::ExplicitNonAnsiPort,
    SyntaxKind::ExpressionConstraint,
    SyntaxKind::ExpressionCoverageBinInitializer,
    SyntaxKind::ExpressionOrDist,
    SyntaxKind::ExpressionPattern,
    SyntaxKind::ExpressionStatement,
    SyntaxKind::ExpressionTimingCheckArg,
    SyntaxKind::ExtendsClause,
    SyntaxKind::ExternInterfaceMethod,
    SyntaxKind::ExternModuleDecl,
    SyntaxKind::ExternUdpDecl,
    SyntaxKind::FilePathSpec,
    SyntaxKind::FinalBlock,
    SyntaxKind::FirstMatchSequenceExpr,
    SyntaxKind::FollowedByPropertyExpr,
    SyntaxKind::ForLoopStatement,
    SyntaxKind::ForVariableDeclaration,
    SyntaxKind::ForeachLoopList,
    SyntaxKind::ForeachLoopStatement,
    SyntaxKind::ForeverStatement,
    SyntaxKind::ForwardTypeRestriction,
    SyntaxKind::ForwardTypedefDeclaration,
    SyntaxKind::FunctionDeclaration,
    SyntaxKind::FunctionPort,
    SyntaxKind::FunctionPortList,
    SyntaxKind::FunctionPrototype,
    SyntaxKind::GenerateBlock,
    SyntaxKind::GenerateRegion,
    SyntaxKind::GenvarDeclaration,
    SyntaxKind::GreaterThanEqualExpression,
    SyntaxKind::GreaterThanExpression,
    SyntaxKind::HierarchicalInstance,
    SyntaxKind::HierarchyInstantiation,
    SyntaxKind::IdWithExprCoverageBinInitializer,
    SyntaxKind::IdentifierName,
    SyntaxKind::IdentifierSelectName,
    SyntaxKind::IfDefDirective,
    SyntaxKind::IfGenerate,
    SyntaxKind::IfNDefDirective,
    SyntaxKind::IfNonePathDeclaration,
    SyntaxKind::IffEventClause,
    SyntaxKind::IffPropertyExpr,
    SyntaxKind::ImmediateAssertStatement,
    SyntaxKind::ImmediateAssertionMember,
    SyntaxKind::ImmediateAssumeStatement,
    SyntaxKind::ImmediateCoverStatement,
    SyntaxKind::ImplementsClause,
    SyntaxKind::ImplicationConstraint,
    SyntaxKind::ImplicationPropertyExpr,
    SyntaxKind::ImplicitAnsiPort,
    SyntaxKind::ImplicitEventControl,
    SyntaxKind::ImplicitNonAnsiPort,
    SyntaxKind::ImplicitType,
    SyntaxKind::ImpliesPropertyExpr,
    SyntaxKind::IncludeDirective,
    SyntaxKind::InequalityExpression,
    SyntaxKind::InitialBlock,
    SyntaxKind::InsideExpression,
    SyntaxKind::InstanceConfigRule,
    SyntaxKind::InstanceName,
    SyntaxKind::IntType,
    SyntaxKind::IntegerLiteralExpression,
    SyntaxKind::IntegerType,
    SyntaxKind::IntegerVectorExpression,
    SyntaxKind::InterfaceDeclaration,
    SyntaxKind::InterfaceHeader,
    SyntaxKind::InterfacePortHeader,
    SyntaxKind::IntersectClause,
    SyntaxKind::IntersectSequenceExpr,
    SyntaxKind::InvocationExpression,
    SyntaxKind::JumpStatement,
    SyntaxKind::LessThanEqualExpression,
    SyntaxKind::LessThanExpression,
    SyntaxKind::LetDeclaration,
    SyntaxKind::LibraryDeclaration,
    SyntaxKind::LibraryIncDirClause,
    SyntaxKind::LibraryIncludeStatement,
    SyntaxKind::LibraryMap,
    SyntaxKind::LineDirective,
    SyntaxKind::LocalScope,
    SyntaxKind::LocalVariableDeclaration,
    SyntaxKind::LogicType,
    SyntaxKind::LogicalAndExpression,
    SyntaxKind::LogicalEquivalenceExpression,
    SyntaxKind::LogicalImplicationExpression,
    SyntaxKind::LogicalLeftShiftAssignmentExpression,
    SyntaxKind::LogicalOrExpression,
    SyntaxKind::LogicalRightShiftAssignmentExpression,
    SyntaxKind::LogicalShiftLeftExpression,
    SyntaxKind::LogicalShiftRightExpression,
    SyntaxKind::LongIntType,
    SyntaxKind::LoopConstraint,
    SyntaxKind::LoopGenerate,
    SyntaxKind::LoopStatement,
    SyntaxKind::MacroActualArgument,
    SyntaxKind::MacroActualArgumentList,
    SyntaxKind::MacroArgumentDefault,
    SyntaxKind::MacroFormalArgument,
    SyntaxKind::MacroFormalArgumentList,
    SyntaxKind::MacroUsage,
    SyntaxKind::MatchesClause,
    SyntaxKind::MemberAccessExpression,
    SyntaxKind::MinTypMaxExpression,
    SyntaxKind::ModAssignmentExpression,
    SyntaxKind::ModExpression,
    SyntaxKind::ModportClockingPort,
    SyntaxKind::ModportDeclaration,
    SyntaxKind::ModportExplicitPort,
    SyntaxKind::ModportItem,
    SyntaxKind::ModportNamedPort,
    SyntaxKind::ModportSimplePortList,
    SyntaxKind::ModportSubroutinePort,
    SyntaxKind::ModportSubroutinePortList,
    SyntaxKind::ModuleDeclaration,
    SyntaxKind::ModuleHeader,
    SyntaxKind::MultipleConcatenationExpression,
    SyntaxKind::MultiplyAssignmentExpression,
    SyntaxKind::MultiplyExpression,
    SyntaxKind::NameValuePragmaExpression,
    SyntaxKind::NamedArgument,
    SyntaxKind::NamedBlockClause,
    SyntaxKind::NamedConditionalDirectiveExpression,
    SyntaxKind::NamedLabel,
    SyntaxKind::NamedParamAssignment,
    SyntaxKind::NamedPortConnection,
    SyntaxKind::NamedStructurePatternMember,
    SyntaxKind::NamedType,
    SyntaxKind::NetAlias,
    SyntaxKind::NetDeclaration,
    SyntaxKind::NetPortHeader,
    SyntaxKind::NetTypeDeclaration,
    SyntaxKind::NewArrayExpression,
    SyntaxKind::NewClassExpression,
    SyntaxKind::NoUnconnectedDriveDirective,
    SyntaxKind::NonAnsiPortList,
    SyntaxKind::NonAnsiUdpPortList,
    SyntaxKind::NonblockingAssignmentExpression,
    SyntaxKind::NonblockingEventTriggerStatement,
    SyntaxKind::NullLiteralExpression,
    SyntaxKind::NumberPragmaExpression,
    SyntaxKind::OneStepDelay,
    SyntaxKind::OrAssignmentExpression,
    SyntaxKind::OrPropertyExpr,
    SyntaxKind::OrSequenceExpr,
    SyntaxKind::OrderedArgument,
    SyntaxKind::OrderedParamAssignment,
    SyntaxKind::OrderedPortConnection,
    SyntaxKind::OrderedStructurePatternMember,
    SyntaxKind::PackageDeclaration,
    SyntaxKind::PackageExportAllDeclaration,
    SyntaxKind::PackageExportDeclaration,
    SyntaxKind::PackageHeader,
    SyntaxKind::PackageImportDeclaration,
    SyntaxKind::PackageImportItem,
    SyntaxKind::ParallelBlockStatement,
    SyntaxKind::ParameterDeclaration,
    SyntaxKind::ParameterDeclarationStatement,
    SyntaxKind::ParameterPortList,
    SyntaxKind::ParameterValueAssignment,
    SyntaxKind::ParenExpressionList,
    SyntaxKind::ParenPragmaExpression,
    SyntaxKind::ParenthesizedBinsSelectExpr,
    SyntaxKind::ParenthesizedConditionalDirectiveExpression,
    SyntaxKind::ParenthesizedEventExpression,
    SyntaxKind::ParenthesizedExpression,
    SyntaxKind::ParenthesizedPattern,
    SyntaxKind::ParenthesizedPropertyExpr,
    SyntaxKind::ParenthesizedSequenceExpr,
    SyntaxKind::PathDeclaration,
    SyntaxKind::PathDescription,
    SyntaxKind::PatternCaseItem,
    SyntaxKind::PortConcatenation,
    SyntaxKind::PortDeclaration,
    SyntaxKind::PortReference,
    SyntaxKind::PostdecrementExpression,
    SyntaxKind::PostincrementExpression,
    SyntaxKind::PowerExpression,
    SyntaxKind::PragmaDirective,
    SyntaxKind::PrimaryBlockEventExpression,
    SyntaxKind::PrimitiveInstantiation,
    SyntaxKind::ProceduralAssignStatement,
    SyntaxKind::ProceduralDeassignStatement,
    SyntaxKind::ProceduralForceStatement,
    SyntaxKind::ProceduralReleaseStatement,
    SyntaxKind::Production,
    SyntaxKind::ProgramDeclaration,
    SyntaxKind::ProgramHeader,
    SyntaxKind::PropertyDeclaration,
    SyntaxKind::PropertySpec,
    SyntaxKind::PropertyType,
    SyntaxKind::ProtectDirective,
    SyntaxKind::ProtectedDirective,
    SyntaxKind::PullStrength,
    SyntaxKind::PulseStyleDeclaration,
    SyntaxKind::QueueDimensionSpecifier,
    SyntaxKind::RandCaseItem,
    SyntaxKind::RandCaseStatement,
    SyntaxKind::RandJoinClause,
    SyntaxKind::RandSequenceStatement,
    SyntaxKind::RangeCoverageBinInitializer,
    SyntaxKind::RangeDimensionSpecifier,
    SyntaxKind::RangeList,
    SyntaxKind::RealLiteralExpression,
    SyntaxKind::RealTimeType,
    SyntaxKind::RealType,
    SyntaxKind::RegType,
    SyntaxKind::RepeatedEventControl,
    SyntaxKind::ReplicatedAssignmentPattern,
    SyntaxKind::ResetAllDirective,
    SyntaxKind::RestrictPropertyStatement,
    SyntaxKind::ReturnStatement,
    SyntaxKind::RootScope,
    SyntaxKind::RsCase,
    SyntaxKind::RsCodeBlock,
    SyntaxKind::RsElseClause,
    SyntaxKind::RsIfElse,
    SyntaxKind::RsProdItem,
    SyntaxKind::RsRepeat,
    SyntaxKind::RsRule,
    SyntaxKind::RsWeightClause,
    SyntaxKind::SUntilPropertyExpr,
    SyntaxKind::SUntilWithPropertyExpr,
    SyntaxKind::ScopedName,
    SyntaxKind::SequenceDeclaration,
    SyntaxKind::SequenceMatchList,
    SyntaxKind::SequenceRepetition,
    SyntaxKind::SequenceType,
    SyntaxKind::SequentialBlockStatement,
    SyntaxKind::ShortIntType,
    SyntaxKind::ShortRealType,
    SyntaxKind::SignalEventExpression,
    SyntaxKind::SignedCastExpression,
    SyntaxKind::SimpleAssignmentPattern,
    SyntaxKind::SimpleBinsSelectExpr,
    SyntaxKind::SimplePathSuffix,
    SyntaxKind::SimplePragmaExpression,
    SyntaxKind::SimplePropertyExpr,
    SyntaxKind::SimpleRangeSelect,
    SyntaxKind::SimpleSequenceExpr,
    SyntaxKind::SolveBeforeConstraint,
    SyntaxKind::SpecifyBlock,
    SyntaxKind::SpecparamDeclaration,
    SyntaxKind::SpecparamDeclarator,
    SyntaxKind::StandardCaseItem,
    SyntaxKind::StandardPropertyCaseItem,
    SyntaxKind::StandardRsCaseItem,
    SyntaxKind::StreamExpression,
    SyntaxKind::StreamExpressionWithRange,
    SyntaxKind::StreamingConcatenationExpression,
    SyntaxKind::StringLiteralExpression,
    SyntaxKind::StringType,
    SyntaxKind::StrongWeakPropertyExpr,
    SyntaxKind::StructType,
    SyntaxKind::StructUnionMember,
    SyntaxKind::StructurePattern,
    SyntaxKind::StructuredAssignmentPattern,
    SyntaxKind::SubtractAssignmentExpression,
    SyntaxKind::SubtractExpression,
    SyntaxKind::SuperHandle,
    SyntaxKind::SuperNewDefaultedArgsExpression,
    SyntaxKind::SystemName,
    SyntaxKind::SystemTimingCheck,
    SyntaxKind::TaggedPattern,
    SyntaxKind::TaggedUnionExpression,
    SyntaxKind::TaskDeclaration,
    SyntaxKind::ThisHandle,
    SyntaxKind::ThroughoutSequenceExpr,
    SyntaxKind::TimeLiteralExpression,
    SyntaxKind::TimeScaleDirective,
    SyntaxKind::TimeType,
    SyntaxKind::TimeUnitsDeclaration,
    SyntaxKind::TimingCheckEventArg,
    SyntaxKind::TimingCheckEventCondition,
    SyntaxKind::TimingControlExpression,
    SyntaxKind::TimingControlStatement,
    SyntaxKind::TransListCoverageBinInitializer,
    SyntaxKind::TransRange,
    SyntaxKind::TransRepeatRange,
    SyntaxKind::TransSet,
    SyntaxKind::TypeAssignment,
    SyntaxKind::TypeParameterDeclaration,
    SyntaxKind::TypeReference,
    SyntaxKind::TypedefDeclaration,
    SyntaxKind::UdpBody,
    SyntaxKind::UdpDeclaration,
    SyntaxKind::UdpEdgeField,
    SyntaxKind::UdpEntry,
    SyntaxKind::UdpInitialStmt,
    SyntaxKind::UdpInputPortDecl,
    SyntaxKind::UdpOutputPortDecl,
    SyntaxKind::UdpSimpleField,
    SyntaxKind::UnaryBinsSelectExpr,
    SyntaxKind::UnaryBitwiseAndExpression,
    SyntaxKind::UnaryBitwiseNandExpression,
    SyntaxKind::UnaryBitwiseNorExpression,
    SyntaxKind::UnaryBitwiseNotExpression,
    SyntaxKind::UnaryBitwiseOrExpression,
    SyntaxKind::UnaryBitwiseXnorExpression,
    SyntaxKind::UnaryBitwiseXorExpression,
    SyntaxKind::UnaryConditionalDirectiveExpression,
    SyntaxKind::UnaryLogicalNotExpression,
    SyntaxKind::UnaryMinusExpression,
    SyntaxKind::UnaryPlusExpression,
    SyntaxKind::UnaryPredecrementExpression,
    SyntaxKind::UnaryPreincrementExpression,
    SyntaxKind::UnaryPropertyExpr,
    SyntaxKind::UnarySelectPropertyExpr,
    SyntaxKind::UnbasedUnsizedLiteralExpression,
    SyntaxKind::UnconnectedDriveDirective,
    SyntaxKind::UndefDirective,
    SyntaxKind::UndefineAllDirective,
    SyntaxKind::UnionType,
    SyntaxKind::UniquenessConstraint,
    SyntaxKind::UnitScope,
    SyntaxKind::UntilPropertyExpr,
    SyntaxKind::UntilWithPropertyExpr,
    SyntaxKind::Untyped,
    SyntaxKind::UserDefinedNetDeclaration,
    SyntaxKind::ValueRangeExpression,
    SyntaxKind::VariableDimension,
    SyntaxKind::VariablePattern,
    SyntaxKind::VariablePortHeader,
    SyntaxKind::VirtualInterfaceType,
    SyntaxKind::VoidCastedCallStatement,
    SyntaxKind::VoidType,
    SyntaxKind::WaitForkStatement,
    SyntaxKind::WaitOrderStatement,
    SyntaxKind::WaitStatement,
    SyntaxKind::WildcardDimensionSpecifier,
    SyntaxKind::WildcardEqualityExpression,
    SyntaxKind::WildcardInequalityExpression,
    SyntaxKind::WildcardLiteralExpression,
    SyntaxKind::WildcardPattern,
    SyntaxKind::WildcardPortConnection,
    SyntaxKind::WildcardPortList,
    SyntaxKind::WildcardUdpPortList,
    SyntaxKind::WithClause,
    SyntaxKind::WithFunctionClause,
    SyntaxKind::WithFunctionSample,
    SyntaxKind::WithinSequenceExpr,
    SyntaxKind::XorAssignmentExpression,
};

#ifdef SLANG_RTTI_ENABLED
const std::type_info* typeFromSyntaxKind(SyntaxKind kind) {
    switch (kind) {
        case SyntaxKind::Unknown: break;
        case SyntaxKind::SyntaxList:
        case SyntaxKind::TokenList:
        case SyntaxKind::SeparatedList:
            return &typeid(SyntaxNode);
        case SyntaxKind::AcceptOnPropertyExpr: return &typeid(AcceptOnPropertyExprSyntax);
        case SyntaxKind::ActionBlock: return &typeid(ActionBlockSyntax);
        case SyntaxKind::AddAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::AddExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::AlwaysBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::AlwaysCombBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::AlwaysFFBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::AlwaysLatchBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::AndAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::AndPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::AndSequenceExpr: return &typeid(BinarySequenceExprSyntax);
        case SyntaxKind::AnonymousProgram: return &typeid(AnonymousProgramSyntax);
        case SyntaxKind::AnsiPortList: return &typeid(AnsiPortListSyntax);
        case SyntaxKind::AnsiUdpPortList: return &typeid(AnsiUdpPortListSyntax);
        case SyntaxKind::ArgumentList: return &typeid(ArgumentListSyntax);
        case SyntaxKind::ArithmeticLeftShiftAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ArithmeticRightShiftAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ArithmeticShiftLeftExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ArithmeticShiftRightExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ArrayAndMethod: return &typeid(KeywordNameSyntax);
        case SyntaxKind::ArrayOrMethod: return &typeid(KeywordNameSyntax);
        case SyntaxKind::ArrayOrRandomizeMethodExpression: return &typeid(ArrayOrRandomizeMethodExpressionSyntax);
        case SyntaxKind::ArrayUniqueMethod: return &typeid(KeywordNameSyntax);
        case SyntaxKind::ArrayXorMethod: return &typeid(KeywordNameSyntax);
        case SyntaxKind::AscendingRangeSelect: return &typeid(RangeSelectSyntax);
        case SyntaxKind::AssertPropertyStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::AssertionItemPort: return &typeid(AssertionItemPortSyntax);
        case SyntaxKind::AssertionItemPortList: return &typeid(AssertionItemPortListSyntax);
        case SyntaxKind::AssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::AssignmentPatternExpression: return &typeid(AssignmentPatternExpressionSyntax);
        case SyntaxKind::AssignmentPatternItem: return &typeid(AssignmentPatternItemSyntax);
        case SyntaxKind::AssumePropertyStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::AttributeInstance: return &typeid(AttributeInstanceSyntax);
        case SyntaxKind::AttributeSpec: return &typeid(AttributeSpecSyntax);
        case SyntaxKind::BadExpression: return &typeid(BadExpressionSyntax);
        case SyntaxKind::BeginKeywordsDirective: return &typeid(BeginKeywordsDirectiveSyntax);
        case SyntaxKind::BinSelectWithFilterExpr: return &typeid(BinSelectWithFilterExprSyntax);
        case SyntaxKind::BinaryAndExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::BinaryBinsSelectExpr: return &typeid(BinaryBinsSelectExprSyntax);
        case SyntaxKind::BinaryBlockEventExpression: return &typeid(BinaryBlockEventExpressionSyntax);
        case SyntaxKind::BinaryConditionalDirectiveExpression: return &typeid(BinaryConditionalDirectiveExpressionSyntax);
        case SyntaxKind::BinaryEventExpression: return &typeid(BinaryEventExpressionSyntax);
        case SyntaxKind::BinaryOrExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::BinaryXnorExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::BinaryXorExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::BindDirective: return &typeid(BindDirectiveSyntax);
        case SyntaxKind::BindTargetList: return &typeid(BindTargetListSyntax);
        case SyntaxKind::BinsSelectConditionExpr: return &typeid(BinsSelectConditionExprSyntax);
        case SyntaxKind::BinsSelection: return &typeid(BinsSelectionSyntax);
        case SyntaxKind::BitSelect: return &typeid(BitSelectSyntax);
        case SyntaxKind::BitType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::BlockCoverageEvent: return &typeid(BlockCoverageEventSyntax);
        case SyntaxKind::BlockingEventTriggerStatement: return &typeid(EventTriggerStatementSyntax);
        case SyntaxKind::ByteType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::CHandleType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::CaseEqualityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::CaseGenerate: return &typeid(CaseGenerateSyntax);
        case SyntaxKind::CaseInequalityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::CasePropertyExpr: return &typeid(CasePropertyExprSyntax);
        case SyntaxKind::CaseStatement: return &typeid(CaseStatementSyntax);
        case SyntaxKind::CastExpression: return &typeid(CastExpressionSyntax);
        case SyntaxKind::CellConfigRule: return &typeid(CellConfigRuleSyntax);
        case SyntaxKind::CellDefineDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::ChargeStrength: return &typeid(ChargeStrengthSyntax);
        case SyntaxKind::CheckerDataDeclaration: return &typeid(CheckerDataDeclarationSyntax);
        case SyntaxKind::CheckerDeclaration: return &typeid(CheckerDeclarationSyntax);
        case SyntaxKind::CheckerInstanceStatement: return &typeid(CheckerInstanceStatementSyntax);
        case SyntaxKind::CheckerInstantiation: return &typeid(CheckerInstantiationSyntax);
        case SyntaxKind::ClassDeclaration: return &typeid(ClassDeclarationSyntax);
        case SyntaxKind::ClassMethodDeclaration: return &typeid(ClassMethodDeclarationSyntax);
        case SyntaxKind::ClassMethodPrototype: return &typeid(ClassMethodPrototypeSyntax);
        case SyntaxKind::ClassName: return &typeid(ClassNameSyntax);
        case SyntaxKind::ClassPropertyDeclaration: return &typeid(ClassPropertyDeclarationSyntax);
        case SyntaxKind::ClassSpecifier: return &typeid(ClassSpecifierSyntax);
        case SyntaxKind::ClockingDeclaration: return &typeid(ClockingDeclarationSyntax);
        case SyntaxKind::ClockingDirection: return &typeid(ClockingDirectionSyntax);
        case SyntaxKind::ClockingItem: return &typeid(ClockingItemSyntax);
        case SyntaxKind::ClockingPropertyExpr: return &typeid(ClockingPropertyExprSyntax);
        case SyntaxKind::ClockingSequenceExpr: return &typeid(ClockingSequenceExprSyntax);
        case SyntaxKind::ClockingSkew: return &typeid(ClockingSkewSyntax);
        case SyntaxKind::ColonExpressionClause: return &typeid(ColonExpressionClauseSyntax);
        case SyntaxKind::CompilationUnit: return &typeid(CompilationUnitSyntax);
        case SyntaxKind::ConcatenationExpression: return &typeid(ConcatenationExpressionSyntax);
        case SyntaxKind::ConcurrentAssertionMember: return &typeid(ConcurrentAssertionMemberSyntax);
        case SyntaxKind::ConditionalConstraint: return &typeid(ConditionalConstraintSyntax);
        case SyntaxKind::ConditionalExpression: return &typeid(ConditionalExpressionSyntax);
        case SyntaxKind::ConditionalPathDeclaration: return &typeid(ConditionalPathDeclarationSyntax);
        case SyntaxKind::ConditionalPattern: return &typeid(ConditionalPatternSyntax);
        case SyntaxKind::ConditionalPredicate: return &typeid(ConditionalPredicateSyntax);
        case SyntaxKind::ConditionalPropertyExpr: return &typeid(ConditionalPropertyExprSyntax);
        case SyntaxKind::ConditionalStatement: return &typeid(ConditionalStatementSyntax);
        case SyntaxKind::ConfigCellIdentifier: return &typeid(ConfigCellIdentifierSyntax);
        case SyntaxKind::ConfigDeclaration: return &typeid(ConfigDeclarationSyntax);
        case SyntaxKind::ConfigInstanceIdentifier: return &typeid(ConfigInstanceIdentifierSyntax);
        case SyntaxKind::ConfigLiblist: return &typeid(ConfigLiblistSyntax);
        case SyntaxKind::ConfigUseClause: return &typeid(ConfigUseClauseSyntax);
        case SyntaxKind::ConstraintBlock: return &typeid(ConstraintBlockSyntax);
        case SyntaxKind::ConstraintDeclaration: return &typeid(ConstraintDeclarationSyntax);
        case SyntaxKind::ConstraintPrototype: return &typeid(ConstraintPrototypeSyntax);
        case SyntaxKind::ConstructorName: return &typeid(KeywordNameSyntax);
        case SyntaxKind::ContinuousAssign: return &typeid(ContinuousAssignSyntax);
        case SyntaxKind::CopyClassExpression: return &typeid(CopyClassExpressionSyntax);
        case SyntaxKind::CoverCross: return &typeid(CoverCrossSyntax);
        case SyntaxKind::CoverPropertyStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::CoverSequenceStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::CoverageBins: return &typeid(CoverageBinsSyntax);
        case SyntaxKind::CoverageBinsArraySize: return &typeid(CoverageBinsArraySizeSyntax);
        case SyntaxKind::CoverageIffClause: return &typeid(CoverageIffClauseSyntax);
        case SyntaxKind::CoverageOption: return &typeid(CoverageOptionSyntax);
        case SyntaxKind::CovergroupDeclaration: return &typeid(CovergroupDeclarationSyntax);
        case SyntaxKind::Coverpoint: return &typeid(CoverpointSyntax);
        case SyntaxKind::CycleDelay: return &typeid(DelaySyntax);
        case SyntaxKind::DPIExport: return &typeid(DPIExportSyntax);
        case SyntaxKind::DPIImport: return &typeid(DPIImportSyntax);
        case SyntaxKind::DataDeclaration: return &typeid(DataDeclarationSyntax);
        case SyntaxKind::Declarator: return &typeid(DeclaratorSyntax);
        case SyntaxKind::DefParam: return &typeid(DefParamSyntax);
        case SyntaxKind::DefParamAssignment: return &typeid(DefParamAssignmentSyntax);
        case SyntaxKind::DefaultCaseItem: return &typeid(DefaultCaseItemSyntax);
        case SyntaxKind::DefaultClockingReference: return &typeid(DefaultClockingReferenceSyntax);
        case SyntaxKind::DefaultConfigRule: return &typeid(DefaultConfigRuleSyntax);
        case SyntaxKind::DefaultCoverageBinInitializer: return &typeid(DefaultCoverageBinInitializerSyntax);
        case SyntaxKind::DefaultDecayTimeDirective: return &typeid(DefaultDecayTimeDirectiveSyntax);
        case SyntaxKind::DefaultDisableDeclaration: return &typeid(DefaultDisableDeclarationSyntax);
        case SyntaxKind::DefaultDistItem: return &typeid(DefaultDistItemSyntax);
        case SyntaxKind::DefaultExtendsClauseArg: return &typeid(DefaultExtendsClauseArgSyntax);
        case SyntaxKind::DefaultFunctionPort: return &typeid(DefaultFunctionPortSyntax);
        case SyntaxKind::DefaultNetTypeDirective: return &typeid(DefaultNetTypeDirectiveSyntax);
        case SyntaxKind::DefaultPatternKeyExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::DefaultPropertyCaseItem: return &typeid(DefaultPropertyCaseItemSyntax);
        case SyntaxKind::DefaultRsCaseItem: return &typeid(DefaultRsCaseItemSyntax);
        case SyntaxKind::DefaultSkewItem: return &typeid(DefaultSkewItemSyntax);
        case SyntaxKind::DefaultTriregStrengthDirective: return &typeid(DefaultTriregStrengthDirectiveSyntax);
        case SyntaxKind::DeferredAssertion: return &typeid(DeferredAssertionSyntax);
        case SyntaxKind::DefineDirective: return &typeid(DefineDirectiveSyntax);
        case SyntaxKind::Delay3: return &typeid(Delay3Syntax);
        case SyntaxKind::DelayControl: return &typeid(DelaySyntax);
        case SyntaxKind::DelayModeDistributedDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::DelayModePathDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::DelayModeUnitDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::DelayModeZeroDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::DelayedSequenceElement: return &typeid(DelayedSequenceElementSyntax);
        case SyntaxKind::DelayedSequenceExpr: return &typeid(DelayedSequenceExprSyntax);
        case SyntaxKind::DescendingRangeSelect: return &typeid(RangeSelectSyntax);
        case SyntaxKind::DisableConstraint: return &typeid(DisableConstraintSyntax);
        case SyntaxKind::DisableForkStatement: return &typeid(DisableForkStatementSyntax);
        case SyntaxKind::DisableIff: return &typeid(DisableIffSyntax);
        case SyntaxKind::DisableStatement: return &typeid(DisableStatementSyntax);
        case SyntaxKind::DistConstraintList: return &typeid(DistConstraintListSyntax);
        case SyntaxKind::DistItem: return &typeid(DistItemSyntax);
        case SyntaxKind::DistWeight: return &typeid(DistWeightSyntax);
        case SyntaxKind::DivideAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::DivideExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::DividerClause: return &typeid(DividerClauseSyntax);
        case SyntaxKind::DoWhileStatement: return &typeid(DoWhileStatementSyntax);
        case SyntaxKind::DotMemberClause: return &typeid(DotMemberClauseSyntax);
        case SyntaxKind::DriveStrength: return &typeid(DriveStrengthSyntax);
        case SyntaxKind::EdgeControlSpecifier: return &typeid(EdgeControlSpecifierSyntax);
        case SyntaxKind::EdgeDescriptor: return &typeid(EdgeDescriptorSyntax);
        case SyntaxKind::EdgeSensitivePathSuffix: return &typeid(EdgeSensitivePathSuffixSyntax);
        case SyntaxKind::ElabSystemTask: return &typeid(ElabSystemTaskSyntax);
        case SyntaxKind::ElementSelect: return &typeid(ElementSelectSyntax);
        case SyntaxKind::ElementSelectExpression: return &typeid(ElementSelectExpressionSyntax);
        case SyntaxKind::ElsIfDirective: return &typeid(ConditionalBranchDirectiveSyntax);
        case SyntaxKind::ElseClause: return &typeid(ElseClauseSyntax);
        case SyntaxKind::ElseConstraintClause: return &typeid(ElseConstraintClauseSyntax);
        case SyntaxKind::ElseDirective: return &typeid(UnconditionalBranchDirectiveSyntax);
        case SyntaxKind::ElsePropertyClause: return &typeid(ElsePropertyClauseSyntax);
        case SyntaxKind::EmptyArgument: return &typeid(EmptyArgumentSyntax);
        case SyntaxKind::EmptyIdentifierName: return &typeid(EmptyIdentifierNameSyntax);
        case SyntaxKind::EmptyMember: return &typeid(EmptyMemberSyntax);
        case SyntaxKind::EmptyNonAnsiPort: return &typeid(EmptyNonAnsiPortSyntax);
        case SyntaxKind::EmptyPortConnection: return &typeid(EmptyPortConnectionSyntax);
        case SyntaxKind::EmptyQueueExpression: return &typeid(EmptyQueueExpressionSyntax);
        case SyntaxKind::EmptyStatement: return &typeid(EmptyStatementSyntax);
        case SyntaxKind::EmptyTimingCheckArg: return &typeid(EmptyTimingCheckArgSyntax);
        case SyntaxKind::EndCellDefineDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::EndIfDirective: return &typeid(UnconditionalBranchDirectiveSyntax);
        case SyntaxKind::EndKeywordsDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::EndProtectDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::EndProtectedDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::EnumType: return &typeid(EnumTypeSyntax);
        case SyntaxKind::EqualityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::EqualsAssertionArgClause: return &typeid(EqualsAssertionArgClauseSyntax);
        case SyntaxKind::EqualsTypeClause: return &typeid(EqualsTypeClauseSyntax);
        case SyntaxKind::EqualsValueClause: return &typeid(EqualsValueClauseSyntax);
        case SyntaxKind::EventControl: return &typeid(EventControlSyntax);
        case SyntaxKind::EventControlWithExpression: return &typeid(EventControlWithExpressionSyntax);
        case SyntaxKind::EventType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::ExpectPropertyStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::ExplicitAnsiPort: return &typeid(ExplicitAnsiPortSyntax);
        case SyntaxKind::ExplicitNonAnsiPort: return &typeid(ExplicitNonAnsiPortSyntax);
        case SyntaxKind::ExpressionConstraint: return &typeid(ExpressionConstraintSyntax);
        case SyntaxKind::ExpressionCoverageBinInitializer: return &typeid(ExpressionCoverageBinInitializerSyntax);
        case SyntaxKind::ExpressionOrDist: return &typeid(ExpressionOrDistSyntax);
        case SyntaxKind::ExpressionPattern: return &typeid(ExpressionPatternSyntax);
        case SyntaxKind::ExpressionStatement: return &typeid(ExpressionStatementSyntax);
        case SyntaxKind::ExpressionTimingCheckArg: return &typeid(ExpressionTimingCheckArgSyntax);
        case SyntaxKind::ExtendsClause: return &typeid(ExtendsClauseSyntax);
        case SyntaxKind::ExternInterfaceMethod: return &typeid(ExternInterfaceMethodSyntax);
        case SyntaxKind::ExternModuleDecl: return &typeid(ExternModuleDeclSyntax);
        case SyntaxKind::ExternUdpDecl: return &typeid(ExternUdpDeclSyntax);
        case SyntaxKind::FilePathSpec: return &typeid(FilePathSpecSyntax);
        case SyntaxKind::FinalBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::FirstMatchSequenceExpr: return &typeid(FirstMatchSequenceExprSyntax);
        case SyntaxKind::FollowedByPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::ForLoopStatement: return &typeid(ForLoopStatementSyntax);
        case SyntaxKind::ForVariableDeclaration: return &typeid(ForVariableDeclarationSyntax);
        case SyntaxKind::ForeachLoopList: return &typeid(ForeachLoopListSyntax);
        case SyntaxKind::ForeachLoopStatement: return &typeid(ForeachLoopStatementSyntax);
        case SyntaxKind::ForeverStatement: return &typeid(ForeverStatementSyntax);
        case SyntaxKind::ForwardTypeRestriction: return &typeid(ForwardTypeRestrictionSyntax);
        case SyntaxKind::ForwardTypedefDeclaration: return &typeid(ForwardTypedefDeclarationSyntax);
        case SyntaxKind::FunctionDeclaration: return &typeid(FunctionDeclarationSyntax);
        case SyntaxKind::FunctionPort: return &typeid(FunctionPortSyntax);
        case SyntaxKind::FunctionPortList: return &typeid(FunctionPortListSyntax);
        case SyntaxKind::FunctionPrototype: return &typeid(FunctionPrototypeSyntax);
        case SyntaxKind::GenerateBlock: return &typeid(GenerateBlockSyntax);
        case SyntaxKind::GenerateRegion: return &typeid(GenerateRegionSyntax);
        case SyntaxKind::GenvarDeclaration: return &typeid(GenvarDeclarationSyntax);
        case SyntaxKind::GreaterThanEqualExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::GreaterThanExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::HierarchicalInstance: return &typeid(HierarchicalInstanceSyntax);
        case SyntaxKind::HierarchyInstantiation: return &typeid(HierarchyInstantiationSyntax);
        case SyntaxKind::IdWithExprCoverageBinInitializer: return &typeid(IdWithExprCoverageBinInitializerSyntax);
        case SyntaxKind::IdentifierName: return &typeid(IdentifierNameSyntax);
        case SyntaxKind::IdentifierSelectName: return &typeid(IdentifierSelectNameSyntax);
        case SyntaxKind::IfDefDirective: return &typeid(ConditionalBranchDirectiveSyntax);
        case SyntaxKind::IfGenerate: return &typeid(IfGenerateSyntax);
        case SyntaxKind::IfNDefDirective: return &typeid(ConditionalBranchDirectiveSyntax);
        case SyntaxKind::IfNonePathDeclaration: return &typeid(IfNonePathDeclarationSyntax);
        case SyntaxKind::IffEventClause: return &typeid(IffEventClauseSyntax);
        case SyntaxKind::IffPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::ImmediateAssertStatement: return &typeid(ImmediateAssertionStatementSyntax);
        case SyntaxKind::ImmediateAssertionMember: return &typeid(ImmediateAssertionMemberSyntax);
        case SyntaxKind::ImmediateAssumeStatement: return &typeid(ImmediateAssertionStatementSyntax);
        case SyntaxKind::ImmediateCoverStatement: return &typeid(ImmediateAssertionStatementSyntax);
        case SyntaxKind::ImplementsClause: return &typeid(ImplementsClauseSyntax);
        case SyntaxKind::ImplicationConstraint: return &typeid(ImplicationConstraintSyntax);
        case SyntaxKind::ImplicationPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::ImplicitAnsiPort: return &typeid(ImplicitAnsiPortSyntax);
        case SyntaxKind::ImplicitEventControl: return &typeid(ImplicitEventControlSyntax);
        case SyntaxKind::ImplicitNonAnsiPort: return &typeid(ImplicitNonAnsiPortSyntax);
        case SyntaxKind::ImplicitType: return &typeid(ImplicitTypeSyntax);
        case SyntaxKind::ImpliesPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::IncludeDirective: return &typeid(IncludeDirectiveSyntax);
        case SyntaxKind::InequalityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::InitialBlock: return &typeid(ProceduralBlockSyntax);
        case SyntaxKind::InsideExpression: return &typeid(InsideExpressionSyntax);
        case SyntaxKind::InstanceConfigRule: return &typeid(InstanceConfigRuleSyntax);
        case SyntaxKind::InstanceName: return &typeid(InstanceNameSyntax);
        case SyntaxKind::IntType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::IntegerLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::IntegerType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::IntegerVectorExpression: return &typeid(IntegerVectorExpressionSyntax);
        case SyntaxKind::InterfaceDeclaration: return &typeid(ModuleDeclarationSyntax);
        case SyntaxKind::InterfaceHeader: return &typeid(ModuleHeaderSyntax);
        case SyntaxKind::InterfacePortHeader: return &typeid(InterfacePortHeaderSyntax);
        case SyntaxKind::IntersectClause: return &typeid(IntersectClauseSyntax);
        case SyntaxKind::IntersectSequenceExpr: return &typeid(BinarySequenceExprSyntax);
        case SyntaxKind::InvocationExpression: return &typeid(InvocationExpressionSyntax);
        case SyntaxKind::JumpStatement: return &typeid(JumpStatementSyntax);
        case SyntaxKind::LessThanEqualExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LessThanExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LetDeclaration: return &typeid(LetDeclarationSyntax);
        case SyntaxKind::LibraryDeclaration: return &typeid(LibraryDeclarationSyntax);
        case SyntaxKind::LibraryIncDirClause: return &typeid(LibraryIncDirClauseSyntax);
        case SyntaxKind::LibraryIncludeStatement: return &typeid(LibraryIncludeStatementSyntax);
        case SyntaxKind::LibraryMap: return &typeid(LibraryMapSyntax);
        case SyntaxKind::LineDirective: return &typeid(LineDirectiveSyntax);
        case SyntaxKind::LocalScope: return &typeid(KeywordNameSyntax);
        case SyntaxKind::LocalVariableDeclaration: return &typeid(LocalVariableDeclarationSyntax);
        case SyntaxKind::LogicType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::LogicalAndExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalEquivalenceExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalImplicationExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalLeftShiftAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalOrExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalRightShiftAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalShiftLeftExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LogicalShiftRightExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::LongIntType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::LoopConstraint: return &typeid(LoopConstraintSyntax);
        case SyntaxKind::LoopGenerate: return &typeid(LoopGenerateSyntax);
        case SyntaxKind::LoopStatement: return &typeid(LoopStatementSyntax);
        case SyntaxKind::MacroActualArgument: return &typeid(MacroActualArgumentSyntax);
        case SyntaxKind::MacroActualArgumentList: return &typeid(MacroActualArgumentListSyntax);
        case SyntaxKind::MacroArgumentDefault: return &typeid(MacroArgumentDefaultSyntax);
        case SyntaxKind::MacroFormalArgument: return &typeid(MacroFormalArgumentSyntax);
        case SyntaxKind::MacroFormalArgumentList: return &typeid(MacroFormalArgumentListSyntax);
        case SyntaxKind::MacroUsage: return &typeid(MacroUsageSyntax);
        case SyntaxKind::MatchesClause: return &typeid(MatchesClauseSyntax);
        case SyntaxKind::MemberAccessExpression: return &typeid(MemberAccessExpressionSyntax);
        case SyntaxKind::MinTypMaxExpression: return &typeid(MinTypMaxExpressionSyntax);
        case SyntaxKind::ModAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ModExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::ModportClockingPort: return &typeid(ModportClockingPortSyntax);
        case SyntaxKind::ModportDeclaration: return &typeid(ModportDeclarationSyntax);
        case SyntaxKind::ModportExplicitPort: return &typeid(ModportExplicitPortSyntax);
        case SyntaxKind::ModportItem: return &typeid(ModportItemSyntax);
        case SyntaxKind::ModportNamedPort: return &typeid(ModportNamedPortSyntax);
        case SyntaxKind::ModportSimplePortList: return &typeid(ModportSimplePortListSyntax);
        case SyntaxKind::ModportSubroutinePort: return &typeid(ModportSubroutinePortSyntax);
        case SyntaxKind::ModportSubroutinePortList: return &typeid(ModportSubroutinePortListSyntax);
        case SyntaxKind::ModuleDeclaration: return &typeid(ModuleDeclarationSyntax);
        case SyntaxKind::ModuleHeader: return &typeid(ModuleHeaderSyntax);
        case SyntaxKind::MultipleConcatenationExpression: return &typeid(MultipleConcatenationExpressionSyntax);
        case SyntaxKind::MultiplyAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::MultiplyExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::NameValuePragmaExpression: return &typeid(NameValuePragmaExpressionSyntax);
        case SyntaxKind::NamedArgument: return &typeid(NamedArgumentSyntax);
        case SyntaxKind::NamedBlockClause: return &typeid(NamedBlockClauseSyntax);
        case SyntaxKind::NamedConditionalDirectiveExpression: return &typeid(NamedConditionalDirectiveExpressionSyntax);
        case SyntaxKind::NamedLabel: return &typeid(NamedLabelSyntax);
        case SyntaxKind::NamedParamAssignment: return &typeid(NamedParamAssignmentSyntax);
        case SyntaxKind::NamedPortConnection: return &typeid(NamedPortConnectionSyntax);
        case SyntaxKind::NamedStructurePatternMember: return &typeid(NamedStructurePatternMemberSyntax);
        case SyntaxKind::NamedType: return &typeid(NamedTypeSyntax);
        case SyntaxKind::NetAlias: return &typeid(NetAliasSyntax);
        case SyntaxKind::NetDeclaration: return &typeid(NetDeclarationSyntax);
        case SyntaxKind::NetPortHeader: return &typeid(NetPortHeaderSyntax);
        case SyntaxKind::NetTypeDeclaration: return &typeid(NetTypeDeclarationSyntax);
        case SyntaxKind::NewArrayExpression: return &typeid(NewArrayExpressionSyntax);
        case SyntaxKind::NewClassExpression: return &typeid(NewClassExpressionSyntax);
        case SyntaxKind::NoUnconnectedDriveDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::NonAnsiPortList: return &typeid(NonAnsiPortListSyntax);
        case SyntaxKind::NonAnsiUdpPortList: return &typeid(NonAnsiUdpPortListSyntax);
        case SyntaxKind::NonblockingAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::NonblockingEventTriggerStatement: return &typeid(EventTriggerStatementSyntax);
        case SyntaxKind::NullLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::NumberPragmaExpression: return &typeid(NumberPragmaExpressionSyntax);
        case SyntaxKind::OneStepDelay: return &typeid(OneStepDelaySyntax);
        case SyntaxKind::OrAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::OrPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::OrSequenceExpr: return &typeid(BinarySequenceExprSyntax);
        case SyntaxKind::OrderedArgument: return &typeid(OrderedArgumentSyntax);
        case SyntaxKind::OrderedParamAssignment: return &typeid(OrderedParamAssignmentSyntax);
        case SyntaxKind::OrderedPortConnection: return &typeid(OrderedPortConnectionSyntax);
        case SyntaxKind::OrderedStructurePatternMember: return &typeid(OrderedStructurePatternMemberSyntax);
        case SyntaxKind::PackageDeclaration: return &typeid(ModuleDeclarationSyntax);
        case SyntaxKind::PackageExportAllDeclaration: return &typeid(PackageExportAllDeclarationSyntax);
        case SyntaxKind::PackageExportDeclaration: return &typeid(PackageExportDeclarationSyntax);
        case SyntaxKind::PackageHeader: return &typeid(ModuleHeaderSyntax);
        case SyntaxKind::PackageImportDeclaration: return &typeid(PackageImportDeclarationSyntax);
        case SyntaxKind::PackageImportItem: return &typeid(PackageImportItemSyntax);
        case SyntaxKind::ParallelBlockStatement: return &typeid(BlockStatementSyntax);
        case SyntaxKind::ParameterDeclaration: return &typeid(ParameterDeclarationSyntax);
        case SyntaxKind::ParameterDeclarationStatement: return &typeid(ParameterDeclarationStatementSyntax);
        case SyntaxKind::ParameterPortList: return &typeid(ParameterPortListSyntax);
        case SyntaxKind::ParameterValueAssignment: return &typeid(ParameterValueAssignmentSyntax);
        case SyntaxKind::ParenExpressionList: return &typeid(ParenExpressionListSyntax);
        case SyntaxKind::ParenPragmaExpression: return &typeid(ParenPragmaExpressionSyntax);
        case SyntaxKind::ParenthesizedBinsSelectExpr: return &typeid(ParenthesizedBinsSelectExprSyntax);
        case SyntaxKind::ParenthesizedConditionalDirectiveExpression: return &typeid(ParenthesizedConditionalDirectiveExpressionSyntax);
        case SyntaxKind::ParenthesizedEventExpression: return &typeid(ParenthesizedEventExpressionSyntax);
        case SyntaxKind::ParenthesizedExpression: return &typeid(ParenthesizedExpressionSyntax);
        case SyntaxKind::ParenthesizedPattern: return &typeid(ParenthesizedPatternSyntax);
        case SyntaxKind::ParenthesizedPropertyExpr: return &typeid(ParenthesizedPropertyExprSyntax);
        case SyntaxKind::ParenthesizedSequenceExpr: return &typeid(ParenthesizedSequenceExprSyntax);
        case SyntaxKind::PathDeclaration: return &typeid(PathDeclarationSyntax);
        case SyntaxKind::PathDescription: return &typeid(PathDescriptionSyntax);
        case SyntaxKind::PatternCaseItem: return &typeid(PatternCaseItemSyntax);
        case SyntaxKind::PortConcatenation: return &typeid(PortConcatenationSyntax);
        case SyntaxKind::PortDeclaration: return &typeid(PortDeclarationSyntax);
        case SyntaxKind::PortReference: return &typeid(PortReferenceSyntax);
        case SyntaxKind::PostdecrementExpression: return &typeid(PostfixUnaryExpressionSyntax);
        case SyntaxKind::PostincrementExpression: return &typeid(PostfixUnaryExpressionSyntax);
        case SyntaxKind::PowerExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::PragmaDirective: return &typeid(PragmaDirectiveSyntax);
        case SyntaxKind::PrimaryBlockEventExpression: return &typeid(PrimaryBlockEventExpressionSyntax);
        case SyntaxKind::PrimitiveInstantiation: return &typeid(PrimitiveInstantiationSyntax);
        case SyntaxKind::ProceduralAssignStatement: return &typeid(ProceduralAssignStatementSyntax);
        case SyntaxKind::ProceduralDeassignStatement: return &typeid(ProceduralDeassignStatementSyntax);
        case SyntaxKind::ProceduralForceStatement: return &typeid(ProceduralAssignStatementSyntax);
        case SyntaxKind::ProceduralReleaseStatement: return &typeid(ProceduralDeassignStatementSyntax);
        case SyntaxKind::Production: return &typeid(ProductionSyntax);
        case SyntaxKind::ProgramDeclaration: return &typeid(ModuleDeclarationSyntax);
        case SyntaxKind::ProgramHeader: return &typeid(ModuleHeaderSyntax);
        case SyntaxKind::PropertyDeclaration: return &typeid(PropertyDeclarationSyntax);
        case SyntaxKind::PropertySpec: return &typeid(PropertySpecSyntax);
        case SyntaxKind::PropertyType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::ProtectDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::ProtectedDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::PullStrength: return &typeid(PullStrengthSyntax);
        case SyntaxKind::PulseStyleDeclaration: return &typeid(PulseStyleDeclarationSyntax);
        case SyntaxKind::QueueDimensionSpecifier: return &typeid(QueueDimensionSpecifierSyntax);
        case SyntaxKind::RandCaseItem: return &typeid(RandCaseItemSyntax);
        case SyntaxKind::RandCaseStatement: return &typeid(RandCaseStatementSyntax);
        case SyntaxKind::RandJoinClause: return &typeid(RandJoinClauseSyntax);
        case SyntaxKind::RandSequenceStatement: return &typeid(RandSequenceStatementSyntax);
        case SyntaxKind::RangeCoverageBinInitializer: return &typeid(RangeCoverageBinInitializerSyntax);
        case SyntaxKind::RangeDimensionSpecifier: return &typeid(RangeDimensionSpecifierSyntax);
        case SyntaxKind::RangeList: return &typeid(RangeListSyntax);
        case SyntaxKind::RealLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::RealTimeType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::RealType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::RegType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::RepeatedEventControl: return &typeid(RepeatedEventControlSyntax);
        case SyntaxKind::ReplicatedAssignmentPattern: return &typeid(ReplicatedAssignmentPatternSyntax);
        case SyntaxKind::ResetAllDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::RestrictPropertyStatement: return &typeid(ConcurrentAssertionStatementSyntax);
        case SyntaxKind::ReturnStatement: return &typeid(ReturnStatementSyntax);
        case SyntaxKind::RootScope: return &typeid(KeywordNameSyntax);
        case SyntaxKind::RsCase: return &typeid(RsCaseSyntax);
        case SyntaxKind::RsCodeBlock: return &typeid(RsCodeBlockSyntax);
        case SyntaxKind::RsElseClause: return &typeid(RsElseClauseSyntax);
        case SyntaxKind::RsIfElse: return &typeid(RsIfElseSyntax);
        case SyntaxKind::RsProdItem: return &typeid(RsProdItemSyntax);
        case SyntaxKind::RsRepeat: return &typeid(RsRepeatSyntax);
        case SyntaxKind::RsRule: return &typeid(RsRuleSyntax);
        case SyntaxKind::RsWeightClause: return &typeid(RsWeightClauseSyntax);
        case SyntaxKind::SUntilPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::SUntilWithPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::ScopedName: return &typeid(ScopedNameSyntax);
        case SyntaxKind::SequenceDeclaration: return &typeid(SequenceDeclarationSyntax);
        case SyntaxKind::SequenceMatchList: return &typeid(SequenceMatchListSyntax);
        case SyntaxKind::SequenceRepetition: return &typeid(SequenceRepetitionSyntax);
        case SyntaxKind::SequenceType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::SequentialBlockStatement: return &typeid(BlockStatementSyntax);
        case SyntaxKind::ShortIntType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::ShortRealType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::SignalEventExpression: return &typeid(SignalEventExpressionSyntax);
        case SyntaxKind::SignedCastExpression: return &typeid(SignedCastExpressionSyntax);
        case SyntaxKind::SimpleAssignmentPattern: return &typeid(SimpleAssignmentPatternSyntax);
        case SyntaxKind::SimpleBinsSelectExpr: return &typeid(SimpleBinsSelectExprSyntax);
        case SyntaxKind::SimplePathSuffix: return &typeid(SimplePathSuffixSyntax);
        case SyntaxKind::SimplePragmaExpression: return &typeid(SimplePragmaExpressionSyntax);
        case SyntaxKind::SimplePropertyExpr: return &typeid(SimplePropertyExprSyntax);
        case SyntaxKind::SimpleRangeSelect: return &typeid(RangeSelectSyntax);
        case SyntaxKind::SimpleSequenceExpr: return &typeid(SimpleSequenceExprSyntax);
        case SyntaxKind::SolveBeforeConstraint: return &typeid(SolveBeforeConstraintSyntax);
        case SyntaxKind::SpecifyBlock: return &typeid(SpecifyBlockSyntax);
        case SyntaxKind::SpecparamDeclaration: return &typeid(SpecparamDeclarationSyntax);
        case SyntaxKind::SpecparamDeclarator: return &typeid(SpecparamDeclaratorSyntax);
        case SyntaxKind::StandardCaseItem: return &typeid(StandardCaseItemSyntax);
        case SyntaxKind::StandardPropertyCaseItem: return &typeid(StandardPropertyCaseItemSyntax);
        case SyntaxKind::StandardRsCaseItem: return &typeid(StandardRsCaseItemSyntax);
        case SyntaxKind::StreamExpression: return &typeid(StreamExpressionSyntax);
        case SyntaxKind::StreamExpressionWithRange: return &typeid(StreamExpressionWithRangeSyntax);
        case SyntaxKind::StreamingConcatenationExpression: return &typeid(StreamingConcatenationExpressionSyntax);
        case SyntaxKind::StringLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::StringType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::StrongWeakPropertyExpr: return &typeid(StrongWeakPropertyExprSyntax);
        case SyntaxKind::StructType: return &typeid(StructUnionTypeSyntax);
        case SyntaxKind::StructUnionMember: return &typeid(StructUnionMemberSyntax);
        case SyntaxKind::StructurePattern: return &typeid(StructurePatternSyntax);
        case SyntaxKind::StructuredAssignmentPattern: return &typeid(StructuredAssignmentPatternSyntax);
        case SyntaxKind::SubtractAssignmentExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::SubtractExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::SuperHandle: return &typeid(KeywordNameSyntax);
        case SyntaxKind::SuperNewDefaultedArgsExpression: return &typeid(SuperNewDefaultedArgsExpressionSyntax);
        case SyntaxKind::SystemName: return &typeid(SystemNameSyntax);
        case SyntaxKind::SystemTimingCheck: return &typeid(SystemTimingCheckSyntax);
        case SyntaxKind::TaggedPattern: return &typeid(TaggedPatternSyntax);
        case SyntaxKind::TaggedUnionExpression: return &typeid(TaggedUnionExpressionSyntax);
        case SyntaxKind::TaskDeclaration: return &typeid(FunctionDeclarationSyntax);
        case SyntaxKind::ThisHandle: return &typeid(KeywordNameSyntax);
        case SyntaxKind::ThroughoutSequenceExpr: return &typeid(BinarySequenceExprSyntax);
        case SyntaxKind::TimeLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::TimeScaleDirective: return &typeid(TimeScaleDirectiveSyntax);
        case SyntaxKind::TimeType: return &typeid(IntegerTypeSyntax);
        case SyntaxKind::TimeUnitsDeclaration: return &typeid(TimeUnitsDeclarationSyntax);
        case SyntaxKind::TimingCheckEventArg: return &typeid(TimingCheckEventArgSyntax);
        case SyntaxKind::TimingCheckEventCondition: return &typeid(TimingCheckEventConditionSyntax);
        case SyntaxKind::TimingControlExpression: return &typeid(TimingControlExpressionSyntax);
        case SyntaxKind::TimingControlStatement: return &typeid(TimingControlStatementSyntax);
        case SyntaxKind::TransListCoverageBinInitializer: return &typeid(TransListCoverageBinInitializerSyntax);
        case SyntaxKind::TransRange: return &typeid(TransRangeSyntax);
        case SyntaxKind::TransRepeatRange: return &typeid(TransRepeatRangeSyntax);
        case SyntaxKind::TransSet: return &typeid(TransSetSyntax);
        case SyntaxKind::TypeAssignment: return &typeid(TypeAssignmentSyntax);
        case SyntaxKind::TypeParameterDeclaration: return &typeid(TypeParameterDeclarationSyntax);
        case SyntaxKind::TypeReference: return &typeid(TypeReferenceSyntax);
        case SyntaxKind::TypedefDeclaration: return &typeid(TypedefDeclarationSyntax);
        case SyntaxKind::UdpBody: return &typeid(UdpBodySyntax);
        case SyntaxKind::UdpDeclaration: return &typeid(UdpDeclarationSyntax);
        case SyntaxKind::UdpEdgeField: return &typeid(UdpEdgeFieldSyntax);
        case SyntaxKind::UdpEntry: return &typeid(UdpEntrySyntax);
        case SyntaxKind::UdpInitialStmt: return &typeid(UdpInitialStmtSyntax);
        case SyntaxKind::UdpInputPortDecl: return &typeid(UdpInputPortDeclSyntax);
        case SyntaxKind::UdpOutputPortDecl: return &typeid(UdpOutputPortDeclSyntax);
        case SyntaxKind::UdpSimpleField: return &typeid(UdpSimpleFieldSyntax);
        case SyntaxKind::UnaryBinsSelectExpr: return &typeid(UnaryBinsSelectExprSyntax);
        case SyntaxKind::UnaryBitwiseAndExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseNandExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseNorExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseNotExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseOrExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseXnorExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryBitwiseXorExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryConditionalDirectiveExpression: return &typeid(UnaryConditionalDirectiveExpressionSyntax);
        case SyntaxKind::UnaryLogicalNotExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryMinusExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryPlusExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryPredecrementExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryPreincrementExpression: return &typeid(PrefixUnaryExpressionSyntax);
        case SyntaxKind::UnaryPropertyExpr: return &typeid(UnaryPropertyExprSyntax);
        case SyntaxKind::UnarySelectPropertyExpr: return &typeid(UnarySelectPropertyExprSyntax);
        case SyntaxKind::UnbasedUnsizedLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::UnconnectedDriveDirective: return &typeid(UnconnectedDriveDirectiveSyntax);
        case SyntaxKind::UndefDirective: return &typeid(UndefDirectiveSyntax);
        case SyntaxKind::UndefineAllDirective: return &typeid(SimpleDirectiveSyntax);
        case SyntaxKind::UnionType: return &typeid(StructUnionTypeSyntax);
        case SyntaxKind::UniquenessConstraint: return &typeid(UniquenessConstraintSyntax);
        case SyntaxKind::UnitScope: return &typeid(KeywordNameSyntax);
        case SyntaxKind::UntilPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::UntilWithPropertyExpr: return &typeid(BinaryPropertyExprSyntax);
        case SyntaxKind::Untyped: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::UserDefinedNetDeclaration: return &typeid(UserDefinedNetDeclarationSyntax);
        case SyntaxKind::ValueRangeExpression: return &typeid(ValueRangeExpressionSyntax);
        case SyntaxKind::VariableDimension: return &typeid(VariableDimensionSyntax);
        case SyntaxKind::VariablePattern: return &typeid(VariablePatternSyntax);
        case SyntaxKind::VariablePortHeader: return &typeid(VariablePortHeaderSyntax);
        case SyntaxKind::VirtualInterfaceType: return &typeid(VirtualInterfaceTypeSyntax);
        case SyntaxKind::VoidCastedCallStatement: return &typeid(VoidCastedCallStatementSyntax);
        case SyntaxKind::VoidType: return &typeid(KeywordTypeSyntax);
        case SyntaxKind::WaitForkStatement: return &typeid(WaitForkStatementSyntax);
        case SyntaxKind::WaitOrderStatement: return &typeid(WaitOrderStatementSyntax);
        case SyntaxKind::WaitStatement: return &typeid(WaitStatementSyntax);
        case SyntaxKind::WildcardDimensionSpecifier: return &typeid(WildcardDimensionSpecifierSyntax);
        case SyntaxKind::WildcardEqualityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::WildcardInequalityExpression: return &typeid(BinaryExpressionSyntax);
        case SyntaxKind::WildcardLiteralExpression: return &typeid(LiteralExpressionSyntax);
        case SyntaxKind::WildcardPattern: return &typeid(WildcardPatternSyntax);
        case SyntaxKind::WildcardPortConnection: return &typeid(WildcardPortConnectionSyntax);
        case SyntaxKind::WildcardPortList: return &typeid(WildcardPortListSyntax);
        case SyntaxKind::WildcardUdpPortList: return &typeid(WildcardUdpPortListSyntax);
        case SyntaxKind::WithClause: return &typeid(WithClauseSyntax);
        case SyntaxKind::WithFunctionClause: return &typeid(WithFunctionClauseSyntax);
        case SyntaxKind::WithFunctionSample: return &typeid(WithFunctionSampleSyntax);
        case SyntaxKind::WithinSequenceExpr: return &typeid(BinarySequenceExprSyntax);
        case SyntaxKind::XorAssignmentExpression: return &typeid(BinaryExpressionSyntax);
    }
    return nullptr;
}
#endif

}
